//////////////////////////////////////////////////////////////////////////////
// Noritsu Printing Service (NPS) SDK   v.1.13  [2012.05.18]
//
//  Nps.h
//
// Copyright (C) 2006-2010 Noritsu Koki Co.,Ltd. All rights reserved.
//////////////////////////////////////////////////////////////////////////////

#ifndef _NPS_H_
#define _NPS_H_

#ifdef NPS_EXPORTS
#define NPS_API __declspec(dllexport) __cdecl
#else
#define NPS_API __declspec(dllimport) __cdecl
#endif

#pragma pack(push, 8)

// Return value
#define	NPSERR_NORMAL			(1)			// Normal end 
#define	NPSERR_REJECT2			(4)			// Cannot accept print request as temperature adjustment is in progress.
#define	NPSERR_BADPARAM			(5)			// Could not execute with the specified parameter.
#define	NPSERR_SYSERR			(6)			// Could not execute due to insufficient resource, etc. 
#define	NPSERR_PRNERR			(7)			// Printer returned an error.
#define	NPSERR_REJECT3			(10)		// Cannot accept print request as it is receiving an order from another application. 
#define	NPSERR_REMAINING_DATA	(15)		// Insufficient buffer area for lpRecvBuf.
#define	NPSERR_TIMEOUT			(16)		// Response was not received within the timeout time. 

// npsDevGetUnitInfo : NPS_UnitInfo : dwPrinterStatus
#define	INFO_SALLBOOT			(0)			// Printer in preparation (in the maintenance mode) 
#define	INFO_SALLOFFLN			(6)			// Off-line (power off, etc) (DEFAULT) 
#define	INFO_SALLEND			(7)			// Closed
#define	INFO_SALLSELFINST		(9)			// Installing the software from own PC 
#define	INFO_SALLIDLE			(101)		// Idling 
#define	INFO_SALLPRINT			(102)		// Printing 
#define	INFO_SALLPRGTM			(103)		// Program Timer mode
#define	INFO_SALLINST			(104)		// Installing

// npsDevGetUnitInfo : NPS_UnitInfo : dwAcceptStatus
#define	INFO_SACDISABLE			(0)			// Not possible (DEFAULT) 
#define	INFO_SACENABLE			(1)			// Possible 

// npsDevGetUnitInfo : NPS_UnitInfo : dwPrinterPossession
#define	INFO_SPPNOUSE			(0)			// Unoccupied (DEFAULT) 
#define	INFO_SPPRESTART			(1)			// Unoccupied (resumption pending) 
#define	INFO_SPPUSENORMAL		(2)			// Normal occupation 
#define	INFO_SPPUSEEXPRESS		(3)			// Express occupation 

// npsDevGetUnitInfo : NPS_UnitInfo : dwAdvanceStatus
#define	INFO_SMCALLMOTNG		(0)			// The section cannot receive the next request. 
#define	INFO_SMCALLMOTOK		(1)			// The section can receive the next request.
#define	INFO_SMCALLMOTACT		(2)			// The section is running. 
#define	INFO_SMCALLMOTNONE		(9)			// Could not get the status (DEFAULT)  

// npsDevGetUnitInfo : NPS_UnitInfo : dwLaserStatus
#define	INFO_SLDLZSTOP			(0)			// Uninitialized 
#define	INFO_SLDLZSTART			(1)			// Temp control started (not completed) 
#define	INFO_SLDLZEND			(2)			// Temp control completed 
#define	INFO_SLDLZNONE			(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwDevelopmentStatus
#define	INFO_SPRALLMTNG			(0)			// The section cannot receive the next request.
#define	INFO_SPRALLMTOK			(1)			// The section can receive the next request. 
#define	INFO_SPRALLMTDO			(2)			// The section is running. 
#define	INFO_SPRALLMTNONE		(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwProcessorStatus
#define	INFO_SPRBTHTPNO			(0)			// No temperature control 
#define	INFO_SPRBTHHTUP			(1)			// Solution being heated up 
#define	INFO_SPRBTHPRTP			(2)			// Developer temp controlled 
#define	INFO_SPRBTHTPNG			(4)			// Temp control impossible 
#define	INFO_SPRBTHNONE			(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwReplenisherStatus
#define	INFO_SPRSPAAL			(0)			// Normal operation 
#define	INFO_SPRSPASA			(1)			// Compensating for the evaporation 
#define	INFO_SPRSPADO			(2)			// Quiet process in progress
#define	INFO_SPRSPAKT			(3)			// Preparing the new replenishment solution
#define	INFO_SPRSPNONE			(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwReplaceCartridgeStatus
#define	INFO_SPRKITCG			(0)			// Replacement is possible. 
#define	INFO_SPRKITLY			(1)			// Waiting for replenishment 
#define	INFO_SPRKITOP			(2)			// Opening 
#define	INFO_SPRKITNONE			(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwStartUpChecksStatus
#define	INFO_SUCSNO				(0)
#define	INFO_SUCSOK				(1)			// Finishing
#define	INFO_SUCSNONE			(9)			// Could not get the status (DEFAULT) 

// npsDevGetUnitInfo : NPS_UnitInfo : dwRefillWaterStatus
#define	INFO_RWSNO				(0)
#define	INFO_RWSOK				(1)
#define	INFO_RWSNONE			(9)

// npsDevGetUnitInfo : NPS_UnitInfo : dwDailySetupStatus
#define	INFO_DSSNO				(0)
#define	INFO_DSSOK				(1)
#define	INFO_DSSNONE			(9)

// npsDevGetUnitInfo : NPS_UnitInfo : dwControlStripStatus
#define	INFO_CSSNO				(0)
#define	INFO_CSSOK				(1)
#define	INFO_CSSNONE			(9)

// npsDevGetUnitInfo : NPS_UnitInfo : dwMaintenanceStatus
#define	INFO_MNTNOTUSE			(0)
#define	INFO_MNTUSE				(1)
#define	INFO_MNTNONE			(9)

// npsDevGetUnitInfo : NPS_UnitInfo : dwFadStatus
#define	INFO_FADOFFLN			(1)
#define	INFO_FADUNWK			(2)
#define	INFO_FADWRRNG			(3)
#define	INFO_FADMNT				(4)
#define	INFO_FADIDLE			(5)
#define	INFO_FADNONE			(9)

// npsDevGetMagInfo : NPS_MagDetailInfo : dwSetupStatus
#define	INFO_SETUPNG			(0)			// Setup incomplete
#define	INFO_SETUPOK			(1)			// Setup completed

// npsDevGetMagInfo : NPS_MagInfo : dwFeed
// npsDevGetMagInfo : NPS_MagDetailInfo : dwFeed
#define	INFO_ROLL				(0)			// Roll (Default) 
#define	INFO_SHEET				(1)			// Sheet 

// npsDevGetSetUpInfo : NPS_SetUpInfo : wProcessorType
#define	INFO_PRIDNONE			(0)			// l
#define	INFO_PRIDGPRO1			(11)		// LPP600(iBEAM600)
#define	INFO_PRIDGPRO2			(12)		// LPP600(Laser600)
#define	INFO_PRIDGPRO3			(13)		// LPP1000(Laser1000)
#define	INFO_PRIDGPRO4			(14)		// LP1700(900)
#define	INFO_PRIDGPRO5			(15)		// LP1700(1300)
#define	INFO_PRIDGPRO6			(16)		// LP1700(1700)
#define	INFO_PRIDGPRO7			(17)		// LP2500(2300)
#define	INFO_PRIDGPRO8			(18)		// LP2500(2500)

// npsDevGetSetUpInfo : NPS_SetUpInfo : wEmulsionNumber
// QSS̏e[uQ

// npsDevGetSetUpInfo : NPS_SetUpInfo : wMachineTypeID
#define	INFO_TYPEEXP			(0)			// AgX (Default) 
#define	INFO_TYPEIJ				(1)			// Inkjet
#define	INFO_TYPEIBEAM			(2)			// iBeam

// npsDevGetSetUpInfo : NPS_SetUpInfo : SupportImageFormat
#define	INFO_IMGNO				(0)			// Not supported (Default)
#define	INFO_IMGOK				(1)			// Supported 

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportAngle
#define	INFO_ROTATIONNO			(0)			// Unsupported (Default) 
#define	INFO_ROTATIONOK			(1)			// Supported 

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportIntoPrinter
#define	INFO_EXPRESSNO			(0)			// Unsupported (Default) 
#define	INFO_EXPRESSOK			(1)			// Supported 

// npsDevGetSetUpInfo : NPS_SetUpInfo : wLaminatorUnitAttach
#define	INFO_LAMIDISABLE		(0)			// Unset
#define	INFO_LAMIENABLE			(1)			// Set

// npsDevGetSetUpInfo : NPS_SetUpInfo : wCvpStatus
#define	INFO_SMCMT1BPUNSET		(0)			// Unset
#define	INFO_SMCMT1BPSET		(1)			// Set (1Line)
#define	INFO_SMCMT2BPSET		(2)			// Set (2Line)

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportPaperFitting
#define	INFO_PFNO				(0)			// Unsupported
#define	INFO_PFOK				(1)			// Supported

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportEdgeEnhancement
#define	INFO_EENO				(0)			// Unsupported
#define	INFO_EEOK				(1)			// Supported

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportWithBorder
#define	INFO_WBNO				(0)			// Unsupported
#define	INFO_WBOK				(1)			// Supported

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportCMS
#define	INFO_CMSNO				(0)			// Unsupported
#define	INFO_CMSOK				(1)			// Supported

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportDuplex
#define	INFO_DUPLEXNO			(0)			// Unsupported
#define	INFO_DUPLEXOK			(1)			// Supported

// npsDevGetSetUpInfo : NPS_SetUpInfo : wSupportInterrupt
#define	INFO_SUPPORTINTNO		(0)			// Unsupported
#define	INFO_SUPPORTINTOK		(1)			// Supported
#define	INFO_SUPPORTINTNEW		(2)			// Supported(New type interrupt)

// npsDevResetEvent : dwActionId
#define	PRESS_BUTTON01			(1)			// Button 1 was pressed. 
#define	PRESS_BUTTON02			(2)			// Button 2 was pressed. 
#define	PRESS_BUTTON03			(3)			// Button 3 was pressed. 
#define	PRESS_BUTTON04			(4)			// Button 4 was pressed. 
#define	PRESS_BUTTON05			(5)			// Button 5 was pressed. 

// npsDevStartOrder : dwPriority
#define	PRIORITY_NORMAL			(0)			// Normal
#define	PRIORITY_EXPRESS		(1)			// Express

// npsDevStartOrder : dwSortFrame
#define	SORTFRAME_DISABLE		(0)			// Disable
#define	SORTFRAME_ENABLE		(1)			// Enable 

// npsDevStartOrderEx : dwExOptions	gIvV(Pvg) BitORŎw 2014.10.28 M.Yamamoto
#define	EX_OPTIONS_NONE			(0x00000000)	// wȂ
#define	EX_OPTIONS_SINGLE_LINE	(0x00000001)	// Pvg


// npsDevPrint : NPS_PrintInfo : dwSourceType
#define	IMGSRC_SHAREDMEM		(0)			// shared memory 
#define	IMGSRC_FILE				(1)			// file 

// npsDevPrint : NPS_PrintInfo : dwImageFormat
#define	IMGFMT_JPEG				(0)			// JPEG TYPE1
#define	IMGFMT_BMP				(1)			// Bitmap TYPE1
#define	IMGFMT_RAW24			(2)			// RGB 24 bit color dot sequential 
#define	IMGFMT_RGB48_H12_LSB	(3)			// RGB 48 bit color dot sequential - Effective 12 high rank bits - Little Endian
#define	IMGFMT_RGB48_L12_LSB	(4)			// RGB 48 bit color dot sequential - Effective 12 low rank bits  - Little Endian
#define	IMGFMT_BGR48_H12_LSB	(5)			// BGR 48 bit color dot sequential - Effective 12 high rank bits - Little Endian
#define	IMGFMT_BGR48_L12_LSB	(6)			// BGR 48 bit color dot sequential - Effective 12 low rank bits  - Little Endian
#define	IMGFMT_RGB48_H12_MSB	(7)			// RGB 48 bit color dot sequential - Effective 12 high rank bits - Big Endian
#define	IMGFMT_RGB48_L12_MSB	(8)			// RGB 48 bit color dot sequential - Effective 12 low rank bits  - Big Endian
#define	IMGFMT_BGR48_H12_MSB	(9)			// BGR 48 bit color dot sequential - Effective 12 high rank bits - Big Endian
#define	IMGFMT_BGR48_L12_MSB	(10)		// BGR 48 bit color dot sequential - Effective 12 low rank bits  - Big Endian
#define	IMGFMT_JPEG2			(11)		// JPEG TYPE2
#define	IMGFMT_BMP2				(12)		// Bitmap TYPE2
#define	IMGFMT_TIFF				(13)		// TIFF TYPE1
#define	IMGFMT_BMP_PATH			(14)		// ini-file (Bitmap TYPE1)

// npsDevPrint : NPS_PrintInfo : dwColorSpace
#define	ICS_SRGB				(0)			// sRGB
#define	ICS_ARGB				(1)			// AdobeRGB

// npsDevPrint : NPS_PrintInfo : dwFeed
#define	PAPER_ROLL				(0)			// Roll 
#define	PAPER_SHEET				(1)			// Sheet 

// npsDevPrint : NPS_PrintInfo : dwCvpPrintSize
#define	CVPSIZE_NORMAL			(0)			// Normal
#define	CVPSIZE_SMALL			(1)			// Small
#define	CVPSIZE_LARGE			(2)			// Large

// npsDevPrint : NPS_PrintInfo : wCMS
#define	PROC_CMSOFF				(0)			// OFF
#define	PROC_CMSONNORMAL		(1)			// ON (Normal)
#define	PROC_CMSONCUSTOM		(2)			// ON (Custom)

// npsDevPrint : NPS_PrintInfo : wAngle
#define	PROC_ANGLE0				(0)			// 0
#define	PROC_ANGLE90			(1)			// 90
#define	PROC_ANGLE180			(2)			// 180
#define	PROC_ANGLE270			(3)			// 270

// npsDevPrint : NPS_PrintInfo : wPaperFitting
#define	PROC_REALSIZE			(0)			// Real size (Top)
#define	PROC_CUT				(1)			// Cut
#define	PROC_OVERALL			(2)			// Overall
#define	PROC_REALSIZECNTR		(3)			// Real size (Center)

// npsDevPrint : NPS_PrintInfo : wEdgeEnhancement
#define	PROC_EE_OFF				(0)			// OFF
#define	PROC_EE_ON				(1)			// ON

// npsDevPrint : NPS_PrintInfo : PrintQuality
#define	PROC_PRNQLT_PRINTER		(0)			// 
#define	PROC_PRNQLT_NORMAL		(1)			// 
#define	PROC_PRNQLT_QUALITY1	(2)			// 

// npsDevPrint : NPS_PrintInfo : byImageEnlargeType
#define	PROC_IMGENLG_BILINEAR	(0)			// bi-linear
#define	PROC_IMGENLG_NNEIGHBOR	(1)			// nearest neighbor

// npsDevBlankPrint : NPS_BlankPrintInfo : dwClearInk
#define	CLEAR_INK_OFF			(0)			// 
#define	CLEAR_INK_ON			(1)			// 

// npsDevGetPrintStatus : pPrintStatus
#define	REQSTS_UNKNOWN			(1)			// Printing has been completed or the ID does not exist. 
#define	REQSTS_WAIT				(2)			// Waiting inside this library. 
#define	REQSTS_REQUEST			(3)			// Requesting printing. 
#define	REQSTS_EXEC				(4)			// Being processed in the printer (not come off the printer) 

// npsDevCtrlPrint : dwCtrl
#define	CTRL_STOP_FEED			(0)			// Ban start of the next printing operation. 
#define	CTRL_RESTART_FEED		(1)			// Lift a ban and resume printing operation. 

// NPSEVENTPROC : NPSEVENTINFO : dwOnOff
#define	EVENT_OFF				(0)			// Event occurred
#define	EVENT_ON				(1)			// Event cleared 

// NPSCOMPLETIONPROC : dwCompletionCode
#define	COMPLETION_PRINT		(0)			// Printing completed
#define	COMPLETION_ORDER		(3)			// Order completed

// NPSCOMPLETIONPROC : NPSPRINTINFO : dwStatus
// NPSCOMPLETIONPROC : NPSORDERINFO : dwStatus
#define	RESULT_OK				(0)			// Order was fulfilled successfully
#define	RESULT_NG				(1)			// Abnormal end 
#define	RESULT_USER_CANCEL		(2)			// Canceled by the user 
#define	RESULT_TRANSFER			(4)			// Transfer completed 
#define	RESULT_PRINT			(11)		// Print completed 
#define	RESULT_OK_REPEAT		(20)		// Order was fulfilled successfully (Repeat)
#define	RESULT_PRINT_REPEAT		(21)		// Print completed (Repeat)
#define	RESULT_LOADING			(30)		// Loading start
#define	RESULT_LOADING_REPEAT	(31)		// Loading start (Repeat)
#define	RESULT_OK_RETRANSMISSION	(40)	// Order was fulfilled successfully (for Retransmission)

// NPSUNITPROC : NPSUNITNOTIFYINFO : lUnitId
#define	INFO_PRINTER			0x50000000	// Overall printer status
#define	INFO_ADVANCE			0x54000000	// Advance section
#define	INFO_LASER				0x55300000	// Optic laser
#define	INFO_DEVELOPMENT		0x56000000	// Development section
#define	INFO_PROCESSOR			0x56100000	// Processing tanks
#define	INFO_REPLENISHER		0x56300000	// Replenishment section
#define	INFO_REPLACECARTRIDGE	0x56360000	// replenishment cartridge
#define	INFO_ACCEPT				0x61000000	// Order receipt
#define	INFO_POSSESSION			0x62000000	// Printer occupancy
#define	INFO_INSTMAG			0x63000000	// Paper magazine installed
#define INFO_INFOMAG			0x64000000	// Paper magazine information
#define INFO_STARTCHECK			0x65000000	// Start up checks status
#define INFO_REFILLWATER		0x66000000	// Refill water status
#define INFO_DAILYSETUP			0x67000000	// Daily setup status
#define INFO_CNTRSTRP			0x68000000	// Process control strip status
#define INFO_MNTNNC				0x69000000	// Printer occupancy status of Maintenance
#define INFO_FAD				0x70000000	// FAD status


// NPSUNITPROC : NPSUNITNOTIFYINFO : lUnitId = INFO_INSTMAG : iNewStatus, iOldStatus
#define	INFO_MAGINSTCHANGE		(0)			// Change magazine installed

// NPSUNITPROC : NPSUNITNOTIFYINFO : lUnitId = INFO_INFOMAG : iNewStatus, iOldStatus
#define	INFO_MAGINFOCHANGE		(0)			// Change magazine information

// npsSetCompletionProcMode : dwMode
#define	NPS_PRINT_DETAIL_NOTIFY_ENABLE		0x00000001	// 
#define	NPS_OUTPUT_DETAIL_NOTIFY_ENABLE		0x00000002	// 
#define	NPS_LOADING_DETAIL_NOTIFY_ENABLE	0x00000004	// 

#define NPS_HPRIN_ALL			((HPRINTER)0xffffffff)	//!< Handle to specify all printers (currently for npsDevCloseCheck)
typedef void* HPRINTER;

typedef struct {
	DWORD	dwYear;			// Year				1980-2079
	DWORD	dwMonth;		// Month			1-12
	DWORD	dwDay;			// Day				1-31
	DWORD	dwDayofweek;	// Day of the week 	0(Sun)-6(Sat)
} NPS_Date, *PNPS_Date;

typedef struct {
	DWORD	dwHour;		// Hour 	0-23
	DWORD	dwMinute;	// Minute 	0-59
	DWORD	dwSecond;	// Second 	0-59
} NPS_Time, *PNPS_Time;

typedef struct {
	NPS_Date	tDate;	// Date 
	NPS_Time	tTime;	// Time 
} NPS_DateTime, *PNPS_DateTime;

typedef struct {
	DWORD	dwIPAddress;			// Printer IP address 
	char	szMachineTypeName[20];	// Model name 
	char	szSoftName[20];			// Software information
	char	szSerialNumber[20];		// Serial number 
	WORD	wSupportResolutions[8];	// Resolution(unit: 0.1 dpi) 
	WORD	wNpsVersion;			// NPS I/F version 
	unsigned char MacAddress[6];	// Mac address 
	unsigned char Reserve[32];		// Reserved (Unused) 
} NPS_PRINTER_ENUM, *PNPS_PRINTER_ENUM;

typedef struct {
	DWORD	dwPrinterStatus;			// Overall printer status 
	DWORD	dwAcceptStatus;				// Order receipt status 
	DWORD	dwPrinterPossession;		// Printer occupancy 
	DWORD	dwAdvanceStatus;			// Advance section 
	DWORD	dwLaserStatus;				// Optic laser 
	DWORD	dwDevelopmentStatus;		// Development section 
	DWORD	dwProcessorStatus;			// Processing tanks 
	DWORD	dwReplenisherStatus;		// Replenishment section 
	DWORD	dwReplaceCartridgeStatus;	// Whether the replenishment cartridge can be replaced or not
	DWORD	dwStartUpChecksStatus;		// Start up checks status
	DWORD	dwRefillWaterStatus;		// Refill water status
	DWORD	dwDailySetupStatus;			// Daily setup status
	DWORD	dwControlStripStatus;		// Process control strip status
	DWORD	dwMaintenanceStatus;		// Printer occupancy status of Maintenance
	DWORD	dwFadStatus;				// FAD status
	unsigned char Reserve[24];			// Reserved (Unused) 
} NPS_UnitInfo, *PNPS_UnitInfo;

typedef struct {
	DWORD	dwWidth;			// Paper width(unit: 0.1 mm)
	DWORD	dwSurface;			// Paper surface 
	DWORD	dwRemain;			// Remaining length of the paper(unit: 0.1 mm)
	DWORD	dwFeed;				// Feed method 
	DWORD	dwPresence;			// Magazine installation status 
	char	szName[32];			// Paper name
	unsigned char Reserve[32];	// Reserved (Unused) 
} NPS_MagInfo, *PNPS_MagInfo;

typedef struct {
	char			szMachineTypeName[20];	// Model name 
	char			szSoftName[20];			// Software information
	char			szSerialNumber[20];		// Serial number 
	WORD			wSupportResolutions[8];	// Resolution(unit: 0.1 dpi) 
	WORD			wNpsVersion;			// NPS I/F version 
	WORD			wMachineTypeID;			// Model type 
	DWORD			dwTotalMemory;			// Total memory capacity of the printer(unit: Byte) 
	DWORD			dwImageSizeMinWidth;	// Acceptable minimum width for image to receive (Unit: pixel) 
	DWORD			dwImageSizeMinHeight;	// Acceptable minimum height for image to receive (Unit: pixel) 
	DWORD			dwImageSizeMaxWidth;	// Acceptable maximum width for image to receive (Unit: pixel) 
	DWORD			dwImageSizeMaxHeight;	// Acceptable maximum height for image to receive (Unit: pixel) 
	WORD			dwNumberOfMagazine;		// Number of the paper magazines that can be installed
	NPS_DateTime	PrinterTime;			// Date set to the printer 
	DWORD			dwRepeatCountMax;		// Acceptable maximum repeat count 
	char			SupportImageFormat[32];	// Supported image format 
	WORD			wLaminatorUnitAttach;	// Presence of the laminator unit 
	NPS_Date		InstallationDate;		// Installation date 
	NPS_Date		OperationStartDate;		// Operation start date 
	WORD			wProcessorType;			// Processor type 
	WORD			wEmulsionNumber;		// Process method 
	char			szPrinterNickname[13];	// User-defined printer name 
	WORD			wSupportAngle;			// Supported image rotation angle 
	WORD			wSupportIntoPrinter;	// Interruption 
	WORD			wSorterStatus;			// Number of the sorter trays 
	WORD			wCvpStatus;				// Number of CVP lines 
	WORD			wSupportPaperFitting;	// Supported paper fitting
	WORD			wSupportEdgeEnhancement;// Supported edge enhancement
	WORD			wSupportWithBorder;		// Supported with border
	WORD			wMachinTypeForProfile;	// Machin type for profile
	WORD			wPaperTypeCode[6];		// Paper type code
	WORD			wSupportCMS;			// Supported CMS
	WORD			wSetupAlgorithm;		// Setup Algorithm
	WORD			wSupportDuplex;			// Supported duplex printing
	DWORD			dwFadAttachNo;			// Full auto dispenser
	WORD			wSupportInterrupt;		// Supported interrupt
	unsigned char	Reserve[22];			// Reserved (Unused) 
} NPS_SetUpInfo, *PNPS_SetUpInfo;

typedef struct {
	DWORD	dwSdkReserver;		// Number of print data not printed yet in the library 
	DWORD	dwFrmRatio;			// Frame memory utilization 
	DWORD	dwReserver;			// Number of print data waiting to be printed 
	DWORD	dwPrtNumber;		// Number of print data in the printer 
	DWORD	dwProNumber;		// Number of print data in the processor 
	DWORD	dwTotalCount;		// Total number of print data in the library 
	unsigned char Reserve[32];	// Reserved (Unused) 
} NPS_PrintNumInfo, *PNPS_PrintNumInfo;

typedef struct {
	DWORD	dwImageFormat;		// Image format 
	DWORD	dwColorSpace;		// Color space
	DWORD	dwSourceType;		// Delivery method of the image data 
	DWORD	dwDataLength;		// Size in byte of the image data (unit: Byte) 
	LPCSTR	pName;				// File mapping object name or filename
	DWORD	dwOffset;			// Offset position where the image data is stored 
	DWORD	dwImgWidth;			// Image width (Unit: pixel) 
	DWORD	dwImgHeight;		// Image height (Unit: pixel) 
	DWORD	dwResolution;		// Resolution (Unit: 0.1 dpi) 
	DWORD	dwPaperWidth;		// Paper width (Unit: 0.1 mm) 
	DWORD	dwPaperLength;		// Paper advance length (Unit: 0.1 mm) 
	DWORD	dwCvpPrintSize;		// CVP print size
	DWORD	dwCvpInitialValue1;	// Initial value for the serial number to be printed in the 1st line of CVP 
	DWORD	dwCvpPoint1;		// Position where the serial number is inserted in the 1st line of CVP 
	DWORD	dwCvpInitialWidth1;	// Digit of serial number to be printed in the 1st line of CVP 
	char	szCvpLine1[256];	// Character data of the 1st line of CVP 
	DWORD	dwCvpInitialValue2;	// Initial value for the serial number to be printed in the 2nd line of CVP 
	DWORD	dwCvpPoint2;		// Position where the serial number is inserted in the 2nd line of CVP 
	DWORD	dwCvpInitialWidth2;	// Digit of serial number to be printed in the 2nd line of CVP 
	char	szCvpLine2[256];	// Character data of the 2nd line of CVP 
	DWORD	dwPrintNum;			// Print quantity 
	DWORD	dwFeed;				// Feed method 
	DWORD	dwSurface;			// Paper surface 
	DWORD	dwPaperPresence;	// Specify the paper magazine (magazine number of the installed magazine) 
	short	nEspc;				// Exposure start position correction (Unit: 0.1 mm) 
	WORD	wCMS;				// CMS
	WORD	wAngle;				// Angle
	WORD	wPaperFitting;		// Paper fitting
	WORD	wEdgeEnhancement;	// Edge enhancement
	WORD	wWithBorderTop;		// With border top
	WORD	wWithBorderBottom;	// With border bottom
	WORD	wWithBorderLeft;	// With border left
	WORD	wWithBorderRight;	// With border right
	BYTE	byWithBorderColor[3];// With border color
	char	szPaperName[32];	// Paper name
	short	nPcfms;				// Position correction for main scan (Unit: 0.1 mm)
	WORD	wPrintQuality;		// Print quality
	BYTE	byImageEnlargeType;	// Image enlarge algorithm
	WORD	wLoadingCount;		// Loading count
	WORD	wPrintedCount;		// Printed count
	DWORD	dwEventId;			// Event Id
	WORD	wEventCodeMain;		// Event Code (Main No.)
	unsigned char Reserve[51];	// Reserved (Unused) 
} NPS_PrintInfo, *PNPS_PrintInfo;

typedef struct {
	DWORD	dwWidth;			// Paper width(unit: 0.1 mm)
	DWORD	dwLengthMin;		// Minimum paper advance length(unit: 0.1 mm)
	DWORD	dwLengthMax;		// Maximum paper advance length(unit: 0.1 mm)
	DWORD	dwSurface;			// Paper surface 
	DWORD	dwResolution[8];	// Input resolution(unit: 0.1 dpi)
	short	nAllocationTop;		// Allocation top (unit: 0.1 mm)
	short	nAllocationBottom;	// Allocation bottom (unit: 0.1 mm)
	short	nAllocationLeft;	// Allocation left (unit: 0.1 mm)
	short	nAllocationRight;	// Allocation right (unit: 0.1 mm)
	DWORD	dwSetupStatus;		// Setup status
	DWORD	dwFeed;				// Feed method
	short	nWBAdjustLeft;		// WB correction (left)
	short	nWBAdjustRight;		// WB correction (right)
	char	szPaperName[32];	// Paper name
	WORD	wPaperTypeCode;		// Paper type code
	WORD	wDirection;			// (Unused) 
	WORD	wPrintQuality;		// (Unused)
	unsigned char PaperTypeValid;// Paper type [Valid/Invalid] Information
	unsigned char PaperType;	// Paper type
	unsigned char Reserve[30];	// Reserved (Unused) 
} NPS_MagDetailInfo, *PNPS_MagDetailInfo;

typedef struct {
	DWORD	dwWidth;			// Paper width(unit: 0.1 mm)
	DWORD	dwSurface;			// Paper surface
	DWORD	dwFeed;				// Feed method
	char	szPaperName[32];	// Paper name
	unsigned char Reserve[32];	// Reserved (Unused) 
} NPS_PaperInfo, *PNPS_PaperInfo;

typedef struct {
	HPRINTER	hPrinter;		// Handle of the printer where the event occurred 
	DWORD		dwIPAddress;	// IP address of the printer where the event occurred 
	DWORD		dwErrHandle;	// Handle to be used for event clear 
	SYSTEMTIME	sysTime;		// Time when the event occurred
	DWORD		dwErrCode;		// Event code (main) 
	DWORD		dwOnOff;		// Event occurrence and clear 
	long		alParams[4];	// Event parameter 
	char		szStrings[4][32];// (Unused) 
	unsigned char Reserve[16];	// Reserved (Unused) 
} NPSEVENTINFO, *PNPSEVENTINFO;

typedef struct {
	HPRINTER	hPrinter;		// Handle of the printer where the event occurred
	DWORD		dwIPAddress;	// IP address of the printer where the event occurred
	SYSTEMTIME	sysTime;		// Time when the event occurred
	DWORD		dwPrintId;		// Print ID 
	DWORD		dwStatus;		// Processing result 
	DWORD		dwFinishNum;	// Number of processed image data
	USHORT		wPortNo;		// Port No of the printer where the event occurred
	unsigned char	Reserve[14];// Reserved (Unused) 
} NPSPRINTINFO, *PNPSPRINTINFO;

typedef struct {
	HPRINTER	hPrinter;		// Handle of the printer where the event occurred
	DWORD		dwIPAddress;	// IP address of the printer where the event occurred
	SYSTEMTIME	sysTime;		// Time when the event occurred
	DWORD		dwOrderId;		// Order ID
	DWORD		dwStatus;		// Processing result
	USHORT		wPortNo;		// Port No of the printer where the event occurred
	unsigned char	Reserve[14];// Reserved (Unused) 
} NPSORDERINFO, *PNPSORDERINFO;

typedef struct {
	HPRINTER	hPrinter;		// Handle of the printer where the event occurred 
	DWORD		dwIPAddress;	// IP address of the printer where the event occurred
	long		lUnitId;		// ID of the unit where the change occurred
	short		iNewStatus;		// New status 
	short		iOldStatus;		// Former status 
	USHORT		wPortNo;		// Port No of the printer where the event occurred
	unsigned char	Reserve[14];// Reserved (Unused) 
} NPSUNITNOTIFYINFO, *PNPSUNITNOTIFYINFO;

typedef struct {
	DWORD		dwResolution;
	DWORD		dwPaperWidth;
	DWORD		dwPaperLength;
	DWORD		dwPrintNum;
	DWORD		dwFeed;
	DWORD		dwSurface;
	DWORD		dwPaperPresence;
	char		szPaperName[32];
	DWORD		dwClearInk;
	WORD		wPrintQuality;
	WORD		wLoadingCount;		// Loading count
	WORD		wPrintedCount;		// Printed count
	DWORD		dwEventId;			// Event Id
	WORD		wEventCodeMain;		// Event Code (Main No.)
	unsigned char Reserve[52];
} NPS_BlankPrintInfo, *PNPS_BlankPrintInfo;

typedef VOID (CALLBACK* NPSEVENTPROC)( PNPSEVENTINFO pEventInfo );
typedef VOID (CALLBACK* NPSUNITPROC)( PNPSUNITNOTIFYINFO pUnitInfo );
typedef VOID (CALLBACK* NPSCOMPLETIONPROC)( DWORD dwCompletionCode, PVOID pCompletionInfo );

extern "C" {
long NPS_API npsLibOpen( LPCSTR lpLogFileName );
long NPS_API npsLibClose();
long NPS_API npsGetNpsVersion( LPWORD pNpsVersion );
long NPS_API npsSearchPrinter( LPWORD pPrinterNum, DWORD dwWaitTime=6000 );
long NPS_API npsGetPrinter( WORD wBufferNum, PNPS_PRINTER_ENUM pPrinterInfo );
long NPS_API npsDevOpen( DWORD dwIPAddress, HPRINTER* phPrinter, NPSEVENTPROC pEventProc, NPSUNITPROC pUnitProc );
long NPS_API npsDevClose( HPRINTER hPrinter );
long NPS_API npsDevGetUnitInfo( HPRINTER hPrinter, PNPS_UnitInfo pUnitInfo );
long NPS_API npsDevGetMagInfo( HPRINTER hPrinter, PNPS_MagInfo pMagInfo, DWORD* pdwSize );
long NPS_API npsDevGetSetUpInfo( HPRINTER hPrinter, PNPS_SetUpInfo pSetUpInfo );
long NPS_API npsDevGetPrintNumInfo( HPRINTER hPrinter, PNPS_PrintNumInfo pPrintNumInfo );
long NPS_API npsDevResetEvent( HPRINTER hPrinter, DWORD dwErrHandle, DWORD dwActionId );
long NPS_API npsDevIsReady( HPRINTER hPrinter );
long NPS_API npsDevStartOrder( HPRINTER hPrinter, DWORD* pdwOrderId, NPSCOMPLETIONPROC pEventProc, DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame );
long NPS_API npsDevStartOrderEx( HPRINTER hPrinter, DWORD* pdwOrderId, NPSCOMPLETIONPROC pEventProc, DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame, DWORD dwExOptions );
long NPS_API npsDevEndOrder( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevPrint( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_PrintInfo pPrintInfo );
long NPS_API npsDevSort( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevCancelPrintOrder( HPRINTER hPrinter, DWORD dwOrderId, DWORD dwPrintID );
long NPS_API npsDevGetPrintStatus( HPRINTER hPrinter, DWORD dwPrintID, LPDWORD pPrintStatus );
long NPS_API npsDevSetTime( HPRINTER hPrinter, PNPS_DateTime pTime );
long NPS_API npsDevGetTime( HPRINTER hPrinter, PNPS_DateTime pTime );
long NPS_API npsDevCloseCheck( HPRINTER hPrinter );
long NPS_API npsDevGetAllMagInfo( HPRINTER hPrinter, PNPS_MagDetailInfo pMagDetailInfo, DWORD* pdwSize );
long NPS_API npsDevCtrlPrint( HPRINTER hPrinter, DWORD dwCtrl );
long NPS_API npsDevExpressOrder( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevGetProfile( HPRINTER hPrinter, LPCSTR lpFileName, PNPS_PaperInfo pPaperInfo );
long NPS_API npsSetCompletionProcMode( DWORD dwMode );
long NPS_API npsDevStartDuplex( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevEndDuplex( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevBlankPrint( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, PNPS_BlankPrintInfo pBlankPrintInfo );
}	// extern "C" 


//////////////////////////////////////////////////////////////////////////////(Withheld)

// npsSetCustomMode : dwMode
#define	NPSCTM_QSSVERCHK_OFF	0x00000001
#define	NPSCTM_OFFLINECHK_ON	0x00000002
#define	NPSCTM_CMSTBLMAKE_ON	0x00000004
#define	NPSCTM_PAPERCHK_OFF		0x00000008

typedef struct {
	NPS_PrintInfo		printInfo;
	LPCSTR				pIccsCmdFilePath;
} NPS_PrintInfoIccsXml, *PNPS_PrintInfoIccsXml;

typedef struct {
	WORD		wOrderState;	// Cancel order status
	WORD		wMainSideState;	// Main side status
	WORD		wBackSideState;	// Back side status
	WORD		wPrintSide;		// Print side
	unsigned char Reserve[32];	// Reserved (Unused)
} NPS_InterruptOrderInfo, *PNPS_InterruptOrderInfo;

typedef struct {
	DWORD		dwPrintId;			// Print ID 
	DWORD		dwEventId;			// Event Id 
	WORD		wEventCodeMain;		// Event code (main) 
	unsigned char Reserve[16];		// Reserved (Unused) 
} NPSEVENTINFOEX, *PNPSEVENTINFOEX;

typedef VOID (CALLBACK*  RECVPROC)( WORD wIfId, WORD wRecvCmdId, LPVOID lpRecvBuf, WORD RecvBufLen, long Result );
typedef VOID (CALLBACK*  NOTICEPROC)( HPRINTER hPrinter, DWORD dwIPAddress, WORD wIfId, WORD wCmdId, LPVOID lpBuf, WORD wBufLen );
typedef VOID (CALLBACK* NPSEVENTPROCEX)( PNPSEVENTINFOEX pEventInfoEx );

extern "C" {
long NPS_API npsSearchPrinter2( LPWORD pPrinterNum, DWORD dwWaitTime=6000 );
long NPS_API npsDevNpsCommand1( HPRINTER hPrinter, WORD wIfId, WORD wSendCmdId, WORD wSendBufLen, LPVOID lpSendBuf, WORD wRecvCmdId, LPWORD pwRecvBufLen, LPVOID lpRecvBuf, DWORD dwTimeOut );
long NPS_API npsDevNpsCommand2( HPRINTER hPrinter, WORD wIfId, WORD wSendCmdId, WORD wSendBufLen, LPVOID lpSendBuf, WORD wRecvCmdId, LPWORD pwRecvBufLen, RECVPROC pRecvProc, DWORD dwTimeOut );
long NPS_API npsDevNpsNotice( HPRINTER hPrinter, WORD wIfId, WORD wCmdId, NOTICEPROC pNoticeProc );
long NPS_API npsDevCancelPrintAll( HPRINTER hPrinter );
long NPS_API npsDevOccupyCheck( HPRINTER hPrinter );
long NPS_API npsSetLanguage( LPCSTR lpLangName );
long NPS_API npsSetCustomMode( DWORD dwMode );
long NPS_API npsSetConnectMode( DWORD dwMode );
long NPS_API npsDevGetTransmitTime( HPRINTER hPrinter, LPDWORD pOrderId, LPDWORD pPrintID, LPDWORD pTime );
long NPS_API npsSetTempFolder( LPCSTR lpFolderName );
long NPS_API npsDevPrintIccsXml ( HPRINTER hPrinter, DWORD dwOrderId, LPDWORD pPrintID, NPSCOMPLETIONPROC pEventProc, short priority, PNPS_PrintInfoIccsXml pPrintInfo );
long NPS_API npsDevStartFAD( HPRINTER hPrinter, DWORD dwOrderId, LPCSTR lpOrderKey, LPDWORD lpdwResult, WORD wFadOut, LPCSTR lpFadFileName );
long NPS_API npsDevAdjustForPrint( HPRINTER hPrinter );
long NPS_API npsDevStartRetransmission( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo );
long NPS_API npsDevEndRetransmission( HPRINTER hPrinter, DWORD dwOrderId );
long NPS_API npsDevInterruptPrintOrder( HPRINTER hPrinter, DWORD dwOrderId, PNPS_InterruptOrderInfo pInterruptOrderInfo );
long NPS_API npsDevNpsNoticeEventProcEx( HPRINTER hPrinter, NPSEVENTPROCEX 	pEventProcEx );
}	// extern "C" 

#pragma pack(pop)

#endif	// _NPS_H_
