//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : DrawObjImage.cpp
//	ABSTRACT  : CDrawObjImage NX̃Cve[V
//	
//	CREATE    : T.Isogai	2009.11.25
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DrawObjImage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::CDrawObjImage()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDrawObjImage::CDrawObjImage()
{
	m_bBmpAccess	= FALSE;
	m_pData			= NULL;
	m_DataSize		= 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::~CDrawObjImage()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDrawObjImage::~CDrawObjImage()
{
	End();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::End()
//	ABSTRACT : I
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDrawObjImage::End()
{
	if(m_bBmpAccess)
	{
		CloseBmpFile();
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::OpenBmpFile()
//	ABSTRACT : rbg}bvANZXJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDrawObjImage::OpenBmpFile()
{
	try
	{
		//--------------------------
		// t@CI[v
		//--------------------------
		CFileException ex;

		if( !m_File.Open(m_strFilePath,
			CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone, &ex) )
		{
			TCHAR szCause[1024];
			ex.GetErrorMessage(szCause, 1024);
			m_strLastError.Format("Error File Open : %s / %s(%d)", m_strFilePath, szCause, ex.m_cause);
			return FALSE;
		}

		//--------------------------
		// wb_̓ǂݍ
		//--------------------------
		m_File.Read(&m_FileHeader, sizeof(BITMAPFILEHEADER));
		m_File.Read(&m_InfoHeader, sizeof(BITMAPINFOHEADER));
	}
	catch (CFileException* e)
	{
		TCHAR szCause[255];
		e->GetErrorMessage( szCause, 255 );
		m_strLastError.Format("Error Header Read : %s / %s(%d)", m_strFilePath, szCause, e->m_cause);
		e->Delete();
		return FALSE;
	}

	//--------------------------
	// 
	//--------------------------
	m_bBmpAccess = TRUE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::LoadBmpFile()
//	ABSTRACT : rbg}bvANZXǂݍ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	ARGUMENT :	rect	ǂݍ݈ʒu
//	
//	RETURN   : 
//				TRUE	
//				FALSE	s
//	
//	CREATE	 : T.Isogai	2009.12.04	EZ Controller 6x6C` tHgubNΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDrawObjImage::LoadBmpFile(RECT rect)
{
	//--------------------------------------------------------------------------------
	// <ꂩs̐>
	// @obt@m
	// @݂܂łɃobt@mۂĂȂA܂́A݊mۂĂobt@傫obt@KvłƂA
	// @rbg}bvt@Cf[^ǂݍނ߂̃obt@mۂ
	// Aǂݍ
	// @Ŏw肳Ăǂݍ݈ʒũf[^A
	// @rbg}bvt@C@Ŋmۂobt@ɓǂݍ
	//--------------------------------------------------------------------------------

	int nDataSize = (rect.right - rect.left + 1) * (rect.bottom - rect.top + 1) * 3;

	//---------------------
	// @obt@m
	//---------------------
	if(nDataSize > m_DataSize)
	{
		if(m_pData)
		{
			delete []m_pData;
		}

		m_pData = new unsigned char[nDataSize];

		if((0 != nDataSize) && (NULL == m_pData))
		{
			m_strLastError.Format("Error Memory Allocate %d Byte", nDataSize);
			return FALSE;
		}
	}

	m_DataSize = nDataSize;

	//---------------------
	// Aǂݍ
	//---------------------
	try
	{
		int nDataPos = 0;
		int nLineDataSize = (rect.right - rect.left + 1) * 3;
		int nOffset = 0;

		for(int y = rect.top; y <= rect.bottom; y++)
		{
			nOffset = NkcComApi::RowByte(m_InfoHeader.biWidth) * (m_InfoHeader.biHeight - (m_Trim1.top + y) - 1) + (m_Trim1.left + rect.left) * 3;
			m_File.Seek(m_FileHeader.bfOffBits + nOffset ,CFile::begin);
			
			m_File.Read(m_pData + nDataPos, nLineDataSize);
			nDataPos += nLineDataSize;
		}
	}
	catch (CFileException* e)
	{
		TCHAR szCause[255];
		e->GetErrorMessage( szCause, 255 );
		m_strLastError.Format("Error Data Read : %s / %s(%d)", m_strFilePath, szCause, e->m_cause);
		e->Delete();
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::CloseBmpFile()
//	ABSTRACT : I
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				TRUE	
//				FALSE	s
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDrawObjImage::CloseBmpFile()
{
	//--------------------------
	// t@CN[Y
	//--------------------------
	m_File.Close();

	//--------------------------
	// ľn
	//--------------------------
	if(m_pData)
	{
		delete []m_pData;
		m_pData = NULL;
	}

	m_DataSize		= 0;
	m_bBmpAccess	= FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDrawObjImage::Draw()
//	ABSTRACT : ẅ`
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				pData	݃obt@
//				rect	݃obt@̈ʒui`̈Ŝɑ΂ʒuj
//
//	RETURN   :	G[R[h
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDrawObj::ECODE CDrawObjImage::Draw(unsigned char* pData, RECT rect)
{
	//--------------------------------------------------------------------------------
	// <ꂩs̐>
	// @摜`ʒuw肳ꂽobt@̈ʒuǂ`FbNi͈͊OȂȍ~Ȃj
	// A`FbNi摜rbg}bvt@CI[vĂ邩`FbNj
	// B摜rbg}bvt@C̓ǂݍݕKv̈Zo
	// CKv̈̓ǂݍ݁iBŎZoǂݍݕKv̈ǂݍށj
	// D݁inꂽobt@ɇCœǂݍ񂾉摜ށj
	//--------------------------------------------------------------------------------

	//--------------------------------------------------------------------------------
	// @摜`ʒuw肳ꂽobt@̈ʒuǂ`FbNi͈͊OȂȍ~Ȃj
	//--------------------------------------------------------------------------------
	if(
		// XW`FbN
		((m_Trim2.left > rect.right) || (m_Trim2.right < rect.left)) ||

		// YW`FbN
		((m_Trim2.top > rect.bottom) || (m_Trim2.bottom < rect.top))
		)
	{
		// ͈͊O
		if(m_bBmpAccess)
		{
			CloseBmpFile();
		}
		return SUCCESS;
	}

	//--------------------------------------------------------------------------------
	// A`FbNi摜rbg}bvt@CI[vĂ邩`FbNj
	//--------------------------------------------------------------------------------
	if(FALSE == m_bBmpAccess)
	{
		if(FALSE == OpenBmpFile())
		{
			return ERR_BITMAP;
		}
	}

	//--------------------------------------------------------------------------------
	// B摜rbg}bvt@C̓ǂݍݕKv̈Zo
	//--------------------------------------------------------------------------------
	RECT Trim;			// ͉摜oʒu
	int OffsetX = 0;	// 摜oItZbgʒu X
	int OffsetY = 0;	// 摜oItZbgʒu Y

	//-----------------------------------
	// LEFT
	if(m_Trim2.left < rect.left)
	{
		Trim.left = rect.left - m_Trim2.left;
		OffsetX = 0;
	}
	else
	{
		Trim.left = 0;
		OffsetX = m_Trim2.left - rect.left;
	}

	//-----------------------------------
	// RIGHT
	if(m_Trim2.right < rect.right)
	{
		Trim.right = m_Trim2.right - m_Trim2.left;
	}
	else
	{
		Trim.right = rect.right - m_Trim2.left;
	}

	//-----------------------------------
	// TOP
	if(m_Trim2.top < rect.top)
	{
		Trim.top = rect.top - m_Trim2.top;
		OffsetY = 0;
	}
	else
	{
		Trim.top = 0;
		OffsetY = m_Trim2.top - rect.top;
	}

	//-----------------------------------
	// BOTTOM
	if(m_Trim2.bottom < rect.bottom)
	{
		Trim.bottom = m_Trim2.bottom - m_Trim2.top;
	}
	else
	{
		Trim.bottom = rect.bottom - m_Trim2.top;
	}

	//--------------------------------------------------------------------------------
	// CKv̈̓ǂݍ݁iBŎZoǂݍݕKv̈ǂݍށj
	//--------------------------------------------------------------------------------

	// rbg}bv䂦̏㉺t]l

	if(FALSE == LoadBmpFile(Trim))
	{
		return ERR_BITMAP;
	}

	//--------------------------------------------------------------------------------
	// D݁inꂽobt@ɇCœǂݍ񂾉摜ށj
	//--------------------------------------------------------------------------------
	int x1;
	int y1;
	int x2;
	int y2;
	unsigned char* pTmp1;
	unsigned char* pTmp2;
	int Width		= Trim.right - Trim.left + 1;
	int Height		= Trim.bottom - Trim.top + 1;
	int BmpRowByte = Width * 3;
	int BufRowByte = NkcComApi::RowByte(rect.right - rect.left + 1);

	// rbg}bv䂦̏㉺t]l
	
	for(int x = 0; x < Width; x++)
	{
		for(int y = 0; y < Height; y++)
		{
			x1 = x;
			y1 = Height - y -1;

			x2 = OffsetX + x;
			y2 = rect.bottom - rect.top - (OffsetY + y1);

			pTmp1 = m_pData + BmpRowByte * y1 + 3 * x1;
			pTmp2 = pData + BufRowByte * y2 + 3 * x2;

			pTmp2[0] = pTmp1[0];
			pTmp2[1] = pTmp1[1];
			pTmp2[2] = pTmp1[2];
		}
	}

	return SUCCESS;
}
