#ifndef NKC_IMAGE_FILE_H
#define NKC_IMAGE_FILE_H

/*
	m[c|@p File I/O Interface Base Class
*/

#if	defined(_MSC_VER)
	#if	defined(_NKC_CO_STATICLIB)
		#define	NKC_MODAL				/* Static Link Library 쐬ꍇ͕KvȂ */
	#elif	defined(_NKC_EXPORTING)
		#define	NKC_MODAL	__declspec(dllexport)
	#else
		#define	NKC_MODAL	__declspec(dllimport)
	#endif

#else	// _MSC_VER
	#define	NKC_MODAL
#endif	// _MSC_VER

typedef void * (*CREATE)(int ClassLevel);
typedef int * (*MAXLEVEL)();

// ErrorCodeꗗ
#define NKC_NO_ERROR					(0)
#define NKC_INVALID_OPEN_MODE			(1)		// OpenModes					[Open()]
#define NKC_INVALID_FORMAT_TYPE			(2)		// Format`s					[Open()]
#define NKC_INVALID_WRITE_TYPE			(3)		// ۑ`s					[Open()]
#define NKC_INVALID_PATH				(4)		// w肳ꂽPaths				[Open()]
#define NKC_FILE_ALREADY_OPEN			(5)		// OpenĂ				[Open()]
#define NKC_FILE_OPEN_ERROR				(6)		// FileOpenɎs					[Open()]
#define NKC_FILE_NOT_SUPPORTED			(7)		// SupportĂȂ摜Format	[Open()]
#define NKC_INVALID_LAYER_NUMBER		(8)		// w肳ꂽLayerԍȂ	[Open()]
#define NKC_FILE_NOT_OPENED				(10)	// FileOpenĂȂ			[Close()]
#define NKC_INVALID_IMAGE_FILE			(11)	// ReadOpenꂽ摜Filẻ摜s [Open()]
#define NKC_FILE_WRITE_ERROR_1			(12)	// Filȅ݂Error			[Write()]
#define NKC_FILE_WRITE_ERROR_2			(13)	// FileError					[Write()]
#define NKC_INVALID_IMAGE_SIZE			(14)	// ݉摜Sizes				[Write()]
#define NKC_FILE_READ_ERROR				(15)	// FileǍError					[Read()]
#define NKC_INVALID_IMAGE_HEADER		(16)	// wb_񂪕s					[Open()]
#define NKC_INVALID_EMBEDDED_DATA		(17)	// TlCȂǖߍݏ񂪕s	[Open()]
#define NKC_FILE_CLOSE_ERROR			(20)	// FileCloseɎs				[Close()]
#define NKC_GETSIZE_FUNCTION_ERROR		(30)	// 摜Size̎擾Error				[GetImageSize()]
#define NKC_SELECTIMAGE_FUNCTION_ERROR	(31)	// 摜̑IError					[SelectImage()]
#define NKC_INVALID_LINE				(88)	// 摜̓Ǎ/Lines	[Read(), Write()]
#define NKC_INVALID_IMAGE_BUFFER		(89)	// 摜pBuffers				[Read(), Write()]
#define NKC_INVALID_IMAGE_INDEX			(90)	// 摜Indexs					[GetImageSize()]
#define NKC_INVALID_EXIFTAGSIZE			(91)	// EXIF ^O񂪑傫		[Close()]	// (NFIO0020)
#define NKC_INVALID_NOEXIF				(92)	// EXIF t@Cł͂Ȃ			[GetExifTags]	// (NFIO0020)
#define NKC_INVALID_EXIFTHUMB			(93)	// EXIF TlC쐬G[		[Close()]	// (NFIO0020)
#define NKC_NON_SUPORTED_FUNCTION		(100)	// SupportĂȂ@\
#define NKC_FILE_IO_ERROR				(199)	// General File I/O Error
#define NKC_INVALID_INTERNAL_STATE		(200)	// ISL_CAM2֘AInternalError

// defined by Arcage
#define NKC_NON_SUPPORTED_FUNCTION		(100)	// (Typo)
#define NKC_MEMORY_ALLOCATION_ERROR		(201)	// mۂɎs

// 071024 MJ_1 7494~30144pixelΉ
#define	NKC_BIG_IMAGE_BUFFER		12		// mۃobt@TCY (P:MB)
#define	NKC_BIG_IMAGE_THRESHOLD1	13000	// ǂݍݕ@؂ւ臒l1	(P:sNZ)
#define	NKC_BIG_IMAGE_THRESHOLD2	5120	// ǂݍݕ@؂ւ臒l2	(P:sNZ)


/*
Class͑SẲ摜FormatɋʂȊ֐݂̂L鏃z֐݂̂ō\Base ClassƂĒ`܂B
Application͊{IɂClassInstanceeDLLɗpӂCreate( )֐gpč쐬܂B
*/
class NKC_Image_File {
public:
	// Open( )ŎgpOpenMode̒` ///////////////////////////////////////////////
	enum {
		// Open Mode: ȉ̂ÂꂩPI܂
		AllOpenMode = 3,		// SĂOpenMode̘a
		modeRead = 0,			// (Dafault)
		modeWrite = 1,
		modeThumbnailRead = 2,
		// Format`Fȉ̂ÂꂩPI܂
		AllFormatType = 0x70,	// SĂFormat`̘a
		BGR24 = 0,				// (Default)
		BGR32 = 0x10,
		RGB24 = 0x20,
		RGB32 = 0x40,
	};
public:
	virtual ~NKC_Image_File() {};
	// FileOpen ////////////////////////////////////////////////////////////////////
	virtual BOOL	Open( LPCTSTR path, UINT flags ) = 0;
	/*
	Input:	path	OpenFileւFullpath
			flags	Ǎ/݂̎wȂ(̐ݒ\)
			  Open Mode: ȉ̂ÂꂩPI܂
			  NKC_Image_File::modeRead			t@CǂݏopŊJ܂
			  NKC_Image_File::modeWrite			t@CݐpŊJ܂		  
			  NKC_Image_File::modeThumbnailRead TlCǍ݂̏ꍇ
			  Format`Fȉ̂ÂꂩPI܂
	 (Default)NKC_Image_File::BGR24				24bitDIB`̉摜Datagp
			  NKC_Image_File::BGR32				32bitDIB`̉摜Datagp
			  NKC_Image_File::RGB24				24bitRGB`̉摜Datagp
			  NKC_Image_File::RGB32				32bitRGB`̉摜Datagp
	*/
	// FileClose //////////////////////////////////////////////////////////////////
	virtual BOOL	Close( ) = 0;
	// LinePʂł̉摜̓Ǎ /////////////////////////////////////////////////////
	virtual int	Read( void * pbuf, int lines ) = 0;
	/*
	Input:	pbuf	摜ǂݍBufferւPointer
			Lines	ǂݍLine
	Return:	ۂɓǂݍ܂ꂽLine
	*/
	// LinePʂł̉摜̏ /////////////////////////////////////////////////////
	virtual int	Write( void * pbuf, int lines ) = 0;
	/*
	Input:	pbuf	މ摜BufferւPointer
			Lines	Line
	Return:	ۂɏ܂ꂽLine
	*/
	// Ǎݎ̋@\B摜Size̎擾 ///////////////////////////////////////////////
	virtual CSize	GetImageSize( int index = -1 ) = 0;
	/*
	𑜓xΉ摜̏ꍇ́A摜Indexw肵Ăꂼ̉𑜓x̉摜Size擾B
	Input:	index	摜Index(-1̏ꍇ͌ݎw肳Ă摜Index)
	Return:	w肳ꂽ摜Index̉摜Size
	*/
	// ݎ̋@\B摜Size̐ݒ ////////////////////////////////////////////////
	virtual BOOL	SetImageSize( CSize size ) = 0;
	/*
	Input:	size	މ摜Size
	Return:	ǂ
	*/
	// ŌɔErrorErrorCode̎擾 //////////////////////////////////////////
	virtual int	GetLastErrorCode( ) = 0;
	/*
	Return:	Error Code
	*/
};
#endif	// NKC_IMAGE_FILE_H
