#ifndef NKC_IMAGE_FILE_JPG_EXIFTAGS_L1_H
#define NKC_IMAGE_FILE_JPG_EXIFTAGS_L1_H
#include	<stdlib.h>
#include "NKC_Image_File_JPG_ExifTags.h"

//
// macro for ratio
//
#define	IS_RATIO_UNDEF(r)	(r.denominator == 0)

//
// Exif Tags Class
//
class NKC_Image_File_JPG_ExifTags_L1 : public NKC_Image_File_JPG_ExifTags
{
protected:
	char m_szMake[256];
	char m_szModel[256];
	char m_szSoftware[256];
	char m_szDateTime[256];
	char m_szDateTimeOriginal[256];
	char m_szDateTimeDigitized[256];
	char m_szSpectralSensitivity[256];
	char m_szExifVersion[256];
	char m_szInteroperabilityIndex[256];
	//*---------------------------
	LPBYTE	m_UserComment; //
	int		m_UserCommentCount;
	NKC_Image_File_JPG_ExifTags_StrCode		m_UserCommentStrCode;

	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_ExposureTime;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_FNumber;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_ApertureValue;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_MaxApertureValue;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_SubjectDistance;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_FocalLength;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_FlashEnergy;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_FocalPlaneXResolution;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_FocalPlaneYResolution;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_ExposureIndex;

	NKC_Image_File_JPG_ExifTags_SRational	m_sratio_ShutterSpeedValue;
	NKC_Image_File_JPG_ExifTags_SRational	m_sratio_BrightnessValue;
	NKC_Image_File_JPG_ExifTags_SRational	m_sratio_ExposureBiasValue;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_DigitalZoomRatio;
	NKC_Image_File_JPG_ExifTags_Rational	m_ratio_Magnification;
		
	int		m_ISOSpeedRatingsCount;
	WORD	m_ISOSpeedRatings[256];

	int		m_CFAPatternCount;
	BYTE	m_CFAPattern[256];

	int		m_SubjectAreaCount;
	WORD	m_SubjectArea[4];

	BOOL	b_SubjectLocation;
	WORD	m_SubjectLocation_x;
	WORD	m_SubjectLocation_y;

	BOOL	b_ExposureProgram;
	WORD	m_ExposureProgram;

	BOOL	b_MeteringMode;
	WORD	m_MeteringMode;

	BOOL	b_LightSource;
	WORD	m_LightSource;

	BOOL	b_Flash;
	WORD	m_Flash;

	BOOL	b_FocalPlaneResolutionUnit;
	WORD	m_FocalPlaneResolutionUnit;

	BOOL	b_SensingMethod;
	WORD	m_SensingMethod;

	BOOL	b_FileSource;
	WORD	m_FileSource;

	BOOL	b_SceneType;
	WORD	m_SceneType;

	BOOL	b_Orientation;
	WORD	m_Orientation;

	//new tags
	BOOL	b_CustomRendered;
	WORD	m_CustomRendered;

	BOOL	b_WhiteBalance;
	WORD	m_WhiteBalance;

	BOOL	b_FocalLengthIn35mmFilm;
	WORD	m_FocalLengthIn35mmFilm;

	BOOL	b_SceneCaptureType;
	WORD	m_SceneCaptureType;	

	BOOL	b_GainControl;
	WORD	m_GainControl;

	BOOL	b_Contrast;
	WORD	m_Contrast;

	BOOL	b_Saturation;
	WORD	m_Saturation;

	BOOL	b_Sharpness;
	WORD	m_Sharpness;

	BOOL	b_SubjectDistanceRange;
	WORD	m_SubjectDistanceRange;
	
	char	m_szImageUniqueID[256];

	char	m_szMetadataVersionNum[256];
	WORD	m_IntendedPrintArea;
	WORD	m_ImageSource;
	char	m_szScannerSoftware[256];
	WORD	m_ScanFramSeqNum;
	WORD	m_FilmSize;
	WORD	m_EditTagArray;
	
	char	m_szFilmProductCode[256];
	char	m_szCameraOwnerID[256];
	char	m_szGroupCaption[256];
	char	m_szOrderID[256];
	
	WORD	m_FilmCategory;	
	BOOL	b_FilmCategory;

	char	m_szFilmgenCode[256];

	//new tag 2006.11.15 NKC M.Uetsuji

	//QƔF_̐FxWl R/W
	BOOL b_WhitePoint;
	NKC_Image_File_JPG_ExifTags_Rational m_WhitePoint[2];
	//F̐FxWl R/W
	BOOL b_PrimaryChromaticities;
	NKC_Image_File_JPG_ExifTags_Rational m_PrimaryChromaticities[6];
	//Fϊ}gNXW R/W
	BOOL b_YCbCrCoefficients;
	NKC_Image_File_JPG_ExifTags_Rational m_YCbCrCoefficients[3];
	//Fԏ R/W
	BOOL b_ColorSpace;
	WORD m_ColorSpace;
	//Io[h R
	BOOL b_ExposureMode;
	WORD m_ExposureMode;
	//BeLq R
	BOOL b_DeviceSettingDescription;
	char m_DeviceSettingDescription[260];
	//ĐK} R
	BOOL b_Gamma;
	NKC_Image_File_JPG_ExifTags_Rational m_Gamma;


public:
	NKC_Image_File_JPG_ExifTags_L1();
	virtual ~NKC_Image_File_JPG_ExifTags_L1();

	// 摜͋@̃[J[
	virtual BOOL GetMake(char* ascii);
	virtual BOOL SetMake(char* ascii);
	virtual BOOL DelMake(void);

	// 摜͋@̃f
	virtual BOOL GetModel(char* ascii);
	virtual BOOL SetModel(char* ascii);
	virtual BOOL DelModel(void);

	virtual BOOL GetOrientation(WORD* orientation);
	virtual BOOL SetOrientation(WORD* orientation);
	virtual BOOL DelOrientation();

	virtual BOOL GetSoftware(char* ascii);
	virtual BOOL SetSoftware(char* ascii);
	virtual BOOL DelSoftware();

	virtual BOOL GetDateTime(char* ascii);
	virtual BOOL SetDateTime(char* ascii);
	virtual BOOL DelDateTime();

	// 摜f[^̐
	virtual BOOL GetDateTimeOriginal(char* ascii);
	virtual BOOL SetDateTimeOriginal(char* ascii);
	virtual BOOL DelDateTimeOriginal(void);

	// fBW^f[^̐
	virtual BOOL GetDateTimeDigitized(char* ascii);
	virtual BOOL SetDateTimeDigitized(char* ascii);
	virtual BOOL DelDateTimeDigitized();

	//Pxl
	virtual BOOL GetBrightnessValue(NKC_Image_File_JPG_ExifTags_SRational* srational);
	virtual BOOL SetBrightnessValue(NKC_Image_File_JPG_ExifTags_SRational* srational);
	virtual BOOL DelBrightnessValue();
	//ʑ̋
	virtual BOOL SetSubjectDistance(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetSubjectDistance(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL DelSubjectDistance();
	//
	virtual BOOL GetLightSource(WORD* source);
	virtual BOOL SetLightSource(WORD* source);
	virtual BOOL DelLightSource();
	//FLASH
	virtual BOOL GetFlash(WORD* n);
	virtual BOOL SetFlash(WORD* n);
	virtual BOOL DelFlash();
	//Yœ_
	virtual BOOL GetFocalLength(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL SetFocalLength(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL DelFocalLength();
	
	//SubjectArea
	virtual BOOL GetSubjectArea(WORD* pBuf);
	virtual BOOL SetSubjectArea(WORD* pBuf);
	virtual BOOL DelSubjectArea();	
	virtual BOOL GetSubjectAreaCount(int* count);
	virtual BOOL SetSubjectAreaCount(int* count);

	//ʑ̈ʒu
	virtual BOOL GetSubjectLocation(WORD* x, WORD* y);
	virtual BOOL SetSubjectLocation(WORD* x, WORD* y);
	virtual BOOL DelSubjectLocation();

	//[U[Rg
	/*
	virtual BOOL GetUserComment(char* ascii);
	virtual BOOL SetUserComment(char* ascii); 
	virtual BOOL DelUserComment();*/
	virtual BOOL GetUserComment(BYTE* pBuf, int* nSize);
	virtual BOOL GetUserCommentCount(int* count);
	virtual BOOL GetUserCommentCode(NKC_Image_File_JPG_ExifTags_StrCode* code);
	virtual BOOL SetUserComment(BYTE* pBuf, int* nSize, NKC_Image_File_JPG_ExifTags_StrCode* code);
	virtual BOOL DelUserComment();

	//ʉʏ
	virtual BOOL GetCustomRendered(WORD* rendered);
	virtual BOOL SetCustomRendered(WORD* rendered);
	virtual BOOL DelCustomRendered();
	//zCgoX
	virtual BOOL GetWhiteBalance(WORD* balance);
	virtual BOOL SetWhiteBalance(WORD* balance);
	virtual BOOL DelWhiteBalance();
	//fBW^Y[{
	virtual BOOL GetDigitalZoomRatio(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL SetDigitalZoomRatio(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL DelDigitalZoomRatio();
	//35mmZYœ_
	virtual BOOL GetFocalLengthIn35mmFilm(WORD* fl35mmfilm);
	virtual BOOL SetFocalLengthIn35mmFilm(WORD* fl35mmfilm);
	virtual BOOL DelFocalLengthIn35mmFilm();
	//BeV[^Cv
	virtual BOOL GetSceneCaptureType(WORD* capturetype);
	virtual BOOL SetSceneCaptureType(WORD* capturetype);
	virtual BOOL DelSceneCaptureType();
	//QC
	virtual BOOL GetGainControl(WORD* gaincontrol);
	virtual BOOL SetGainControl(WORD* gaincontrol);
	virtual BOOL DelGainControl();
	
	//BeRgXg
	virtual BOOL GetContrast(WORD* contrast);
	virtual BOOL SetContrast(WORD* contrast);
	virtual BOOL DelContrast();

	//Beʓx
	virtual BOOL GetSaturation(WORD* saturation);
	virtual BOOL SetSaturation(WORD* saturation);
	virtual BOOL DelSaturation();

	//BeV[vlX
	virtual BOOL GetSharpness(WORD* shapness);
	virtual BOOL SetSharpness(WORD* sharpness);
	virtual BOOL DelSharpness();
	
	//ʑ̋W
	virtual BOOL GetSubjectDistanceRange(WORD* range);
	virtual BOOL SetSubjectDistanceRange(WORD* range);
	virtual BOOL DelSubjectDistanceRange();

	//摜j[Nhc
	virtual BOOL GetImageUniqueID(char* ascii);
	virtual BOOL SetImageUniqueID(char* ascii);
	virtual BOOL DelImageUniqueID();

	virtual BOOL GetExposureTime(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetFNumber(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetExposureProgram(WORD* n);
	virtual BOOL GetSpectralSensitivity(char* ascii);
	virtual BOOL GetISOSpeedRatings(WORD* pBuf);
	virtual BOOL GetISOSpeedRatingsCount(int* count);
	virtual BOOL GetShutterSpeedValue(NKC_Image_File_JPG_ExifTags_SRational* srational);
	virtual BOOL GetApertureValue(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetExposureBiasValue(NKC_Image_File_JPG_ExifTags_SRational* srational);
	virtual BOOL GetMaxApertureValue(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetMeteringMode(WORD* mode);
	virtual BOOL GetFlashEnergy(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetFocalPlaneXResolution(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetFocalPlaneYResolution(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetFocalPlaneResolutionUnit(WORD* unit);
	virtual BOOL GetExposureIndex(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL GetSensingMethod(WORD* method);
	virtual BOOL GetFileSource(WORD* source);
	virtual BOOL GetSceneType(WORD* type);
	virtual BOOL GetCFAPattern(BYTE* pBuf);
	virtual BOOL GetCFAPatternCount(int* count);

	//
	// added to set value from file
	//
	virtual BOOL SetExposureTime(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetFNumber(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetExposureProgram(WORD n);
	virtual BOOL SetSpectralSensitivity(char* ascii);
	virtual BOOL SetISOSpeedRatings(WORD pBuf);
	virtual BOOL SetISOSpeedRatingsCount(int count);
	virtual BOOL SetShutterSpeedValue(NKC_Image_File_JPG_ExifTags_SRational srational);
	virtual BOOL SetApertureValue(NKC_Image_File_JPG_ExifTags_Rational rational);
//	virtual BOOL SetBrightnessValue(NKC_Image_File_JPG_ExifTags_SRational srational);
	virtual BOOL SetExposureBiasValue(NKC_Image_File_JPG_ExifTags_SRational srational);
	virtual BOOL SetMaxApertureValue(NKC_Image_File_JPG_ExifTags_Rational rational);
//	virtual BOOL SetSubjectDistance(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetMeteringMode(WORD mode);
//	virtual BOOL SetLightSource(WORD source);
//	virtual BOOL SetFlash(WORD n);
//	virtual BOOL SetFocalLength(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetFlashEnergy(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetFocalPlaneXResolution(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL SetFocalPlaneYResolution(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL SetFocalPlaneResolutionUnit(WORD *unit);
//	virtual BOOL SetSubjectLocation(WORD x, WORD y);
	virtual BOOL SetExposureIndex(NKC_Image_File_JPG_ExifTags_Rational rational);
	virtual BOOL SetSensingMethod(WORD method);
	virtual BOOL SetFileSource(WORD source);
	virtual BOOL SetSceneType(WORD type);
	virtual BOOL SetCFAPattern(BYTE pBuf);
	virtual BOOL SetCFAPatternCount(int count);

	// Exifo[W
	virtual BOOL SetExifVersion(char* ascii);
	virtual BOOL GetExifVersion(char* ascii);
	virtual BOOL DelExifVersion();

	// ݊ʎq
	virtual BOOL GetInteroperabilityIndex(char* ascii);
	virtual BOOL SetInteroperabilityIndex(char* ascii);
	virtual BOOL DelInteroperabilityIndex();

	virtual BOOL DelFocalPlaneXResolution();
	virtual BOOL DelFocalPlaneYResolution();
	virtual BOOL DelFocalPlaneResolutionUnit();

	// APP3̃^f[^̃o[W
	virtual BOOL GetMetadataVersionNum(char* ascii);
	virtual BOOL SetMetadataVersionNum(char* ascii);
	virtual BOOL DelMetadataVersionNum();

	// 摜؂oTCY
	virtual BOOL GetIntendedPrintArea(WORD* printarea);
	virtual BOOL SetIntendedPrintArea(WORD* printarea);
	virtual BOOL DelIntendedPrintArea();

	// 摜擾
	virtual BOOL GetImageSource(WORD* imagesource);
	virtual BOOL SetImageSource(WORD* imagesource);
	virtual BOOL DelImageSource();

	// gpXLĩ\tgEFA
	virtual BOOL GetScannerSoftware(char* ascii);
	virtual BOOL SetScannerSoftware(char* ascii);
	virtual BOOL DelScannerSoftware();

	// R}io[
	virtual BOOL GetScanFramSeqNum(WORD* scanframseqnum);
	virtual BOOL SetScanFramSeqNum(WORD* scanframseqnum);
	virtual BOOL DelScanFramSeqNum();

	// tB̃TCY
	virtual BOOL GetFilmSize(WORD* filmsize);
	virtual BOOL SetFilmSize(WORD* filmsize);
	virtual BOOL DelFilmSize();

	// 摜̏C
	virtual BOOL GetEditTagArray(WORD* edittagarray);
	virtual BOOL SetEditTagArray(WORD* edittagarray);
	virtual BOOL DelEditTagArray();

	//tB̐ԍ
	virtual BOOL GetFilmProductCode(char* ascii);
	virtual BOOL SetFilmProductCode(char* ascii);
	virtual BOOL DelFilmProductCode();

	//APSJ̃I[i[hc
	virtual BOOL GetCameraOwnerID(char* ascii);
	virtual BOOL SetCameraOwnerID(char* ascii);
	virtual BOOL DelCameraOwnerID();

	//APStB̃O[vLvV
	virtual BOOL GetGroupCaption(char* ascii);
	virtual BOOL SetGroupCaption(char* ascii);
	virtual BOOL DelGroupCaption();

	//I[_[ID
	virtual BOOL GetOrderID(char* ascii);
	virtual BOOL SetOrderID(char* ascii);
	virtual BOOL DelOrderID();
	
	//tB̃JeS[
	virtual BOOL GetFilmCategory(WORD* category);
	virtual BOOL SetFilmCategory(WORD* category);
	virtual BOOL DelFilmCategory();

	//tBGenCode
	virtual BOOL GetFilmgenCode(char* ascii);
	virtual BOOL SetFilmgenCode(char* ascii);
	virtual BOOL DelFilmgenCode();
	
	//g嗦
	virtual BOOL GetMagnification(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL SetMagnification(NKC_Image_File_JPG_ExifTags_Rational* rational);
	virtual BOOL DelMagnification();

	//QƔF_̐FxWl R/W
	//BOOL b_WhitePoint;
	//NKC_Image_File_JPG_ExifTags_SRational *m_WhitePoint[2];
	virtual BOOL GetWhitePoint(	NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size );
	virtual BOOL SetWhitePoint(	NKC_Image_File_JPG_ExifTags_Rational* rational , int set_size );
	virtual BOOL DefSetWhitePoint();
	virtual BOOL DelWhitePoint();

	//F̐FxWl R/W
	//BOOL b_PrimaryChromaticities;
	//NKC_Image_File_JPG_ExifTags_SRational m_PrimaryChromaticities[6];
	virtual BOOL GetPrimaryChromaticities( NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size );
	virtual BOOL SetPrimaryChromaticities( NKC_Image_File_JPG_ExifTags_Rational* rational , int set_size );
	virtual BOOL DefSetPrimaryChromaticities();
	virtual BOOL DelPrimaryChromaticities();

	//Fϊ}gNXW R/W
	//BOOL b_YCbCrCoefficients;
	//NKC_Image_File_JPG_ExifTags_SRational m_YCbCrCoefficients[3];
	virtual BOOL GetYCbCrCoefficients( NKC_Image_File_JPG_ExifTags_Rational* rational , int get_size );
	virtual BOOL SetYCbCrCoefficients( NKC_Image_File_JPG_ExifTags_Rational* rational , int set_size );
	virtual BOOL DefSetYCbCrCoefficients();
	virtual BOOL DelYCbCrCoefficients();

	//Fԏ R/W
	//BOOL b_ColorSpace;
	//WORD m_ColorSpace;
	virtual BOOL GetColorSpace( WORD* ColorSpace );
	virtual BOOL SetColorSpace( WORD* ColorSpace );
	virtual BOOL DelColorSpace();

	//Io[h R
	//BOOL b_ExposureMode;
	//WORD m_ExposureMode;
	virtual BOOL GetExposureMode( WORD* ExposureMode );
	virtual BOOL SetExposureMode( WORD* ExposureMode );
	virtual BOOL DelExposureMode();

	//BeLq R
	//BOOL b_DeviceSettingDescription;
	//char m_DeviceSettingDescription[260];
	virtual BOOL GetDeviceSettingDescription( char* DeviceSettingDescription );
	virtual BOOL SetDeviceSettingDescription( char* DeviceSettingDescription );
	virtual BOOL DelDeviceSettingDescription();

	//ĐK} R
	//BOOL b_Gamma;
	//NKC_Image_File_JPG_ExifTags_SRational m_Gamma;
	virtual BOOL GetGamma( NKC_Image_File_JPG_ExifTags_Rational* rational );
	virtual BOOL SetGamma( NKC_Image_File_JPG_ExifTags_Rational* rational );
	virtual BOOL DefSetGamma();
	virtual BOOL DelGamma();

};
#endif
