//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsCallback.cpp
//	ABSTRACT  : CNpsCallback NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.10
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCallback.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern BOOL g_bDetatch;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallback::CNpsCallback()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallback::CNpsCallback()
{
	InitializeCriticalSection( &m_CS );

	// Xbh̐
	m_hExitEvent    = CreateEvent( 0, FALSE, FALSE, 0 );		// IpCxg
	m_hEvent		= CreateEvent( 0, FALSE, FALSE, 0 );		// MmpCxg

	int nPriority;
	#if defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_BELOW_NORMAL;
	#else  // defined(NPS_THREAD_PRIORITY_BELOW)
	nPriority = THREAD_PRIORITY_NORMAL;
	#endif // defined(NPS_THREAD_PRIORITY_BELOW)
	m_pWinThread	= AfxBeginThread( CallbackThread, this, nPriority, 0, CREATE_SUSPENDED, NULL );
	m_pWinThread->m_bAutoDelete = FALSE;	// 폜Ȃ
	m_pWinThread->ResumeThread();			// Xbh̏Jn
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCallback::~CNpsCallback()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCallback::~CNpsCallback()
{
	// e㏈
	CloseHandle( m_hExitEvent );
	CloseHandle( m_hEvent );

	NPS_LOGOUT_DEBUG( "CNpsCallback::~CNpsCallback()" );
	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallback::IsEmpty()
//	ABSTRACT : R[obNo^Xg󂩒ׂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.07.05
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCallback::IsEmpty()
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	if ( 0 == m_vectorCALLBACKDATA.size() )
	{
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallback::EndObject()
//	ABSTRACT : Xbh̏I
//	FUNCTION : KhNXĂяo
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.01.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCallback::EndObject()
{
	// Ip̃Cxgݒ肵܂
	::SetEvent( m_hExitEvent );

	// XbhI҂
	if( g_bDetatch )
	{
		TerminateThread( m_pWinThread->m_hThread , 0 );
		delete m_pWinThread;
	}
	else if( GetCurrentThreadId() != m_pWinThread->m_nThreadID )
	{
		// Xbhł͂ȂƂ
		HANDLE hThread;

		hThread = m_pWinThread->m_hThread;
#if defined(NPS_SINGLE_WAIT)
		::WaitForSingleObject( hThread, INFINITE );
#else  // NPS_SINGLE_WAIT
		while ( WAIT_OBJECT_0 != ::MsgWaitForMultipleObjects( 1, &hThread, FALSE, INFINITE, QS_ALLEVENTS ) )
		{
			MSG msg;
			CWinThread* pWinThread;
			while( PeekMessage( &msg , NULL , 0 , 0 , PM_NOREMOVE ) )
			{
				pWinThread = AfxGetThread();
				if ( NULL != pWinThread )
				{
					pWinThread->PumpMessage();
				}
				else
				{
					// ݎs̃XbhȂ̂ PeekMessage ̃[v𔲂
					NPS_LOGOUT( "---CNpsCallback::EndObject() AfxGetThread() is NULL" );
					break;
				}
			}
		}
#endif // NPS_SINGLE_WAIT
		delete m_pWinThread;			// XbhpNX̍폜
		m_pWinThread = NULL;
	}else{
		// XbhĝƂ
		m_pWinThread->m_bAutoDelete = TRUE;		// 폜
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallback::CallbackThread()
//	ABSTRACT : Xbh֐
//	FUNCTION : Xbh֐
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsCallback::CallbackThread( LPVOID pParam )
{
	return ((CNpsCallback*)pParam)->Callback();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallback::PopCallbackData()
//	ABSTRACT : vo
//	FUNCTION : Xg珈vo
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsCALLBACKDATA* CNpsCallback::PopCallbackData()
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	for( int i = 0; i < (int)m_vectorCALLBACKDATA.size(); i++ )
	{
		CNpsCALLBACKDATA*	pCALLBACKDATA	= (CNpsCALLBACKDATA*) m_vectorCALLBACKDATA[i];
		m_vectorCALLBACKDATA.erase(m_vectorCALLBACKDATA.begin() + i );
		return pCALLBACKDATA;
	}

	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCallback::Callback()
//	ABSTRACT : CallbackThreadĂяo֐
//	FUNCTION : CallbackThreadĂяo֐
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsCallback::Callback()
{
	HANDLE		evt[2] = { m_hExitEvent, m_hEvent };

	DWORD	dwState;
	while ( WAIT_OBJECT_0 + 1 == (dwState = ::WaitForMultipleObjects( COUNTOF( evt ), evt, FALSE, INFINITE )) )
	{
		DWORD	dwThreadID = GetCurrentThreadId();

		CNpsCALLBACKDATA*	pCALLBACKDATA;

		while( pCALLBACKDATA = PopCallbackData() )
		{
			CallCallback( pCALLBACKDATA );	// ł̓NeBJZNVgpȂ
			delete pCALLBACKDATA;
		}
	}

	return 0;
}
