//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsControl.cpp
//	ABSTRACT  : CNpsControl NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.26
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void NpsLogValueHex( CString str1, DWORD val )
{
	CString str;
	str.Format( "   %s = 0x%08X", str1, val );NPS_LOGOUT( str );
}

void NpsLogValueDec( CString str1, DWORD val )
{
	CString str;
	str.Format( "   %s = %d", str1, val );NPS_LOGOUT( str );
}

void NpsLogValueStr( CString str1, CString str2 )
{
	CString str;
	str.Format( "   %s = %s", str1, str2 );NPS_LOGOUT( str );
}

void NpsLogValueHex( CString str1, void* ptr )
{
	CString str;
	str.Format( "   %s = 0x%08X", str1, ptr );NPS_LOGOUT( str );
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsControl::CNpsControl()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsControl::CNpsControl()
{
	::InitializeCriticalSection( &m_csLibOpen );
	::InitializeCriticalSection( &m_csSdk );

	ClearPrinterList();
	NkcComApi::WinSockStartup();
	m_dwPrinter = 0;

	m_bLibOpen = FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsControl::~CNpsControl()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsControl::~CNpsControl()
{
	// CSdkXg폜
	DeleteSdkAll();

	// v^Xg폜
	ClearPrinterList();

	// EB\bNN[Abv
	NkcComApi::WinSockCleanup();

	::DeleteCriticalSection( &m_csSdk );
	::DeleteCriticalSection( &m_csLibOpen );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::DeleteSdkAll()
//	ABSTRACT : o^ĂCSdkIuWFNgSč폜
//	FUNCTION : o^ĂCSdkIuWFNgSč폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.18
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
void CNpsControl::DeleteSdkAll()
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_csSdk );

	long	lResult;

	for( int i = 0; i < (int)m_vectorSdk.size(); i++ )
	{
		CSdk *	pSdk	= ( CSdk * ) m_vectorSdk[i];
		lResult	= pSdk->DevClose();
		delete pSdk;
	}

	m_vectorSdk.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::GetPrinterHandle()
//	ABSTRACT : v^nh̔Ԃ擾
//	FUNCTION : v^nh̔Ԃ擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void* CNpsControl::GetPrinterHandle()
{
	// v^nh̐ݒ
	m_dwPrinter++;

	return (HPRINTER)m_dwPrinter;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::AddSdk()
//	ABSTRACT : CSdkIuWFNgXgɒǉ
//	FUNCTION : CSdkIuWFNgXgɒǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::AddSdk(
				CSdk * pSdk
				)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_csSdk );

	// o^
	m_vectorSdk.push_back( pSdk );

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::DeleteSdk()
//	ABSTRACT : CSdkIuWFNg폜
//	FUNCTION : CSdkIuWFNg폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.26
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::DeleteSdk(
				HPRINTER	hPrinter	// v^̃nhw肷
				)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_csSdk );

	long	lResult	= FALSE;

	for( int i = 0; i < (int)m_vectorSdk.size(); i++ )
	{
		CSdk *	pSdk	= ( CSdk * ) m_vectorSdk[i];
		
		if( hPrinter == pSdk->GetPrinterHandle() )
		{
			lResult	= pSdk->DevClose();
			delete pSdk;
			m_vectorSdk.erase( m_vectorSdk.begin() + i );
			i--;
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : * CNpsControl::GetSdk()
//	ABSTRACT : CSdkIuWFNgXg擾iv^nhj
//	FUNCTION : CSdkIuWFNgXg擾iv^nhj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.26
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CSdk * CNpsControl::GetSdk(
				HPRINTER	hPrinter	// v^̃nhw肷
				)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_csSdk );

	CSdk *	pSdk	= NULL;

	for( int i = 0; i < (int)m_vectorSdk.size(); i++ )
	{
		CSdk *	pTmpSdk	= ( CSdk * ) m_vectorSdk[i];
		
		if( hPrinter == pTmpSdk->GetPrinterHandle() )
		{
			pSdk	= pTmpSdk;
		}
	}

	return pSdk;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : * CNpsControl::GetSdk()
//	ABSTRACT : CSdkIuWFNgXg擾iv^IPAhXwj
//	FUNCTION : CSdkIuWFNgXg擾iv^IPAhXwj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.3
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CSdk * CNpsControl::GetSdk(								// CSdkIuWFNgXg擾
				DWORD		dwIPAddress,				// v^IPAhX
				USHORT		wNpsPortNo,					// v^NPSp|[gԍ̎擾
				USHORT		wImgPortNo					// v^NPS(摜f[^])p|[gԍ̎擾
				)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_csSdk );

	CSdk *	pSdk	= NULL;

	for( int i = 0; i < (int)m_vectorSdk.size(); i++ )
	{
		CSdk *	pTmpSdk	= ( CSdk * ) m_vectorSdk[i];
		
		if( dwIPAddress == pTmpSdk->GetIPAddress() &&
			wNpsPortNo == pTmpSdk->GetNpsPortNo() &&
			wImgPortNo == pTmpSdk->GetImgPortNo() )
		{
			pSdk	= pTmpSdk;
		}
	}

	return pSdk;
}

// v^m
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::ClearPrinter()
//	ABSTRACT : v^ꗗ̏J
//	FUNCTION : v^ꗗ̏J
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.6
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::ClearPrinterList()
{
	for( int i = 0; i < (int)m_vPrinterInfo.size(); i++ )
	{
		T_NpsPrinterInfo* pPrinterInfo	= (T_NpsPrinterInfo*)m_vPrinterInfo[i];
		delete pPrinterInfo;
	}

	m_vPrinterInfo.clear();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::EnterLibOpen()
//	ABSTRACT : LibOpen ł邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::EnterLibOpen( LPCSTR lpLogFileName )
{
	BOOL bResult = FALSE;

	::EnterCriticalSection( &m_csLibOpen );

	if ( FALSE == m_bLibOpen )
	{
		// Ot@CI[v
		#if !defined(NPS_CUSTOM_LOG)
		::CreateOutputLog( lpLogFileName );
		{	// Oo
			CString str;
			str.Format( "===== NoritsuPrinter.dll Version %s [%s %s] =====",
							NORITSU_PRINTER_DLL_VERSION, __DATE__, __TIME__ );
			NPS_LOGOUT( str );
		}
		#endif // !defined(NPS_CUSTOM_LOG)

		m_bLibOpen = TRUE;
		bResult = TRUE;
	}

	::LeaveCriticalSection( &m_csLibOpen );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::LeaveLibOpen()
//	ABSTRACT : LibCloseł邩mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::LeaveLibOpen()
{
	BOOL bResult = FALSE;

	::EnterCriticalSection( &m_csLibOpen );

	if ( TRUE == m_bLibOpen )
	{
		// CSdkXg폜
		DeleteSdkAll();

		// v^Xg폜
		ClearPrinterList();

		// Ot@Ct@Cɏo
		GetOutputLog()->Flush();

		m_bLibOpen = FALSE;
		bResult = TRUE;
	}

	::LeaveCriticalSection( &m_csLibOpen );

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::IsLibOpen()
//	ABSTRACT : LibOpen ς݂mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsControl::IsLibOpen()
{
	BOOL bLibOpen = TRUE;

	::EnterCriticalSection( &m_csLibOpen );
	bLibOpen = m_bLibOpen;
	::LeaveCriticalSection( &m_csLibOpen );

	return bLibOpen;
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::SearchPrinter()
//	ABSTRACT : v^ms
//	FUNCTION : v^ms
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.6
//	UPDATE   : Y.Yoshinobu	2008.10.28	HubXΉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsControl::SearchPrinter(
					BOOL			bEnableLoopBack,	// [vobNւ̌mLɂ
					LPWORD			pPrinterNum,		// v^̑䐔
					DWORD			dwWaitTime			// ҋ@(~b)
					)
{
	// Xg폜
	ClearPrinterList();

	// v^m
	CNpsBc	wNpsBc;
	BOOL	bResult;
	long	lResult;
	bResult	= wNpsBc.SearchPrinter( bEnableLoopBack, &m_vPrinterInfo, dwWaitTime );

	if ( TRUE == bResult )
	{
		lResult = NPSERR_NORMAL;
	}
	else
	{
		ClearPrinterList();
		lResult = NPSERR_SYSERR;
	}

	// vg
	*pPrinterNum = (WORD)m_vPrinterInfo.size();

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsControl::GetPrinter()
//	ABSTRACT : mv^̎擾
//	FUNCTION : mv^̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.6
//	UPDATE   : J.fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
long CNpsControl::GetPrinterList(
					WORD				wBufferNum,		// pPrinterInfõobt@
					T_NpsPrinterInfo*	pPrinterInfo	// v^
					)
{
	// Ԃ
	for( int i = 0; i < (int)m_vPrinterInfo.size(); i++ )
	{
		if( wBufferNum <= i )
		{
			return NPSERR_REMAINING_DATA;
		}

		T_NpsPrinterInfo* pPrinterInfo2	= (T_NpsPrinterInfo*)m_vPrinterInfo[i];
		memcpy( pPrinterInfo + i,
				pPrinterInfo2,
				sizeof( T_NpsPrinterInfo ) );
	}

	return NPSERR_NORMAL;
}

