// NpsGetIPAddr.cpp: CNpsGetIPAddr NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NkcComApi.h"
#include "NpsGetIPAddr.h"
#include "SendCmdBuffer.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : int WINAPI NpsGetIPAddrEntry()
//	ABSTRACT : MXbh̃Gg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
unsigned int WINAPI NpsGetIPAddrEntry( LPVOID pParam )
{
	CNpsGetIPAddr* pNpsGetIPAddr = (CNpsGetIPAddr*)pParam;

	NPS_LOGOUT( ">>> Nps GetIPAddr Thread Start" );
	if ( TRUE == pNpsGetIPAddr->ThreadInitInstance() )
	{
		pNpsGetIPAddr->ThreadExecProc();
		pNpsGetIPAddr->ThreadExitInstance();
	}
	NPS_LOGOUT( "<<< Nps GetIPAddr Thread End" );

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : DWORD GetRealIPAddress()
//	ABSTRACT : w肵MACAhXPCIPAhX擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CNpsGetIPAddr::GetRealIPAddress( UCHAR MacAddress[], DWORD dwWaitTime )
{
	CNpsGetIPAddr* pNpsGetIPAddr = new CNpsGetIPAddr( MacAddress );
	CWinThread* pWinThread = ::AfxBeginThread( (AFX_THREADPROC)NpsGetIPAddrEntry, pNpsGetIPAddr, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL );
	pWinThread->m_bAutoDelete = FALSE;
	pWinThread->ResumeThread();

	::Sleep( 100L );

	// ^CAEg邩ȏI܂ŃXbh҂
	DWORD nResult;
	for( DWORD retry = 0; retry < ( dwWaitTime / 200L ); retry++ )
	{
		nResult = ::WaitForSingleObject( pWinThread->m_hThread, 200L );
		if ( WAIT_OBJECT_0 == nResult )
		{
			break;
		}
	}

	// ^CAEg̏ꍇ̓XbhI
	if( WAIT_OBJECT_0 != nResult )
	{
		pNpsGetIPAddr->ThreadEnd();
		::WaitForSingleObject( pWinThread->m_hThread, INFINITE );
	}

	delete pWinThread;

	DWORD dwIpAddress = pNpsGetIPAddr->GetIPAddress();
	delete pNpsGetIPAddr;

	return dwIpAddress;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::GetLocalIPAddress()
//	ABSTRACT : w肵MACAhXPCł΂IPAhX擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CNpsGetIPAddr::GetLocalIPAddress( UCHAR MacAddress[] )
{
	DWORD dwIPAddress = 0L;
	// 񋓂ɕKvȃTCY擾
	ULONG bufferLen = 0;
	DWORD result = ::GetAdaptersAddresses( AF_UNSPEC, 0, 0, 0, &bufferLen );
	if( ERROR_BUFFER_OVERFLOW != result )
	{
		return dwIPAddress;
	}

	// 񋓂ɕKvȃobt@mۂ
	PIP_ADAPTER_ADDRESSES addresses = ( PIP_ADAPTER_ADDRESSES )new BYTE[ bufferLen ];

	// NIC񋓂
	result = ::GetAdaptersAddresses( AF_UNSPEC, 0, 0, addresses, &bufferLen );
	if( ERROR_SUCCESS != result )
	{
		delete[] addresses;
		return dwIPAddress;
	}

	for( PIP_ADAPTER_ADDRESSES address = addresses;
		 address;
		 address = address->Next )
	{
		// f[^NwȂ͖̂
		if( 0 >= address->PhysicalAddressLength ) continue;
		// [vobN AhX͖
		if( IF_TYPE_SOFTWARE_LOOPBACK == address->IfType ) continue;
		// L/lbg[NȊO͖
		if( IF_TYPE_ETHERNET_CSMACD != address->IfType && IF_TYPE_IEEE80211 != address->IfType ) continue;

		// MACAhXH
		if( !memcmp( address->PhysicalAddress, MacAddress, sizeof( MacAddress ) ) )
		{
			for( PIP_ADAPTER_UNICAST_ADDRESS unicastAddress = address->FirstUnicastAddress;
				 unicastAddress;
				 unicastAddress = unicastAddress->Next )
			{
				// IPv4ȊO͖
				if( AF_INET != unicastAddress->Address.lpSockaddr->sa_family ) continue;

				// AvP[VgׂłȂAhX͖
				if( unicastAddress->Flags & IP_ADAPTER_ADDRESS_TRANSIENT ) continue;

				dwIPAddress = (( struct sockaddr_in* )unicastAddress->Address.lpSockaddr)->sin_addr.S_un.S_addr;
				break;
			}
		}
	}

	delete[] addresses;

	return dwIPAddress;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::CNpsGetIPAddr()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsGetIPAddr::CNpsGetIPAddr( const UCHAR MacAddress[] )
{
	m_Socket = INVALID_SOCKET;

	m_dwInAddr = NkcComApi::htonl(INADDR_ANY);

	m_dwIPAddress = 0;
	memcpy( m_ucMacAddress, MacAddress, sizeof( m_ucMacAddress ) );

	::InitializeCriticalSection( &m_csLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::~CNpsGetIPAddr()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsGetIPAddr::~CNpsGetIPAddr()
{
	::DeleteCriticalSection( &m_csLock );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::SendCmd()
//	ABSTRACT : IPAhX擾R}hM
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsGetIPAddr::SendCmd()
{
	int nResult;
	WORD wPort;
	SOCKADDR_IN ServAddrIn;
	CSendCmdBuffer SendCmdBuf;

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// |[gԍ̎擾
	int nSize;
	SOCKADDR SockAddr;

	nSize = sizeof( SockAddr );
	::ZeroMemory( &SockAddr , nSize );
	::getsockname( m_Socket, &SockAddr, &nSize );
	wPort = (WORD)( SockAddr.sa_data[0]<<8 ) + (UCHAR)SockAddr.sa_data[1];

	// T[o[̃Zbg
	ServAddrIn.sin_family		= AF_INET;
	ServAddrIn.sin_addr.s_addr	= NkcComApi::htonl(INADDR_BROADCAST);
	ServAddrIn.sin_port			= NkcComApi::htons(NPS_UDP_SERVER_PORT_2);

	// MR}h̍쐬
	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		return FALSE;
	}
	SendCmdBuf.AddHeader( 0x000F, 0x0300 );
	SendCmdBuf.AddTagChar( 1, (CHAR*) m_ucMacAddress, 6 );
	SendCmdBuf.AddTagFooter();

	// M
	nResult = ::sendto( m_Socket, (const char*)SendCmdBuf.GetBuffer(), SendCmdBuf.GetBufferLen(), 0, (SOCKADDR*)&ServAddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::ThreadInitInstance()
//	ABSTRACT : XbhJn
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsGetIPAddr::ThreadInitInstance()
{
	BOOL bBroadcast = TRUE;

	//----------------------------------------
	// M\Pbg̍쐬
	//----------------------------------------

	SOCKADDR_IN AddrIn;
	int nResult;

	AddrIn.sin_family			= AF_INET;
	AddrIn.sin_addr.S_un.S_addr	= m_dwInAddr;
	AddrIn.sin_port				= NkcComApi::htons(0);

	// \Pbg쐬
	m_Socket = ::socket( AF_INET, SOCK_DGRAM, 0 );

	if ( INVALID_SOCKET == m_Socket )
	{
		return FALSE;
	}

	// u[hLXgLɂ
	nResult = ::setsockopt( m_Socket, SOL_SOCKET, SO_BROADCAST, (CHAR*)&bBroadcast, sizeof(BOOL));

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	// \Pbg̃oCh
	nResult = ::bind( m_Socket, (SOCKADDR FAR *)&AddrIn, sizeof(SOCKADDR_IN) );

	if ( SOCKET_ERROR == nResult )
	{
		return FALSE;
	}

	//----------------------------------------
	// mR}hM
	//----------------------------------------
	if ( !SendCmd() )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::ThreadExecProc()
//	ABSTRACT : Xbh
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsGetIPAddr::ThreadExecProc()
{

	int nSize;
	int nRecvLen;
	BYTE byBuffer[1028];				// R}h̍őTCY1024Byte + R}hwb_4Byte
	SOCKADDR_IN	SockAddr;
	WORD wIfId;			// C^[tFCXID
	WORD wCmdId;		// R}hID

	nSize = sizeof(SOCKADDR_IN);

	while (1)
	{
		::ZeroMemory( byBuffer, sizeof(byBuffer) );
		::ZeroMemory( &SockAddr , sizeof(SockAddr) );

		nRecvLen = ::recvfrom( m_Socket, (char*)&byBuffer, sizeof(byBuffer), 0, 
								(SOCKADDR FAR*)&SockAddr, &nSize );

		if ( SOCKET_ERROR == nRecvLen )
		{
			return;
		}

		if ( ReadCmdHdr( byBuffer, wIfId, wCmdId ) )
		{
			if ( 0x000F0301 == MAKELONG( wCmdId, wIfId ) )
			{
				// IPAhX擾łXbhI
				if ( AnalyzePacket( byBuffer, SockAddr.sin_addr.S_un.S_addr ) )
				{
					break;
				}
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::AnalyzePacket()
//	ABSTRACT : pPbg
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsGetIPAddr::AnalyzePacket( LPBYTE lpBuffer, DWORD dwHostAddress )
{
	int Type = NPS_DATATYPE_TAG_NO;
	USHORT TagNo;
	USHORT Length;
	BYTE* pBufAtt;
	unsigned long Counter = 0;
	UCHAR MacAddress[6];

	pBufAtt	= lpBuffer + sizeof( DWORD );

	// Mf[^ǂݎ
	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			TagNo	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			TagNo	= NkcComApi::ntohs( TagNo );

			if( 0 == TagNo )
			{
				break;
			}

			Type	= NPS_DATATYPE_TAG_LENGTH;
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			Length	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			Length	= NkcComApi::ntohs( Length );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:
				{
					for( int i = 0; i < Length; i++ )
					{
						MacAddress[i] = pBufAtt[ Counter + sizeof( UCHAR ) * i ];
					}
				}
				break;
			default:
				break;
			}

			Counter += Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}
	}

	// TBD MACAhXȂIPAhXۑ
	if( !memcmp( m_ucMacAddress, MacAddress, sizeof( m_ucMacAddress ) ) )
	{
		m_dwIPAddress = dwHostAddress;
		return TRUE;
	}

	return FALSE;
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::ThreadExitInstance()
//	ABSTRACT : XbhI
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsGetIPAddr::ThreadExitInstance()
{
	NkcComApi::CCSScopeLock lock( &m_csLock );

	// Ô߃\PbgN[Y܂
	if ( INVALID_SOCKET != m_Socket )
	{
		::closesocket( m_Socket );
		m_Socket = INVALID_SOCKET;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::ThreadEnd()
//	ABSTRACT : XbhIv
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsGetIPAddr::ThreadEnd()
{
	NkcComApi::CCSScopeLock lock( &m_csLock );

	// \PbgN[Y܂
	::closesocket( m_Socket );
	m_Socket = INVALID_SOCKET;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsGetIPAddr::ReadCmdHdr()
//	ABSTRACT : NPSR}h̃wb_[擾
//	FUNCTION :
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsGetIPAddr::ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId )
{
	WORD wId1;
	WORD wId2;

	::memcpy( &wId1, lpBuffer, sizeof(WORD) );
	::memcpy( &wId2, lpBuffer + sizeof(WORD), sizeof(WORD) );

	wInterfaceId = NkcComApi::ntohs( wId1 );
	wCommandId = NkcComApi::ntohs( wId2 );

	return TRUE;
}
