//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsImg.h
//	ABSTRACT  : CNpsImg NX̃C^[tFCX
//	
//	CREATE    : T.Isogai	2006.8.4
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSIMG_H__4E62B61A_085E_411C_834F_01B567584B0B__INCLUDED_)
#define AFX_NPSIMG_H__4E62B61A_085E_411C_834F_01B567584B0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Nps.h"
#include "WS2Tcp2.h"
#include "NkcComApi.h"
#include "CmnDef.h"
#include "NpsCommand.h"

#define NPS_IMAGEDATASENDBYTE	( 1024 * 1024 * 2 )

//----------------------------------------
// enum`
//----------------------------------------
enum E_SendFunc
{	// 摜M
	FUNC_NORMAL,		// ʏ
	FUNC_BMP2RAW,		// BMP -> RAW ϊőM
	FUNC_RAW2BMP,		// RAW -> BMP ϊőM
	FUNC_CRCDATA,		// CRCf[^̑M
};

//----------------------------------------------------------------------------
// 摜]ɕKvȃp[^Zbg邽߂̃NX
//----------------------------------------------------------------------------

class CImgSendParam
{
public:

	//----------------------------------------
	// o֐
	//----------------------------------------
	CImgSendParam() { Clear(); };
	virtual ~CImgSendParam() { Clear(); };
	void Clear()
	{
		m_eSendFunc			= FUNC_NORMAL;
		m_dwSourceType		= IMGSRC_SHAREDMEM;
		m_dwTransDataLength	= 0;
		m_dwFileDataLength	= 0;
		m_dwOffset			= 0;
		m_dwImgWidth		= 0;
		m_dwImgHeight		= 0;
		m_hMemory			= NULL;
		m_strFileName.Empty();
	}

public:

	//----------------------------------------
	// oϐ
	//----------------------------------------
	DWORD				m_dwSourceType;			// 摜f[^[̎󂯓n@i 0:Ln, 1:t@Cn j
	DWORD				m_dwTransDataLength;	// 摜Mf[^̃TCYiPʁFBytej
	DWORD				m_dwFileDataLength;		// 摜t@Cf[^̃TCYiPʁFBytej
	DWORD				m_dwOffset;				// 摜f[^̊i[ĂItZbg
	DWORD				m_dwImgWidth;			// 摜̕
	DWORD				m_dwImgHeight;			// 摜̍
	HANDLE				m_hMemory;				// MMFpnh
	CString				m_strFileName;			// M摜̃t@Ci܂͋Lj
	E_SendFunc			m_eSendFunc;			// 摜M

};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsImg
//	ABSTRACT : \PbgʐMNXi摜f[^]j
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : T.Isogai	2006.8.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsImg : public CWS2Tcp2  
{
private:

	USHORT	m_PortNo;				// |[gԍ
	CString	m_strHostAddress;		// zXgAhX
	USHORT	m_wImgPortNo;			// zXg|[gԍ

	// 摜f[^MiLnj
	long SendImageDataByMMF( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pName, E_SendFunc eSendFunc, LPDWORD lpdwTransmitTime );

	// 摜f[^Mit@Cnj
	long SendImageDataByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwWidth, DWORD dwHeight, DWORD dwOffset, LPCSTR pName, E_SendFunc eSendFunc, LPDWORD lpdwTransmitTime );

	// CRCf[^Mit@Cnj
	long SendCRCDataByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pName, LPDWORD lpdwTransmitTime );

	// 摜f[^M BMP -> RAWit@Cnj
	long SendRawByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pFileName, LPDWORD lpdwTransmitTime );

	// 摜f[^M BMP -> RAWiLnj
	long SendRawByMmf( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwOffset, LPCSTR pMmfName, LPDWORD lpdwTransmitTime );

	// 摜f[^M RAW -> BMPit@Cnj
	long SendBmpByFile( DWORD dwTransDataLength, DWORD dwDataLength, DWORD dwWidth, DWORD dwHeight, DWORD dwOffset, LPCSTR pFileName, LPDWORD lpdwTransmitTime );

public:
	CNpsImg();						// RXgN^
	virtual ~CNpsImg();				// fXgN^

	BOOL Open( LPCTSTR lpszHostAddress, USHORT wImgPortNo, USHORT nPortNo = 0 );	// 摜Mp\PbgI[v
	BOOL Connect();								// 摜Mp\PbgRlNg
	BOOL Close();								// 摜Mp\PbgN[Y

	USHORT	GetPortNo()					{ return m_PortNo; }	// |[gԍ̎擾
	void	SetPortNo( USHORT PortNo )	{ m_PortNo = PortNo; }	// |[gԍ̐ݒ

	void	SetHostAddress( LPCTSTR lpszHostAddress )	// zXgAhXݒ	2006.10.11 T.Mizushima
	{
		m_strHostAddress = lpszHostAddress;
	}
	CString	GetHostAddress()							// zXgAhX擾	2006.11.08 T.Mizushima
	{
		return m_strHostAddress;
	}

	// 摜f[^M
	long SendImageData( CImgSendParam* pobjParam, LPDWORD lpdwTransmitTime );
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsImgManager
//	ABSTRACT : 摜MNXǗ(r)NX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2008.2.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsImgManager
{
public:

	//----------------------------------------
	// o[֐
	//----------------------------------------

	// RXgN^
	CNpsImgManager();
	// fXgN^
	virtual ~CNpsImgManager();

	// zXgAhXݒ
	void SetHostAddress( LPCTSTR lpszHostAddress, USHORT wImgPortNo );

	// 摜]p\Pbg̍쐬
	USHORT CreateSocket();

	// |[gԍw肵ĉ摜]p\Pbg쐬
	BOOL CreateSocketByPortNo( const USHORT nPortNo );

	// \PbgI[vĂ邩mF
	BOOL IsOpenSocket( const USHORT nPortNo );

	// 摜]p\PbgIuWFNg̍폜
	void Delete( const USHORT nPortNo, const BOOL bEnableLock = TRUE );

	// 摜]p\PbgIuWFNg̑S폜
	void Clear( const BOOL bEnableLock = TRUE );

	// T[o[ւ̐ڑ
	BOOL Connect( const USHORT nPortNo );

	// T[o[ւ̍Đڑ
	BOOL ReConnect( const USHORT nPortNo );

	// 摜f[^M
	long SendImageData( const USHORT nPortNo, CImgSendParam* pobjParam, LPDWORD lpdwTransmitTime );

private:

	//----------------------------------------
	// o[ϐ
	//----------------------------------------
	std::vector<CNpsImg*>	m_vNpsImg;				// 摜f[^MIuWFNg̃Rei
	CRITICAL_SECTION		m_csNpsImg;				// m_pNpsImg̔rpNeBJZNV

	CString					m_strIPAddress;			// ڑIPAhX
	USHORT					m_wImgPortNo;
};



#endif // !defined(AFX_NPSIMG_H__4E62B61A_085E_411C_834F_01B567584B0B__INCLUDED_)
