//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : NpsNoticeRequestControl.cpp
//	ABSTRACT  : CNpsNoticeRequestControl NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.9.6
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsNoticeRequestControl.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsNoticeRequestControl::CNpsNoticeRequestControl()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequestControl::CNpsNoticeRequestControl()
{
	InitializeCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsNoticeRequestControl::~CNpsNoticeRequestControl()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequestControl::~CNpsNoticeRequestControl()
{
	{
		NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

		for( int i =0; i < (int)m_vectorNoticeRequest.size(); i++ )
		{
			CNpsNoticeRequest* ptmpNpsNoticeRequest	= ( CNpsNoticeRequest* ) m_vectorNoticeRequest[i];
			delete ptmpNpsNoticeRequest;
		}

		m_vectorNoticeRequest.erase( m_vectorNoticeRequest.begin(), m_vectorNoticeRequest.end() );
	}

	DeleteCriticalSection( &m_CS );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequestControl::AddData()
//	ABSTRACT : CNpsNoticeRequestIuWFNgXg֒ǉ
//	FUNCTION : CNpsNoticeRequestIuWFNgXg֒ǉ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsNoticeRequestControl::AddRequest( CNpsNoticeRequest * pNoticeRequest )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	// ɓl̃C^[tFCXID, R}hIDœo^Ăꍇ͓o^Ȃ
	CNpsNoticeRequest*	pNpsNoticeRequest;
	pNpsNoticeRequest	= GetRequestNotCS( pNoticeRequest->GetIfId(), pNoticeRequest->GetCmdId() );

	if( NULL != pNpsNoticeRequest )
	{
		return FALSE;
	}

	m_vectorNoticeRequest.push_back( pNoticeRequest );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequestControl::GetRequestNotCS()
//	ABSTRACT : CNpsNoticeRequestIuWFNg擾iNeBJZNVȂj
//	FUNCTION : CNpsNoticeRequestIuWFNg擾iNeBJZNVȂj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequest* CNpsNoticeRequestControl::GetRequestNotCS( WORD IfId, WORD CmdId )
{
	CNpsNoticeRequest* pNpsNoticeRequest = NULL;

	for( int i =0; i < (int)m_vectorNoticeRequest.size(); i++ )
	{
		CNpsNoticeRequest* ptmpNpsNoticeRequest	= ( CNpsNoticeRequest* ) m_vectorNoticeRequest[i];

		if( ( IfId == ptmpNpsNoticeRequest->GetIfId() ) && ( CmdId == ptmpNpsNoticeRequest->GetCmdId() ) )
		{
			pNpsNoticeRequest	= ptmpNpsNoticeRequest;
			break;
		}
	}

	return pNpsNoticeRequest;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :  CNpsNoticeRequestControl::GetRequest()
//	ABSTRACT : CNpsNoticeRequestIuWFNg擾iNeBJZNVj
//	FUNCTION : CNpsNoticeRequestIuWFNg擾iNeBJZNVj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsNoticeRequest* CNpsNoticeRequestControl::GetRequest( WORD IfId, WORD CmdId )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	return GetRequestNotCS( IfId, CmdId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :  CNpsNoticeRequestControl::DeleteRequest()
//	ABSTRACT : CNpsNoticeRequestIuWFNg폜
//	FUNCTION : CNpsNoticeRequestIuWFNg폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.7
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsNoticeRequestControl::DeleteRequest( WORD IfId, WORD CmdId )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	BOOL	bResult	= FALSE;

	for( int i =0; i < (int)m_vectorNoticeRequest.size(); i++ )
	{
		CNpsNoticeRequest* ptmpNpsNoticeRequest	= ( CNpsNoticeRequest* ) m_vectorNoticeRequest[i];

		if( ( IfId == ptmpNpsNoticeRequest->GetIfId() ) &&
			( CmdId == ptmpNpsNoticeRequest->GetCmdId() ) )
		{
			m_vectorNoticeRequest.erase( m_vectorNoticeRequest.begin() + i );
			i--;
			delete ptmpNpsNoticeRequest;
			bResult	= TRUE;
			break;
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsNoticeRequestControl::SetBuf()
//	ABSTRACT : CNpsNoticeRequestIuWFNgփf[^
//	FUNCTION : CNpsNoticeRequestIuWFNgփf[^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsNoticeRequestControl::SetBuf( WORD wIfId, WORD wCmdId, BYTE * lpBuff, unsigned long AttSize )
{
	NkcComApi::CCSScopeLock	CSScopeLock( &m_CS );

	CNpsNoticeRequest* pNpsNoticeRequest = NULL;

	pNpsNoticeRequest	= GetRequestNotCS( wIfId, wCmdId );
	
	if( NULL == pNpsNoticeRequest )
	{
		return FALSE;
	}

	CString str;
	str.Format( "***** NpsNotice find IfId=0x%04X CmdId=0x%04X", wIfId, wCmdId );
	NPS_LOGOUT_DEBUG( str );

	pNpsNoticeRequest->AddData( AttSize, lpBuff );

	return TRUE;
}

