#include "stdafx.h"
#include "SendCmdBuffer.h"
#include "RecvCmdBuffer.h"
#include "NpsPrinterChecker.h"

#pragma comment(lib ,"winmm.lib")

extern DWORD g_dwConnectMode;		// iڑ[h

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : NpsPrinterCheckerThreadEntry()
//	ABSTRACT : XbhGg[
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT WINAPI NpsPrinterCheckerThreadEntry(LPVOID pParam)
{
	CNpsPrinterChecker* pNpsPrinterChecker = (CNpsPrinterChecker*)pParam;

	return pNpsPrinterChecker->ThreadExecProc();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::CNpsPrinterChecker()
//	ABSTRACT : RXgN^
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsPrinterChecker::CNpsPrinterChecker()
{
	m_uTimerID = 0;
	m_pWinThread = NULL;
	g_hExitEvent = NULL;
	m_Socket = INVALID_SOCKET;

	::InitializeCriticalSection(&m_cs);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::~CNpsPrinterChecker()
//	ABSTRACT : fXgN^
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsPrinterChecker::~CNpsPrinterChecker()
{
	int ii;

	for (ii = 0; ii < (int)m_vCheckPrinter.size(); ii++)
	{
		T_NpsPrinterInfo* pNpsPrinterInfo = m_vCheckPrinter[ii];
		delete pNpsPrinterInfo;
	}

	for (ii = 0; ii < (int)m_vPrinterInfo.size(); ii++)
	{
		T_NpsPrinterInfo* pNpsPrinterInfo = m_vPrinterInfo[ii];
		delete pNpsPrinterInfo;
	}

	m_vCheckPrinter.clear();
	m_vPrinterInfo.clear();

	if (g_hExitEvent)
		::CloseHandle(g_hExitEvent);

	::DeleteCriticalSection(&m_cs);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::AddCheckPrinter()
//	ABSTRACT : v^[@mF
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : 
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsPrinterChecker::AddCheckPrinter(const T_NpsPrinterInfo* pPrinterInfo)
{
	T_NpsPrinterInfo* pPrinterInfoT = new T_NpsPrinterInfo();

	::memcpy(pPrinterInfoT, pPrinterInfo, sizeof(T_NpsPrinterInfo));

	::EnterCriticalSection(&m_cs);

	m_vCheckPrinter.push_back(pPrinterInfoT);

	::LeaveCriticalSection(&m_cs);
}

// v^[擾
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::GetPrinterInfo()
//	ABSTRACT : v^[擾
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsPrinterChecker::GetPrinterInfo(int nIndex, T_NpsPrinterInfo* pPrinterInfo)
{
	if (nIndex < 0 || nIndex > (int)m_vPrinterInfo.size()) {
		::LeaveCriticalSection(&m_cs);
		return NULL;
	}

	T_NpsPrinterInfo* pPrinterInfoT = m_vPrinterInfo[nIndex];
	::memcpy(pPrinterInfo, pPrinterInfoT, sizeof(T_NpsPrinterInfo));

	return TRUE;
}

// XbhI
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::EndThread()
//	ABSTRACT : XbhIҋ@
//	FUNCTION : XbhI܂őҋ@
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsPrinterChecker::WaitEndThread()
{
	// XbhICxgVOiԂɂ
	SetEvent(g_hExitEvent);

	// XbhIҋ@
	::WaitForSingleObject(m_pWinThread->m_hThread, INFINITE);

	delete m_pWinThread;

	m_pWinThread = NULL;
}

// XbhN
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::StartupThread()
//	ABSTRACT : XbhN
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : 
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsPrinterChecker::StartupThread()
{
	if (m_pWinThread)
		return FALSE;

	if (g_hExitEvent)
		::CloseHandle(g_hExitEvent);

	g_hExitEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);

	m_pWinThread = ::AfxBeginThread((AFX_THREADPROC)NpsPrinterCheckerThreadEntry, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL );

	m_pWinThread->m_bAutoDelete = FALSE;

	m_pWinThread->ResumeThread();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::TimerProcEntry()
//	ABSTRACT : R[obN֐
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CNpsPrinterChecker::TimerProcEntry(UINT uID, UINT uMsg, LPARAM lpUser, DWORD dw1, DWORD dw2)
{
	// NX̃|C^
	CNpsPrinterChecker* pThis = (CNpsPrinterChecker*)lpUser;

	pThis->TimerProc();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::TimerProc()
//	ABSTRACT : ^C}[
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsPrinterChecker::TimerProc()
{
	NPS_LOGOUT_FATAL("===Filed : The command could not be received in the time.\n");

	// ^C}[I
	::timeKillEvent(m_uTimerID);
	m_uTimerID = 0;

	// IɃv^[ؒf
	Disconnect();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::GetCheckPrinter()
//	ABSTRACT : ƍ҂v^[擾
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
T_NpsPrinterInfo* CNpsPrinterChecker::GetCheckPrinter()
{
	::EnterCriticalSection(&m_cs);

	if (0 == m_vCheckPrinter.size()) {
		::LeaveCriticalSection(&m_cs);
		return NULL;
	}

	T_NpsPrinterInfo* pPrinterInfo = m_vCheckPrinter.front();
	m_vCheckPrinter.erase(m_vCheckPrinter.begin());

	::LeaveCriticalSection(&m_cs);

	return pPrinterInfo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsPrinterChecker::ThreadExecProc()
//	ABSTRACT : Xbh
//	FUNCTION :
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : Y.Yoshinobu	2008.11.25	ڑmFvOEMR[h^Oǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
UINT CNpsPrinterChecker::ThreadExecProc()
{
	BOOL bExit = FALSE;

	LPBYTE pRecvBuf = new BYTE[MAX_BUFFSIZE];	// Mobt@

	ULONG nRecvSize;	// Mf[^TCY
	CString str;

	while (1)
	{
		USHORT usResult;	// 
		UCHAR ucOemCode;	// OEMR[h
	
		if (WAIT_OBJECT_0 == ::WaitForSingleObject(g_hExitEvent, 100L))
			bExit = TRUE;

		// mF҂v^[擾
		T_NpsPrinterInfo* pPrinterInfo = GetCheckPrinter();

		if (TRUE == bExit && NULL == pPrinterInfo)
			break;

		if (NULL == pPrinterInfo)
			continue;


		try
		{
			CSendCmdBuffer SendCmdBuf;				// MR}hNX
			CRecvCmdBuffer RecvCmdBuffer;			// MR}h̓NX

			str.Format(" --Checking %s[%s].", pPrinterInfo->Nps000FH_0101H.MachineTypeName, pPrinterInfo->szIP);
			NPS_LOGOUT(str);

			// v^[ɐڑ
			m_Socket = Connect(pPrinterInfo->szIP);


			// ڑJn̑M

			if (FALSE == SendCmdBuf.Create(32))
			{
				NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );

				delete pPrinterInfo;
				Disconnect();
				
				// vIG[Ȃߌps
				break;
			}

			SendCmdBuf.AddHeader( 0x6000, 0x0E00 );
			SendCmdBuf.AddTagLong ( 1, g_dwConnectMode );
			SendCmdBuf.AddTagFooter();

			SendCmd(SendCmdBuf.GetBuffer(), SendCmdBuf.GetBufferLen());
			NPS_LOGOUT(" --COMMAND SEND( IfId=0x6000H, CmdId=0x0E00H)");

			SendCmdBuf.Empty();

			// ڑJn̎M
			nRecvSize = RecvCmd(pRecvBuf, 0x6000, 0x0E01);

			// ڑJn̉
			RecvCmdBuffer.AddTagList(1, NPS_TYPE_SHORT);	// 
			RecvCmdBuffer.Analysis((LPBYTE)pRecvBuf, nRecvSize);

			if (0 == RecvCmdBuffer.GetTagValue(1, (LPBYTE)&usResult))
				usResult = 0xFFFF;

			RecvCmdBuffer.EmptyTagList();

			str.Format(" --COMMAND RECV( IfId=0x6000H, CmdId=0x0E01H, Result=%d )", usResult);
			NPS_LOGOUT(str);

			if (0 != usResult)
			{
				delete pPrinterInfo;
				goto DONE;
			}


			// v^[ݒ擾v
			if (FALSE == SendCmdBuf.Create(32))
			{
				NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );

				delete pPrinterInfo;
				Disconnect();
				
				// vIG[Ȃߌps
				break;
			}

			SendCmdBuf.AddHeader( 0x6000, 0x0200 );
			SendCmdBuf.AddTagFooter();

			SendCmd(SendCmdBuf.GetBuffer(), SendCmdBuf.GetBufferLen());
			NPS_LOGOUT(" --COMMAND SEND( IfId=0x6000H, CmdId=0x0200H)");

			SendCmdBuf.Empty();

			// v^[ݒ擾
			nRecvSize = RecvCmd(pRecvBuf, 0x6000, 0x0201);

			// v^[ݒ擾̉
			RecvCmdBuffer.AddTagList(1, NPS_TYPE_SHORT);	// 
			RecvCmdBuffer.AddTagList(31, NPS_TYPE_CHAR);	// OEMR[h
			RecvCmdBuffer.Analysis((LPBYTE)pRecvBuf, nRecvSize);

			if (1 != RecvCmdBuffer.GetTagValue(1, (LPBYTE)&usResult) )
			{
				usResult = 0xFFFF;
			}

			if (1 != RecvCmdBuffer.GetTagValue(31, (LPBYTE)&ucOemCode) )
			{
				ucOemCode = 0;
			}

			RecvCmdBuffer.EmptyTagList();

			str.Format(" --COMMAND RECV( IfId=0x6000H, CmdId=0x0201H, Result=%d OemCode=%d)", usResult, ucOemCode);
			NPS_LOGOUT(str);

			if (0 != usResult)
			{
				delete pPrinterInfo;
				goto DONE;
			}

			// OEMR[hɂOEMv^[𔻒f
			if (TRUE == NkcComApi::IsNoritsuPrinterByCode(ucOemCode))
			{
				str.Format(" --%s is Noritsu Product.", pPrinterInfo->Nps000FH_0101H.MachineTypeName);
				NPS_LOGOUT(str);

				switch ( g_dwConnectMode )
				{
				case 0x00000000:	// NKCî݋AOEM(FUJI)i͋Ȃ
				case 0x0FEDCBA0:	// NKCꃂ[h (SĂ)
				case 0x0FEDCBA1:	// FUJIꃂ[h (SĂ)
				default:

					// m[cv^[݂̂o^
					m_vPrinterInfo.push_back(pPrinterInfo);

					break;
				case 0x00000001:	// NKCi͋ȂAOEM(FUJI)î݋

					// OEM(FFdl)v^[͓o^Ȃ
					delete pPrinterInfo;

					break;
				}

			}
			else
			{
				str.Format(" --%s is OEM Product.", pPrinterInfo->Nps000FH_0101H.MachineTypeName);
				NPS_LOGOUT(str);

				switch ( g_dwConnectMode )
				{
				case 0x00000001:	// NKCi͋ȂAOEM(FUJI)î݋
				case 0x0FEDCBA0:	// NKCꃂ[h (SĂ)
				case 0x0FEDCBA1:	// FUJIꃂ[h (SĂ)

					// OEM(FFdl)v^[݂̂o^
					m_vPrinterInfo.push_back(pPrinterInfo);

					break;
				case 0x00000000:	// NKCî݋AOEM(FUJI)i͋Ȃ
				default:

					// m[cv^[͓o^Ȃ
					delete pPrinterInfo;

					break;
				}

			}


DONE:


			// v^[ؒf
			Disconnect();
		} 
		catch (CString* pExceptMsg)
		{
			// O

			delete pPrinterInfo;

			NPS_LOGOUT_FATAL((char*)(LPCTSTR)*pExceptMsg);
			delete pExceptMsg;

			// v^[ؒf
			Disconnect();
		}
	}

	delete[] pRecvBuf;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : Connect()
//	ABSTRACT : v^[ڑ
//	FUNCTION : 
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
SOCKET CNpsPrinterChecker::Connect(const char* szAddr)
{
	SOCKADDR_IN AddrIn;
	int sts;

	SOCKET Socket = ::socket(AF_INET, SOCK_STREAM, 0);

	if (INVALID_SOCKET == Socket) {

		// OX[
		CString str;
		str.Format("===Filed : socket() = %d.", ::WSAGetLastError());
		throw new CString(str);
	}

	AddrIn.sin_family = AF_INET;
	AddrIn.sin_port = ::htons(30582);
	AddrIn.sin_addr.s_addr = ::inet_addr(szAddr);

	// \Pbg RlNg
	sts = ::connect(Socket, (const LPSOCKADDR) &AddrIn, sizeof(AddrIn));

	if (SOCKET_ERROR == sts)	{

		::closesocket(Socket);

		// OX[
		CString str;
		str.Format("===Filed : connect() = %d.", ::WSAGetLastError());
		throw new CString(str);
	}

	return Socket;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : SendCmd()
//	ABSTRACT : R}hM
//	FUNCTION : 
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
ULONG CNpsPrinterChecker::SendCmd(const LPBYTE pBuff, ULONG nSize)
{
	ULONG nTotalSize = 0;

	while (nTotalSize < nSize) {

		int nSendSize = ::send(m_Socket, (const char*)pBuff + nTotalSize, nSize - nTotalSize, 0);

		if (nSendSize == SOCKET_ERROR) {

			// OX[
			CString str;
			str.Format( "===Filed : send() = %d.", WSAGetLastError());
			throw new CString(str);
		}
		nTotalSize += nSendSize;
	}

	return nTotalSize;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : RecvCmd()
//	ABSTRACT : R}hM
//	FUNCTION : 
//	
//	NOTE     :
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
ULONG CNpsPrinterChecker::RecvCmd(LPBYTE pBuff, WORD wIfId, WORD wCmdId, UINT uDelay /*= 15000L*/)
{
	ULONG nTotalSize;
	DWORD* pRecvCmd;
	DWORD dwNeedCmd = MAKELONG(NkcComApi::htons(wIfId), NkcComApi::htons(wCmdId));	

	// ^C}[N
	m_uTimerID = ::timeSetEvent(uDelay, 0, (LPTIMECALLBACK)TimerProcEntry, (LPARAM)this, TIME_ONESHOT);

	do
	{
		::ZeroMemory(pBuff, MAX_BUFFSIZE);

		// wb_[擾
		nTotalSize = RecvData(pBuff, 4);

		pRecvCmd = (DWORD*)pBuff;

		while (1)
		{
			// ^O擾
			DWORD* pTag = (DWORD*)(pBuff + nTotalSize);

			nTotalSize += RecvData((pBuff + nTotalSize), sizeof(DWORD));

			if (*pTag)
			{
				WORD wDataSize = NkcComApi::ntohs(HIWORD(*pTag));

				// f[^M
				nTotalSize += RecvData((pBuff + nTotalSize), (ULONG)wDataSize);
			}
			else
			{
				// R}hM
				break;
			}
		}

	} while (dwNeedCmd != *pRecvCmd);

	// ^C}[I
	::timeKillEvent(m_uTimerID);
	m_uTimerID = 0;

	return nTotalSize;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : RecvData()
//	ABSTRACT : f[^M
//	FUNCTION : 
//	
//	NOTE     : ̂߃CC֐ƂĒ`
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2008.10.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
inline ULONG CNpsPrinterChecker::RecvData(LPBYTE pBuff, ULONG nSize)
{
	ULONG nTotalSize = 0;

	while (nTotalSize < nSize)
	{
		int nRecvSize = ::recv(m_Socket, (char*)(pBuff + nTotalSize), nSize - nTotalSize, 0);

		switch (nRecvSize)
		{
		case 0:
			{
				// ^C}[I
				::timeKillEvent(m_uTimerID);
				m_uTimerID = 0;

				// OX[
				throw new CString("===Filed : recv() = Peer was disconnected.");
			}
			break;

		case SOCKET_ERROR:
			{
				// ^C}[I
				if (m_uTimerID) 
				{
					::timeKillEvent(m_uTimerID);
					m_uTimerID = 0;
				}

				// OX[
				CString str;
				str.Format("===Filed : recv() = %d.", WSAGetLastError());
				throw new CString(str);
			}
			break;

		default:
			nTotalSize += nRecvSize;
			break;
		}
	}

	return nTotalSize;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : Disconnect()
//	ABSTRACT : v^[ؒf
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : S.Heya	2002.11.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsPrinterChecker::Disconnect()
{
	if (INVALID_SOCKET == m_Socket)
		return;

	::shutdown(m_Socket, 2);
	::closesocket(m_Socket);

	m_Socket = INVALID_SOCKET;
}
