//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : OrderData.cpp
//	ABSTRACT  : COrderData NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.9.21
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OrderData.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :COrderData::COrderData()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
COrderData::COrderData()
{
	m_eOrderStep	= STEP0_ORDER_NONE;
	m_bEndOrder		= FALSE;
	m_bIsMaintenance= FALSE;
	m_nInterruptMode= 0;
	m_dwLatestIndexNo = 0;

	m_nNpsImgPort	= 0;

	m_dwOrderId = 0;
	m_dwSortFrame = 0;
	m_nPossessionNo = 0;
	m_nFirstPossessionNo = 0;
	m_pCompletionProc = NULL;
	m_dwOption = 0;
	m_nSorterNum = 0;

	m_dwExOptions	= 0x00000000;	// gIvV(Pvg)

	m_bReOccupy = FALSE;	// @@@RD-151Ή 2012.05.08 T.Mizushima
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :COrderData::~COrderData()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
COrderData::~COrderData()
{
	// m_vFrameXg폜
	for( int i =0; i < (int)m_vFrame.size(); i++ )
	{
		CFrameData * ptmpFrameData	= ( CFrameData * ) m_vFrame[i];
		delete ptmpFrameData;
	}

	m_vFrame.erase( m_vFrame.begin(), m_vFrame.end() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData::GetLatestIndexNo()
//	ABSTRACT : ŐṼCfbNXԍԂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2009.11.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD COrderData::GetLatestIndexNo()
{
	return ++m_dwLatestIndexNo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData::GetFrameData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CFrameData* COrderData::GetFrameData( DWORD dwPrintId )
{
	CFrameData*	pFrameData	= NULL;

	for( int i =0; i < (int)m_vFrame.size(); i++ )
	{
		CFrameData * ptmpFrameData	= ( CFrameData * ) m_vFrame[i];
		
		if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
		{
			if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
			{
				pFrameData	= ptmpFrameData;
			}
		}
	}

	return pFrameData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData::GetFrameDataByReceiptNo()
//	ABSTRACT : t[̎擾itԍwj
//	FUNCTION : t[̎擾itԍwj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CFrameData* COrderData::GetFrameDataByReceiptNo( ULONG ReceiptNo )
{
	CFrameData*	pFrameData	= NULL;

	for( int i =0; i < (int)m_vFrame.size(); i++ )
	{
		CFrameData * ptmpFrameData	= ( CFrameData * ) m_vFrame[i];
		
		if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
		{
			if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNo )
			{
				pFrameData	= ptmpFrameData;
			}
		}
	}

	return pFrameData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData::GetFrameDataByReceiptNo2()
//	ABSTRACT : t[̎擾itԍwjtԍ܂Ō
//	FUNCTION : t[̎擾itԍwjtԍ܂Ō
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.07
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
CFrameData* COrderData::GetFrameDataByReceiptNo2( ULONG ReceiptNo )
{
	CFrameData*	pFrameData	= NULL;

	for( int i =0; i < (int)m_vFrame.size(); i++ )
	{
		CFrameData * ptmpFrameData	= ( CFrameData * ) m_vFrame[i];
		
		if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
		{
			for( int i = (int)( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetSize() - 1; i >= 0; i-- )
			{
				if( ReceiptNo == ( (CFrameDataPrint*)ptmpFrameData )->m_ReceiptNoArray.GetAt( i ) )
				{
					pFrameData	= ptmpFrameData;
					return pFrameData;
				}
			}
		}
	}

	return pFrameData;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrderData::DeleteFrameData()
//	ABSTRACT : t[̍폜
//	FUNCTION : t[̍폜
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.21
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή@for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL COrderData::DeleteFrameData( DWORD dwPrintId )
{
	BOOL	bRet	= FALSE;

	for( int i =0; i < (int)m_vFrame.size(); i++ )
	{
		CFrameData * ptmpFrameData	= ( CFrameData * ) m_vFrame[i];
		
		if( CFrameData::TYPE_PRINT == ptmpFrameData->GetType() )
		{
			if( dwPrintId == ( (CFrameDataPrint*)ptmpFrameData )->m_dwPrintId )
			{
				delete ptmpFrameData;
				bRet	= TRUE;
				break;
			}
		}
	}

	return bRet;
}
