//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrintThread.cpp
//	ABSTRACT  : CPrintThread NX̃Cve[V
//	
//	CREATE    : Y.Yoshinobu	2006.10.8
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sdk.h"
#include "PrintThread.h"
#include "nkcProfileModule.h"

extern char		g_szTempFolder[MAX_PATH];

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : int WINAPI PrintThreadEntry()
//	ABSTRACT : vg̃Xbh̃Gg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.2
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
unsigned int WINAPI PrintThreadEntry( LPVOID pParam )
{
	CPrintThread* pPrintThread = (CPrintThread*)pParam;

	NPS_LOGOUT( ">>> Print Thread Start" );
	pPrintThread->InitInstance();
	pPrintThread->ExecProc();
	pPrintThread->ExitInstance();
	NPS_LOGOUT( "<<< Print Thread End" );

	return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::CPrintThread()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPrintThread::CPrintThread()
{
	InitializeCriticalSection( &m_csPrintPause );

	m_hEvent[EVENT_STOP]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );
	m_hEvent[EVENT_PRINT]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );
#if defined(EVENT_TIMER_ON)
	m_hEvent[EVENT_TIMER]	= ::CreateWaitableTimer( NULL, FALSE, NULL );
#endif // defined(EVENT_TIMER_ON)
	m_hEvent[EVENT_FINISH]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );	// 2006.11.06 T.Mizushima


	m_hStartEvent			= ::CreateEvent( NULL, FALSE, FALSE, NULL );

	m_pPrintQue = NULL;
	m_pNpsCmd = NULL;

	m_bPrintPause = FALSE;

	m_hImgFileJpgL6 = NULL;

	m_hImgFileBmpL2 = NULL;

	m_hImgFileTifL1 = NULL;

	m_hNkcICorrGPro = NULL;

	m_ImgPortRetry = FALSE;

	m_hIccsCall	= NULL;
	m_pIccsCall	= NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::~CPrintThread()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPrintThread::~CPrintThread()
{
	::CloseHandle( m_hStartEvent );

	for ( int ii=0 ; EVENT_CNT > ii ; ii++ )
	{
		::CloseHandle( m_hEvent[ii] );
	}

	DeleteCriticalSection( &m_csPrintPause );

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::InitInstance()
//	ABSTRACT : XbhJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::InitInstance()
{
	// IpCxg
	::ResetEvent( m_hEvent[EVENT_STOP] );

	// MmpCxg
	::ResetEvent( m_hEvent[EVENT_PRINT] );

	// XbhImFpCxg
	::ResetEvent( m_hEvent[EVENT_FINISH] );

#if defined(EVENT_TIMER_ON)
	// ^C}[Zbg
	LARGE_INTEGER	InitTime;
	InitTime.QuadPart = -10000;
	::SetWaitableTimer( m_hEvent[EVENT_TIMER], &InitTime, 3000, NULL, NULL, FALSE );
#endif // defined(EVENT_TIMER_ON)

	if ( NULL == m_hImgFileJpgL6 )
	{
		m_hImgFileJpgL6 = ::AfxLoadLibrary( "JPGconv.dll" );

		if ( NULL == m_hImgFileJpgL6 )
		{
			NPS_LOGOUT_FATAL( "===AfxLoadLibrary( JPGconv.dll ) FAIL" );
		}
	}

	if ( NULL == m_hImgFileBmpL2 )
	{
		m_hImgFileBmpL2 = ::AfxLoadLibrary( "BMPconv.dll" );

		if ( NULL == m_hImgFileBmpL2 )
		{
			NPS_LOGOUT_FATAL( "===AfxLoadLibrary( BMPconv.dll ) FAIL" );
		}
	}

	if ( NULL == m_hImgFileTifL1 )
	{
		m_hImgFileTifL1 = ::AfxLoadLibrary( "TIFconv.dll" );

		if ( NULL == m_hImgFileTifL1 )
		{
			NPS_LOGOUT_FATAL( "===AfxLoadLibrary( TIFconv.dll ) FAIL" );
		}
	}

#if defined(NKC_CMS_PROC)

	// GPro摜IuWFNg̃nh
	m_hNkcICorrGPro = NkcICorr_GProImgProc_Start();

	if ( NULL == m_hNkcICorrGPro )
	{
		{	// Oo
			NPS_LOGOUT_FATAL( "===NkcICorr_GProImgProc_Start() FAIL" );
		}
	}
	else
	{
		m_pDataManager->SetExistGProProc( TRUE );
	}

#endif // defined(NKC_CMS_PROC)

	//-----------------------------
	// IccsCall
	//-----------------------------
	if ( NULL == m_hIccsCall )
	{
		m_hIccsCall = ::AfxLoadLibrary( "IccsCall.dll" );

		if ( m_hIccsCall )
		{
			CREATEICCSCALL funcCreateIccsCall = (CREATEICCSCALL)::GetProcAddress( m_hIccsCall, "CreateIccsCall" );

			if( funcCreateIccsCall )
			{
				m_pIccsCall	= funcCreateIccsCall();

				if( NULL == m_pIccsCall )
				{
					NPS_LOGOUT_FATAL( "===CreateIccsCall FAIL" );
				}
			}
			else
			{
				NPS_LOGOUT_FATAL( "===GetProcAddress( CreateIccsCall ) FAIL" );
			}
		}
		else
		{
			NPS_LOGOUT_FATAL( "===AfxLoadLibrary( IccsCall.dll ) FAIL" );
		}
	}

	::SetEvent( m_hStartEvent );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ExitInstance()
//	ABSTRACT : XbhI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::ExitInstance()
{

	if ( NULL != m_hImgFileJpgL6 )
	{
		::AfxFreeLibrary( m_hImgFileJpgL6 );
		m_hImgFileJpgL6 = NULL;
	}

	if ( NULL != m_hImgFileBmpL2 )
	{
		::AfxFreeLibrary( m_hImgFileBmpL2 );
		m_hImgFileBmpL2 = NULL;
	}

	if ( NULL != m_hImgFileTifL1 )
	{
		::AfxFreeLibrary( m_hImgFileTifL1 );
		m_hImgFileTifL1 = NULL;
	}


#if defined(NKC_CMS_PROC)

	// CMS摜I
	if ( NULL != m_hNkcICorrGPro )
	{
		NkcICorr_GProImgProc_End( m_hNkcICorrGPro );
		m_hNkcICorrGPro = NULL;
	}

#endif // defined(NKC_CMS_PROC)

	//-----------------------------
	// IccsCall
	//-----------------------------
	if ( m_hIccsCall )
	{
		if( m_pIccsCall )
		{
			RELEASEICCSCALL funcReleaseIccsCall = (RELEASEICCSCALL)::GetProcAddress( m_hIccsCall, "ReleaseIccsCall" );

			if( funcReleaseIccsCall )
			{
				funcReleaseIccsCall( m_pIccsCall );
			}
			else
			{
				NPS_LOGOUT_FATAL( "===GetProcAddress( funcReleaseIccsCall ) FAIL" );
			}
		}

		::AfxFreeLibrary( m_hIccsCall );
		m_hIccsCall = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ExecProc()
//	ABSTRACT : XbhC[v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::ExecProc()
{
	DWORD dwHandleSignaled;

	while ( TRUE )
	{
		dwHandleSignaled = ::WaitForMultipleObjects( EVENT_CNT, m_hEvent, FALSE, INFINITE );

		if ( EVENT_STOP == ( dwHandleSignaled - WAIT_OBJECT_0 ) )
		{
			// XbhI
			break;
		}

		switch ( dwHandleSignaled - WAIT_OBJECT_0 )
		{
		case EVENT_PRINT:
#if defined(EVENT_TIMER_ON)
		case EVENT_TIMER:
#endif // defined(EVENT_TIMER_ON)

			::EnterCriticalSection( &(m_pSdk->m_csExpress) );

			// vgC֐
			PrintProcMain();

			::LeaveCriticalSection( &(m_pSdk->m_csExpress) );

			break;

		}
	}

	::SetEvent( m_hEvent[EVENT_FINISH] );	// XbhImFpCxgZbg	2006.11.06 T.Mizushima
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::EndThread()
//	ABSTRACT : XbhIv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::EndThread()
{
	::SetEvent( m_hEvent[EVENT_STOP] );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintPause()
//	ABSTRACT : vgvꎞ~
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintPause()
{
	::EnterCriticalSection( &m_csPrintPause );

	m_bPrintPause = TRUE;

	::LeaveCriticalSection( &m_csPrintPause );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintRestart()
//	ABSTRACT : vgvĊJ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintRestart()
{
	::EnterCriticalSection( &m_csPrintPause );

	m_bPrintPause = FALSE;

	::LeaveCriticalSection( &m_csPrintPause );

	::SetEvent( m_hEvent[EVENT_PRINT] );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetPrintEvent()
//	ABSTRACT : vgJnCxg쓮
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetPrintEvent()
{
	::SetEvent( m_hEvent[EVENT_PRINT] );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::GetStartEventHandle()
//	ABSTRACT : ImFpCxg̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.14
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
HANDLE CPrintThread::GetStartEventHandle()
{
	return m_hStartEvent;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetPrintQue()
//	ABSTRACT : vgL[IuWFNg̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetPrintQue( CPrintQue* pPrintQue )
{
	m_pPrintQue = pPrintQue;

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetNpsCmd()
//	ABSTRACT : R}hMIuWFNg̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetNpsCmd( CNpsCmd* pNpsCmd )
{
	m_pNpsCmd = pNpsCmd;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetNpsImgMng()
//	ABSTRACT : 摜MIuWFNg̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetNpsImgMng( CNpsImgManager* pNpsImgMng )
{
	m_pNpsImgMng = pNpsImgMng;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetDataManager()
//	ABSTRACT : v^ǗIuWFNg̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetDataManager( CDataManager* pDataManager )
{
	m_pDataManager = pDataManager;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcMain()
//	ABSTRACT : vgC֐
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcMain()
{
	short nRetry;
	BOOL bPrintPause;

	::EnterCriticalSection( &m_csPrintPause );
	bPrintPause = m_bPrintPause;
	::LeaveCriticalSection( &m_csPrintPause );

	if ( TRUE == bPrintPause )
	{
		return;
	}

	if ( NULL == m_pPrintQue )
	{
		return;
	}


	T_NextCmd tNextCmd;
	::ZeroMemory( &tNextCmd, sizeof(T_NextCmd) );

	if ( TRUE == m_pPrintQue->GetNextProcData( &tNextCmd ) )
	{
		if (( FALSE == m_pDataManager->IsPrintEnable( &tNextCmd ) ) &&
			( CMD_ORDER_END != tNextCmd.eCmdType ))		// LI͏ԂɊ֌WȂł悤ɏC 2006.12.24 gM
		{
			// v^tłȂ
			return;
		}

		switch ( tNextCmd.eCmdType )
		{
		case CMD_ORDER_START:	// I[_[Jn
			PrintProcOrderStart( &tNextCmd );
			break;
		case CMD_FRAME:			// R}
			// gC񐔂̏𖳐ɕύX Y.Yoshinobu 2006.11.18
			// (gC񐔂̓v^̉Ŕf邽)
			for ( nRetry=0 ;  ; nRetry++ )
			{
				if ( TRUE == PrintProcFrame( &tNextCmd, nRetry ) )
				{
					// đȂ
					break;
				}
			}
			break;
		case CMD_BLANK_FRAME:	// 󔒃R}
			PrintProcBlankFrame( &tNextCmd );
			break;
		case CMD_SORTER:		// \[^[
			PrintProcSort( &tNextCmd );
			break;
		case CMD_DUPLEX_START:	// ʈJn
			PrintProcDuplexStart( &tNextCmd );
			break;
		case CMD_DUPLEX_END:	// ʈI
			PrintProcDuplexEnd( &tNextCmd );
			break;
		case CMD_RETRANSMISSION_START:	// đJn		2011.11.21 A.Nagamatsu
			PrintProcRetransmissionStart( &tNextCmd );
			break;
		case CMD_RETRANSMISSION_END:	// đI		2011.11.21 A.Nagamatsu
			PrintProcRetransmissionEnd( &tNextCmd );
			break;
		case CMD_ORDER_END:		// I[_[I
			PrintProcOrderEnd( &tNextCmd );
			break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcOrderStart()
//	ABSTRACT : I[_[Jnv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcOrderStart( T_NextCmd* pNextCmd )
{
	long nResult;
	T_StartOrderData tStartOrderData;

	::ZeroMemory( &tStartOrderData, sizeof(T_StartOrderData) );

	//------------------------------------------------------------
	// v^LJn
	//------------------------------------------------------------

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetStartOrderData( pNextCmd, &tStartOrderData ) )
	{
		return;
	}

	//------------------------------------------------------------
	// 摜Mp\Pbg쐬
	//------------------------------------------------------------
	if ( 0 == pNextCmd->wNpsImgPort )
	{
		// 摜Mp\PbgȂ
		pNextCmd->wNpsImgPort = m_pNpsImgMng->CreateSocket();
		if( 0 == pNextCmd->wNpsImgPort )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CREATE SOCKET ERROR" );
			return;
		}
		m_pPrintQue->SetPortNo( pNextCmd->dwOrderId, pNextCmd->wNpsImgPort );
	}
	else
	{
		//------------------------------------------------------------
		// 摜Mp|[gOpen
		//------------------------------------------------------------
		if ( FALSE == m_pNpsImgMng->IsOpenSocket( pNextCmd->wNpsImgPort ) )
		{
			// \Pbg쐬łĂȂ΍č쐬
			if ( FALSE == m_pNpsImgMng->CreateSocketByPortNo( pNextCmd->wNpsImgPort ) )
			{
				NPS_LOGOUT_FATAL( " --NPS IMG CREATE SOCKET BY PORTNO ERROR" );
				::Sleep( 1000 );
				return;
			}
		}
	}

	//------------------------------------------------------------
	// vgLJn
	//------------------------------------------------------------
	if ( STEP0_ORDER_NONE == tStartOrderData.eOrderStep )
	{
		BOOL bResume = FALSE;

		if ( FALSE == m_pDataManager->IsEnableOccupy( pNextCmd, &bResume ) )
		{
			// v^L̂ߐLłȂ
			return;
		}

		T_Nps6000H_0500H tNps6000H_0500H;	// v^LJnv
		T_Nps6000H_0501H tNps6000H_0501H;	// v^LJn

		tNps6000H_0500H.Port			= pNextCmd->wNpsImgPort;			// 摜Mp̃|[gԍ
		tNps6000H_0500H.InterruptMode	= tStartOrderData.wInterruptMode;	// 荞݃[h
		if ( QUE_PRINT == pNextCmd->eQueModeM )								// eiX
		{
			tNps6000H_0500H.InMaintenance	= 0;							// eAvLĂȂ
		}
		else
		{
			tNps6000H_0500H.InMaintenance	= 1;							// eAvLĂ
		}

		// L[h
		switch ( pNextCmd->eQueModeP )
		{
		case QUE_NORMAL:
			tNps6000H_0500H.PossessionMode = 0;	// ʏ
			break;
		case QUE_EXPRESS1:
			tNps6000H_0500H.PossessionMode = 2;	// }[x1]
			break;
		case QUE_EXPRESS2:
			NPS_LOGOUT_FATAL( " --   logic error" );	// VXeƂāAɗ邱Ƃ͂肦Ȃ
			tNps6000H_0500H.PossessionMode = 4;	// }[x2]
			break;
		}
		if ( TRUE == bResume )
		{
			// 荞ݒf̍ĊJ1ZL[h𑗐M
			tNps6000H_0500H.PossessionMode += 1;
		}

		if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
		{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.09	T.Mizushima
			if ( TRUE == bResume )
			{	// 荞ݒf̍ĊJ͊荞܂O̐LԍZbg
				tNps6000H_0500H.PossessionNo = tStartOrderData.wPossessionNo;
			}
			else
			{
				tNps6000H_0500H.PossessionNo = 0;
			}
		}
		else
		{
			tNps6000H_0500H.PossessionNo = 0;
		}

		tNps6000H_0500H.ExOptions	=	tStartOrderData.dwExOptions;	// gIvV(Pvg) 2014.10.28 M.Yamamoto

		{	// Oo
			CString str;
			str.Format( " --OccupyStart( dwOrderId=%d )", pNextCmd->dwOrderId );
			NPS_LOGOUT( str );
		}

		nResult	= m_pNpsCmd->OccupyStart( &tNps6000H_0500H, &tNps6000H_0501H );

		if( NPSERR_NORMAL != nResult )
		{
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0500H )" );

			// ʐMG[̂ŉIɐؒfďZbg
			m_pSdk->SocketCloseProc();
			return;
		}

		if( NPS_SUCCESS != tNps6000H_0501H.Result )
		{
			// v^G[
			return;
		}

		// Lԍo^
		m_pPrintQue->SetPossessionNo( pNextCmd->dwOrderId, tNps6000H_0501H.PossessionNo );
		m_pPrintQue->UpdateOrderStep( pNextCmd->dwOrderId, STEP1_ORDER_6000_0500 );
	}

	//------------------------------------------------------------
	// 摜Mp|[gConnect
	//------------------------------------------------------------

	// I[_[JnvɕKvȏĎ擾
	if ( FALSE == m_pPrintQue->GetStartOrderData( pNextCmd, &tStartOrderData ) )
	{
		return;
	}

	if ( STEP1_ORDER_6000_0500 == tStartOrderData.eOrderStep )
	{
		if( FALSE == m_pNpsImgMng->Connect( pNextCmd->wNpsImgPort ) )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CONNECT ERROR" );
			return;
		}

		// |[gԍLĂ
		m_pPrintQue->SetPortNo( pNextCmd->dwOrderId, pNextCmd->wNpsImgPort );
		{
			CString	str;
			str.Format( "--StartOrder NpsImg Connect ( OrderId=%d, PortNo=%d )", pNextCmd->dwOrderId, pNextCmd->wNpsImgPort );
			NPS_LOGOUT( str );
		}

		// 摜]|[g̐ڑݒ
		m_pPrintQue->UpdateOrderStep( pNextCmd->dwOrderId, STEP2_ORDER_IMG_CONNECT );
	}

	//------------------------------------------------------------
	// vgIvVݒ
	//------------------------------------------------------------

	// I[_[JnvɕKvȏĎ擾
	if ( FALSE == m_pPrintQue->GetStartOrderData( pNextCmd, &tStartOrderData ) )
	{
		return;
	}

	if ( STEP2_ORDER_IMG_CONNECT == tStartOrderData.eOrderStep )
	{
		if( ( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() ) &&
			( TRUE == tStartOrderData.bReOccupy ) )
		{	// V^荞ݑΉ		@@@RD-151Ή	2012.05.08	T.Mizushima
			// }ݏI̍ĐLȂAvgIvVݒ͍đȂ
		}
		else
		{
			T_Nps6000H_1200H tNps6000H_1200H;	// vgIvVݒv
			T_Nps6000H_1201H tNps6000H_1201H;	// vgIvVݒ艞

			tNps6000H_1200H.PossessionNo	= tStartOrderData.wPossessionNo;	// Lԍ
			tNps6000H_1200H.SorterNum		= tStartOrderData.wSorterNum;		// vg̎d

			nResult	= m_pNpsCmd->SetPrintOption( &tNps6000H_1200H, &tNps6000H_1201H );

			if (( NPSERR_NORMAL != nResult ) &&
				( NPSERR_BADPARAM != nResult ))		// dDP̓R}hT|[gĂȂ̂NPSERR_BADPARAMłOKƂ
			{
				NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x1200H )" );

				// ʐMG[̂ŉIɐؒfďZbg
				m_pSdk->SocketCloseProc();
				return;
			}

			if( NPS_SUCCESS != tNps6000H_1201H.Result )
			{
				// >>> _08241Ή 2008.05.20 Y.Yoshinobu
				switch ( tNps6000H_1201H.Result )
				{
				case NPS_ERROR_01:		// 1 `G[
				default:
					// Oo͂čđ
					NPS_LOGOUT_FATAL( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1201H ) RETRY" );
					break;
				case NPS_ERROR_09:		// 9 v^̐LsĂ܂
				case NPS_ERROR_27:		// 27 v^Lf܂
				case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
					// LJnēxs
					m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId );
					SetPrintEvent();
					break;
				}
				// <<< _08241Ή 2008.05.20 Y.Yoshinobu
				return;
			}
		}

		m_pPrintQue->UpdateOrderStep( pNextCmd->dwOrderId, STEP3_ORDER_6000_1200 );
	}

	//------------------------------------------------------------
	// NWbgJn
	//------------------------------------------------------------

	// NWbgJn
	PrintProcCreditStart( pNextCmd );

	//------------------------------------------------------------
	// [hύXv
	//------------------------------------------------------------

	// [h
	PrintProcModeChange( pNextCmd, 4 );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcFrame()
//	ABSTRACT : R}v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : đȂ	TRUE
//             đ		FALSE
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : T.Isogai		2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : Y.Yoshinobu	2008.09.01 npsDevPrintIccsXml ̏ō쐬摜폜悤ɕύX
//	UPDATE   : Y.Yoshinobu	2008.10.24 npsDevPrintIccsXml0701ɉ摜TCYZbgĂȂ̂ŏC
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::PrintProcFrame( T_NextCmd* pNextCmd, const short nRetry )
{
	long nResult;
	T_FrameData tFrameData;
	BOOL bIsImgProc=FALSE;			// 摜sǂi TRUE:, FALSE:Ȃ j
	CImgSendParam objImgSendParam;	// 摜M̃p[^
	CIcwProcParam objIcwProcParam;	// 摜p[^
	T_Nps6000H_0101H tNps6000H_0101H;
	T_Nps6000H_0201H tNps6000H_0201H;
	T_Nps6000H_0700H tNps6000H_0700H;	// tJnv
#if defined( NKC_CMS_PROC )
	BOOL bDeleteCmsDatFile = FALSE;	// CMSŎgpDatt@C폜邩ǂ
	T_NpsRegMagInfo tMagInfo;
#endif

	// 
	::ZeroMemory( &tFrameData, sizeof(T_FrameData) );

	// v^{̎擾
	m_pDataManager->GetPrinterBasic( &tNps6000H_0101H );

	// v^ݒ̎擾
	m_pDataManager->GetPrinterSetup( &tNps6000H_0201H );

	//------------------------------------------------------------
	// 摜M|[gƂ̃RlNVԂmF
	//------------------------------------------------------------

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}


	if ( FALSE == m_pNpsImgMng->IsOpenSocket( pNextCmd->wNpsImgPort ) )
	{
		// v^dfȂǂŁAv^Ƃ̒ʐMˑRؒfꍇ
		//  Connect() ŔĂȂȂꍇ
		// ŐؒfĂ̂͊{Iɂ͂̂ŁA^[
		// Đڑ̏ɔC
		// pNpsImgUdeleteāAĐڑ@łǂȂ...

		// ڑؒf
		m_pNpsImgMng->Delete( pNextCmd->wNpsImgPort );

		// \Pbg̍č쐬
		if ( FALSE == m_pNpsImgMng->CreateSocketByPortNo( pNextCmd->wNpsImgPort ) )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CREATE SOCKET BY PORTNO ERROR" );
			::Sleep( 1000 );
			SetPrintEvent();	// Ô
			return TRUE;
		}

		// Đڑ
		if ( FALSE == m_pNpsImgMng->Connect( pNextCmd->wNpsImgPort ) )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CONNECT ERROR" );
			::Sleep( 1000 );
			SetPrintEvent();	// Ô
			return TRUE;
		}
	}

	//------------------------------------------------------------
	// M摜쐬
	//------------------------------------------------------------

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}

	if (( STEP0_FRAME_NONE == tFrameData.eFrameStep ) ||
		( STEPA_FRAME_6000_0700_13 == tFrameData.eFrameStep ))
	{

		objImgSendParam.Clear();
		::ZeroMemory( &tNps6000H_0700H, sizeof( T_Nps6000H_0700H ) );

		{	// NPS ̏

			// T_Nps6000H_0700Hւ̏ݒ
			MakeCmd_6000_0700( tFrameData, tNps6000H_0700H );

			// 摜Mf[^̏ݒ
			objImgSendParam.m_dwSourceType		= tFrameData.dwSourceType;
			objImgSendParam.m_dwTransDataLength	= tFrameData.tPrnParam.dwDataLength;
			objImgSendParam.m_dwFileDataLength	= tFrameData.tPrnParam.dwDataLength;
			objImgSendParam.m_dwOffset			= tFrameData.tPrnParam.dwOffset;
			objImgSendParam.m_dwImgWidth		= tFrameData.tPrnParam.dwImgWidth;
			objImgSendParam.m_dwImgHeight		= tFrameData.tPrnParam.dwImgHeight;
			objImgSendParam.m_strFileName		= tFrameData.szName;

#if defined( NKC_CMS_PROC )
			// y[p[̎擾
			if ( FALSE == m_pDataManager->GetMagInfo(
							(UCHAR)tFrameData.tPrnParam.dwFeed,
							(USHORT)tFrameData.tPrnParam.dwResolution,
							(USHORT)tFrameData.tPrnParam.dwPaperWidth,
							(USHORT)tFrameData.tPrnParam.dwPaperLength,
							(USHORT)tFrameData.tPrnParam.dwSurface,
							tFrameData.tPrnParam.szPaperName,
							&tMagInfo ) )
			{
				// s
				NPS_LOGOUT_FATAL( "===[PAPER NOT FOUND]" );
				ErrorNoticeON_6681( 1 );	// lbg[NʐMG[ ( [1]tJnR}hŎsԂĂ )
				m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
				SetPrintEvent();
				return TRUE;
			}

			objIcwProcParam.Clear();
			objIcwProcParam.m_objInitParam.m_SourceType			= objImgSendParam.m_dwSourceType;
			objIcwProcParam.m_objInitParam.m_FileOffset			= objImgSendParam.m_dwOffset;
			objIcwProcParam.m_objInitParam.m_ImageFormat		= tNps6000H_0700H.ImageFormat;
			objIcwProcParam.m_objInitParam.m_ImageCapacity		= tNps6000H_0700H.ImageCapacity;
			objIcwProcParam.m_objInitParam.m_ImageWidth			= tNps6000H_0700H.ImageWidth;
			objIcwProcParam.m_objInitParam.m_ImageHeight		= tNps6000H_0700H.ImageHeight;
			objIcwProcParam.m_objInitParam.m_Resolution			= tNps6000H_0700H.PaperResolution;
			objIcwProcParam.m_objInitParam.m_SpRect.top			= tMagInfo.PaperAllocationTop;
			objIcwProcParam.m_objInitParam.m_SpRect.bottom		= tMagInfo.PaperAllocationBottom;
			objIcwProcParam.m_objInitParam.m_SpRect.left		= tMagInfo.PaperAllocationLeft;
			objIcwProcParam.m_objInitParam.m_SpRect.right		= tMagInfo.PaperAllocationRight;
			objIcwProcParam.m_objInitParam.m_PaperSize.cx		= tNps6000H_0700H.PaperWidth;
			objIcwProcParam.m_objInitParam.m_PaperSize.cy		= tNps6000H_0700H.PaperLength;
			objIcwProcParam.m_objInitParam.m_PaperAdjustLeft	= tMagInfo.WBAdjustLeft;
			objIcwProcParam.m_objInitParam.m_PaperAdjustRight	= tMagInfo.WBAdjustRight;
			objIcwProcParam.m_objInitParam.m_Angle				= tNps6000H_0700H.Angle;
			objIcwProcParam.m_objInitParam.m_Espc				= tNps6000H_0700H.Espc;
			objIcwProcParam.m_objInitParam.m_PaperFitting		= tNps6000H_0700H.PaperFitting;
			objIcwProcParam.m_objInitParam.m_EdgeEnhancement	= ((INFO_EEOK == tNps6000H_0700H.EdgeEnhancement) && (2 == tNps6000H_0101H.MachineTypeID)) ? TRUE : FALSE ;
			objIcwProcParam.m_objInitParam.m_WB.top				= tNps6000H_0700H.WithBorderTop;
			objIcwProcParam.m_objInitParam.m_WB.bottom			= tNps6000H_0700H.WithBorderBottom;
			objIcwProcParam.m_objInitParam.m_WB.left			= tNps6000H_0700H.WithBorderLeft;
			objIcwProcParam.m_objInitParam.m_WB.right			= tNps6000H_0700H.WithBorderRight;
			objIcwProcParam.m_objInitParam.m_PrintCenterOffset	= tNps6000H_0700H.PrintCenterOffset;

			// NTOConverterCMST|[g悤ɂȂ̂ŁAv^CMST|[gĂƂ
			// v^CMSs悤ɕύX Y.Yoshinobu 2009.06.12
			if ( 0 == tNps6000H_0201H.SupportCMS )
			{
				// v^CMSɖΉ̂Ƃ
				if ( FALSE == GetFileNameOfCmsDat(
									tNps6000H_0700H.CMS,
									tFrameData.tPrnParam.dwColorSpace,
									tMagInfo.PaperTypeCode,
									&tNps6000H_0101H,
									&tNps6000H_0201H,
									&bDeleteCmsDatFile,
									&objIcwProcParam.m_objInitParam.m_strCmsFileName ) )
				{
					objIcwProcParam.m_objInitParam.m_strCmsFileName.Empty();
					bDeleteCmsDatFile = FALSE;
				}
			}
			else
			{
				// v^CMSΉĂƂ́ACMSv^ōŝNPSłCMSsȂ
				objIcwProcParam.m_objInitParam.m_strCmsFileName.Empty();
				bDeleteCmsDatFile = FALSE;
			}
			objIcwProcParam.m_objInitParam.m_strFileName		= objImgSendParam.m_strFileName;

			// 摜
			IcwMainProc( &objIcwProcParam );

			if ( TRUE == bDeleteCmsDatFile )
			{
				// Datt@C폜
				::DeleteFile( objIcwProcParam.m_objInitParam.m_strCmsFileName );
			}

			if ( TRUE == objIcwProcParam.m_objResultParam.m_bSuccess )
			{
				// 
				tNps6000H_0700H.ImageFormat			= objIcwProcParam.m_objResultParam.m_ImageFormat;
				tNps6000H_0700H.ImageCapacity		= objIcwProcParam.m_objResultParam.m_ImageCapacity;
				tNps6000H_0700H.ImageWidth			= objIcwProcParam.m_objResultParam.m_ImageWidth;
				tNps6000H_0700H.ImageHeight			= objIcwProcParam.m_objResultParam.m_ImageHeight;
				tNps6000H_0700H.Angle				= PROC_ANGLE0;
				tNps6000H_0700H.Espc				= objIcwProcParam.m_objResultParam.m_Espc;
				tNps6000H_0700H.PaperFitting		= PROC_REALSIZE;
				tNps6000H_0700H.EdgeEnhancement		= PROC_EE_OFF;
				if ( 0 == tNps6000H_0201H.SupportCMS )
				{
					// v^CMSɖΉ̂Ƃ́AICMSOFFɂăv^֑M
					tNps6000H_0700H.CMS					= PROC_CMSOFF;
				}
				tNps6000H_0700H.WithBorderTop		= 0;
				tNps6000H_0700H.WithBorderBottom	= 0;
				tNps6000H_0700H.WithBorderLeft		= 0;
				tNps6000H_0700H.WithBorderRight		= 0;
				tNps6000H_0700H.PrintCenterOffset	= objIcwProcParam.m_objResultParam.m_PrintCenterOffset;

				objImgSendParam.m_dwSourceType		= objIcwProcParam.m_objResultParam.m_SourceType;
				objImgSendParam.m_dwTransDataLength	= objIcwProcParam.m_objResultParam.m_ImageCapacity;
				objImgSendParam.m_dwFileDataLength	= objIcwProcParam.m_objResultParam.m_ImageCapacity;
				objImgSendParam.m_dwOffset			= objIcwProcParam.m_objResultParam.m_FileOffset;
				objImgSendParam.m_dwImgWidth		= objIcwProcParam.m_objResultParam.m_ImageWidth;
				objImgSendParam.m_dwImgHeight		= objIcwProcParam.m_objResultParam.m_ImageHeight;
				objImgSendParam.m_strFileName		= objIcwProcParam.m_objResultParam.m_strFileName;

				bIsImgProc = objIcwProcParam.m_objResultParam.m_bDeleteFile;
			}
			else
			{
				// s
				NPS_LOGOUT_FATAL( "===[IMG PROC] FAIL" );
				ErrorNoticeON_6681( 2 );	// lbg[NʐMG[ ( [2]摜̓ǂݍݎs )
				m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
				SetPrintEvent();
				return TRUE;
			}

#else  // defined( NKC_CMS_PROC )

			//-------------------------------
			// IccsCall摜
			//-------------------------------
			if( tFrameData.bIccsXml )
			{
				BOOL	bSuccess	= FALSE;

				//----------------------------------------
				// 摜
				//----------------------------------------
				if( m_pIccsCall )
				{
					CString str;
					str.Format( "---CallXmlCmdExecFile START dwOrderId=%d, dwPrintId=%d, ", pNextCmd->dwOrderId, pNextCmd->dwPrintId );
					NPS_LOGOUT( str );

					HRESULT hr = m_pIccsCall->CallXmlCmdExecFile( tFrameData.tIccsXml.priority, tFrameData.tIccsXml.IccsCmdFilePath );

					str.Format( "---CallXmlCmdExecFile END HRESULT( %08Xh )", hr );
					NPS_LOGOUT( str );

					if( SUCCEEDED( hr ) )
					{
						bSuccess	= TRUE;
					}
				}

				//----------------------------------------
				// 摜t@CTCYdwDataLengthɐݒ
				//----------------------------------------
				if( bSuccess )
				{
					DWORD	dwDataLength	= NkcComApi::GetFileSize( objImgSendParam.m_strFileName );

					if( 0 != dwDataLength )
					{
						// npsDevPrintIccsXml0701ɉ摜TCYZbgĂȂ̂ŏC Y.Yoshinobu 2008.10.24
						tNps6000H_0700H.ImageCapacity		= dwDataLength;

						tFrameData.tPrnParam.dwDataLength	= tFrameData.dwDataLength	= dwDataLength;
						objImgSendParam.m_dwTransDataLength	= tFrameData.tPrnParam.dwDataLength;
						objImgSendParam.m_dwFileDataLength	= tFrameData.tPrnParam.dwDataLength;
					}
					else
					{
						bSuccess	= FALSE;
					}
				}

				//----------------------------------------
				// sł΃G[\
				//----------------------------------------
				if( FALSE == bSuccess )
				{
					// s
					NPS_LOGOUT_FATAL( "===[IMG PROC ICCS CALL] FAIL" );
					// init@Cn̏ꍇ́Ainit@C폜Ȃ悤ɂ
					if ( IMGFMT_BMP_PATH != tNps6000H_0700H.ImageFormat )
					{
						::DeleteFile( objImgSendParam.m_strFileName );	// Ô߃t@C폜
					}
					ErrorNoticeON_6681( 2 );	// lbg[NʐMG[ ( [2]摜̓ǂݍݎs )
					m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
					SetPrintEvent();
					return TRUE;
				}

				// init@Cn̏ꍇ́Ainit@C폜Ȃ悤ɂ
				if ( IMGFMT_BMP_PATH != tNps6000H_0700H.ImageFormat )
				{
					// npsDevPrintIccsXml ̏ō쐬摜폜悤ɕύX	Y.Yoshinobu 2008.09.01
					bIsImgProc = TRUE;
				}
			}

#endif // defined( NKC_CMS_PROC )

			// BMPRAW֕ϊȂ摜𑗐Mꍇ̃p[^ݒ
			if ( IMGFMT_BMP == tNps6000H_0700H.ImageFormat )
			{
				if (( INFO_IMGNO == tNps6000H_0201H.SupportImageFormat[1] ) &&
					( INFO_IMGOK == tNps6000H_0201H.SupportImageFormat[2] ))
				{
					// tNps6000H_0700H ɃZbg摜 BMP => RAW ɕϊ

					objImgSendParam.m_eSendFunc = FUNC_BMP2RAW;

					// 摜e iPʁFBytej
					objImgSendParam.m_dwTransDataLength	= tNps6000H_0700H.ImageCapacity = tNps6000H_0700H.ImageWidth * tNps6000H_0700H.ImageHeight * 3;
					objImgSendParam.m_dwFileDataLength	= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + NkcComApi::DIBWidthBytes( tNps6000H_0700H.ImageWidth, 24 ) * tNps6000H_0700H.ImageHeight;

					// 摜tH[}bg
					tNps6000H_0700H.ImageFormat = IMGFMT_RAW24;
				}

			}

			// RAWBMP֕ϊȂ摜𑗐Mꍇ̃p[^ݒ
			if (( IMGFMT_RAW24 == tNps6000H_0700H.ImageFormat ) &&
				( FUNC_NORMAL == objImgSendParam.m_eSendFunc ))
			{
				if (( INFO_IMGOK == tNps6000H_0201H.SupportImageFormat[1] ) &&
					( INFO_IMGNO == tNps6000H_0201H.SupportImageFormat[2] ))
				{
					// tNps6000H_0700H ɃZbg摜 RAW => BMP ɕϊ

					objImgSendParam.m_eSendFunc = FUNC_RAW2BMP;

					// 摜e iPʁFBytej
					objImgSendParam.m_dwTransDataLength	= tNps6000H_0700H.ImageCapacity = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + NkcComApi::DIBWidthBytes( tNps6000H_0700H.ImageWidth, 24 ) * tNps6000H_0700H.ImageHeight;
					objImgSendParam.m_dwFileDataLength	= tNps6000H_0700H.ImageCapacity = tNps6000H_0700H.ImageWidth * tNps6000H_0700H.ImageHeight * 3;

					// 摜tH[}bg
					tNps6000H_0700H.ImageFormat = IMGFMT_BMP;
				}

			}

			// CRCf[^]
			if (( 0x64 ==tNps6000H_0700H.ImageFormat ) ||	// ʐMx摜
				( 0x65 ==tNps6000H_0700H.ImageFormat ))		// lbg[NȐff摜(CRC`FbNp)
			{
				objImgSendParam.m_eSendFunc = FUNC_CRCDATA;
			}
		}

		m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP1_FRAME_IMGPROC, pNextCmd->dwPrintId );
	}

	//------------------------------------------------------------
	// tJn
	//------------------------------------------------------------

	// tJnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}

	if (( STEP1_FRAME_IMGPROC == tFrameData.eFrameStep ) ||
		( STEPA_FRAME_6000_0700_13 == tFrameData.eFrameStep ))
	{

		T_Nps6000H_0701H tNps6000H_0701H;	// tJn

		if( m_ImgPortRetry == TRUE )
		{	// 摜]pؒfɂ0700HđȂ烊gCJEg0ɂ
			tNps6000H_0700H.Retry	= 0;				// MgC;
			m_ImgPortRetry			= FALSE;
		}
		else
		{
			tNps6000H_0700H.Retry	= nRetry;			// MgC
		}

		nResult	= m_pNpsCmd->PrintRequest( &tNps6000H_0700H, &tNps6000H_0701H );

		if ( NPSERR_NORMAL != nResult )
		{
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0700H )" );
			if ( TRUE == bIsImgProc )
			{
				// ꎞ摜t@C̍폜
				::DeleteFile( objImgSendParam.m_strFileName );
			}
			m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP0_FRAME_NONE, pNextCmd->dwPrintId );

			// ʐMG[̂ŉIɐؒfďZbg
			m_pSdk->SocketCloseProc();
			return TRUE;
		}

		if ( NPS_SUCCESS != tNps6000H_0701H.Result )
		{
			// v^G[
			{	// NPS ̏
				if ( TRUE == bIsImgProc )
				{
					// ꎞ摜t@C̍폜
					::DeleteFile( objImgSendParam.m_strFileName );
				}
			}

			if (( NPS_ERROR_13 == tNps6000H_0701H.Result ) &&
				( 0 != tNps6000H_0701H.ReceiptNumber ))
			{
				// QSS̏ꍇLZKvɂȂ̂ŏԂXV ( ReceiptNumber̒l QSS[0ȊO], dDP[0] )
				if ( STEP1_FRAME_IMGPROC == tFrameData.eFrameStep )
				{
					m_pPrintQue->SetReceiptNo( pNextCmd->dwOrderId, pNextCmd->dwPrintId, tNps6000H_0701H.ReceiptNumber );
					m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEPA_FRAME_6000_0700_13, pNextCmd->dwPrintId );
				}
			}
			else
			{
				m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP0_FRAME_NONE, pNextCmd->dwPrintId );
			}

			// v^G[
			switch ( tNps6000H_0701H.Result )
			{
			case NPS_ERROR_01:		// 1 `G[
			case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
			case NPS_ERROR_11:		// 11 摜tH[}bg̓T|[gĂ܂
			case NPS_ERROR_12:		// 12 s[gsł
			case NPS_ERROR_14:		// 14 摜TCY܂
			case NPS_ERROR_15:		// 15 摜TCY܂
			case NPS_ERROR_16:		// 16 w肵y[p[͎gpł܂
			case NPS_ERROR_17:		// 17 y[p[̑蒷sł
			case NPS_ERROR_40:		// 40 ʈŕ\ʂƗʂ̃y[p[񂪈قȂ܂
			case NPS_ERROR_41:		// 41 ʈŕ\ʂƗʂ̃s[gقȂ܂
				// łȂ̂ŃG[Ƃ
				ErrorNoticeON_6681( 1 );	// lbg[NʐMG[ ( [1]tJnR}hŎsԂĂ )
				m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
				SetPrintEvent();
				break;
			case NPS_ERROR_27:		// 27 v^Lf܂
				if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
				{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
					// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
					if( pNextCmd->eQueModeP == QUE_NORMAL )
					{	// ʏL
						m_pDataManager->SetRestartNormal( TRUE );
					}
					else
					{	// }L
						m_pDataManager->SetRestartExpress( TRUE );
					}
				}
				// breakȂ
			case NPS_ERROR_09:		// 9 v^̐LsĂ܂
			case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
				// LJnēxs
				m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
				SetPrintEvent();
				break;
			case NPS_ERROR_18:		// 18 tsԂł
									//    DryPrinterłԂĂȂ̂ŁAgCJEgAtԍ̓NAĂȂ
			case NPS_ERROR_32:		// 32 CPULZ܂
			case NPS_ERROR_36:		// 36 tLZ܂
				break;
			case NPS_ERROR_13:	// Xv[eʂ̋󂫗eʂ܂
				// gCJEgAbvčđ
				::LeaveCriticalSection( &(m_pSdk->m_csExpress) );	// _02964̑Ή rꎞIɉăv^LJnv[6000][0500]𔭍sł悤ɂ 2007.02.21 gM
				::Sleep( 1000 );	// Xv[󂭂܂1b~
				::EnterCriticalSection( &(m_pSdk->m_csExpress) );	// _02964̑Ή rs	2007.02.21 gM
				return FALSE;
				break;
			case NPS_ERROR_20:		// 20 摜Mp|[gƂ̐ڑmłĂ܂
				// 摜]p|[gĐڑ0700Hđ	2007.01.11 T.Mizushima
				if ( FALSE == m_pNpsImgMng->ReConnect( pNextCmd->wNpsImgPort ) )
				{
					NPS_LOGOUT_FATAL( " --NPS IMG RECONNECT ERROR ( 0700H result 20 )" );
				}
				m_ImgPortRetry = TRUE;	// 摜]pؒfɂ0700HđtOON
				return FALSE;
				break;
			}

			return TRUE;
		}

		m_pPrintQue->SetReceiptNo( pNextCmd->dwOrderId, pNextCmd->dwPrintId, tNps6000H_0701H.ReceiptNumber );
		m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP2_FRAME_6000_0700, pNextCmd->dwPrintId );

		{	// Oo
			CString str;
			str.Format( "---<<< Frame transfer start >>> Priority=%u, OrderId=%u, IndexNo=%u PrintId=%u, Repeat=%u ( ReceiptNo=%u )",
						pNextCmd->eQueModeP, pNextCmd->dwOrderId, pNextCmd->dwIndexNo, pNextCmd->dwPrintId, tNps6000H_0700H.Repeat, tNps6000H_0701H.ReceiptNumber );
			NPS_LOGOUT( str );
		}
	}

	//------------------------------------------------------------
	// 摜f[^M
	//------------------------------------------------------------

	T_TransmitTimeInfo stLastImgTransmitTime;

	::ZeroMemory( &stLastImgTransmitTime, sizeof(T_TransmitTimeInfo) );

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}

	if ( STEP2_FRAME_6000_0700 == tFrameData.eFrameStep )
	{

		nResult = m_pNpsImgMng->SendImageData(
			pNextCmd->wNpsImgPort,
			&objImgSendParam,
			&(stLastImgTransmitTime.dwTime)			// 摜]
			);

		{	// NPS ̏
			if ( TRUE == bIsImgProc )
			{
				// ꎞ摜t@C̍폜
				::DeleteFile( objImgSendParam.m_strFileName );
			}
		}

		switch ( nResult )
		{
		case 0:	// I
			stLastImgTransmitTime.dwOrderId = pNextCmd->dwOrderId;
			stLastImgTransmitTime.dwPrintID = pNextCmd->dwPrintId;
			m_pDataManager->SetLastImgTransmitTime( &stLastImgTransmitTime );	// MԂL^
		case 1:	// 摜Msi摜MmFʂŊmFj
			m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP3_FRAME_IMG_SEND, pNextCmd->dwPrintId );
			break;
		case 2:	// 摜ǂݍݎs
			{
				ErrorNoticeON_6681( 2 );	// lbg[NʐMG[ ( [2]摜̓ǂݍݎs )
				m_pPrintQue->InsideProcError( pNextCmd->dwPrintId );

				if ( 0 != pNextCmd->wNpsImgPort )
				{
					// ڑؒf
					m_pNpsImgMng->Delete( pNextCmd->wNpsImgPort );
					pNextCmd->wNpsImgPort = 0;
					m_pPrintQue->SetPortNo( pNextCmd->dwOrderId, pNextCmd->wNpsImgPort );
				}

				// ̃R}LZ
				T_Nps6000H_0900H	wNps6000H_0900H = { 0 };
				T_Nps6000H_0901H	wNps6000H_0901H = { 0 };
				wNps6000H_0900H.ReceiptNumber = tFrameData.nReceiptNo;
				nResult = m_pNpsCmd->PrintCancel( &wNps6000H_0900H, &wNps6000H_0901H );
				if( nResult != NPSERR_NORMAL )
				{
					NPS_LOGOUT_FATAL( " --NPS IMG ERROR ( CANCEL FAIL )" );
				}
				SetPrintEvent();
				return TRUE;
			}
			break;
		}
	}

	//------------------------------------------------------------
	// 摜MmF
	//------------------------------------------------------------

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}

	if ( STEP3_FRAME_IMG_SEND == tFrameData.eFrameStep )
	{

		T_Nps6000H_0800H tNps6000H_0800H;	// 摜MmFv
		T_Nps6000H_0801H tNps6000H_0801H;	// 摜MmF

		tNps6000H_0800H.PossessionNo = tFrameData.wPossessionNo;
		tNps6000H_0800H.ReceiptNumber = tFrameData.nReceiptNo;

		nResult	= m_pNpsCmd->CheckSendImage( &tNps6000H_0800H, &tNps6000H_0801H );

		if ( NPSERR_NORMAL != nResult )
		{
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0800H )" );
			m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP0_FRAME_NONE, pNextCmd->dwPrintId );

			// ʐMG[̂ŉIɐؒfďZbg
			m_pSdk->SocketCloseProc();
			return TRUE;
		}

		if ( NPS_SUCCESS != tNps6000H_0801H.Result )
		{
			m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP0_FRAME_NONE, pNextCmd->dwPrintId );

			// v^G[
			switch ( tNps6000H_0801H.Result )
			{
			case NPS_ERROR_01:		// `G[
			case NPS_ERROR_03:		// R}h̃TCYw肪sł
			case NPS_ERROR_21:		// 摜f[^sł
				// łȂ̂ŃG[Ƃ
				ErrorNoticeON_6681( 3 );	// lbg[NʐMG[ ( [3]摜MmFR}hŎsԂĂ )
				m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
				SetPrintEvent();
				break;
			case NPS_ERROR_27:		// 27 v^Lf܂
				if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
				{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
					// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
					if( pNextCmd->eQueModeP == QUE_NORMAL )
					{	// ʏL
						m_pDataManager->SetRestartNormal( TRUE );
					}
					else
					{	// }L
						m_pDataManager->SetRestartExpress( TRUE );
					}
				}
				// breakȂ
			case NPS_ERROR_09:		// v^̐LsĂ܂
			case NPS_ERROR_28:		// ڑJnv󂯕tĂ܂
				// LJnēxs
				m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
				break;
			case NPS_ERROR_32:		// 32 CPULZ܂
				break;
			case NPS_ERROR_20:		// 摜Mp|[gƂ̐ڑmłĂ܂
				// 摜]p|[gĐڑ0700Hđ	2007.01.12 T.Mizushima
				if ( FALSE == m_pNpsImgMng->ReConnect( pNextCmd->wNpsImgPort ) )
				{
					NPS_LOGOUT_FATAL( " --NPS IMG RECONNECT ERROR ( 0800H result 20 )" );
				}
				// gCJEgAbvčđ
				m_ImgPortRetry = TRUE;	// 摜]pؒfɂ0700HđtOON
				return FALSE;
				break;
			case NPS_ERROR_29:		// 摜̃f[^Ă܂B
				// gCJEgAbvčđ
				return FALSE;
				break;
			case NPS_ERROR_19:		// 摜̎MɎs܂
			case NPS_ERROR_22:		// 摜f[^M^CAEg
				// ̃R}LZ
				T_Nps6000H_0900H	wNps6000H_0900H = { 0 };
				T_Nps6000H_0901H	wNps6000H_0901H = { 0 };
				wNps6000H_0900H.ReceiptNumber = tFrameData.nReceiptNo;
				nResult = m_pNpsCmd->PrintCancel( &wNps6000H_0900H, &wNps6000H_0901H );
				if( nResult != NPSERR_NORMAL )
				{
					ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
					m_pPrintQue->InsideProcError( pNextCmd->dwPrintId );
					SetPrintEvent();
					{
						NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0900H )" );
					}
					return TRUE;
				}
				// 摜M|[g̍č\z
				if ( FALSE == m_pNpsImgMng->ReConnect( pNextCmd->wNpsImgPort ) )
				{
					NPS_LOGOUT_FATAL( " --NPS IMG RECONNECT ERROR ( 0800H result 19 or 22 )" );
				}
				break;
			}
			SetPrintEvent();
			return TRUE;
		}

		m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP4_FRAME_6000_0800, pNextCmd->dwPrintId );

		{	// Oo
			CString str;
			str.Format( "---<<< Frame transfer end   >>> Priority=%u, OrderId=%u, IndexNo=%u, PrintId=%u ( ReceiptNo=%u )",
						pNextCmd->eQueModeP, pNextCmd->dwOrderId, pNextCmd->dwIndexNo, pNextCmd->dwPrintId, tNps6000H_0800H.ReceiptNumber );
			NPS_LOGOUT( str );
		}
	}

	//------------------------------------------------------------
	// R}̃\[g@\
	//------------------------------------------------------------

	// I[_[JnvɕKvȏ擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return TRUE;
	}

	if (( STEP4_FRAME_6000_0800 == tFrameData.eFrameStep ) &&
		( SORTFRAME_ENABLE == tFrameData.dwSortFrame ))
	{

		T_Nps6000H_0B00H tNps6000H_0B00H;	// gCύXv
		T_Nps6000H_0B01H tNps6000H_0B01H;	// gCύX

		tNps6000H_0B00H.PossessionNo = tFrameData.wPossessionNo;

		nResult	= m_pNpsCmd->ChangeTray( &tNps6000H_0B00H, &tNps6000H_0B01H );

		if (( NPSERR_NORMAL != nResult ) &&
			( NPSERR_BADPARAM != nResult ))		// dDP̓R}hT|[gĂȂ̂NPSERR_BADPARAMłOKƂ
		{
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0B00H )" );

			// ʐMG[̂ŉIɐؒfďZbg
			m_pSdk->SocketCloseProc();
			return TRUE;
		}

		if( NPS_SUCCESS != tNps6000H_0B01H.Result )
		{	// v^G[
			// >>> _08241Ή 2008.05.20 Y.Yoshinobu
			switch ( tNps6000H_0B01H.Result )
			{
			case NPS_ERROR_01:		// 1 `G[
			case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
			case NPS_ERROR_25:		// 25 gCύX̗vɎ󂯕tĂ܂
			case NPS_ERROR_26:		// 26 gCύXł܂
				// \[^[삵ȂȂ̂ŉΏɏp
				NPS_LOGOUT_FATAL( " --NPS SORT ERROR ( 0B01H result 1, 3, 25, 26 ) CONTINUOUS PROCESS" );
				break;
			case NPS_ERROR_27:		// 27 v^Lf܂
				if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
				{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
					// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
					if( pNextCmd->eQueModeP == QUE_NORMAL )
					{	// ʏL
						m_pDataManager->SetRestartNormal( TRUE );
					}
					else
					{	// }L
						m_pDataManager->SetRestartExpress( TRUE );
					}
				}
				// breakȂ
			case NPS_ERROR_09:		// 9 v^̐LsĂ܂
			case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
				// ĂȂƁALăvgv܂PĂȂꍇɐLĊJȂ
				m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
				return TRUE;
			}
			// <<< _08241Ή 2008.05.20 Y.Yoshinobu
		}

		m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE, pNextCmd->dwPrintId );
	}

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::MakeCmd_6000_0700()
//	ABSTRACT : tJnv(6000H 0700H)R}h̍쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.01.24
//	UPDATE   : J.Fukumori 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::MakeCmd_6000_0700( const T_FrameData &tFrameData, T_Nps6000H_0700H &tNps6000H_0700H )
{
	tNps6000H_0700H.PossessionNo		= tFrameData.wPossessionNo;							// 2006.10.31 T.Mizushima	wE59
	tNps6000H_0700H.ImageCapacity		= tFrameData.tPrnParam.dwDataLength;				// 摜e iPʁFBytej
	tNps6000H_0700H.ImageFormat			= (UCHAR)tFrameData.tPrnParam.dwImageFormat;		// 摜tH[}bg
	tNps6000H_0700H.ImageWidth			= (USHORT)tFrameData.tPrnParam.dwImgWidth;			// 摜̕ iPʁFPixelj
	tNps6000H_0700H.ImageHeight			= (USHORT)tFrameData.tPrnParam.dwImgHeight;			// 摜̍ iPʁFPixelj
	tNps6000H_0700H.PaperResolution		= (USHORT)tFrameData.tPrnParam.dwResolution;		// ͉𑜓x iPʁF0.1dpij
	tNps6000H_0700H.PaperWidth			= (USHORT)tFrameData.tPrnParam.dwPaperWidth; 		// y[p[̕ iPʁF0.1mmj
	tNps6000H_0700H.PaperLength			= (USHORT)tFrameData.tPrnParam.dwPaperLength;		// y[p[̑蒷 iPʁF0.1mmj
	tNps6000H_0700H.PaperID				= (USHORT)tFrameData.tPrnParam.dwSurface;			// y[p[ID
	tNps6000H_0700H.Repeat				= (USHORT)tFrameData.tPrnParam.dwPrintNum;			// s[g
																							// 1[v^ݒ̎擾]Ŏ擾[ő僊s[g]͈̔͂ŃZbgĉ
	tNps6000H_0700H.PaperFeed			= (USHORT)tFrameData.tPrnParam.dwFeed;				// @
	tNps6000H_0700H.Laminator			= 0;												// ~l[g 0FȂ
	tNps6000H_0700H.CvpInitialValue1	= (USHORT)tFrameData.tPrnParam.dwCvpInitialValue1;	// CVP1sڂ̒ʂԍ̏l
	tNps6000H_0700H.CvpPoint1			= (USHORT)tFrameData.tPrnParam.dwCvpPoint1;			// CVP1sڂ̒ʂԍ}ʒu
	tNps6000H_0700H.CvpInitialWidth1	= (USHORT)tFrameData.tPrnParam.dwCvpInitialWidth1;	// CVP1sڂ̒ʂԍ󎚂錅
																							// CvpLine1̃f[^Ɏw茅̒ʂԍZbg܂B
																							// CvpPoint1Ŏw肵ʒuCvpInitialWidth1Ŏw肵ŁACvpInitialValue1̒ʂԍ󎚂܂
																							// ʂԍ͉Elň󎚂܂BʂԍCvpInitialWidth1Ŏw肵ɖȂꍇ͋󔒕߂܂
																							// CvpLine1w肳ĂȂꍇ́Aʂԍ󎚂܂B܂ACvpPoint1CvpInitialWidth1̘aCvpLine1̃f[^傫ꍇʂԍ󎚂܂
	tNps6000H_0700H.CvpInitialValue2	= (USHORT)tFrameData.tPrnParam.dwCvpInitialValue2;	// CVP2sڂ̒ʂԍ̏l
	tNps6000H_0700H.CvpPoint2			= (USHORT)tFrameData.tPrnParam.dwCvpPoint2;			// CVP2sڂ̒ʂԍ}ʒu
	tNps6000H_0700H.CvpInitialWidth2	= (USHORT)tFrameData.tPrnParam.dwCvpInitialWidth2;	// CVP2sڂ̒ʂԍ󎚂錅
																							// CvpLine2̃f[^Ɏw茅̒ʂԍZbg܂
																							// CvpPoint2Ŏw肵ʒuCvpInitialWidth2Ŏw肵ŁACvpInitialValue2̒ʂԍ󎚂܂
																							// ʂԍ͉Elň󎚂܂BʂԍCvpInitialWidth2Ŏw肵ɖȂꍇ͋󔒕߂܂
																							// CvpLine2w肳ĂȂꍇ́Aʂԍ󎚂܂B܂ACvpPoint2CvpInitialWidth2̘aCvpLine2̃f[^傫ꍇʂԍ󎚂܂
	strcpy( (char*)tNps6000H_0700H.CvpLine1, tFrameData.tPrnParam.szCvpLine1 );				// CVP1s
																							// 󎚂镶Ǝw@ɂẮAuYt1.m[cLN^[R[h\vQƂĂ
	strcpy( (char*)tNps6000H_0700H.CvpLine2, tFrameData.tPrnParam.szCvpLine2 );				// CVP2s
																							// f[^̎wCVP1sڂɋLڂƓ
	tNps6000H_0700H.Angle				= tFrameData.tPrnParam.wAngle;						// ]px
	tNps6000H_0700H.PaperPresence		= (UCHAR)tFrameData.tPrnParam.dwPaperPresence;		// Uy[p[w
																							// AB̃}KWɓy[p[ĂꍇɁAǂ̃}KW̃y[p[Ńvgsw肵܂
	tNps6000H_0700H.Espc				= tFrameData.tPrnParam.nEspc;						// IJnʒu␳ iPʁF0.1mmj

	tNps6000H_0700H.OrderId				= tFrameData.wFirstPossessionNo;					// I[_[ʔԍ

	tNps6000H_0700H.PaperFitting		= tFrameData.tPrnParam.wPaperFitting;				// y[p[tBbeBO
	tNps6000H_0700H.EdgeEnhancement		= tFrameData.tPrnParam.wEdgeEnhancement;			// GbW
	tNps6000H_0700H.CMS					= tFrameData.tPrnParam.wCMS;						// CMS
	tNps6000H_0700H.WithBorderTop		= tFrameData.tPrnParam.wWithBorderTop;				// 㕔 iPʁF0.1mmj
	tNps6000H_0700H.WithBorderBottom	= tFrameData.tPrnParam.wWithBorderBottom;			//  iPʁF0.1mmj
	tNps6000H_0700H.WithBorderLeft		= tFrameData.tPrnParam.wWithBorderLeft;				//  iPʁF0.1mmj
	tNps6000H_0700H.WithBorderRight		= tFrameData.tPrnParam.wWithBorderRight;			// E iPʁF0.1mmj

	// ̐F
	tNps6000H_0700H.WithBorderColor[0]	= tFrameData.tPrnParam.byWithBorderColor[0];		// z[0] Red
	tNps6000H_0700H.WithBorderColor[1]	= tFrameData.tPrnParam.byWithBorderColor[1];		// z[1] Green
	tNps6000H_0700H.WithBorderColor[2]	= tFrameData.tPrnParam.byWithBorderColor[2];		// z[2] Blue

	strncpy( tNps6000H_0700H.PaperName, tFrameData.tPrnParam.szPaperName, 32 );				// y[p[
	tNps6000H_0700H.PrintCenterOffset	= tFrameData.tPrnParam.nPcfms;						// 呖vgZ^[ʒuItZbgl(0.1mm)
	tNps6000H_0700H.CvpPrintSize		= (USHORT)tFrameData.tPrnParam.dwCvpPrintSize;		// CVP󎚕TCY ( 0:, 1:, 2: )
	tNps6000H_0700H.PrintQuality		= tFrameData.tPrnParam.wPrintQuality;				// @ ( 0:v^ݒD, 1:W, 2:掿D )
	tNps6000H_0700H.ImageEnLargeType	= tFrameData.tPrnParam.byImageEnlargeType;			// 摜gASY( 0:oCjA, 1:jAXglCo[ )

	tNps6000H_0700H.LoadingCount		= tFrameData.tPrnParam.wLoadingCount;				// [fBOJn		2011.11.17 A.Nagamatsu
	tNps6000H_0700H.PrintedCount		= tFrameData.tPrnParam.wPrintedCount;				// ro				2011.11.17 A.Nagamatsu
	tNps6000H_0700H.EventId				= tFrameData.tPrnParam.dwEventId;					// Cxgʎq			2011.11.17 A.Nagamatsu
	tNps6000H_0700H.EventCodeMain		= tFrameData.tPrnParam.wEventCodeMain;				// CxgR[h iԁj	2011.11.17 A.Nagamatsu
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcBlankFrame()
//	ABSTRACT : 󔒃R}v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : đȂ	TRUE
//             đ		FALSE
//	
//	CREATE	 : Y.Yoshinobu	2008.5.23
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcBlankFrame( T_NextCmd* pNextCmd )
{
	long nResult;
	T_FrameData tFrameData;

	// \̂̏
	::ZeroMemory( &tFrameData, sizeof(T_FrameData) );

	// 󔒃R}vɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetFrameData( pNextCmd, &tFrameData ) )
	{
		return;
	}

	if ( FALSE == m_pNpsImgMng->IsOpenSocket( pNextCmd->wNpsImgPort ) )
	{
		// v^dfȂǂŁAv^Ƃ̒ʐMˑRؒfꍇ
		//  Connect() ŔĂȂȂꍇ
		// ŐؒfĂ̂͊{Iɂ͂̂ŁA^[
		// Đڑ̏ɔC
		// pNpsImgUdeleteāAĐڑ@łǂȂ...

		// ڑؒf
		m_pNpsImgMng->Delete( pNextCmd->wNpsImgPort );

		// \Pbg̍č쐬
		if ( FALSE == m_pNpsImgMng->CreateSocketByPortNo( pNextCmd->wNpsImgPort ) )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CREATE SOCKET BY PORTNO ERROR" );
			::Sleep( 1000 );
			SetPrintEvent();	// Ô
			return;
		}

		// Đڑ
		if ( FALSE == m_pNpsImgMng->Connect( pNextCmd->wNpsImgPort ) )
		{
			NPS_LOGOUT_FATAL( " --NPS IMG CONNECT ERROR" );
			::Sleep( 1000 );
			SetPrintEvent();	// Ô
			return;
		}
	}

	//------------------------------------------------------------
	// 󔒃R}v
	//------------------------------------------------------------

	T_Nps6000H_1800H tNps6000H_1800H;
	T_Nps6000H_1801H tNps6000H_1801H;

	tNps6000H_1800H.PossessionNo	= tFrameData.wPossessionNo;
	tNps6000H_1800H.PaperResolution	= (USHORT)tFrameData.tPrnParam.dwResolution;
	tNps6000H_1800H.PaperWidth		= (USHORT)tFrameData.tPrnParam.dwPaperWidth;
	tNps6000H_1800H.PaperLength		= (USHORT)tFrameData.tPrnParam.dwPaperLength;
	tNps6000H_1800H.PaperID			= (USHORT)tFrameData.tPrnParam.dwSurface;
	tNps6000H_1800H.Repeat			= (USHORT)tFrameData.tPrnParam.dwPrintNum;
	tNps6000H_1800H.PaperFeed		= (USHORT)tFrameData.tPrnParam.dwFeed;
	tNps6000H_1800H.Laminator		= 0;
	tNps6000H_1800H.PaperPresence	= (UCHAR)tFrameData.tPrnParam.dwPaperPresence;
	tNps6000H_1800H.OrderId			= tFrameData.wFirstPossessionNo;
	strncpy( tNps6000H_1800H.PaperName, tFrameData.tPrnParam.szPaperName, 32 );
	tNps6000H_1800H.ClearInk		= (USHORT)tFrameData.dwClearInk;
	tNps6000H_1800H.PrintQuality	= (USHORT)tFrameData.tPrnParam.wPrintQuality;
	tNps6000H_1800H.LoadingCount	= tFrameData.tPrnParam.wLoadingCount;			// [fBOJn		2011.11.18 A.Nagamatsu
	tNps6000H_1800H.PrintedCount	= tFrameData.tPrnParam.wPrintedCount;			// ro				2011.11.18 A.Nagamatsu
	tNps6000H_1800H.EventId			= tFrameData.tPrnParam.dwEventId;				// Cxgʎq			2011.11.18 A.Nagamatsu
	tNps6000H_1800H.EventCodeMain	= tFrameData.tPrnParam.wEventCodeMain;			// CxgR[h iԁj	2011.11.18 A.Nagamatsu

	nResult	= m_pNpsCmd->BlankPrintRequest( &tNps6000H_1800H, &tNps6000H_1801H );

	if ( NPSERR_NORMAL != nResult )
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x1800H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6000H_1801H.Result )
	{	// v^G[
		switch ( tNps6000H_1801H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
		case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
		case NPS_ERROR_12:		// 12 s[gsł
		case NPS_ERROR_16:		// 16 w肵y[p[͎gpł܂
		case NPS_ERROR_17:		// 17 y[p[̑蒷sł
		case NPS_ERROR_37:		// 37 ʈɑΉĂ܂
		case NPS_ERROR_38:		// 38 ʈJnv󂯕tĂ܂
			// łȂ̂ŃG[Ƃ
			ErrorNoticeON_6681( 1 );	// lbg[NʐMG[ ( [1]tJnR}hŎsԂĂ )
			m_pPrintQue->InsideProcError( tFrameData.dwPrintId );
			SetPrintEvent();
			break;
		case NPS_ERROR_27:		// 27 v^Lf܂
			if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
			{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
				// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
				if( pNextCmd->eQueModeP == QUE_NORMAL )
				{	// ʏL
					m_pDataManager->SetRestartNormal( TRUE );
				}
				else
				{	// }L
					m_pDataManager->SetRestartExpress( TRUE );
				}
			}
			// breakȂ
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// LJnēxs
			m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
			SetPrintEvent();
			break;
		case NPS_ERROR_18:		// 18 tsԂł
								//    DryPrinterłԂĂȂ̂ŁAgCJEgAtԍ̓NAĂȂ
		case NPS_ERROR_32:		// 32 CPULZ܂
		case NPS_ERROR_36:		// 36 tLZ܂
			break;
		}

		return;
	}

	m_pPrintQue->SetReceiptNo( pNextCmd->dwOrderId, pNextCmd->dwPrintId, tNps6000H_1801H.ReceiptNumber );
	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP4_FRAME_6000_0800, pNextCmd->dwPrintId );

	{	// Oo
		CString str;
		str.Format( "---<<< Frame transfer start >>> Priority=%u, OrderId=%u, IndexNo=%u, PrintId=%u, Repeat=%u ( ReceiptNo=%u ) [Blank]",
					pNextCmd->eQueModeP, pNextCmd->dwOrderId, pNextCmd->dwIndexNo, pNextCmd->dwPrintId, tNps6000H_1800H.Repeat, tNps6000H_1801H.ReceiptNumber );
		NPS_LOGOUT( str );
		str.Format( "---<<< Frame transfer end   >>> Priority=%u, OrderId=%u, IndexNo=%u, PrintId=%u ( ReceiptNo=%u ) [Blank]",
					pNextCmd->eQueModeP, pNextCmd->dwOrderId, pNextCmd->dwIndexNo, pNextCmd->dwPrintId, tNps6000H_1801H.ReceiptNumber );
		NPS_LOGOUT( str );
	}

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcSort()
//	ABSTRACT : \[^[v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcSort( T_NextCmd* pNextCmd )
{
	long nResult;
	T_SortData tSortData;

	// \̂̏
	::ZeroMemory( &tSortData, sizeof(T_SortData) );


	// \[gvɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetSortData( pNextCmd, &tSortData ) )
	{
		return;
	}

	//------------------------------------------------------------
	// \[g@\
	//------------------------------------------------------------

	T_Nps6000H_0B00H tNps6000H_0B00H;
	T_Nps6000H_0B01H tNps6000H_0B01H;

	tNps6000H_0B00H.PossessionNo = tSortData.wPossessionNo;

	nResult	= m_pNpsCmd->ChangeTray( &tNps6000H_0B00H, &tNps6000H_0B01H );

	if (( NPSERR_NORMAL != nResult ) &&
		( NPSERR_BADPARAM != nResult ))		// dDP̓R}hT|[gĂȂ̂NPSERR_BADPARAMłOKƂ
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0B00H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6000H_0B01H.Result )
	{	// v^G[
		// >>> _08241Ή 2008.05.20 Y.Yoshinobu
		switch ( tNps6000H_0B01H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
		case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
		case NPS_ERROR_25:		// 25 gCύX̗vɎ󂯕tĂ܂
		case NPS_ERROR_26:		// 26 gCύXł܂
			// \[^[삵ȂȂ̂ŉΏɏp
			NPS_LOGOUT_FATAL( " --NPS SORT ERROR ( 0B01H result 1, 3, 25, 26 ) CONTINUOUS PROCESS" );
			break;
		case NPS_ERROR_27:		// 27 v^Lf܂
			if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
			{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
				// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
				if( pNextCmd->eQueModeP == QUE_NORMAL )
				{	// ʏL
					m_pDataManager->SetRestartNormal( TRUE );
				}
				else
				{	// }L
					m_pDataManager->SetRestartExpress( TRUE );
				}
			}
			// breakȂ
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// ĂȂƁALăvgv܂PĂȂꍇɐLĊJȂ
			m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
			SetPrintEvent();
			return;
		}
		// <<< _08241Ή 2008.05.20 Y.Yoshinobu
	}

	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcDuplexStart()
//	ABSTRACT : ʈJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.05.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcDuplexStart( T_NextCmd* pNextCmd )
{
	long nResult;
	T_StartDuplexData tStartDuplexData;

	// \̂̏
	::ZeroMemory( &tStartDuplexData, sizeof(T_StartDuplexData) );

	// ʈJnɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetStartDuplexData( pNextCmd, &tStartDuplexData ) )
	{
		return;
	}

	//------------------------------------------------------------
	// ʈJn
	//------------------------------------------------------------

	T_Nps6000H_1600H tNps6000H_1600H;
	T_Nps6000H_1601H tNps6000H_1601H;

	tNps6000H_1600H.PossessionNo = tStartDuplexData.wPossessionNo;

	nResult	= m_pNpsCmd->DuplexStart( &tNps6000H_1600H, &tNps6000H_1601H );

	if ( NPSERR_NORMAL != nResult )
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x1600H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6000H_1601H.Result )
	{	// v^G[
		switch ( tNps6000H_1601H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
		case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
		case NPS_ERROR_37:		// 37 ʈɑΉĂ܂
			// łȂ̂ŉΏɏp
			NPS_LOGOUT_FATAL( " --NPS DUPLEX START ERROR ( 1700H result 1, 3, 37 ) CONTINUOUS PROCESS" );
			break;
		case NPS_ERROR_27:		// 27 v^Lf܂
			if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
			{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
				// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
				if( pNextCmd->eQueModeP == QUE_NORMAL )
				{	// ʏL
					m_pDataManager->SetRestartNormal( TRUE );
				}
				else
				{	// }L
					m_pDataManager->SetRestartExpress( TRUE );
				}
			}
			// breakȂ
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// ĂȂƁALăvgv܂PĂȂꍇɐLĊJȂ
			m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
			SetPrintEvent();
			return;
		}
	}

	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcDuplexEnd()
//	ABSTRACT : ʈI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.05.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcDuplexEnd( T_NextCmd* pNextCmd )
{
	long nResult;
	T_EndDuplexData tEndDuplexData;

	// \̂̏
	::ZeroMemory( &tEndDuplexData, sizeof(T_EndDuplexData) );

	// ʈIɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetEndDuplexData( pNextCmd, &tEndDuplexData ) )
	{
		return;
	}

	//------------------------------------------------------------
	// ʈI
	//------------------------------------------------------------

	T_Nps6000H_1700H tNps6000H_1700H;
	T_Nps6000H_1701H tNps6000H_1701H;

	tNps6000H_1700H.PossessionNo = tEndDuplexData.wPossessionNo;

	nResult	= m_pNpsCmd->DuplexEnd( &tNps6000H_1700H, &tNps6000H_1701H );

	if ( NPSERR_NORMAL != nResult )
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x1700H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6000H_1701H.Result )
	{	// v^G[
		switch ( tNps6000H_1701H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
		case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
		case NPS_ERROR_37:		// 37 ʈɑΉĂ܂
		case NPS_ERROR_38:		// 38 ʈJnv󂯕tĂ܂
			// łȂ̂ŉΏɏp
			NPS_LOGOUT_FATAL( " --NPS DUPLEX END ERROR ( 1700H result 1, 3, 37, 38 ) CONTINUOUS PROCESS" );
			break;
		case NPS_ERROR_27:		// 27 v^Lf܂
			if( INFO_SUPPORTINTNEW == m_pDataManager->GetPrinterSetupSupportInterrupt() )
			{	// V^荞ݑΉ		@@@RD-151Ή	2012.02.10	T.Mizushima
				// 荞ݒf̍ĊJ(ʏ/})]ŐLĊJ悤ɃtOZbg
				if( pNextCmd->eQueModeP == QUE_NORMAL )
				{	// ʏL
					m_pDataManager->SetRestartNormal( TRUE );
				}
				else
				{	// }L
					m_pDataManager->SetRestartExpress( TRUE );
				}
			}
			// breakȂ
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// ĂȂƁALăvgv܂PĂȂꍇɐLĊJȂ
			m_pPrintQue->ResetOrderStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo );
			SetPrintEvent();
			return;
		}

	}

	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcOrderEnd()
//	ABSTRACT : I[_[Iv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcOrderEnd( T_NextCmd* pNextCmd )
{
	//------------------------------------------------------------
	// [hύXv
	//------------------------------------------------------------

	// ʏ탂[h
	PrintProcModeChange( pNextCmd, 1 );


	//------------------------------------------------------------
	// NWbgI
	//------------------------------------------------------------

	// NWbgI
	PrintProcCreditEnd( pNextCmd );

	//------------------------------------------------------------
	// LZ
	// tJnv(0700)sĂ摜MmFv(0800)
	// MłĂȂƂ́ALZvs
	//------------------------------------------------------------
	ULONG nReceiptNo;

	if ( TRUE == m_pPrintQue->GetEndOrderDataCancelReceiptNo( &nReceiptNo ) )
	{
		// ̃R}LZ
		T_Nps6000H_0900H	wNps6000H_0900H = { 0 };
		T_Nps6000H_0901H	wNps6000H_0901H = { 0 };
		wNps6000H_0900H.ReceiptNumber = nReceiptNo;
		m_pNpsCmd->PrintCancel( &wNps6000H_0900H, &wNps6000H_0901H );
	}

	//------------------------------------------------------------
	// v^LI
	//------------------------------------------------------------

	long nResult;
	T_EndOrderData tEndOrderData;

	::ZeroMemory( &tEndOrderData, sizeof(T_EndOrderData) );

	// v^LIɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetEndOrderData( pNextCmd, &tEndOrderData ) )
	{
		return;
	}

	if ( STEP1_ORDER_6000_0500 < tEndOrderData.eOrderStep )
	{
		// LMOɉ摜]p\Pbg 2007.01.06 T.Mizushima
		if ( 0 != pNextCmd->wNpsImgPort )
		{
			// ڑؒf
			m_pNpsImgMng->Delete( pNextCmd->wNpsImgPort );
			pNextCmd->wNpsImgPort = 0;
			m_pPrintQue->SetPortNo( pNextCmd->dwOrderId, pNextCmd->wNpsImgPort );
		}

		T_Nps6000H_0600H tNps6000H_0600H;	// v^LIv
		T_Nps6000H_0601H tNps6000H_0601H;	// v^LI

		tNps6000H_0600H.PossessionNo = tEndOrderData.wPossessionNo;

		{	// Oo
			CString str;
			str.Format( " --OccupyEnd( dwOrderId=%d )", pNextCmd->dwOrderId );
			NPS_LOGOUT( str );
		}

		nResult	= m_pNpsCmd->OccupyEnd( &tNps6000H_0600H, &tNps6000H_0601H );

		if( NPSERR_NORMAL != nResult )
		{
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6000H, CmdId=0x0600H )" );

			// ʐMG[̂ŉIɐؒfďZbg
			m_pSdk->SocketCloseProc();
			return;
		}

		if( NPS_SUCCESS != tNps6000H_0601H.Result )
		{
			// v^G[
			switch ( tNps6000H_0601H.Result )
			{
			case NPS_ERROR_01:		// 1 `G[
			case NPS_ERROR_03:		// 3 R}h̃TCYw肪sł
				// 肦ȂȂ̂ŃgC
				SetPrintEvent();
				return;
			case NPS_ERROR_09:		// 9 v^̐LsĂ܂
			case NPS_ERROR_27:		// 27 v^Lf܂
			case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
				// ÎƂĈ
				break;
			}
		}

		m_pPrintQue->UpdateOrderStep( pNextCmd->dwOrderId, STEP4_ORDER_6000_0600 );
	}


	// EndOrder̊
	m_pPrintQue->RequestEndOrderEnd( pNextCmd->dwOrderId );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcCreditStart()
//	ABSTRACT : NWbgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.02.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::PrintProcCreditStart( T_NextCmd* pNextCmd )
{
	if ( !(pNextCmd->dwOption & OPTION_BERG_CREDIT) )
	{
		return TRUE;
	}

	T_CreditOrderData tCreditOrderData;

	// \̂̏
	::ZeroMemory( &tCreditOrderData, sizeof(T_CreditOrderData) );


	// NWbgvɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetCreditOrderData( pNextCmd, &tCreditOrderData ) )
	{
		return FALSE;
	}

	long nResult;
	T_Nps6001H_B006H tNps6001H_B006H;
	T_Nps6001H_B007H tNps6001H_B007H;

	tNps6001H_B006H.PossessionNo = tCreditOrderData.wPossessionNo;

	nResult	= m_pNpsCmd->NpsCmd_6001_B006_B007( &tNps6001H_B006H, &tNps6001H_B007H );

	if( NPSERR_NORMAL != nResult )
	{
		ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
		m_pPrintQue->OfflineErrorReset();
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0xB006H )" );

		return FALSE;
	}

	if( NPS_SUCCESS != tNps6001H_B007H.Result )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcCreditEnd()
//	ABSTRACT : NWbgI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.02.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::PrintProcCreditEnd( T_NextCmd* pNextCmd )
{
	if ( !(pNextCmd->dwOption & OPTION_BERG_CREDIT) )
	{
		return TRUE;
	}

	T_CreditOrderData tCreditOrderData;

	// \̂̏
	::ZeroMemory( &tCreditOrderData, sizeof(T_CreditOrderData) );


	// NWbgvɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetCreditOrderData( pNextCmd, &tCreditOrderData ) )
	{
		return FALSE;
	}

	long nResult;
	T_Nps6001H_B008H tNps6001H_B008H;
	T_Nps6001H_B009H tNps6001H_B009H;

	tNps6001H_B008H.PossessionNo = tCreditOrderData.wPossessionNo;

	nResult	= m_pNpsCmd->NpsCmd_6001_B008_B009( &tNps6001H_B008H, &tNps6001H_B009H );

	if( NPSERR_NORMAL != nResult )
	{
		ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
		m_pPrintQue->OfflineErrorReset();
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0xB008H )" );
		return FALSE;
	}

	if( NPS_SUCCESS != tNps6001H_B009H.Result )
	{
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcModeChange()
//	ABSTRACT : [hύX
//	FUNCTION : v^6002_7300Tag50ȊOԂĂƂ
//             2b҂ĂđBő50JԂB
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.03.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::PrintProcModeChange( T_NextCmd* pNextCmd, WORD wMode )
{
	if ( !(pNextCmd->dwOption & OPTION_SETTING_PRN) )
	{
		return TRUE;
	}

	int nIdx;
	long nResult;
	T_Nps6002H_7300H tNps6002H_7300H;
	T_Nps6002H_7301H tNps6002H_7301H;

	tNps6002H_7300H.TargetCpu	= 0xFFFF;
	tNps6002H_7300H.Mode		= wMode;

	for ( nIdx=0 ; 50 > nIdx ; nIdx++ )
	{
		nResult	= m_pNpsCmd->NpsCmd_6002_7300_7301( &tNps6002H_7300H, &tNps6002H_7301H );

		if( NPSERR_NORMAL != nResult )
		{
			ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
			m_pPrintQue->OfflineErrorReset();
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6002H, CmdId=0x7300H )" );
			return FALSE;
		}

		if( NPS_SUCCESS == tNps6002H_7301H.Result )
		{	// 
			break;
		}

		// 2bҋ@
		::Sleep( 2000 );	

	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcRetransmissionStart()
//	ABSTRACT : đJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu		2011.11.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcRetransmissionStart( T_NextCmd* pNextCmd )
{
	T_InterruptOrderInfoData tInterruptOrderInfo;
	
	// \̂̏
	::ZeroMemory( &tInterruptOrderInfo, sizeof(T_InterruptOrderInfoData) );

	// đJnvɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetStartInterruptOrderInfoData( pNextCmd, &tInterruptOrderInfo ) )
	{
		return;
	}

	//------------------------------------------------------------------
	// đJn
	//------------------------------------------------------------------

	// ̐ݒ
	long nResult = NPSERR_NORMAL;

	T_Nps6001H_0C00H	tNps6001H_0C00H;
	T_Nps6001H_0C01H	tNps6001H_0C01H;

	tNps6001H_0C00H.PossessionNo	= tInterruptOrderInfo.wPossessionNo;
	tNps6001H_0C00H.OrderState		= tInterruptOrderInfo.tInterruptOrderParam.wOrderState;
	tNps6001H_0C00H.MainSideState	= tInterruptOrderInfo.tInterruptOrderParam.wMainSideState;
	tNps6001H_0C00H.BackSideState	= tInterruptOrderInfo.tInterruptOrderParam.wBackSideState;
	tNps6001H_0C00H.PrintSide		= tInterruptOrderInfo.tInterruptOrderParam.wPrintSide;

	nResult	= m_pNpsCmd->NpsCmd_6001_0C00_0C01( &tNps6001H_0C00H, &tNps6001H_0C01H );
	if( NPSERR_NORMAL != nResult )
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0x0C00H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6001H_0C01H.Result )
	{	// v^G[
		switch ( tNps6001H_0C01H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
			// łȂ̂ŉΏɏp
			NPS_LOGOUT_FATAL( " --NPS DUPLEX START ERROR ( 0C00H result 1 ) CONTINUOUS PROCESS" );
			break;
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_18:		// 18 tsԂł
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// WGiD703jΉ̍đJnEIR}hł́ALłُ͔̈邱Ƃ͂Ȃi\tgsj
			// ƂȂ邽߁AʐMG[𔭐邱ƂƂB
		case NPS_ERROR_44:		// 44 ɍđJnĂ܂
			ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
			m_pPrintQue->OfflineErrorReset();
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0x0C00H )" );
			return;
		}
	}

	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::PrintProcRetransmissionEnd()
//	ABSTRACT : đI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu		2011.11.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::PrintProcRetransmissionEnd( T_NextCmd* pNextCmd )
{
	T_InterruptOrderInfoData tInterruptOrderInfo;
	
	// \̂̏
	::ZeroMemory( &tInterruptOrderInfo, sizeof(T_InterruptOrderInfoData) );

	// đJnvɕKvȃf[^擾
	if ( FALSE == m_pPrintQue->GetEndInterruptOrderInfoData( pNextCmd, &tInterruptOrderInfo ) )
	{
		return;
	}

	//------------------------------------------------------------------
	// đI
	//------------------------------------------------------------------

	// ̐ݒ
	long nResult = NPSERR_NORMAL;

	T_Nps6001H_0D00H	tNps6001H_0D00H;
	T_Nps6001H_0D01H	tNps6001H_0D01H;

	tNps6001H_0D00H.PossessionNo	= tInterruptOrderInfo.wPossessionNo;

	nResult	= m_pNpsCmd->NpsCmd_6001_0D00_0D01( &tNps6001H_0D00H, &tNps6001H_0D01H );
	if( NPSERR_NORMAL != nResult )
	{
		NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0x0D00H )" );

		// ʐMG[̂ŉIɐؒfďZbg
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6001H_0D01H.Result )
	{	// v^G[
		switch ( tNps6001H_0D01H.Result )
		{
		case NPS_ERROR_01:		// 1 `G[
			// łȂ̂ŉΏɏp
			NPS_LOGOUT_FATAL( " --NPS DUPLEX START ERROR ( 0C00H result 1 ) CONTINUOUS PROCESS" );
			break;
		case NPS_ERROR_09:		// 9 v^̐LsĂ܂
		case NPS_ERROR_28:		// 28 ڑJnv󂯕tĂ܂
			// WGiD703jΉ̍đJnEIR}hł́ALłُ͔̈邱Ƃ͂Ȃi\tgsj
			// ƂȂ邽߁AʐMG[𔭐邱ƂƂB
		case NPS_ERROR_45:		// 45 ܂đJnĂ܂
			ErrorNoticeON_6681( 5 );	// lbg[NʐMG[ ( [5]ʐMs )
			m_pPrintQue->OfflineErrorReset();
			NPS_LOGOUT_FATAL( " --COMMAND SEND ERROR ( IfId=0x6001H, CmdId=0x0C00H )" );
			return;
		}
	}

	m_pPrintQue->UpdateFrameStep( pNextCmd->dwOrderId, pNextCmd->dwIndexNo, STEP5_SORT_COMPLETE );

	// ̃vgvs߂ɃCxgLɂ
	SetPrintEvent();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::GetFinishEventHandle()
//	ABSTRACT : XbhImFpCxg̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.06
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
HANDLE CPrintThread::GetFinishEventHandle()
{
	return m_hEvent[EVENT_FINISH];
}


#if defined(NKC_CMS_PROC)
#if 0
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ProcIcw()
//	ABSTRACT : 摜s摜쐬
//	FUNCTION : 摜Ɏsꍇ́A͏o͏ɂ̂܂ܓn
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//             pParamIn       ̓p[^
//             pParamOut      o̓p[^
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.14
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::ProcIcw( T_CmsProcParamIn *pParamIn, T_CmsProcParamOut *pParamOut )
{
	BOOL bResult;
	char szTempFilePath[MAX_PATH];
	T_Nps6000H_0101H tNps6000H_0101H;
	T_Nps6000H_0201H tNps6000H_0201H;


	// ͏o͏ɃZbg
	pParamOut->bOriginalImgFile	= TRUE;
	pParamOut->dwSourceType		= pParamIn->dwSourceType;
	pParamOut->dwImageCapacity	= pParamIn->dwImgFileLength;
	pParamOut->dwOffset			= pParamIn->dwImgFileOffset;
	pParamOut->ImageFormat		= pParamIn->ImageFormat;
	::lstrcpy( pParamOut->szImgFile, pParamIn->szImgFile );

	// v^{̎擾
	m_pDataManager->GetPrinterBasic( &tNps6000H_0101H );

	// v^ݒ̎擾
	m_pDataManager->GetPrinterSetup( &tNps6000H_0201H );

	//--------------------------------------------------
	// CMSp͉̓摜t@C̏
	//--------------------------------------------------

	if ( IMGSRC_SHAREDMEM == pParamIn->dwSourceType )
	{
		// Ln
		NkcComApi::GetTempFilePath( TEMP_TEMP, ".BMP", szTempFilePath );		// gqBMPŖƉ揈ŃG[ƂȂ

		// L̏ꍇ͈Ut@Cɏo
		bResult = NkcComApi::WriteFileByMmf( szTempFilePath, pParamIn->szImgFile, pParamIn->dwImgFileOffset, pParamIn->dwImgFileLength );
		if ( FALSE == bResult )
		{
			// L̏oɎs
			{	// Oo
				CString str;
				str.Format( "===[PROC CMS] MMF TO FILE FAIL ( %s -> %s )", pParamIn->szImgFile, szTempFilePath );
				NPS_LOGOUT_FATAL( str );
			}
			return FALSE;
		}
		pParamOut->bOriginalImgFile	= FALSE;
		pParamOut->dwSourceType		= IMGSRC_FILE;
		pParamOut->dwImageCapacity	= pParamIn->dwImgFileLength;
		pParamOut->dwOffset			= 0;
		pParamOut->ImageFormat		= IMGFMT_BMP;
		::lstrcpy( pParamOut->szImgFile, szTempFilePath );
	}
	else
	{
		if ( 0 != pParamIn->dwImgFileOffset )
		{
			// p[^G[
			{	// Oo
				CString str;
				str.Format( "===[PROC CMS] BMP FILE OFFSET is not 0 ( %d )", pParamIn->dwImgFileOffset );
				NPS_LOGOUT_FATAL( str );
			}
			return FALSE;
		}

		// t@Cn
		::lstrcpy( pParamOut->szImgFile, pParamIn->szImgFile );
	}

	//--------------------------------------------------
	// Edge
	//--------------------------------------------------

	if ( 2 == tNps6000H_0101H.MachineTypeID )	// 2:≖I^Cv(iBeam)
	{

		NkcComApi::GetTempFilePath( TEMP_TEMP, ".BMP", szTempFilePath );

		bResult = ProcIcwEdge( pParamOut->szImgFile, szTempFilePath );
		if ( TRUE == bResult )
		{
			if ( FALSE == pParamOut->bOriginalImgFile )
			{
				::DeleteFile( pParamOut->szImgFile );
			}
			pParamOut->bOriginalImgFile	= FALSE;
			pParamOut->dwImageCapacity = NkcComApi::GetFileSize( szTempFilePath );
			::lstrcpy( pParamOut->szImgFile, szTempFilePath );
		}
		else
		{
			// CMSɎs
			{	// Oo
				NPS_LOGOUT_FATAL( "===[PROC EDGE] EDGE PROC FAIL" );
			}
		}

	}

	//--------------------------------------------------
	// CMS
	//--------------------------------------------------

	if ( TRUE == pParamIn->bEnableCms )
	{

		NkcComApi::GetTempFilePath( TEMP_TEMP, ".BMP", szTempFilePath );

		bResult = ProcIcwCms( pParamOut->szImgFile, szTempFilePath, &pParamIn->tCmsParam );
		if ( TRUE == bResult )
		{
			if ( FALSE == pParamOut->bOriginalImgFile )
			{
				::DeleteFile( pParamOut->szImgFile );
			}
			pParamOut->bOriginalImgFile	= FALSE;
			pParamOut->dwImageCapacity = NkcComApi::GetFileSize( szTempFilePath );
			::lstrcpy( pParamOut->szImgFile, szTempFilePath );
		}
		else
		{
			// CMSɎs
			{	// Oo
				NPS_LOGOUT_FATAL( "===[PROC CMS] CMS PROC FAIL" );
			}
		}

	}

	//--------------------------------------------------
	// 摜tH[}bgϊ ( BMP -> JPEG )
	//--------------------------------------------------

	if ( 0x000000FF == pParamIn->ImageFormat )
	{
		if ( INFO_IMGNO == tNps6000H_0201H.SupportImageFormat[1] )
		{
			// BMPT|[gv^[̏ꍇ ( BMP => JPEG )
			NkcComApi::GetTempFilePath( TEMP_TEMP, ".JPG", szTempFilePath );

			bResult = NkcComApi::FileConvertBmpToJpeg( pParamOut->szImgFile, szTempFilePath );
			if ( TRUE == bResult )
			{
				if ( FALSE == pParamOut->bOriginalImgFile )
				{
					::DeleteFile( pParamOut->szImgFile );
				}
				pParamOut->bOriginalImgFile	= FALSE;
				pParamOut->dwImageCapacity	= NkcComApi::GetFileSize( szTempFilePath );
				pParamOut->ImageFormat		= IMGFMT_JPEG;
				::lstrcpy( pParamOut->szImgFile, szTempFilePath );
			}
			else
			{
				{	// Oo
					CString str;
					str.Format( "===[PROC CMS] FILE CONVERT FAIL ( %s -> %s )", pParamOut->szImgFile, szTempFilePath );
					NPS_LOGOUT_FATAL( str );
				}
			}

		}

		if ( 0x000000FF == pParamIn->ImageFormat )
		{
			// 摜tH[}bgϊĂȂ΁AIBMPƂăZbgB
			// JPEGϊɎsĂĂAv^[BMPMłȂꍇ0700̉
			// G[ԂĂ̂ŁAŃG[sB
			pParamOut->ImageFormat = IMGFMT_BMP;
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ProcIcwCms()
//	ABSTRACT : CMSs
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//             lpInName           ͉摜̃IuWFNg
//             lpOutName          o͉摜̃IuWFNg
//             pParam             CMSɕKvȃp[^
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::ProcIcwCms( LPCTSTR lpInFile, LPCTSTR lpOutFile, T_CmsProcParam* pParam )
{
	int nProfFlg;
	int nCustomFlg;
	DWORD dwPaperTypeCode;
	int nPrnCustomCode=0;
	int nUnitNo=0;
	BOOL bResult;
	char szFileName[MAX_PATH];
	CNkcProfileModule ProObject;
	HRESULT hErrCode;
	T_CorrectWrapDll_ImgInf tImgInf;
	T_CorrectWrapDll_CmsInf tCMSInf;
	LPBYTE pCms;

	::ZeroMemory( &tImgInf, sizeof(T_CorrectWrapDll_ImgInf) );
	::ZeroMemory( &tCMSInf, sizeof(T_CorrectWrapDll_CmsInf) );

	if ( NULL == m_hNkcICorrCms )
	{
		// 揈W[NĂȂ̂ŏI
		return FALSE;
	}

	//------------------------------------------------------------
	// vt@C̃CXg[mF
	//------------------------------------------------------------

#if !defined(CMS_TEST)

	if ( FALSE == ProObject.CheckProfileExist() )
	{
		{	// Oo
			NPS_LOGOUT_WARN( "===[PROC CMS] PROFILE NOT EXIST" );
		}
		return FALSE;
	}

	//------------------------------------------------------------
	// v^ݒ̎擾
	//------------------------------------------------------------

	T_Nps6000H_0101H tNps6000H_0101H;
	m_pDataManager->GetPrinterBasic( &tNps6000H_0101H );

	//--------------------------------------------------
	// CMSf[^t@C̎擾
	//--------------------------------------------------

	nProfFlg	= ( 0 == pParam->dwColorSpace ) ? 1 : 0;
	nCustomFlg	= ( 1 == pParam->dwCmsMode ) ? 0 : 1;

	switch ( pParam->dwCmsMode )
	{
	case 1:		// Normal

		// y[p[R[h̎擾
		if ( FALSE == m_pDataManager->GetPaperTypeCode( pParam->dwPaperWidth, pParam->dwPaperId,
														pParam->dwFeed, pParam->szPaperName, &dwPaperTypeCode ) )
		{
			{	// Oo
				NPS_LOGOUT_WARN( "===[PROC CMS] PAPER TYPE CODE NOT EXIST" );
			}
			return FALSE;
		}

		break;

	case 2:		// Custom

		// y[p[R[h1Œ
		dwPaperTypeCode = 1;

		break;

	default:
		return FALSE;
		break;
	}

	// CMSf[^t@C̎擾
	bResult = ProObject.GetPrintCmsName(
					nProfFlg,
					nCustomFlg,
					dwPaperTypeCode,
					nPrnCustomCode,
					tNps6000H_0101H.MachineTypeName,
					nUnitNo,
					tNps6000H_0101H.SerialNumber,
					szFileName );

	if ( FALSE == bResult )
	{
		{	// Oo
			NPS_LOGOUT_WARN( "===[PROC CMS] GET PRINT CMS NAME FAIL" );
		}
		return FALSE;
	}

	//--------------------------------------------------
	// CMSf[^̓ǂݍ
	//--------------------------------------------------
	pCms = (LPBYTE)LoadCmsFile( szFileName );

	if ( NULL == pCms )
	{
		{	// Oo
			CString str;
			str.Format( "===[PROC CMS] CMS DATA READ FAIL (%s)", szFileName );
			NPS_LOGOUT_WARN( str );
		}
		return FALSE;
	}

	//--------------------------------------------------
	// CMS
	//--------------------------------------------------

	// 摜p[^
	tImgInf.ImgType	= 0;								// o͉摜`(0:t@C@1:)
	tImgInf.pSrcImg = (char*)lpInFile;					// ͉摜t@C/AhX
	tImgInf.pDstImg	= (char*)lpOutFile;					// o͉摜t@C/AhX
	tImgInf.DstCh	= 3;								// o͉摜`l(3:3ch@4:4ch)

	// CMSp[^
	tCMSInf.pCMS	= (unsigned short*)pCms;

	bResult = NkcICorr_CMS(
					m_hNkcICorrCms,			// nh
					0,						// Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
					&tImgInf,				// 摜p[^
					&tCMSInf,				// CMSp[^
					&hErrCode );			// ڍ׃G[R[h

	delete [] pCms;

#else  // !defined(CMS_TEST)

	bResult = ::CopyFile( lpInFile, lpOutFile, FALSE );
	hErrCode = 0;

#endif // !defined(CMS_TEST)

	if ( FALSE == bResult )
	{
		{	// Oo
			CString str;
			str.Format( "===[PROC CMS] NkcICorr_CMS FAIL ( %08X )", hErrCode );
			NPS_LOGOUT_WARN( str );
		}
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ProcIcwEdge()
//	ABSTRACT : EDGEs
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//             lpInName           ͉摜̃IuWFNg
//             lpOutName          o͉摜̃IuWFNg
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.3.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::ProcIcwEdge( LPCTSTR lpInFile, LPCTSTR lpOutFile )
{
	BOOL bResult;
	HRESULT hErrCode;
	T_CorrectWrapDll_ImgInf tImgInf;
	T_CorrectWrapDll_NxNInf tEdgeInf;

	::ZeroMemory( &tImgInf, sizeof(T_CorrectWrapDll_ImgInf) );
	::ZeroMemory( &tEdgeInf, sizeof(T_CorrectWrapDll_NxNInf) );

	if ( NULL == m_hNkcICorrEdge )
	{
		// 揈W[NĂȂ̂ŏI
		return FALSE;
	}

	//--------------------------------------------------
	// Edge
	//--------------------------------------------------

	// 摜p[^
	tImgInf.ImgType	= 0;								// o͉摜`(0:t@C@1:)
	tImgInf.pSrcImg = (char*)lpInFile;					// ͉摜t@C/AhX
	tImgInf.pDstImg	= (char*)lpOutFile;					// o͉摜t@C/AhX
	tImgInf.DstCh	= 3;								// o͉摜`l(3:3ch@4:4ch)

	// Edgep[^
	tEdgeInf.EgInt	= 2;								// NxNtB^[x(-2048`2047)
	tEdgeInf.MskSiz	= 3;								// NxNtB^[TCY(3/5/7)

	bResult = NkcICorr_NxNFilter(
					m_hNkcICorrEdge,		// nh
					0,						// Dx -2 to 2 (-2=lowest, 1=below norrmal, 0=normat, 1=above normal, 2=highest)
					&tImgInf,				// 摜p[^
					&tEdgeInf,				// Edgep[^
					&hErrCode );			// ڍ׃G[R[h

	if ( FALSE == bResult )
	{
		{	// Oo
			CString str;
			str.Format( "===[PROC Edge] NkcICorr_NxNFilter FAIL ( %08X )", hErrCode );
			NPS_LOGOUT_WARN( str );
		}
		return FALSE;
	}

	return TRUE;
}
#endif
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::LoadCmsFile()
//	ABSTRACT : CMSf[^̓ǂݍ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.12
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
LPVOID CPrintThread::LoadCmsFile( LPCTSTR lpFileName )
{
	LPVOID	pCms = NULL;

	//--------------------------------------------------
	// CMSt@C̓ǂݍ
	//--------------------------------------------------
	HANDLE hFile;
	DWORD dwFileSize;
	DWORD dwByteRead;

	hFile = ::CreateFile( lpFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( INVALID_HANDLE_VALUE != hFile )
	{
		// t@CTCY̎擾
		dwFileSize = ::GetFileSize( hFile, NULL );

		try
		{
			pCms = new BYTE[dwFileSize];
		}
		catch (CMemoryException* e)
		{
			e->Delete();
			pCms = NULL;
		}

		if ( TRUE == ReadFile( hFile, pCms, dwFileSize, &dwByteRead, NULL ) )
		{
			if ( dwFileSize != dwByteRead )
			{
				delete [] pCms;
				pCms = NULL;
			}
		}
		else
		{
			delete [] pCms;
			pCms = NULL;
		}

		::CloseHandle(hFile);
	}

	return pCms;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::MakeTempFolderFullPath()
//	ABSTRACT : ƗptH_̃tpXԂ܂
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
// ƗptH_̃tpXԂ܂
CString	CPrintThread::MakeTempFolderFullPath()
{
	CString strFolderPath;

	if ( 0 < ::strlen( g_szTempFolder ) )
	{
		if ( TRUE == ::PathFileExists( g_szTempFolder ) )
		{
			strFolderPath = g_szTempFolder;
		}
	}

	if ( TRUE == strFolderPath.IsEmpty() )
	{
		// ƗptH_w肳ĂȂ̂łnr̍ƃtH_擾
		strFolderPath = NkcComApi::GetTempFolderPath( TEMP_TEMP );
	}

	return strFolderPath;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::MakeTempFileFullPath()
//	ABSTRACT : Ɨpt@C̃tpXԂ܂
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString	CPrintThread::MakeTempFileFullPath( LPCTSTR lpFileName )
{
	CString strFileName;
	CString strFilePath;

	// t@C̍쐬
	strFileName.Format( "NPS_%08X_%08X_DAT_%s", ::GetCurrentProcessId(), ::GetCurrentThreadId(), lpFileName );

	// tpX̍쐬
	strFilePath = NkcComApi::MakeFullPath( MakeTempFolderFullPath(), strFileName );

	return strFilePath;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::WriteLogIcwParam()
//	ABSTRACT : 摜p[^̃Oo
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::WriteLogIcwParam( CIcwInfo& objParam, LPCTSTR lpMessage )
{
	CString strLogMessage;

	strLogMessage.Format(
		"   [%s][1/2] Ret=%d, Del=%d, Src=%u, Offset=%u, Fmt=%d, ImgLen=%d, ImgSize=%dx%d, Reso=%d, SP=[%d,%d,%d,%d], PaperSize=%dx%d, WBAdju=[%d,%d]",
		lpMessage,
		objParam.m_bSuccess,
		objParam.m_bDeleteFile,
		objParam.m_SourceType,
		objParam.m_FileOffset,
		objParam.m_ImageFormat,
		objParam.m_ImageCapacity,
		objParam.m_ImageWidth,
		objParam.m_ImageHeight,
		objParam.m_Resolution,
		objParam.m_SpRect.top,
		objParam.m_SpRect.bottom,
		objParam.m_SpRect.left,
		objParam.m_SpRect.right,
		objParam.m_PaperSize.cx,
		objParam.m_PaperSize.cy,
		objParam.m_PaperAdjustLeft,
		objParam.m_PaperAdjustRight );
	NPS_LOGOUT( strLogMessage );

	strLogMessage.Format(
		"   [%s][2/2] Angle=%d, Espc=%d, Fitt=%d, Edge=%d, WB=[%d,%d,%d,%d], CntOffset=%d, CMS=%s, File=%s",
		lpMessage,
		objParam.m_Angle,
		objParam.m_Espc,
		objParam.m_PaperFitting,
		objParam.m_EdgeEnhancement,
		objParam.m_WB.top,
		objParam.m_WB.bottom,
		objParam.m_WB.left,
		objParam.m_WB.right,
		objParam.m_PrintCenterOffset,
		objParam.m_strCmsFileName,
		objParam.m_strFileName );
	NPS_LOGOUT( strLogMessage );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::IcwMainProc()
//	ABSTRACT : 摜C
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::IcwMainProc( CIcwProcParam* pParam )
{
	CIcwInfo objParam;

	objParam = pParam->m_objInitParam;
	objParam.m_bSuccess = TRUE;

	WriteLogIcwParam( objParam, "ICW PROC START" );

	switch ( pParam->m_objInitParam.m_PaperFitting )
	{
	case PROC_REALSIZE:
		// 摜Tu1itBbeBOΉŁj
		IcwSubProc1( objParam );
		WriteLogIcwParam( objParam, "ICW PROC STEP1" );
		IcwSubProc21( objParam );
		break;
	case PROC_CUT:
	case PROC_OVERALL:
	case PROC_REALSIZECNTR:
		// 摜Tu1itBbeBOΉŁj
		IcwSubProc1( objParam );
		WriteLogIcwParam( objParam, "ICW PROC STEP1" );
		IcwSubProc22( objParam );
		break;
	default:
		// 揈
		pParam->m_objResultParam = pParam->m_objInitParam;
		pParam->m_objResultParam.m_bSuccess = FALSE;
		break;
	}

	WriteLogIcwParam( objParam, "ICW PROC END  " );

	pParam->m_objResultParam = objParam;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::IcwSubProc1()
//	ABSTRACT : 摜Tu1i摜tH[}bgϊj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.30
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::IcwSubProc1( CIcwInfo& objParam )
{
	BOOL bResult;
	SIZE siImg;
	CString strTmpFileName;

	//--------------------------------------------------
	// STEP-1-1	L̏ꍇ͈Ut@Cɕۑ
	//--------------------------------------------------
	if ( TRUE == objParam.m_bSuccess )
	{
		if ( IMGSRC_SHAREDMEM == objParam.m_SourceType )
		{
			objParam.m_bSuccess = FALSE;

			strTmpFileName = MakeTempFileFullPath( "STEP1.img" );

			if ( TRUE == NkcComApi::WriteFileByMmf(
							strTmpFileName,
							objParam.m_strFileName,
							objParam.m_FileOffset,
							objParam.m_ImageCapacity ) )
			{
				NPS_LOGOUT( "   NkcComApi::WriteFileByMmf() SUCCESS" );

				objParam.m_strFileName		= strTmpFileName;
				objParam.m_bDeleteFile		= TRUE;

				objParam.m_bSuccess			= TRUE;
				objParam.m_FileOffset		= 0;
				objParam.m_ImageCapacity	= 0;	// 摜ǂݍݎɂ͎gpȂ̂0Zbg
			}
			else
			{
				NPS_LOGOUT_FATAL( "===NkcComApi::WriteFileByMmf() FAIL" );
			}
		}
	}

	//--------------------------------------------------
	// STEP-1-2	ItZbgꍇ͉摜t@Cɕۑ
	//--------------------------------------------------
	if ( TRUE == objParam.m_bSuccess )
	{
		if ( 0 < objParam.m_FileOffset )
		{
			objParam.m_bSuccess = FALSE;

			strTmpFileName = MakeTempFileFullPath( "STEP2.img" );

			if ( TRUE == NkcComApi::CopyFileMid(
							objParam.m_strFileName,
							strTmpFileName,
							objParam.m_FileOffset,
							objParam.m_ImageCapacity ) )
			{
				NPS_LOGOUT( "   NkcComApi::CopyFileMid() SUCCESS" );

				if ( TRUE == objParam.m_bDeleteFile )
				{
					::DeleteFile( objParam.m_strFileName );
				}
				objParam.m_strFileName		= strTmpFileName;
				objParam.m_bDeleteFile		= TRUE;

				objParam.m_bSuccess			= TRUE;
				objParam.m_FileOffset		= 0;
			}
			else
			{
				NPS_LOGOUT_FATAL( "===NkcComApi::CopyFileMid() FAIL" );
			}
		}
	}

#if defined(NKC_ICW_BMP)
	//--------------------------------------------------
	// STEP-1-3	摜BMP(24)ɕϊ
	//--------------------------------------------------
	if ( TRUE == objParam.m_bSuccess )
	{
		if ( IMGFMT_BMP != objParam.m_ImageFormat )
		{
			objParam.m_bSuccess = FALSE;

			strTmpFileName = MakeTempFileFullPath( "STEP3.bmp" );

			switch ( objParam.m_ImageFormat )
			{
			case IMGFMT_JPEG:
			case IMGFMT_JPEG2:
				bResult = NkcComApi::FileConvertJpgToBmp(
							m_hImgFileJpgL6,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			case IMGFMT_BMP2:
				bResult = NkcComApi::FileConvertBmpToBmp(
							m_hImgFileBmpL2,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			case IMGFMT_TIFF:
				bResult = NkcComApi::FileConvertTifToBmp(
							m_hImgFileTifL1,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			default:
				bResult = FALSE;
				break;
			}

			if ( TRUE == bResult )
			{
				NPS_LOGOUT( "   NkcComApi::FileConvertXXXXToBmp() SUCCESS" );

				if ( TRUE == objParam.m_bDeleteFile )
				{
					::DeleteFile( objParam.m_strFileName );
				}
				objParam.m_strFileName		= strTmpFileName;
				objParam.m_bDeleteFile		= TRUE;

				objParam.m_bSuccess			= TRUE;
				objParam.m_ImageFormat		= IMGFMT_BMP;
				objParam.m_ImageWidth		= (USHORT)siImg.cx;
				objParam.m_ImageHeight		= (USHORT)siImg.cy;
				objParam.m_ImageCapacity	= NkcComApi::GetFileSize( objParam.m_strFileName );
			}
			else
			{
				NPS_LOGOUT_FATAL( "===NkcComApi::FileConvertXXXXToBmp() FAIL" );
			}
		}
	}
#else  // defined(NKC_ICW_BMP)
	//--------------------------------------------------
	// STEP-1-3	摜RAW(24)ɕϊ
	//--------------------------------------------------
	if ( TRUE == objParam.m_bSuccess )
	{
		if ( IMGFMT_RAW24 != objParam.m_ImageFormat )
		{
			objParam.m_bSuccess = FALSE;

			strTmpFileName = MakeTempFileFullPath( "STEP3.raw" );

			switch ( objParam.m_ImageFormat )
			{
			case IMGFMT_JPEG:
			case IMGFMT_JPEG2:
				bResult = NkcComApi::FileConvertJpgToRaw(
							m_hImgFileJpgL6,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			case IMGFMT_BMP:
			case IMGFMT_BMP2:
				bResult = NkcComApi::FileConvertBmpToRaw(
							m_hImgFileBmpL2,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			case IMGFMT_TIFF:
				bResult = NkcComApi::FileConvertTifToRaw(
							m_hImgFileTifL1,
							objParam.m_strFileName,
							strTmpFileName,
							&siImg );
				break;
			default:
				bResult = FALSE;
				break;
			}

			if ( TRUE == bResult )
			{
				NPS_LOGOUT( "   NkcComApi::FileConvertXXXXToRaw() SUCCESS" );

				if ( TRUE == objParam.m_bDeleteFile )
				{
					::DeleteFile( objParam.m_strFileName );
				}
				objParam.m_strFileName		= strTmpFileName;
				objParam.m_bDeleteFile		= TRUE;

				objParam.m_bSuccess			= TRUE;
				objParam.m_ImageFormat		= IMGFMT_RAW24;
				objParam.m_ImageWidth		= siImg.cx;
				objParam.m_ImageHeight		= siImg.cy;
				objParam.m_ImageCapacity	= siImg.cx * siImg.cy * 3;
			}
			else
			{
				NPS_LOGOUT_FATAL( "===NkcComApi::FileConvertXXXXToRaw() FAIL" );
			}
		}
	}
#endif // defined(NKC_ICW_BMP)

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::IcwSubProc21()
//	ABSTRACT : 摜Tu2iەϊ (tBbeBOΉ)j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//             ~ y[p[tBbeBO (])
//              ]
//             ~ ]
//              GbW
//             ~ y[p[␳
//              CMS
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::IcwSubProc21( CIcwInfo& objParam )
{
	//==================================================
	// STEP-2	ەϊ
	//==================================================
	long nErrCode;
	long lResult;
	RECT rtWB;
	RECT rtSP;
	int nPaperAdjLeft;
	int nPaperAdjRight;
	SIZE PaperArea;
	CString strTmpFileName;
	T_CorrectWrapDll_ImgProcParam tIcwParam;

	if (( TRUE == objParam.m_bSuccess ) && ( 1 == objParam.m_SourceType ) && ( NULL != m_hNkcICorrGPro ))
	{
		objParam.m_bSuccess = FALSE;

		// 0.1mm  Pixel ɊZ
		rtSP.top	= (((objParam.m_SpRect.top * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.bottom	= (((objParam.m_SpRect.bottom * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.left	= (((objParam.m_SpRect.left * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.right	= (((objParam.m_SpRect.right * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.top	= (((objParam.m_WB.top * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.bottom	= (((objParam.m_WB.bottom * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.left	= (((objParam.m_WB.left * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.right	= (((objParam.m_WB.right * objParam.m_Resolution / 254) + 5) / 10);
		nPaperAdjLeft	= (((objParam.m_PaperAdjustLeft * objParam.m_Resolution / 254) + 5) / 10);
		nPaperAdjRight	= (((objParam.m_PaperAdjustRight * objParam.m_Resolution / 254) + 5) / 10);
		PaperArea.cx	= (((objParam.m_PaperSize.cx * objParam.m_Resolution / 254) + 5) / 10)
								+ rtSP.left + rtSP.right;
		PaperArea.cy	= (((objParam.m_PaperSize.cy * objParam.m_Resolution / 254) + 5) / 10)
								+ rtSP.top + rtSP.bottom;

		//--------------------------------------------------
		// STEP-2-1	ەϊp[^̍쐬
		//
		// DWORD	dwInOffset;		// ͉摜f[^̊i[ĂItZbg
		// SIZE		sizeInImage;	// ͉摜̃TCY iP:Pixelj
		// SIZE		sizeZoomImage;	// gk摜̃TCY iP:Pixelj
		// SIZE		sizeOutImage;	// o͉摜̃TCY iP:Pixelj
		// BOOL		bWBEnable;		// ] i FALSE:Ȃ, TRUE: j
		// DWORD	BlankLeft;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankTop;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankRight;		// E]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankBottom;	// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	dwAngle;		// ] ( 0:]Ȃ, 1:90x], 2:180x], 3:270x] )
		// LPVOID	pCmsProFile;	// CMS̃vt@Cf[^ ( NULL̏ꍇCMSsȂ )
		// SHORT	Edge_r;			// NxNtB^[x
		// BYTE		EdgeMaskSize;	// NxNtB^[TCY
		//--------------------------------------------------
		tIcwParam.dwInOffset		= objParam.m_FileOffset;
		tIcwParam.sizeInImage.cx	= objParam.m_ImageWidth;
		tIcwParam.sizeInImage.cy	= objParam.m_ImageHeight;
		tIcwParam.sizeZoomImage.cx	= objParam.m_ImageWidth;
		tIcwParam.sizeZoomImage.cy	= objParam.m_ImageHeight;
		tIcwParam.bWBEnable			= FALSE;
		tIcwParam.BlankLeft			= 0;
		tIcwParam.BlankTop			= 0;
		tIcwParam.BlankRight		= 0;
		tIcwParam.BlankBottom		= 0;

		// ]
		tIcwParam.dwAngle = objParam.m_Angle;
		if (( PROC_ANGLE0 == tIcwParam.dwAngle ) ||
			( PROC_ANGLE180 == tIcwParam.dwAngle ))
		{
			tIcwParam.sizeOutImage.cx	= objParam.m_ImageWidth;
			tIcwParam.sizeOutImage.cy	= objParam.m_ImageHeight;
		}
		else
		{
			tIcwParam.sizeOutImage.cx	= objParam.m_ImageHeight;
			tIcwParam.sizeOutImage.cy	= objParam.m_ImageWidth;
		}

		// GbW
		tIcwParam.Edge_r			= 0;		// NxNtB^[x
		tIcwParam.EdgeMaskSize		= 0;		// NxNtB^[TCY
		if ( TRUE == objParam.m_EdgeEnhancement )
		{
			tIcwParam.Edge_r			= 2;
			tIcwParam.EdgeMaskSize		= 3;
		}

		// CMS
		tIcwParam.pCmsProFile		= NULL;		// CMS̃vt@Cf[^ ( NULL̏ꍇCMSsȂ )
		if ( FALSE == objParam.m_strCmsFileName.IsEmpty() )
		{
			tIcwParam.pCmsProFile = (LPBYTE)LoadCmsFile( objParam.m_strCmsFileName );
		}

		//--------------------------------------------------
		// STEP-2-2	ەϊ̎s
		//--------------------------------------------------
#if defined(NKC_ICW_BMP)
		strTmpFileName = MakeTempFileFullPath( "STEP11.bmp" );
		lResult = NkcICorr_GProImgBmpProcEx(						// GPro摜֐
						m_hNkcICorrGPro,							// nh
						0,											// 摜Dx
						objParam.m_strFileName,						// ͉摜IuWFNg/t@C
						strTmpFileName,								// o͉摜IuWFNg/t@C
						MakeTempFolderFullPath(),					// e|tH_
						&tIcwParam,									// 摜p[^
						&nErrCode,	 								// ڍ׃G[R[h
						WRAPDLL_CASH_AUTO );						// LbVLw
#else  // defined(NKC_ICW_BMP)
		strTmpFileName = MakeTempFileFullPath( "STEP11.raw" );
		lResult = NkcICorr_GProImgProcEx(							// GPro摜֐
						m_hNkcICorrGPro,							// nh
						0,											// 摜Dx
						objParam.m_SourceType,						// o͉摜`(0:MMFIuWFNg 1:t@C)
						objParam.m_strFileName,						// ͉摜IuWFNg/t@C
						strTmpFileName,								// o͉摜IuWFNg/t@C
						MakeTempFolderFullPath(),					// e|tH_
						&tIcwParam,									// 摜p[^
						&nErrCode,	 								// ڍ׃G[R[h
						WRAPDLL_CASH_AUTO );						// LbVLw
#endif // defined(NKC_ICW_BMP)

		if ( NULL != tIcwParam.pCmsProFile )
		{
			delete [] (LPBYTE)tIcwParam.pCmsProFile;
		}

		if ( 0 == lResult )
		{
			NPS_LOGOUT( "   [PROC ICW] NkcICorr_GProImgProc() SUCCESS" );

			if ( TRUE == objParam.m_bDeleteFile )
			{
				::DeleteFile( objParam.m_strFileName );
			}
			objParam.m_strFileName		= strTmpFileName;
			objParam.m_bDeleteFile		= TRUE;

			objParam.m_bSuccess			= TRUE;
			objParam.m_ImageCapacity	= NkcComApi::GetFileSize( objParam.m_strFileName );
			objParam.m_ImageWidth		= (USHORT)tIcwParam.sizeOutImage.cx;
			objParam.m_ImageHeight		= (USHORT)tIcwParam.sizeOutImage.cy;
			objParam.m_Angle			= PROC_ANGLE0;
			objParam.m_Espc				= 0;
			objParam.m_PaperFitting		= PROC_REALSIZE;
			objParam.m_EdgeEnhancement	= PROC_EE_OFF;
			objParam.m_WB.top			= 0;
			objParam.m_WB.bottom		= 0;
			objParam.m_WB.left			= 0;
			objParam.m_WB.right			= 0;

			// y[p[␳lZ^[ʒuItZbglɔf
			objParam.m_PrintCenterOffset
				+= ( objParam.m_PaperAdjustRight - objParam.m_PaperAdjustLeft ) / 2;
		}
		else
		{
			{	// Oo
				CString str;
				str.Format( "===[PROC ICW] NkcICorr_GProImgProc() FAIL ( %08X )", nErrCode );
				NPS_LOGOUT_WARN( str );
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::IcwSubProc22()
//	ABSTRACT : 摜Tu2iەϊ (tBbeBOΉ)j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//              y[p[tBbeBO (])
//              ]
//              ]
//              GbW
//              y[p[␳
//              CMS
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.1.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::IcwSubProc22( CIcwInfo& objParam )
{
	//==================================================
	// STEP-2	ەϊ
	//==================================================
	long nErrCode;
	int nWork;
	double fZoom;
	double fZoomX;
	double fZoomY;
	long lResult;
	RECT rtWB;
	RECT rtSP;
	int nPaperAdjLeft;
	int nPaperAdjRight;
	SIZE PaperArea;
	SIZE DrawArea;	// 摜`悷̈itBbeBOTCY̌vZɎgpj
	CString strTmpFileName;
	T_CorrectWrapDll_ImgProcParam tIcwParam;

	if (( TRUE == objParam.m_bSuccess ) && ( 1 == objParam.m_SourceType ) && ( NULL != m_hNkcICorrGPro ))
	{
		objParam.m_bSuccess = FALSE;

		// 0.1mm  Pixel ɊZ
		rtSP.top	= (((objParam.m_SpRect.top * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.bottom	= (((objParam.m_SpRect.bottom * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.left	= (((objParam.m_SpRect.left * objParam.m_Resolution / 254) + 5) / 10);
		rtSP.right	= (((objParam.m_SpRect.right * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.top	= (((objParam.m_WB.top * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.bottom	= (((objParam.m_WB.bottom * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.left	= (((objParam.m_WB.left * objParam.m_Resolution / 254) + 5) / 10);
		rtWB.right	= (((objParam.m_WB.right * objParam.m_Resolution / 254) + 5) / 10);
		nPaperAdjLeft	= (((objParam.m_PaperAdjustLeft * objParam.m_Resolution / 254) + 5) / 10);
		nPaperAdjRight	= (((objParam.m_PaperAdjustRight * objParam.m_Resolution / 254) + 5) / 10);
		PaperArea.cx	= (((objParam.m_PaperSize.cx * objParam.m_Resolution / 254) + 5) / 10)
								+ rtSP.left + rtSP.right;
		PaperArea.cy	= (((objParam.m_PaperSize.cy * objParam.m_Resolution / 254) + 5) / 10)
								+ rtSP.top + rtSP.bottom;

		//--------------------------------------------------
		// STEP-2-1	ەϊp[^̍쐬
		//
		// DWORD	dwInOffset;		// ͉摜f[^̊i[ĂItZbg
		// SIZE		sizeInImage;	// ͉摜̃TCY iP:Pixelj
		// SIZE		sizeZoomImage;	// gk摜̃TCY iP:Pixelj
		// SIZE		sizeOutImage;	// o͉摜̃TCY iP:Pixelj
		// BOOL		bWBEnable;		// ] i FALSE:Ȃ, TRUE: j
		// DWORD	BlankLeft;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankTop;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankRight;		// E]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	BlankBottom;	// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		// DWORD	dwAngle;		// ] ( 0:]Ȃ, 1:90x], 2:180x], 3:270x] )
		// LPVOID	pCmsProFile;	// CMS̃vt@Cf[^ ( NULL̏ꍇCMSsȂ )
		// SHORT	Edge_r;			// NxNtB^[x
		// BYTE		EdgeMaskSize;	// NxNtB^[TCY
		//--------------------------------------------------
		tIcwParam.dwInOffset		= objParam.m_FileOffset;	// ͉摜f[^̊i[ĂItZbg
		tIcwParam.sizeInImage.cx	= objParam.m_ImageWidth;	// ͉摜̃TCY iP:Pixelj
		tIcwParam.sizeInImage.cy	= objParam.m_ImageHeight;	// ͉摜̃TCY iP:Pixelj

		// ]l摜̕`TCYvZ
		tIcwParam.bWBEnable = FALSE;
		tIcwParam.BlankLeft		= 0;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		tIcwParam.BlankTop		= 0;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		tIcwParam.BlankRight	= 0;		// E]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		tIcwParam.BlankBottom	= 0;		// ]TCY iP:Pixelj@ bWBEnable=TRUȄꍇɎgp
		if (( 0 < rtWB.left ) || ( 0 < rtWB.right ))
		{
			tIcwParam.bWBEnable = TRUE;
			if (( 0 < rtWB.left ) && ( 0 == rtWB.right ))
			{
				tIcwParam.BlankLeft = rtSP.left + rtWB.left;
				DrawArea.cx = PaperArea.cx - tIcwParam.BlankLeft;
			}
			else if (( 0 == rtWB.left ) && ( 0 < rtWB.right ))
			{
				tIcwParam.BlankRight = rtSP.right + rtWB.right;
				DrawArea.cx = PaperArea.cx - tIcwParam.BlankRight;
			}
			else
			{
				tIcwParam.BlankLeft = rtSP.left + rtWB.left;
				tIcwParam.BlankRight = rtSP.right + rtWB.right;
				DrawArea.cx = PaperArea.cx - tIcwParam.BlankLeft - tIcwParam.BlankRight;
			}

		}
		else
		{
			DrawArea.cx = PaperArea.cx;
		}

		if (( 0 < rtWB.top ) || ( 0 < rtWB.bottom ))
		{
			tIcwParam.bWBEnable = TRUE;
			if (( 0 < rtWB.top ) && ( 0 == rtWB.bottom ))
			{
				tIcwParam.BlankTop = rtSP.top + rtWB.top;
				DrawArea.cy = PaperArea.cy - tIcwParam.BlankTop;
			}
			else if (( 0 == rtWB.top ) && ( 0 < rtWB.bottom ))
			{
				tIcwParam.BlankBottom = rtSP.bottom + rtWB.bottom;
				DrawArea.cy = PaperArea.cy - tIcwParam.BlankBottom;
			}
			else
			{
				tIcwParam.BlankTop = rtSP.top + rtWB.top;
				tIcwParam.BlankBottom = rtSP.bottom + rtWB.bottom;
				DrawArea.cy = PaperArea.cy - tIcwParam.BlankTop - tIcwParam.BlankBottom;
			}
		}
		else
		{
			DrawArea.cy = PaperArea.cy;
		}

		// p̌ɂ鎩]
		tIcwParam.dwAngle = objParam.m_Angle;
		if ( tIcwParam.sizeInImage.cx >= tIcwParam.sizeInImage.cy )
		{	// [:]
			if ( DrawArea.cx >= DrawArea.cy )
			{	// [:][o:] ]Ȃ
				tIcwParam.dwAngle += PROC_ANGLE0;
			}
			else
			{	// [:][o:c] 90x
				tIcwParam.dwAngle += PROC_ANGLE90;
			}
		}
		else
		{	// [:c]
			if ( DrawArea.cx <= DrawArea.cy )
			{	// [:c][o:c] 0x
				tIcwParam.dwAngle += PROC_ANGLE0;
			}
			else
			{	// [:c][o:] 270x
				tIcwParam.dwAngle += PROC_ANGLE270;
			}
		}
		tIcwParam.dwAngle %= 4;
		if (( PROC_ANGLE90 == tIcwParam.dwAngle ) ||
			( PROC_ANGLE270 == tIcwParam.dwAngle ))
		{
			nWork = DrawArea.cx;
			DrawArea.cx = DrawArea.cy;
			DrawArea.cy = nWork;
		}

		// o͉摜TCYvZ
		tIcwParam.sizeOutImage.cx	= PaperArea.cx;
		tIcwParam.sizeOutImage.cy	= PaperArea.cy;

		// y[p[␳lAo̓TCYƕ`TCYɔf
		// <<dv>> ]̔ɂ̓y[p[␳l͍lȂ
		if (( PROC_ANGLE0 == tIcwParam.dwAngle ) ||
			( PROC_ANGLE180 == tIcwParam.dwAngle ))
		{
			DrawArea.cx += ( nPaperAdjLeft + nPaperAdjRight );
		}
		else
		{
			DrawArea.cy += ( nPaperAdjLeft + nPaperAdjRight );
		}
		tIcwParam.sizeOutImage.cx	+= ( nPaperAdjLeft + nPaperAdjRight );

		// tBbeBǑvZs
		switch ( objParam.m_PaperFitting )
		{
		case PROC_CUT:
			fZoomX = (double)DrawArea.cx / (double)tIcwParam.sizeInImage.cx;
			fZoomY = (double)DrawArea.cy / (double)tIcwParam.sizeInImage.cy;
			fZoom = max( fZoomX, fZoomY );
			break;
		case PROC_OVERALL:
			fZoomX = (double)DrawArea.cx / (double)tIcwParam.sizeInImage.cx;
			fZoomY = (double)DrawArea.cy / (double)tIcwParam.sizeInImage.cy;
			fZoom = min( fZoomX, fZoomY );
			break;
		case PROC_REALSIZECNTR:
			fZoom = 1.;
			break;
		}
		tIcwParam.sizeZoomImage.cx = (int)( fZoom * (double)tIcwParam.sizeInImage.cx );
		tIcwParam.sizeZoomImage.cy = (int)( fZoom * (double)tIcwParam.sizeInImage.cy );

		// GbW
		tIcwParam.Edge_r			= 0;		// NxNtB^[x
		tIcwParam.EdgeMaskSize		= 0;		// NxNtB^[TCY
		if ( TRUE == objParam.m_EdgeEnhancement )
		{
			tIcwParam.Edge_r			= 2;
			tIcwParam.EdgeMaskSize		= 3;
		}

		// CMS
		tIcwParam.pCmsProFile		= NULL;		// CMS̃vt@Cf[^ ( NULL̏ꍇCMSsȂ )
		if ( FALSE == objParam.m_strCmsFileName.IsEmpty() )
		{
			tIcwParam.pCmsProFile = (LPBYTE)LoadCmsFile( objParam.m_strCmsFileName );
		}

		//--------------------------------------------------
		// STEP-2-2	ەϊ̎s
		//--------------------------------------------------
#if defined(NKC_ICW_BMP)
		strTmpFileName = MakeTempFileFullPath( "STEP11.bmp" );
		lResult = NkcICorr_GProImgBmpProcEx(						// GPro摜֐
						m_hNkcICorrGPro,							// nh
						0,											// 摜Dx
						objParam.m_strFileName,						// ͉摜IuWFNg/t@C
						strTmpFileName,								// o͉摜IuWFNg/t@C
						MakeTempFolderFullPath(),					// e|tH_
						&tIcwParam,									// 摜p[^
						&nErrCode,	 								// ڍ׃G[R[h
						WRAPDLL_CASH_AUTO );						// LbVLw
#else  // defined(NKC_ICW_BMP)
		strTmpFileName = MakeTempFileFullPath( "STEP11.raw" );
		lResult = NkcICorr_GProImgProcEx(							// GPro摜֐
						m_hNkcICorrGPro,							// nh
						0,											// 摜Dx
						objParam.m_SourceType,						// o͉摜`(0:MMFIuWFNg 1:t@C)
						objParam.m_strFileName,						// ͉摜IuWFNg/t@C
						strTmpFileName,								// o͉摜IuWFNg/t@C
						MakeTempFolderFullPath(),					// e|tH_
						&tIcwParam,									// 摜p[^
						&nErrCode,	 								// ڍ׃G[R[h
						WRAPDLL_CASH_AUTO );						// LbVLw
#endif  // defined(NKC_ICW_BMP)

		if ( NULL != tIcwParam.pCmsProFile )
		{
			delete [] (LPBYTE)tIcwParam.pCmsProFile;
		}

		if ( 0 == lResult )
		{
			NPS_LOGOUT( "   [PROC ICW] NkcICorr_GProImgProc() SUCCESS" );

			if ( TRUE == objParam.m_bDeleteFile )
			{
				::DeleteFile( objParam.m_strFileName );
			}
			objParam.m_strFileName		= strTmpFileName;
			objParam.m_bDeleteFile		= TRUE;

			objParam.m_bSuccess			= TRUE;
			objParam.m_ImageCapacity	= NkcComApi::GetFileSize( objParam.m_strFileName );
			objParam.m_ImageWidth		= (USHORT)tIcwParam.sizeOutImage.cx;
			objParam.m_ImageHeight		= (USHORT)tIcwParam.sizeOutImage.cy;
			objParam.m_Angle			= PROC_ANGLE0;
			objParam.m_Espc				= 0;
			objParam.m_PaperFitting		= PROC_REALSIZE;
			objParam.m_EdgeEnhancement	= PROC_EE_OFF;
			objParam.m_WB.top			= 0;
			objParam.m_WB.bottom		= 0;
			objParam.m_WB.left			= 0;
			objParam.m_WB.right			= 0;

			// y[p[␳lZ^[ʒuItZbglɔf
			objParam.m_PrintCenterOffset
				+= ( objParam.m_PaperAdjustRight - objParam.m_PaperAdjustLeft ) / 2;
		}
		else
		{
			{	// Oo
				CString str;
				str.Format( "===[PROC ICW] NkcICorr_GProImgProc() FAIL ( %08X )", nErrCode );
				NPS_LOGOUT_WARN( str );
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::GetFileNameOfCmsDat()
//	ABSTRACT : CMSŎgpDatt@C̃pX擾(Op␳AS)
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//  ARGMENT  : dwCms            CMStO ( 0:OFF, 1:Normal, 2:Custom )
//           : dwColorSpace	    F ( 0:sRGB, 1:AdobeRGB )
//           : dwPaperTypeCode  y[p[R[h
//           : pNps6000H_0101H  v^{
//           : pNps6000H_0201H  v^ݒ
//           : pDeleteCmsDatFilet@C̍폜tO ( TRUE:폜Kv, FALSE:폜sv )
//           : pstrFileName     CMSŎgpDatt@C̃tpX
//	
//	RETURN   : TRUE  : 擾
//             FALSE : 擾s
//	
//	CREATE	 : Y.Yoshinobu	2008.2.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::GetFileNameOfCmsDat( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, T_Nps6000H_0101H* pNps6000H_0101H, T_Nps6000H_0201H* pNps6000H_0201H, BOOL* pDeleteCmsDatFile, CString* pstrFileName )
{
	int nSetupType = 0;
	BOOL bResult = FALSE;
	unsigned short nAlgoVer;
	CNkcProfileModule ProObject;

	*pDeleteCmsDatFile = FALSE;

	// vt@Cf[^̑݃`FbN
	if ( FALSE == ProObject.CheckProfileExist() )
	{
		{	// Oo
			NPS_LOGOUT_WARN( "===PROFILE CD NOT EXIST" );
		}
		return bResult;
	}

	// @敪CNWFbgǂŔf
	if ( 1 != pNps6000H_0101H->MachineTypeID )
	{
		// QSS(≖)̏ꍇ̏
		if ( 200 > pNps6000H_0201H->SetupAlgorithm )
		{
			// Op␳AS
			bResult = GetFileNameOfCmsDat1( dwCms, dwColorSpace, dwPaperTypeCode, pNps6000H_0101H, pstrFileName );
		}
		else
		{
			// ICMAS
			nSetupType = pNps6000H_0201H->SetupAlgorithm;
			bResult = GetFileNameOfCmsDat2( dwCms, dwColorSpace, dwPaperTypeCode, nSetupType, pNps6000H_0101H, pNps6000H_0201H, pstrFileName );
			*pDeleteCmsDatFile = TRUE;
		}
	}
	else
	{
		// IJ(CNWFbg)̏ꍇ̏

		// vt@Cf[^CMS̃ASY̎ނ擾
		nAlgoVer = ProObject.GetCmsAlgoVer( pNps6000H_0201H->MachinTypeForProfile );

		switch ( nAlgoVer )
		{
		case 1:	// Op␳AS
			bResult = GetFileNameOfCmsDat1( dwCms, dwColorSpace, dwPaperTypeCode, pNps6000H_0101H, pstrFileName );
			break;
		case 2:	// ICMAS
			nSetupType = 200;
			bResult = GetFileNameOfCmsDat2( dwCms, dwColorSpace, dwPaperTypeCode, nSetupType, pNps6000H_0101H, pNps6000H_0201H, pstrFileName );
			*pDeleteCmsDatFile = TRUE;
			break;
		default:
			CString str;
			str.Format( "===PROFILE SETUP ALGORITHM VERSION ERROR %d", nAlgoVer );
			NPS_LOGOUT_WARN( str );
			break;
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::GetFileNameOfCmsDat1()
//	ABSTRACT : CMSŎgpDatt@C̃pX擾(Op␳AS)
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//  ARGMENT  : dwCms            CMStO ( 0:OFF, 1:Normal, 2:Custom )
//           : dwColorSpace	    F ( 0:sRGB, 1:AdobeRGB )
//           : dwPaperTypeCode  y[p[R[h
//           : pNps6000H_0101H  v^{
//           : pstrFileName     CMSŎgpDatt@C̃tpX
//	
//	RETURN   : TRUE  : 擾
//             FALSE : 擾s
//	
//	CREATE	 : Y.Yoshinobu	2008.1.29
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::GetFileNameOfCmsDat1( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, T_Nps6000H_0101H* pNps6000H_0101H, CString* pstrFileName )
{
	int nProfFlg;
	int nCustomFlg;
	char szFileName[MAX_PATH];
	BOOL bResult = FALSE;
	DWORD dwPaperNo;
	CNkcProfileModule ProObject;


	// p[^
	switch ( dwCms )
	{
	case PROC_CMSONNORMAL:
		nCustomFlg = 0;
		dwPaperNo = dwPaperTypeCode;
		break;
	case PROC_CMSONCUSTOM:
		nCustomFlg = 1;
		dwPaperNo = 1;	// y[p[R[h1Œ
		break;
	default:				return bResult;
	}

	switch ( dwColorSpace )
	{
	case ICS_SRGB:	nProfFlg = 1;	break;
	case ICS_ARGB:	nProfFlg = 0;	break;
	default:				return bResult;
	}

	// CMSf[^t@C̎擾
	if ( TRUE == ProObject.GetPrintCmsName(
					nProfFlg,
					nCustomFlg,
					dwPaperNo,
					0,									// JX^R[h͖gp
					pNps6000H_0101H->MachineTypeName,
					0,
					pNps6000H_0101H->SerialNumber,
					szFileName ) )
	{
		*pstrFileName = szFileName;
		bResult = TRUE;
	}
	else
	{
		NPS_LOGOUT_WARN( "===GetPrintCmsName() = FALSE" );
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::GetFileNameOfCmsDat2()
//	ABSTRACT : CMSŎgpDatt@C̃pX擾(ICMAS)
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > NKCp
//	
//  ARGMENT  : dwCms            CMStO ( 0:OFF, 1:Normal, 2:Custom )
//           : dwColorSpace	    F ( 0:sRGB, 1:AdobeRGB )
//           : dwPaperTypeCode  y[p[R[h
//           : pNps6000H_0101H  v^{
//           : pNps6000H_0201H  v^ݒ
//           : pstrFileName     CMSŎgpDatt@C̃tpX
//	
//	RETURN   : TRUE  : 擾
//             FALSE : 擾s
//	
//	CREATE	 : Y.Yoshinobu	2008.2.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrintThread::GetFileNameOfCmsDat2( DWORD dwCms, DWORD dwColorSpace, DWORD dwPaperTypeCode, int nSetupType, T_Nps6000H_0101H* pNps6000H_0101H, T_Nps6000H_0201H* pNps6000H_0201H, CString* pstrFileName )
{
	int nProfFlg;
	int nCustomFlg;
	int nResult;
	BOOL bResult = FALSE;
	CString strTmpFileName;
	DWORD dwPaperNo;
	CNkcProfileModule ProObject;


	// p[^
	switch ( dwCms )
	{
	case PROC_CMSONNORMAL:
		nCustomFlg = 0;
		dwPaperNo = dwPaperTypeCode;
		break;
	case PROC_CMSONCUSTOM:
		nCustomFlg = 1;
		dwPaperNo = 1;	// y[p[R[h1Œ
		break;
	default:				return bResult;
	}

	switch ( dwColorSpace )
	{
	case ICS_SRGB:	nProfFlg = 1;	break;
	case ICS_ARGB:	nProfFlg = 0;	break;
	default:				return bResult;
	}

	// CMSf[^t@C̎擾
	strTmpFileName = MakeTempFileFullPath( "CMS.dat" );
	nResult = ProObject.IcmChangeColorDataForPrint(
					nProfFlg,
					nCustomFlg,
					dwPaperNo,
					0,					// JX^R[h͖gp
					pNps6000H_0201H->MachinTypeForProfile,
					pNps6000H_0101H->MachineTypeName,
					0,
					pNps6000H_0101H->SerialNumber,
					strTmpFileName.GetBuffer( strTmpFileName.GetLength() ),
					0,					// gp
					nSetupType );
	if ( 0 == nResult )
	{
		*pstrFileName = strTmpFileName;
		bResult = TRUE;
	}
	else
	{
		CString str;
		str.Format( "===IcmChangeColorDataForPrint( %d, %d, %u, %d, %d, \"%s\", %d, \"%s\", \"%s\", %d, %d ) = %d",
					nProfFlg,
					nCustomFlg,
					dwPaperNo,
					0,
					pNps6000H_0201H->MachinTypeForProfile,
					pNps6000H_0101H->MachineTypeName,
					0,
					pNps6000H_0101H->SerialNumber,
					strTmpFileName.GetBuffer( strTmpFileName.GetLength() ),
					0,
					nSetupType,
					nResult );
		NPS_LOGOUT_WARN( str );
	}

	return bResult;
}

#endif // defined(NKC_CMS_PROC)

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::ErrorNoticeON_6681()
//	ABSTRACT : lbg[NʐMG[
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	           nSubNo = 1: tJnR}hŎsԂĂ
//	                    2: 摜̓ǂݍݎs
//	                    3: 摜MmFR}hŎsԂĂ
//	                    4: 摜ϊs
//	                    5: ʐMs
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.02.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::ErrorNoticeON_6681( LONG nSubNo )
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 6681;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= nSubNo;					// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFF4;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrintThread::SetSdk()
//	ABSTRACT : v^ʂǗNX̃|C^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrintThread::SetSdk( CSdk* pSdk )
{
	m_pSdk = pSdk;
}

