//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PrinterWatchThread.cpp
//	ABSTRACT  : CPrinterWatchThread NX̃Cve[V
//	
//	CREATE    : Y.Yoshinobu	2006.10.11
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sdk.h"
#include "PrinterWatchThread.h"
#include "nkcProfileModule.h"

extern DWORD g_dwMode;				// 샂[h
extern DWORD g_dwConnectMode;		// iڑ[h

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : int WINAPI PrinterWatchThreadEntry()
//	ABSTRACT : v^Ď̃Xbh̃Gg
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.2
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
unsigned int WINAPI PrinterWatchThreadEntry( LPVOID pParam )
{
	CPrinterWatchThread* pPrinterWatchThread = (CPrinterWatchThread*)pParam;

	NPS_LOGOUT( ">>> Printer Watch Thread Start" );
	pPrinterWatchThread->InitInstance();
	pPrinterWatchThread->ExecProc();
	pPrinterWatchThread->ExitInstance();
	NPS_LOGOUT( "<<< Printer Watch Thread End" );

	return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::CPrinterWatchThread()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPrinterWatchThread::CPrinterWatchThread()
{
	m_hEvent[EVENT_STOP]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );
	m_hEvent[EVENT_WATCH]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );
	m_hEvent[EVENT_TIMER]	= ::CreateWaitableTimer( NULL, FALSE, NULL );
	m_hEvent[EVENT_FINISH]	= ::CreateEvent( NULL, FALSE, FALSE, NULL );	// 2006.11.06 T.Mizushima

	m_hStartEvent			= ::CreateEvent( NULL, FALSE, FALSE, NULL );

	m_pPrintThread = NULL;	// vgXbh		2006.11.08 T.Mizushima

	m_dwConnectChkCnt		= CONNECT_INTERVAL_TIME;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::~CPrinterWatchThread()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CPrinterWatchThread::~CPrinterWatchThread()
{
	::CloseHandle( m_hStartEvent );

	for ( int ii=0 ; EVENT_CNT > ii ; ii++ )
	{
		::CloseHandle( m_hEvent[ii] );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::InitInstance()
//	ABSTRACT : XbhJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrinterWatchThread::InitInstance()
{
	// IpCxg
	::ResetEvent( m_hEvent[EVENT_STOP] );

	// MmpCxg
	::ResetEvent( m_hEvent[EVENT_WATCH] );

	// XbhImFpCxg
	::ResetEvent( m_hEvent[EVENT_FINISH] );

	// ^C}[Zbg	1b
	LARGE_INTEGER	InitTime;
	InitTime.QuadPart = -10000;
	::SetWaitableTimer( m_hEvent[EVENT_TIMER], &InitTime, 1000, NULL, NULL, FALSE );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ExitInstance()
//	ABSTRACT : XbhI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CPrinterWatchThread::ExitInstance()
{
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ExecProc()
//	ABSTRACT : XbhC[v
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ExecProc()
{
	DWORD dwHandleSignaled;

	while ( TRUE )
	{
		dwHandleSignaled = ::WaitForMultipleObjects( EVENT_CNT, m_hEvent, FALSE, INFINITE );

		if ( EVENT_STOP == ( dwHandleSignaled - WAIT_OBJECT_0 ) )
		{
			// XbhI
			::SetEvent( m_hStartEvent );
			break;
		}

		switch ( dwHandleSignaled - WAIT_OBJECT_0 )
		{
		case EVENT_WATCH:

			// ŐڑmFs悤ɃJEgɕύX
			m_dwConnectChkCnt = CONNECT_INTERVAL_TIME;

		case EVENT_TIMER:

			// vgC֐
			PrinterWatch();
			::SetEvent( m_hStartEvent );

			break;

		}
	}

	::SetEvent( m_hEvent[EVENT_FINISH] );	// XbhImFpCxgZbg	2006.11.06 T.Mizushima
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::EndThread()
//	ABSTRACT : XbhIv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::EndThread()
{
	::SetEvent( m_hEvent[EVENT_STOP] );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::SetWatchEvent()
//	ABSTRACT : vgJnCxg쓮
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::SetWatchEvent()
{
	::SetEvent( m_hEvent[EVENT_WATCH] );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::SetIPAddress()
//	ABSTRACT : v^IPAhX̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::SetIPAddress( DWORD dwIPAddress )
{
	m_dwIPAddress = dwIPAddress;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::SetNpsPortNo()
//	ABSTRACT : v^NPSp|[gԍ̓o^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::SetNpsPortNo( USHORT wNpsPortNo )
{
	m_wNpsPortNo = wNpsPortNo;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::SetSdk()
//	ABSTRACT : v^ʂǗNX̃|C^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::SetSdk( CSdk* pSdk )
{
	m_pSdk = pSdk;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::GetStartEventHandle()
//	ABSTRACT : ڑmFpCxg̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
HANDLE CPrinterWatchThread::GetStartEventHandle()
{
	return m_hStartEvent;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::GetFinishEventHandle()
//	ABSTRACT : XbhImFpCxg̎擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.06
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
HANDLE CPrinterWatchThread::GetFinishEventHandle()
{
	return m_hEvent[EVENT_FINISH];
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::PrinterWatch()
//	ABSTRACT : v^Ď
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::PrinterWatch()
{
	if ( NULL == m_pSdk )
	{
		return;
	}

	if ( TRUE == m_pSdk->m_NpsCmd.IsOpenSocket() )
	{
		// IC
		m_dwConnectChkCnt = 0;
		PrinterCheck();		// ڑmF
	}
	else
	{
		// ItC
		if ( CONNECT_INTERVAL_TIME <= m_dwConnectChkCnt )
		{
			m_dwConnectChkCnt = 0;
			PrinterConnect();	// ڑ
		}
		else
		{
			// 1bԊuŃJEgAbv
			m_dwConnectChkCnt++;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::PrinterCheck()
//	ABSTRACT : v^ڑmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::PrinterCheck()
{
	if ( FALSE == m_pSdk->m_DataManager.IsSendConnectCheck() )
	{
		// ȎMv莞Ԍo߂ĂȂ̂ŁAڑmF͍sȂ
		return;
	}

	long nResult;
	T_Nps6000H_1500H tNps6000H_1500H;
	T_Nps6000H_1501H tNps6000H_1501H;

	nResult = m_pSdk->m_NpsCmd.NpsCmd_6000_1500_1501( &tNps6000H_1500H, &tNps6000H_1501H );

	if (( NPSERR_NORMAL != nResult ) &&
		( NPSERR_BADPARAM != nResult ))	// o[WƂ̌݊z߁AT|[gʒmMĂOKƂ
	{
		// ڑmFɎŝŁARlNVؒf

		{	// Oo
			NPS_LOGOUT_FATAL( "===PRINTER CONNECT CHECK FIAL" );
		}

		// ʐMؒf
		m_pSdk->SocketCloseProc();

		return;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::PrinterConnect()
//	ABSTRACT : v^ڑ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE	 : A.Nagamatsu	2008.01.23		Tu@B"1"Ή
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::PrinterConnect()
{
	//------------------------------------------------------------
	// v^̃I[v
	//------------------------------------------------------------
	unsigned char *	pChar;
	CString strHostAddress;

	pChar	= ( unsigned char * ) &m_dwIPAddress;
	strHostAddress.Format( "%d.%d.%d.%d", pChar[0], pChar[1], pChar[2], pChar[3] );

	long nResult;

	nResult = m_pSdk->m_NpsCmd.Open( strHostAddress, m_wNpsPortNo );

	if( NPSERR_NORMAL != nResult )
	{
		// OFFLINE
		if ( TRUE == m_pSdk->m_DataManager.IsFirstConnect() )
		{
#if defined(NPS_PRN_VER_CHK_V1)	// 2006.12.12 T.Mizushima
			if ( !(NPSCTM_QSSVERCHK_OFF & g_dwMode) )
			{
				PrinterStateCheck();	// v^I/FԊmF	2006.12.01 T.Mizushima
			}
#endif
			if ( NPSCTM_OFFLINECHK_ON & g_dwMode )
			{
				ErrorNoticeON_1750();
			}
			m_pSdk->m_DataManager.SetFirstConnect( FALSE );
		}
		return;
	}
	else
	{
		// ONLINE
		if ( TRUE == m_pSdk->m_DataManager.IsEnableOfflineEvent() )
		{
			ErrorNoticeOFF_1750();
			m_pSdk->m_DataManager.SetFirstConnect( FALSE );
		}
		if ( TRUE == m_pSdk->m_DataManager.IsFirstConnect() )
		{
			m_pSdk->m_DataManager.SetEnableOfflineEvent( FALSE );
		}
	}

	m_pSdk->m_NpsCmd.SetTimeout( NPS_DEFAULT_TIMEOUT );

	{	// Oo
		NPS_LOGOUT( "===PRINTER ONLINE (Initialize start)" );
	}

	//------------------------------------------------------------
	// ڑJn
	//------------------------------------------------------------

	T_Nps6000H_0E00H tNps6000H_0E00H = { 0 };
	T_Nps6000H_0E01H tNps6000H_0E01H = { 0 };

	tNps6000H_0E00H.OemCode = g_dwConnectMode;

	nResult	= m_pSdk->m_NpsCmd.Login( &tNps6000H_0E00H, &tNps6000H_0E01H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::Login", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != tNps6000H_0E01H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	m_pSdk->m_DataManager.SetNpsVersion( tNps6000H_0E01H.NpsVersion );

	//------------------------------------------------------------
	// v^{̓o^
	//------------------------------------------------------------

	T_Nps6000H_0101H	wNps6000H_0101H;
	nResult	= m_pSdk->m_NpsCmd.GetPrinterBasic( NULL, &wNps6000H_0101H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::GetPrinterBasic", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != wNps6000H_0101H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}


	//------------------------------------------------------------
	// v^ݒ̓o^
	//------------------------------------------------------------

	T_Nps6000H_0201H	wNps6000H_0201H;
	nResult	= m_pSdk->m_NpsCmd.GetPrinterSetup( NULL, &wNps6000H_0201H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::GetPrinterSetup", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != wNps6000H_0201H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

#if defined(NPS_PRN_VER_CHK_V1)	// 2006.12.12 T.Mizushima
	if ( !(NPSCTM_QSSVERCHK_OFF & g_dwMode) )
	{
		//------------------------------------------------------------
		// o[WAbv`FbNc[Ή	2011.06.14 Y.Atoji
		// WXgc[̃pX擾łꍇFc[s
		// 擾łȂꍇF]̃o[W`FbNs
		//------------------------------------------------------------
		char	szSoftName[20];
		CString	strSubKey;
		CString	strCheckerPath;
		
		m_pSdk->m_DataManager.GetPrinterBasicSoftName( szSoftName );
		strSubKey.Format( PRINTER_REG_KEY_ROOT_FMT, szSoftName );

		// o[WAbv`FbNc[̃pX擾
		if( FALSE == NkcComApi::GetRegString( HKEY_LOCAL_MACHINE, strSubKey, "ChkVerup", strCheckerPath ) )
		{	// o[WAbv`FbNc[̃pX擾s
			//------------------------------------------------------------
			// v^o[W̎擾		2006.11.29 T.Mizushima
			// \tgEFA擾6000H-0101ȞA
			// vZT[ʎ擾6000H-0201ȞɂĂ
			//------------------------------------------------------------
			int nCheckResult;
			T_Nps6002H_7305H	wNps6002H_7305H;
			nResult	= m_pSdk->m_NpsCmd.GetVersion( NULL, &wNps6002H_7305H );
			if( nResult == NPSERR_NORMAL )
			{	//@@@Ńo[W`FbNII@@@
				TPtVersionInf		wPtVersionInf;
				memcpy( wPtVersionInf.ptMainIF, wNps6002H_7305H.ptMainIF, sizeof wPtVersionInf.ptMainIF );				// v^I/F
				memset( wPtVersionInf.printerCtrl, 0x20, sizeof wPtVersionInf.printerCtrl );							// ̃obt@40oCgȂ̂ŃXy[XŖ߂Ă
				memcpy( &wPtVersionInf.printerCtrl[0][0], wNps6002H_7305H.printerCtrl1[0], sizeof wNps6002H_7305H.printerCtrl1[0] );	// v^Rg[
				memcpy( &wPtVersionInf.printerCtrl[1][0], wNps6002H_7305H.printerCtrl1[1], sizeof wNps6002H_7305H.printerCtrl1[1] );	// v^Rg[
				memcpy( &wPtVersionInf.printerCtrl[0][20], wNps6002H_7305H.printerCtrl2[0], sizeof wNps6002H_7305H.printerCtrl2[0] );	// v^Rg[
				memcpy( &wPtVersionInf.printerCtrl[1][20], wNps6002H_7305H.printerCtrl2[1], sizeof wNps6002H_7305H.printerCtrl2[1] );	// v^Rg[
				memcpy( wPtVersionInf.laserCtrl, wNps6002H_7305H.laserCtrl, sizeof wPtVersionInf.laserCtrl );			// [U[Rg[
				memcpy( wPtVersionInf.procCtrl, wNps6002H_7305H.procCtrl, sizeof wPtVersionInf.procCtrl );				// vZTRg[
				memcpy( wPtVersionInf.ptMainIF2, wNps6002H_7305H.ptMainIF640, sizeof wPtVersionInf.ptMainIF2 );			// v^I/F iTu@B = "1"pj
				memcpy( wPtVersionInf.laserCtrl1_1, wNps6002H_7305H.laserCtrl640, sizeof wPtVersionInf.laserCtrl1_1 );	// [U[Rg[ iTu@B = "1"pj
				m_pSdk->m_DataManager.GetPrinterBasicSoftName( (CHAR*)wPtVersionInf.softName ); 						// \tgEFA
				T_Nps6000H_0101H	wNps6000H_0101H;
				m_pSdk->m_DataManager.GetPrinterBasic( &wNps6000H_0101H );												// v^{̎擾
				wPtVersionInf.MachineTypeID = wNps6000H_0101H.MachineTypeID;											// vgGW̃^Cv
				T_Nps6000H_0201H	wNps6000H_0201H;
				m_pSdk->m_DataManager.GetPrinterSetup( &wNps6000H_0201H );												// v^ݒ̎擾
				wPtVersionInf.ProcessorType = wNps6000H_0201H.ProcessorType;											// vZT[(vZT[)
			
				wPtVersionInf.MachineSubInfo = GetMachineSubInfo();														// Tu@B

				nCheckResult = ptVersionCheck( &wPtVersionInf );
				if ( PTVERCHK_CAUTION & nCheckResult )
				{	// m点\Kv
					NPS_LOGOUT_WARN( "Version Check NG" );
					#if defined(NPS_PRN_VER_CHK_V1)	// 2006.12.01 T.Mizushima
						ErrorNoticeON_1804( FALSE );
					#endif
				}
				else
				{	// m点\Ȃ
					if ( PTVERCHK_VERSIONUP & nCheckResult )
					{	// o[WAbvKv
						NPS_LOGOUT_WARN( "Version Check NG (AUTO UPDATE)" );
						#if defined(NPS_PRN_VER_CHK_V1)	// 2006.12.01 T.Mizushima
							ErrorNoticeON_1804( TRUE );
						#endif
					}
				}
			}
		}
		else
		{	// o[WAbv`FbNc[̃pX擾
			int	nCheckerResult;

			// o[WAbv`FbNc[s
			nCheckerResult = ExecVerupChecker( strCheckerPath, strHostAddress );

			{	// Oo
				CString str;
				str.Format( "***VERSION CHECK TOOL*** Path=%s, Address=%s, Result=%d", strCheckerPath, strHostAddress, nCheckerResult );
				NPS_LOGOUT( str );
			}

			if( EXITCODE_CAUTION == nCheckerResult )
			{	// m点\Kv
				NPS_LOGOUT_WARN( "Version Check NG" );
				ErrorNoticeON_1804( FALSE );
			}
			else
			{	// m点\Ȃ
				if ( EXITCODE_VERUP == nCheckerResult )
				{	// o[WAbvKv
					NPS_LOGOUT_WARN( "Version Check NG (AUTO UPDATE)" );
					ErrorNoticeON_1804( TRUE );
				}
			}
		}
	}
#endif

	// VXe̎擾
	SYSTEMTIME timePc;
	SYSTEMTIME timePrinter;
	::GetLocalTime( &timePc );
	timePrinter.wYear			= wNps6000H_0201H.PrinterTime[0];
	timePrinter.wMonth			= wNps6000H_0201H.PrinterTime[1];
	timePrinter.wDay			= wNps6000H_0201H.PrinterTime[2];
	timePrinter.wHour			= wNps6000H_0201H.PrinterTime[3];
	timePrinter.wMinute			= wNps6000H_0201H.PrinterTime[4];
	timePrinter.wSecond			= wNps6000H_0201H.PrinterTime[5];
	timePrinter.wMilliseconds	= wNps6000H_0201H.PrinterTime[6];
	timePrinter.wDayOfWeek		= wNps6000H_0201H.PrinterTime[7];

	//------------------------------------------------------------
	// v^Ԃ̓o^
	//------------------------------------------------------------

	T_Nps6000H_0301H	wNps6000H_0301H;
	nResult	= m_pSdk->m_NpsCmd.GetPrinterState( NULL, &wNps6000H_0301H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::GetPrinterState", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != wNps6000H_0301H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	//------------------------------------------------------------
	// Sy[p[̎擾
	//------------------------------------------------------------

	T_Nps6000H_1301H	wNps6000H_1301H;
	nResult	= m_pSdk->m_NpsCmd.GetAllPaper( NULL, &wNps6000H_1301H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::GetAllPaper", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != wNps6000H_1301H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	//------------------------------------------------------------
	// y[p[̎擾
	//------------------------------------------------------------

	T_Nps6000H_0401H	wNps6000H_0401H;
	nResult	= m_pSdk->m_NpsCmd.GetPaper( NULL, &wNps6000H_0401H );

	if( NPSERR_NORMAL != nResult )
	{
		// v^Ƃ̒ʐMɎs
		NPS_LOGOUT_PRINTF( " ==PRNERR CNpsCmd::GetPaper", nResult );
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}

	if( NPS_SUCCESS != wNps6000H_0401H.Result )
	{
		// ʐMؒf
		m_pSdk->SocketCloseProc();
		return;
	}


	//------------------------------------------------------------
	// vt@Co[W̊mF
	//------------------------------------------------------------
	if ( NPSCTM_CMSTBLMAKE_ON & g_dwMode )
	{
		ProfileVersionCheck();
	}

	{	// Oo
		NPS_LOGOUT( "===PRINTER ONLINE (Initialize end)" );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ProfileVersionCheck()
//	ABSTRACT : vt@Co[W̊mF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.06
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ProfileVersionCheck()
{
	int nPaperNo;
	int nIdx;
	char szVerName[64];
	long nResult;
	BOOL bResult;
	CNkcProfileModule ProObject;
	T_EngineCode tEngineCode;
	T_CustomCode tCustomCode;
	T_Nps6000H_0101H tNps6000H_0101H;
	T_Nps6000H_0201H tNps6000H_0201H;
	T_Nps6000H_0500H tNps6000H_0500H;
	T_Nps6000H_0600H tNps6000H_0600H;
	T_Nps6001H_0700H tNps6001H_0700H;
	T_Nps6001H_0701H tNps6001H_0701H;

	//------------------------------------------------------------
	// ϐ̏
	//------------------------------------------------------------
	::ZeroMemory( &tEngineCode, sizeof(T_EngineCode) );
	::ZeroMemory( &tCustomCode, sizeof(T_CustomCode) );
	::ZeroMemory( &tNps6000H_0500H, sizeof(T_Nps6000H_0500H) );
	::ZeroMemory( &tNps6000H_0600H, sizeof(T_Nps6000H_0600H) );
	::ZeroMemory( &tNps6001H_0700H, sizeof(T_Nps6001H_0700H) );

	//------------------------------------------------------------
	// vt@C̃CXg[mF
	//------------------------------------------------------------

	if ( FALSE == ProObject.CheckProfileExist() )
	{
		// vt@C񂪃CXg[ĂȂ̂ŏI
		{	// Oo
			NPS_LOGOUT_WARN( "===PROFILE NOT EXIST" );
		}
		return;
	}

	//------------------------------------------------------------
	// QSSǂ̊mF
	//------------------------------------------------------------

	m_pSdk->m_DataManager.GetPrinterBasic( &tNps6000H_0101H );
	m_pSdk->m_DataManager.GetPrinterSetup( &tNps6000H_0201H );

	tEngineCode.Printer = tNps6000H_0201H.MachinTypeForProfile;

	// @敪CNWFbgǂŔf
	if ( 1 != tNps6000H_0101H.MachineTypeID )
	{
		// QSS(≖)̏ꍇ̏

		//------------------------------------------------------------
		// ^[Qbg擾
		//------------------------------------------------------------

		nResult = m_pSdk->m_NpsCmd.NpsCmd_6001_0700_0701( &tNps6001H_0700H, &tNps6001H_0701H );

		if ( NPSERR_NORMAL != nResult )
		{
			// ʐMs̏ꍇ͏I
			return;
		}
		else
		{
			if ( 0 != tNps6001H_0701H.Result )
			{
				// 擾s̏ꍇ͏I
				return;
			}
		}

		#if 0
		{	// Oo
			int nIdx1;
			int nIdx2;
			CString str;
			NPS_LOGOUT( "+++PROFILE+++ Nps6001H_0701H START" );
			str.Format( "+++PROFILE+++ RegionCode=%d", tNps6001H_0701H.RegionCode );		NPS_LOGOUT( str );
			str.Format( "+++PROFILE+++ NumberOfTarget=%d", tNps6001H_0701H.NumberOfTarget );	NPS_LOGOUT( str );
			for ( nIdx1=0 ; tNps6001H_0701H.NumberOfTarget > nIdx1 ; nIdx1++ )
			{
				if ( 0 == tNps6001H_0701H.PaperTypeCode[nIdx1] )
				{
					continue;
				}

				for ( nIdx2=0 ; 192 > nIdx2 ; nIdx2++ )
				{
					str.Format( "+++PROFILE+++ MeasureColor[%d][%d]=%f", nIdx1, nIdx2, tNps6001H_0701H.MeasureColor[nIdx1][nIdx2] );	NPS_LOGOUT( str );
				}
				str.Format( "+++PROFILE+++ PaperType[%d]=%d", nIdx1, tNps6001H_0701H.PaperType[nIdx1] );	NPS_LOGOUT( str );
				str.Format( "+++PROFILE+++ PaperTypeCode[%d]=%d", nIdx1, tNps6001H_0701H.PaperTypeCode[nIdx1] );	NPS_LOGOUT( str );
				for ( nIdx2=0 ; 60 > nIdx2 ; nIdx2++ )
				{
					str.Format( "+++PROFILE+++ TargetValue[%d][%d]=%f", nIdx1, nIdx2, tNps6001H_0701H.TargetValue[nIdx1][nIdx2] );	NPS_LOGOUT( str );
				}
				for ( nIdx2=0 ; 3 > nIdx2 ; nIdx2++ )
				{
					str.Format( "+++PROFILE+++ DMaxControl[%d][%d]=%f", nIdx1, nIdx2, tNps6001H_0701H.DMaxControl[nIdx1][nIdx2] );	NPS_LOGOUT( str );
				}
				str.Format( "+++PROFILE+++ TypeName[%d]=%s", nIdx1, tNps6001H_0701H.TypeName[nIdx1] );	NPS_LOGOUT( str );
			}
			NPS_LOGOUT( "+++PROFILE+++ Nps6001H_0701H END" );
		}
		#endif

		//------------------------------------------------------------
		// OEMR[h̃`FbN
		//------------------------------------------------------------

		bResult = ProObject.CheckProfileMaker();
		if (( FALSE == bResult ) &&
			( 1 == tNps6000H_0201H.OemCode ))
		{
			// OEMR[hvȂ
			// ( PC = NKCdl ) && ( PRN = FFdl )

			{	// Oo
				CString str;
				str.Format( "===PROFILE SPECK CHECK ERROR PC(%d) PRN(%d)", bResult, tNps6000H_0201H.OemCode );
				NPS_LOGOUT_WARN( str );
			}

			ErrorNoticeON_1754();	// v^[ɓo^Ăvt@Cf[^͌݊܂
			return;
		}

		//------------------------------------------------------------
		// ^[Qbgf[^̃`FbN
		//------------------------------------------------------------

		bResult = ProObject.GetProfileVer( szVerName );
		if ( FALSE == bResult )
		{
			{	// Oo
				CString str;
				str.Format( "===PROFILE VERSION GET ERROR %d", bResult );
				NPS_LOGOUT_WARN( str );
			}

			// 擾s̏ꍇ͏I
			return;
		}

		if ( 0 != ::lstrcmp( szVerName, (char*)tNps6000H_0201H.MachinProfileVersion ) )
		{
			// vt@Co[WvȂ

			{	// Oo
				CString str;
				str.Format( "---PROFILE VERSION DIFFERENT PC(%s) != PRN(%s)", szVerName, tNps6000H_0201H.MachinProfileVersion );
				NPS_LOGOUT_WARN( str );
			}

			// m点\
			ErrorNoticeON_1756();	// v^[̃vt@Co[Wv܂ vt@Cf[^v^[̃o[Wɍ킹Ă

		}

		bResult = ProObject.CheckProfileMaker();
		if (( FALSE == bResult ) &&
			( 0 == tNps6000H_0201H.OemCode ))
		{
			// PCPRN̗NKCdl̏ꍇCMSpf[^쐬
			// ( PC = NKCdl ) && ( PRN = NKCdl )

			if ( 200 <= tNps6000H_0201H.SetupAlgorithm )
			{
				// Oo
				CString str;
				str.Format( "===PROFILE DO NOT MAKE SETUP ALGORITHM VERSION %d", tNps6000H_0201H.SetupAlgorithm );
				NPS_LOGOUT_WARN( str );
			}
			else
			{
				//------------------------------------------------------------
				// CMSpf[^쐬 (Datt@C쐬)
				//------------------------------------------------------------

				for ( nIdx=0 ; COUNTOF(tNps6001H_0701H.PaperTypeCode) >= nIdx ; nIdx++ )
				{

					nResult = ProObject.ChangeColorDataController(
									CHANGE_CONT_PRINTER_CHG,			// XV	[ڑv^ύX]
									0,									// gp0ݒ
									0,									// Kpj^[vt@C  
									0,									// M2P2MŎgpv^vt@C̃^Cv
									tNps6001H_0701H.PaperTypeCode[nIdx],// y[p[ԍ
									tEngineCode,						// v^Aj^AXLiGWR[h` T_EngineCode\
									tNps6000H_0101H.MachineTypeName,	// o͐@햼
									0,									// jbgNo
									tNps6000H_0101H.SerialNumber,		// VAio[
									tCustomCode,						// JX^R[hݒ肵 T_CustomCode\
									tNps6001H_0701H.RegionCode			// R[h 0x00:JP 0x01:̑ 0x02:k 0x03:B@(xm̂Ƃ̂ݎgp)
									);

					if ( 0 != nResult )
					{
						{	// Oo
							CString str;
							str.Format( "===PROFILE MAKE ERROR [%d:%d] = %d", nIdx, tNps6001H_0701H.PaperTypeCode[nIdx], nResult );
							NPS_LOGOUT_WARN( str );
						}
					}

				}

			}

		}
	}
	else
	{
		// dDP̏ꍇ̏
		int nMaxCnt;
		unsigned short nAlgoVer;
		T_PapIniFile tPapIniFile;

		// vt@Cf[^CMS̃ASY̎ނ擾
		nAlgoVer = ProObject.GetCmsAlgoVer( tNps6000H_0201H.MachinTypeForProfile );

		// OpԃAS
		tPapIniFile = ProObject.GetPapIniFile( tEngineCode.Printer, 0 );
		nMaxCnt = ProObject.GetPaperListMax( tPapIniFile, tEngineCode.Printer );

		if ( FALSE == m_pSdk->m_DataManager.ChkRegistPaperNo( nMaxCnt ) )
		{
			// Oo
			CString str;
			str.Format( "===PROFILE PAPER LIST MAX COUNT %d ( tEngineCode.Printer=%d )", nMaxCnt, tEngineCode.Printer );
			NPS_LOGOUT_WARN( str );

			// m点\
			ErrorNoticeON_1756();	// v^[̃vt@Co[Wv܂ vt@Cf[^v^[̃o[Wɍ킹Ă
		}

		if ( 2 <= nAlgoVer )
		{
			// ICMAS or OG[(0xFFFF)
			// Oo
			CString str;
			str.Format( "===PROFILE DO NOT MAKE SETUP ALGORITHM VERSION %d", nAlgoVer );
			NPS_LOGOUT_WARN( str );
		}
		else
		{
			for ( nPaperNo=1 ; nMaxCnt >= nPaperNo ; nPaperNo++ )
			{

				//------------------------------------------------------------
				// CMSpf[^쐬 (Datt@C쐬)
				//------------------------------------------------------------
				nResult = ProObject.ChangeColorDataController(
								CHANGE_CONT_PRINTER_CHG,			// XV	[ڑv^ύX]
								0,									// gp0ݒ
								0,									// Kpj^[vt@C  
								0,									// M2P2MŎgpv^vt@C̃^Cv
								nPaperNo,							// y[p[ԍ
								tEngineCode,						// v^Aj^AXLiGWR[h` T_EngineCode\
								tNps6000H_0101H.MachineTypeName,	// o͐@햼
								0,									// jbgNo
								tNps6000H_0101H.SerialNumber,		// VAio[
								tCustomCode,						// JX^R[hݒ肵 T_CustomCode\
								0									// R[h 0x00:JP 0x01:̑ 0x02:k 0x03:B@(xm̂Ƃ̂ݎgp)
								);

				if ( 0 != nResult )
				{
					{	// Oo
						CString str;
						str.Format( "===PROFILE MAKE ERROR [%d] = %d", nPaperNo, nResult );
						NPS_LOGOUT_WARN( str );
					}
					break;
				}
			}
		}
	}

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1750()
//	ABSTRACT : G[ʒm No.1750
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1750()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1750;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFFF;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1751()
//	ABSTRACT : G[ʒm No.1751
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1751()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1751;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFFE;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1754()
//	ABSTRACT : G[ʒm No.1754
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//                       v^[ɓo^Ăvt@Cf[^
//                       ݊܂
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1754()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1754;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFF8;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1755()
//	ABSTRACT : G[ʒm No.1755
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//                       vt@Co[WύX܂
//                       fB[ZbgAbvsĂ
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.12.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1755()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1755;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFF7;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1756()
//	ABSTRACT : G[ʒm No.1756
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//                       v^[̃vt@Co[Wv܂
//                       vt@Cf[^v^[̃o[W
//                       킹Ă
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1756()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1756;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFF6;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

// G[ʒm No.1750

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeOFF_1750()
//	ABSTRACT : G[ʒm No.1750
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.10.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeOFF_1750()
{
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	if ( TRUE == m_pSdk->m_DataManager.SelectEventInfo( 0xFFFFFFFF, &tNps6000H_F202H ) )
	{
		SYSTEMTIME tLocalTime;

		::GetLocalTime( &tLocalTime );

		tNps6000H_F202H.EventStatus		= 1;						// Cxg̔Ei 0:Cxg, 1:Cxg j
		tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
		tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
		tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
		tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
		tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
		tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
		tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
		tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j

		m_pSdk->CallbackEvent( &tNps6000H_F202H );

	}

}

////////////////////////////////////////////////////////////////////
//MODULE	:	ptVersionCheck
//
//ABSTRACT	:	Ӄjbg̃o[W`FbN
//FUNCTION	:	Ӄjbg̃o[WHDDɃCXg[Ă
//				syst@C̃o[WƂrČʂԐM
//
//				Ώۃjbg
//				v^I/F
//				v^Rg[
//				[U[Rg[
//				vZTRg[
//
//NOTE		:	< RD-111 > 
//				< Note > 
//
//RETURN	:	mF		:@
//
//CREATE	:	A.Nagamatsu		2006.11.20
//UPDATE	:	A.Nagamatsu		2007.05.17	EӃjbg̃o[W擾łȂꍇ
//											@o[WAbv`FbN̑ΏۊOƂ悤ɕύX
//											EӃjbg̃o[W̐擪'0'`'9',' 'ȊȌꍇ
//											@o[Ŵ߁Am点\Ƃ悤ɑΉ
//											EӃjbg̃o[ŴقVꍇ
//											@m点\Ƃ悤ɕύX
//UPDATE	:	Y.Yoshinobu		2007.08.22	EWXgւ̃ANZXKEY_ALL_ACCESSKEY_READɕύX _6240̑Ή
//UPDATE	:	Y.Yoshinobu		2010.08.11	E64bitΉɔWXgANZX֐NkcComApi::GetRegStringɒu
////////////////////////////////////////////////////////////////////
long CPrinterWatchThread::ptVersionCheck(TPtVersionInf* ptVerInf)
{
	////////////////////////////////////////////////////////////////////
	// WXgsyst@C̊i[tH_擾

	CString strSubKey;
	CString strErrMsg;
	CString strSysFilePath;

	strSubKey.Format( SYSFILE_REGKEY_ROOT, ptVerInf->softName );

	// G[e[ut@C̎擾
	if ( FALSE == NkcComApi::GetRegString( HKEY_LOCAL_MACHINE, strSubKey, "SysFile", strSysFilePath, &strErrMsg ) )
	{
		// 炭eAvCDŃCXg[Ă܂
		NPS_LOGOUT( strErrMsg );
		// o[W`FbNȂ = Ƃ
		return PTVERCHK_NORMAL;
	}

	////////////////////////////////////////////////////////////////////
	// ӃjbgHDDsyst@CƂ̃o[Wr
	long	lRet = PTVERCHK_NORMAL;
	int	_upUnit = 0;
	int	_count = 0;
	int	iCmp;
	BOOL	bCmp = TRUE;
	BOOL	bCmp2 = TRUE;

	for(int lp1 = 0; lp1 < VUNIT_TYPE_MAX; lp1 ++)
	{
		UCHAR	unitVersion[41] = {0};			// Ӄjbg̃o[W
		UCHAR	sysVersion[41] = {0};			// syst@C̃o[W

		iCmp = (lp1 == VUNIT_TYPE_PRINTER) ? 4 : 1;
		do
		{
			// Ӄjbg̃o[W擾
			GetUnitVersionInfo(lp1, iCmp, unitVersion, &_count, ptVerInf);
			unitVersion[_count] = '\0';

			if(strncmp((char*)unitVersion, (char*)"000000000", 9) == 0)
			{	// Ӄjbg̃o[W擾łȂꍇ͑S(擪9)'0'Ȃ̂ŁA
				// ʐMُƂăo[WAbv`FbN̑ΏۊOƂ
				//  - v^[̃o[W񂪊ejbgPʂ10Ȃ̂ŁA擪9Ŕf
				break;
			}

			// SYSt@C̃o[W擾
			BOOL bGetSys = GetSysFileVersionInfo(strSysFilePath, lp1, iCmp, sysVersion,
				ptVerInf->MachineTypeID,
				ptVerInf->ProcessorType,
				ptVerInf->MachineSubInfo
			);
			unitVersion[sizeof(unitVersion)-1] = '\0';
			sysVersion[sizeof(sysVersion)-1] = '\0';
			if(bGetSys == FALSE)
			{	// syst@C̃o[W擾s
				{	// Oo
					CString str;
					str.Format( "***VERSION CHECK*** Can not get sysfile version( PATH=%s ).", strSysFilePath );
					NPS_LOGOUT( str );
				}
				break;
			}

#if 1
			char	*pUnitPtr = (char*)unitVersion;
			char	*pFilePtr = (char*)sysVersion;
			int		UnitVer   , FileVer;
			int		VerType;
			
			for( VerType = 0 ; ; VerType++ )
			{
				if(!((pUnitPtr[0] >= '0' && pUnitPtr[0] <= '9') || (pUnitPtr[0] == ' ')))
				{	// Ӄjbg̃o[W̐擪'0'`'9',' 'ȊȌꍇ
					// o[Ŵ߁Am点\Ƃ
					bCmp2 = FALSE;
					break;
				}

				UnitVer = atoi((CHAR*)pUnitPtr);	// l肾
				FileVer = atoi((CHAR*)pFilePtr);
				// W[o[WقȂƂ
				if( VerType == 0 && UnitVer != FileVer )
				{
					if(UnitVer > FileVer)
					{	// Ӄjbg̃o[ŴقV  m点
						bCmp2 = FALSE;
					}
					else
					{	// Ӄjbg̃o[ŴقÂ  o[WAbv
						bCmp = FALSE;
					}
					break;
				}
				// }Ci[o[Wȉ̃o[WԍłȂt@C̕傫Ƃ
				if( VerType > 0 && UnitVer < FileVer )
				{
					bCmp = FALSE;
					break;
				}
				// }Ci[o[Wȉ̃o[WԍłȂt@C̕Ƃ
				else if( VerType > 0 && UnitVer > FileVer )
				{
					break;
				}
				// ̈ʒuo
				pUnitPtr = strchr( pUnitPtr , '.' );
				pFilePtr = strchr( pFilePtr , '.' );
				if( pUnitPtr == NULL )
				{
					if( pFilePtr == NULL )
					{
						// ŏI̎
						break;	// v
					}else{
						// {̂Ȃt@CƂ
						bCmp = FALSE;
						break;	// t@C̕Â
					}
				}else{
					if( pFilePtr == NULL )
					{
						// {̂̕āAt@CȂƂ
						break;	// {̂̕V
					}else{
						// ݂Ƃ
						pUnitPtr++;	// ʒuZ
						pFilePtr++;
					}
				}
			}
#else
			int unitVer = atoi((CHAR*)unitVersion);
			int sysVer = atoi((CHAR*)sysVersion);
			if(unitVer != sysVer)	//W[o[WقȂ
			{
				{	// Oo
					CString str;
					str.Format( "***MAJOR VERSION CHECK*** Unit=%d, UnitVer=%s(%d), SysVer=%s(%d)",
								lp1, (CHAR*)unitVersion, unitVer, (CHAR*)sysVersion, sysVer);
					NPS_LOGOUT( str );
				}
				bCmp = FALSE;
			}
			else
			{
				char* pUnitVer = strchr((CHAR*)unitVersion, '.');	//}Ci[o[W̎o
				char* pSysVer = strchr((CHAR*)sysVersion, '.');		//}Ci[o[W̎o
				int CmpCnt = _count - (pUnitVer - (CHAR*)unitVersion);	//r镶̌vZ
				{	// Oo
					CString str;
					str.Format( "***MINOR VERSION CHECK [0]*** CmpCnt=%d, UnitVer=%s, SysVer=%s", 
								CmpCnt, (CHAR*)unitVersion, (CHAR*)sysVersion);
					NPS_LOGOUT( str );
				}
				if(pUnitVer && pSysVer)
				{
					if(strncmp(pUnitVer, pSysVer, CmpCnt) < 0)	//SYŜقV
					{
						{	// Oo
							CString str;
							str.Format( "***MINOR VERSION CHECK [1]*** Unit=%d, UnitVer=%s(%s), SysVer=%s(%s)", 
										lp1, (CHAR*)unitVersion, pUnitVer, (CHAR*)sysVersion, pSysVer);
							NPS_LOGOUT( str );
						}
						bCmp = FALSE;
					}
				}
				else
				{
					{	// Oo
						CString str;
						str.Format( "***MINOR VERSION CHECK [2]*** Unit=%d, UnitVer=%s(%s), SysVer=%s(%s)", 
									lp1, (CHAR*)unitVersion, pUnitVer, (CHAR*)sysVersion, pSysVer);
						NPS_LOGOUT( str );
					}
					bCmp = FALSE;
				}
			}
#endif

//			if((_mbsncmp(unitVersion, sysVersion, _count) < 0) ||
//			   (_mbsncmp(unitVersion, sysVersion, 1) != 0) )
//			{	// SYŜقV || W[o[WقȂ
//				bCmp = FALSE;
//			}

			iCmp--;
			if((lp1 == VUNIT_TYPE_PRINTER))	//v^[Rg[̏ꍇ
			{
				{	// Oo
					CString str;
					str.Format( "***VERSION CHECK*** PrinterCtrl[1] Cnt=%d", iCmp );
					NPS_LOGOUT( str );
				}
				if(IsProcessorType(ptVerInf->ProcessorType) == 1)	//35PLUS̏ꍇ
				{
					//O20oCg̃`FbN݂̂OK
					if(iCmp < 3)
					{
						iCmp = 0;
						{	// Oo
							CString str;
							str.Format( "***VERSION CHECK*** PrinterCtrl[2] Cnt=%d", iCmp );
							NPS_LOGOUT( str );
						}
					}
				}
			}
		} while(iCmp);

		if(bCmp == FALSE || bCmp2 == FALSE)
		{	// o[W񂪈قȂ
			_upUnit |= (1 << lp1);				// o[WقȂ郆jbg

			lRet |= (bCmp2 == FALSE) ? PTVERCHK_CAUTION : PTVERCHK_VERSIONUP;
			bCmp = bCmp2 = TRUE;
		}
	}

	{	// Oo
		CString str;
		str.Format( "***VERSION CHECK RESULT*** Result=%d", _upUnit );
		NPS_LOGOUT( str );
	}

	return lRet;
}

//////////////////////////////////////////////////////////////////////////////
//vZT^Cv̔(35PLUS or 37)
/////////////////////////////////////////////////////////////////////////////
int	CPrinterWatchThread::IsProcessorType(USHORT _ProcessorType)
{
	int	iType;
	switch(_ProcessorType)
	{
	case	0:			// 0FȂ
	case	1:			// 1FLPP600(iBEAM600)
	case	2:			// 2FLPP600(Laser600)
	case	3:			// 3FLPP1000(Laser1000)
		iType = 1;		// QSS-35 PLUSn
		break;

	case	4:			// 4FLP1700(900)
	case	5:			// 5FLP1700(1300)
	case	6:			// 6FLP1700(1700)
		iType = 2;		// QSS-37n (3701`3703)
		break;

	case	7:			// 7FLP2500(2300)
	case	8:			// 8FLP2500(2500)
		iType = 3;		// QSS-37n (3704`3705)
		break;

	case	14:			// 14FLPP750G2(3900)
	case	15:			// 15FLPP1500(3901HD)
		iType = 4;		// QSS-39n (3900`3901HD)
		break;

	default	:
		iType = 1;		// Ƃ肠 QSS-35 PLUSn ƂĂ
		break;
	}

	return iType;
}

//////////////////////////////////////////////////////////////////////////////
//Tu@B̎擾
//2008.01.23 VK쐬@A.Nagamatsu
/////////////////////////////////////////////////////////////////////////////
USHORT CPrinterWatchThread::GetMachineSubInfo(void)
{
	//////////////////////////////////////////////////////////////////
	// @BdĺhTu@Bh̐ݒ
	USHORT machineSubInfo = 0;

	long nResult;
	T_Nps6002H_732BH	wNps6002H_732BH;
	nResult	= m_pSdk->m_NpsCmd.GetMachineSpec( NULL, &wNps6002H_732BH );
	if( nResult == NPSERR_NORMAL )
	{
		machineSubInfo = wNps6002H_732BH.MachineSubInfo;	// Tu@B
	}


	return machineSubInfo;
}

////////////////////////////////////////////////////////////////////
//	MODULE	 :	GetUnitVersionInfo
//
//	ABSTRACT :	ӂ̃o[Wjbg񂩂擾܂
//	FUNCTION :	jbg񂩂o[W擾܂
//
//	NOTE	 :	
//
//	RETURN	 :	TRUE:
//
//	CREATE	 :	A.Nagamatsu		2006.11.20
//	UPDATE	 :	A.Nagamatsu		2008.01.23		Tu@B"1"Ή
//	UPDATE	 :	
////////////////////////////////////////////////////////////////////
BOOL	CPrinterWatchThread::GetUnitVersionInfo(int _Unit, int _iCmp, UCHAR* UnitVer, int* count, TPtVersionInf* ptVerInf)
{
	char*	pt;

	switch(_Unit)
	{
		//v^[I/F
		case VUNIT_TYPE_PRINTER_MAIN:
			if( ptVerInf->MachineSubInfo )
			{	// Tu@B = "1"
				memcpy(UnitVer, &ptVerInf->ptMainIF2[0][0], 20);
			}
			else
			{
				memcpy(UnitVer, &ptVerInf->ptMainIF[0][0], 20);
			}
			break;

		//v^[
		case VUNIT_TYPE_PRINTER:
			memcpy(UnitVer, &ptVerInf->printerCtrl[0][40-_iCmp*10], 10);
			break;

		//GW
		case VUNIT_TYPE_ENGINE:
			if( ptVerInf->MachineSubInfo )
			{	// Tu@B = "1"
				memcpy(UnitVer, &ptVerInf->laserCtrl1_1[0][0], 20);
			}
			else
			{
				memcpy(UnitVer, &ptVerInf->laserCtrl[0][0], 20);
			}
			break;
		
		//vZT
		case VUNIT_TYPE_PROCESSOR:
			memcpy(UnitVer, &ptVerInf->procCtrl[0][0], 20);
			break;
		
		default:
			UnitVer[0] = NULL;
			*count = 20;
			break;

	}

	// 擪ŏ̃Xy[X܂łr
	//  - Xy[Xȍ~ɂ͓ڃGW̃^Cv̏
	//    tĂ
	pt = strchr((char*)UnitVer, ' ');
	if(pt)
	{
		*count = (int)( pt - (char*)UnitVer + 1 );
		return TRUE;
	}
	else
	{
		*count = 20;
		return TRUE;
	}

}

////////////////////////////////////////////////////////////////////
//	MODULE	 :	GetSysFileVersionInfo
//
//	ABSTRACT :	ӂ̃o[WSYSt@C擾܂
//	FUNCTION :	SYSt@Co[W擾܂
//
//	NOTE	 :	
//
//	RETURN	 :	TRUE:
//
//	CREATE	 :	A.Nagamatsu		2006.11.20
//	UPDATE	 :	A.Nagamatsu		2008.01.23		Tu@B"1"Ή
//	UPDATE	 :	Y.Atoji			2011.06.21		QSS-3901HD/QSS-3900Ή
//	UPDATE	 :	
////////////////////////////////////////////////////////////////////
BOOL	CPrinterWatchThread::GetSysFileVersionInfo(LPCTSTR lpSysFilePath, int _Unit, int _iCmp, UCHAR* sysVersion, USHORT _MachineTypeID, USHORT ProcessorType, USHORT MachineSubInfo)
{
	CString	_sysFileName;

	_sysFileName.Format("%s\\", lpSysFilePath);

	int iType = IsProcessorType(ProcessorType);	// @^Cv
	int	_Offset = 0;			// t@C̐擪萔āAoCgڂǂݎ邩
	int	_Count = 0;				// t@CǂݏoTCY
	switch(_Unit)
	{
		//v^[I/F
		case VUNIT_TYPE_PRINTER_MAIN:
			if( MachineSubInfo )
			{	// Tu@B = "1"
				if( 15 == ProcessorType )
				{	// QSS-3901HD
					_sysFileName += SYS_FILE_39HD_PRINTER_MAIN_1;
				}
				else
				{
					_sysFileName += SYS_FILE_PRINTER_MAIN_2;
				}
			}
			else
			{
				if( 14 == ProcessorType )
				{	// QSS-3900
					_sysFileName += SYS_FILE_3900_PRINTER_MAIN_1;
				}
				else
				{
					_sysFileName += SYS_FILE_PRINTER_MAIN_1;
				}
			}
		
			// 擪0oCgڂ20oCgr
			_Offset = 0;
			_Count = 20;
			break;

		//v^[
		case VUNIT_TYPE_PRINTER:
			if((iType == 2) || (iType == 3))
			{	// QSS-37n
				_sysFileName += SYS_FILE_PRINTER_1;
			}
			else if(4 == iType)
			{
				// QSS-39n
				_sysFileName += SYS_FILE_39_SUPPLY_1;
			}
			else
			{	// QSS-35 PLUSn
				_sysFileName += SYS_FILE_SUPPLY_1;
			}
			
			// 擪42oCgڂ40oCgr
			_Offset = 42+(40-_iCmp*10);
			_Count = 10;
			break;

		//GW
		case VUNIT_TYPE_ENGINE:
			if(_MachineTypeID == 0)			// Laser
			{
				if( MachineSubInfo )
				{	// Tu@B = "1"
					if( 15 == ProcessorType )
					{	// QSS-3901HD
						_sysFileName += SYS_FILE_39HD_LASER_1;
					}
					else
					{
						_sysFileName += SYS_FILE_LASER_1_1;
					}
				}
				else
				{
					if( 14 == ProcessorType )
					{	// QSS-3900
						_sysFileName += SYS_FILE_3900_LASER_1;
					}
					else
					{
						_sysFileName += SYS_FILE_LASER_1;
					}
				}
			}
			else if(_MachineTypeID == 2)	// iBeam
			{
				_sysFileName += SYS_FILE_VFP_1;
			}

			// 擪2oCgڂ20oCg̈ʒuŐ擪ŏ̃Xy[X܂łr
			_Offset = 2;
			_Count = 20;
			break;
		
		//vZT
		case VUNIT_TYPE_PROCESSOR:
			if((iType == 2) || (iType == 3))
			{	// QSS-37n
				_sysFileName += SYS_FILE_PROC_1_1;
			}
			else if(4 == iType)
			{
				// QSS-39n
				_sysFileName += SYS_FILE_39_PROC_1;
			}
			else
			{	// QSS-35 PLUSn
				_sysFileName += SYS_FILE_PROC_1;
			}
					
			// 擪2oCgڂ20oCgr
			_Offset = 2;
			_Count = 20;
			break;
		
		default		:
			break;

	}

	////////////////////////////////////////////////////////////////////
	// SYSt@CI[văo[W擾 (20oCg)
	FILE	*fp;
	if((fp = fopen(_sysFileName, "rb")) != NULL)
	{
		fseek(fp, _Offset, SEEK_SET);

		int cnt = (int)fread(sysVersion, 1, _Count, fp);
		if(feof(fp) || ferror(fp) || cnt != _Count)
		{
			{	// Oo
				CString str;
				str.Format( "***VERSION CHECK*** SysFile Read Error : %s, (Cnt : ReadCnt)=(%d : %d), feof=%d, ferror=%d",
							_sysFileName, _Count, cnt, feof(fp), ferror(fp));
				NPS_LOGOUT( str );
			}
			sysVersion[cnt] = NULL;
			fclose(fp);

			return FALSE;
		}

		// NULL^[~l[gĂ
		sysVersion[_Count + 1] = NULL;

		fclose(fp);
		return TRUE;
	}
	// t@C܂
	else
	{
		{	// Oo
			CString str;
			str.Format( "***VERSION CHECK*** SysFile Open Error : %s", _sysFileName );
			NPS_LOGOUT( str );
		}
		sysVersion[0] = NULL;
		return FALSE;
	}
}

#if 1
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::PrinterStateCheck()
//	ABSTRACT : v^I/F̏ԃ`FbN
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.18 VS2005Ή for̔rLXg
//////////////////////////////////////////////////////////////////////////////
BOOL CPrinterWatchThread::PrinterStateCheck()
{
	NPS_LOGOUT_DEBUG( "   CPrinterWatchThread::PrinterStateCheck()" );

	BOOL	ret = TRUE;

	CNpsBc cNpsBc;
	std::vector<T_NpsPrinterIFState*> vPrinterIFState;

	// u[hLXgŃv^I/F̏ԊmF̗v𑗐M
	long	nResult;
	nResult = cNpsBc.PrinterStateCheck( &vPrinterIFState, 10000 );
	if( nResult == NPSERR_NORMAL )
	{
		for(int i = 0; i < (int)vPrinterIFState.size(); i++ )
		{
			if( vPrinterIFState[i]->Status != 0 )
			{	// ȊO̊
	#if defined(NPS_PRN_VER_CHK_V1)	// 2006.12.01 T.Mizushima
				ErrorNoticeON_1805();	// m点1805
	#endif
				ret = FALSE;
				break;
			}
		}
	}

	for( int j = 0; j < (int)vPrinterIFState.size(); j++ )
	{
		T_NpsPrinterIFState* pPrinterInfo	= ( T_NpsPrinterIFState* ) vPrinterIFState[j];
		delete pPrinterInfo;
	}

	vPrinterIFState.clear();

	return ret;
}
#endif

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1804()
//	ABSTRACT : G[ʒm No.1804
//	FUNCTION : v^[̃o[WĂ܂
//			   o[WmFĂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1804( BOOL bAutoVerUp )
{
	if ( TRUE == bAutoVerUp )
	{
		//------------------------------------------------------------
		// eAv̋N
		//------------------------------------------------------------
		BOOL bResult;
		T_Nps6000H_F502H stNps6000F502;

		::ZeroMemory( &stNps6000F502, sizeof(T_Nps6000H_F502H) );

		stNps6000F502.FunctionCode	= 99;	// 99:o[WAbv

		bResult = m_pSdk->CallbackFunction( &stNps6000F502 );

		if ( TRUE == bResult )
		{
			// eAṽo[WAbvʂĂяô
			// m点\ɏI
			return;
		}
	}

	//------------------------------------------------------------
	// m点 No.1804
	//------------------------------------------------------------
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1804;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFFB;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CPrinterWatchThread::ErrorNoticeON_1805()
//	ABSTRACT : G[ʒm No.1805
//	FUNCTION : v^[ُł
//			   ȏC\tgNĂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.12.01
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CPrinterWatchThread::ErrorNoticeON_1805()
{
	SYSTEMTIME tLocalTime;
	T_Nps6000H_F202H tNps6000H_F202H;

	::ZeroMemory( &tNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	::GetLocalTime( &tLocalTime );

	tNps6000H_F202H.EventCode		= 1805;						// CxgR[h iԁj
	tNps6000H_F202H.EventStatus		= 0;						// Cxg̔Ei 0:Cxg, 1:Cxg j
	tNps6000H_F202H.OccurredTime[0]	= tLocalTime.wYear;			//  z[0] N
	tNps6000H_F202H.OccurredTime[1]	= tLocalTime.wMonth;		//  z[1] 
	tNps6000H_F202H.OccurredTime[2]	= tLocalTime.wDay;			//  z[2] 
	tNps6000H_F202H.OccurredTime[3]	= tLocalTime.wHour;			//  z[3] 
	tNps6000H_F202H.OccurredTime[4]	= tLocalTime.wMinute;		//  z[4] 
	tNps6000H_F202H.OccurredTime[5]	= tLocalTime.wSecond;		//  z[5] b
	tNps6000H_F202H.OccurredTime[6]	= tLocalTime.wMilliseconds;	//  z[6] ~b
	tNps6000H_F202H.OccurredTime[7]	= tLocalTime.wDayOfWeek;	//  z[7] j
	tNps6000H_F202H.EventParam[0]	= 1;						// Cxg̃p[^ ilj
	tNps6000H_F202H.EventParam[1]	= 0;
	tNps6000H_F202H.EventParam[2]	= 0;
	tNps6000H_F202H.EventParam[3]	= 0;
	tNps6000H_F202H.EventId			= 0xFFFFFFFA;				// CxgʎqiŒlj

	m_pSdk->CallbackEvent( &tNps6000H_F202H );
}

////////////////////////////////////////////////////////////////////
//	MODULE	 :	CPrinterWatchThread::ExecVerupChecker
//
//	ABSTRACT :	o[WAbv`FbNc[̎s
//	FUNCTION :	o[WAbv`FbNc[sďIR[hԂ܂
//
//	NOTE	 :	
//
//	RETURN	 :	o[WAbv`FbNc[̏IR[h
//
//	CREATE	 :	Y.Atoji		2011.06.14
//	UPDATE	 :	
////////////////////////////////////////////////////////////////////
int	CPrinterWatchThread::ExecVerupChecker( LPCTSTR lpCheckerPath, LPCTSTR lpHostAddress )
{
	DWORD				dwExitCode;
	TCHAR				szCmdLine[MAX_PATH];
	STARTUPINFO			StartupInfo;
	PROCESS_INFORMATION	ProcessInfo;

	// ϐ̏
	_stprintf( szCmdLine, _T("%s /IP=\"%s\""), lpCheckerPath, lpHostAddress );
	::ZeroMemory( &StartupInfo, sizeof(StartupInfo) );
	StartupInfo.cb = sizeof(STARTUPINFO);
	StartupInfo.dwFlags = STARTF_USESHOWWINDOW;
	StartupInfo.wShowWindow = SW_HIDE;
	::ZeroMemory( &ProcessInfo, sizeof(ProcessInfo) );

	// o[WAbv`FbNc[̎s
	if( FALSE == ::CreateProcess(
					NULL,			// s\W[̖O(2Ԗڂ̈őp)
					szCmdLine,		// R}hC̕
					NULL,			// ZLeBLqq
					NULL,			// ZLeBLqq
					FALSE,			// nȟpIvV
					0,				// 쐬̃tO
					NULL,			// VubN
					NULL,			// JgfBNg̖O
					&StartupInfo,	// X^[gAbv
					&ProcessInfo))	// vZX
	{
		DWORD dwError = ::GetLastError();
		return EXITCODE_UNDEFINED;
	}

	// o[WAbv`FbNc[I܂őҋ@
	::WaitForSingleObject( ProcessInfo.hProcess, INFINITE );

	// o[WAbv`FbNc[IR[h̎擾
	::GetExitCodeProcess( ProcessInfo.hProcess, &dwExitCode );

	::CloseHandle( ProcessInfo.hThread );
	::CloseHandle( ProcessInfo.hProcess );

	return (int)dwExitCode;
}