//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : PseudoIPAddr.h
//	ABSTRACT  : CPseudoIPAddr NX̃C^[tFCX
//	
//	CREATE    : H.Kamiya 2015.12.03
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#ifndef PSEUDO_IP_ADDR_H
#define PSEUDO_IP_ADDR_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#pragma warning(disable : 4200)

#define PSEUDO_IP_ADDR_RECORD_VERSION	1

// [IPAhXe[uR[h`
#pragma pack (1)

struct TPseudoIPAddrHeader
{
	USHORT	Version;
	UCHAR	Reserve[62];		// 62byte \
};

struct TPseudoIPAddrRecord
{
	USHORT	Flag;
	DWORD	PseudoIPAddress;
	DWORD	HostIPAddress;
	UCHAR	HostMacAddress[6];
	USHORT	NpsPortNo;
	USHORT	ImgPortNo;
	ULONG	PrinterIPAddress;
	UCHAR	PrinterMacAddress[6];
	UCHAR	Reserve[16];
};

struct TPseudoIPAddrView
{
	TPseudoIPAddrHeader Header;
	TPseudoIPAddrRecord Record[0];
};
#pragma pack ()

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CPseudoIPAddr
//	ABSTRACT : [IPAhXNX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	CREATE	 : H.Kamiya 2015.12.03
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CPseudoIPAddr
{
public:
	static	CPseudoIPAddr*	sInstance;

	static	CPseudoIPAddr*	Create();
	static	void			Close();
	static	CPseudoIPAddr*	GetInstance();

	DWORD					Add( DWORD HostIPAddr, UCHAR HostMacAddress[], USHORT NpsPortNo, USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[] );
//	DWORD					FindByMacAddr(UCHAR MacAddress[], USHORT NpsPortNo );
//	DWORD 					FindByPrinterIPAddr(UCHAR MacAddress[], USHORT NpsPortNo,  USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[] );
	DWORD					FindByHostIPAddr(  DWORD HostIPAddr, UCHAR HostMacAddress[], USHORT NpsPortNo, USHORT ImgPortNo, ULONG PrinterIPAddress, UCHAR PrinterMacAddress[] );

	TPseudoIPAddrRecord*	FindByIPAddr(DWORD PseudoIPAddress, TPseudoIPAddrRecord* pRecord);

private:
	explicit				CPseudoIPAddr();
	virtual					~CPseudoIPAddr();
//	DWORD					Generate();
	DWORD					PseudoIPGenerate( DWORD dwIPAddr, USHORT NpsPortNo );

	HANDLE					m_hMutex;
	HANDLE					m_hFile;
	DWORD					m_dwSize;
	HANDLE					m_hMapping;
	LPVOID					m_pView;
};
#endif // PSEUDO_IP_ADDR_H
