//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : SdkLayout.cpp
//	ABSTRACT  : CSdkLayout NX̃Cve[V
//	
//	CREATE    : T.Isogai	2009.11.25	EZ Controller 6x6C` tHgubNΉ
//	UPDATE    : 
//	
//	ySdkLayout֐ꗗz
//	                      :T|[g, :T|[g[J], ~:T|[g
//  ---------------------------------------------
//  ֐                  | NPS                
//  ---------------------------------------------
//  DevOpen                 |                  
//  DevClose                |                  
//  DevGetUnitInfo          | ~                 
//  DevGetMagInfo           | ~                 
//  DevGetSetUpInfo         | ~                 
//  DevGetPrintNumInfo      |                  
//  DevResetEvent           | ~                 
//  DevIsReady              | ~                 
//  DevStartOrder           |                  
//  DevEndOrder             |                  
//  DevPrint                |                  
//  DevSort                 |                  
//  DevCancelPrintOrde      |                  
//  DevGetPrintStatus       |                  
//  DevSetTime              | ~                 
//  DevGetTime              | ~                 
//  DevCloseCheck           |                  
//  DevGetAllMagInfo        |                  
//  DevCtrlPrint            | ~                 
//  DevExpressOrder         | ~                 
//  DevGetProfile           |                  
//  DevStartDuplex          |                  
//  DevEndDuplex            |                  
//  DevBlankPrint           |                  
//  DevNpsCommand1          | ~                 
//  DevNpsCommand2          | ~                 
//  DevNpsNotice            | ~                 
//	DevCancelPrintAll       | ~                 
//	DevGetTransmitTime      | ~                 
//	DevStartFAD				| ~                 
//	DevAdjustForPrint		| ~                 
//	DevStartRetransmission	| ~                 
//	DevEndRetransmission	| ~                 
//	DevInterruptPrintOrder	| ~                 
//	DevNpsNoticeEventProcEx	| ~                 
//  ---------------------------------------------
//  
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SdkLayout.h"
#include "NpsControl.h"
#include "nkcProfileModule.h"
#include "MakeCompositeImage.h"

#include <process.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CNpsControl*	g_pNpsControl;
extern CRITICAL_SECTION g_csSdk;	// _04382Ή Y.Yoshinobu 2007.04.24

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::IsUseCSdkLayout()
//	ABSTRACT : ̃NXgp邩`FbNiX^eBbN֐j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				TRUE	CSdkLayoutNXgp
//				FALSE	CSdkLayoutNXgpȂiCSdkNXgpj
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSdkLayout::IsUseCSdkLayout()
{
	BOOL bRet = FALSE;
	int idx;

	//---------------------------
	// W[pX擾
	//---------------------------
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];

	::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
	::_splitpath( szModuleFilePath, drive, dir, fname, ext );

	{	// Oo
		CString	str;
		str.Format( "---ModuleFileName( %s )", szModuleFilePath );
		NPS_LOGOUT( str );
	}

	//---------------------------
	// W[̃`FbN
	//---------------------------
	char CheckModuleName[][MAX_PATH] =
	{
		"POM.exe",
		"Controller.exe",
		"Controller.vshost.exe",
		"NpsTester.exe",	// eXgp
		"NpsClient.exe",	// eXgp
		"NpsClient80.exe",	// eXgp
	};

	CString strFileName;
	strFileName.Format("%s%s", fname, ext);

	for( idx = 0; idx < COUNTOF(CheckModuleName); idx++ )
	{
		if(0 == strFileName.CompareNoCase(CheckModuleName[idx]))
		{
			bRet = TRUE;
			break;
		}
	}

	if( FALSE == bRet )
	{
		return bRet;
	}

	//---------------------------
	// t@C݃`FbN
	//---------------------------
	char CheckFileName[][MAX_PATH] =
	{
		"IccsCall.dll",
	};

	for( idx = 0; idx < COUNTOF(CheckFileName); idx++ )
	{
		CString strFilePath;
		strFilePath.Format("%s%s%s", drive, dir, CheckFileName[idx]);
		WIN32_FIND_DATA FindData = {0};
		HANDLE hFindFile = FindFirstFile( strFilePath, &FindData );

		if (hFindFile == INVALID_HANDLE_VALUE)
		{
		}
		else
		{
			FindClose( hFindFile );
			bRet = FALSE;
			break;
		}
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::CallbackCompletionDummyPrintStatic()
//	ABSTRACT : vgCxgʒmivgjpR[obN֐ X^eBbN
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				dwCompletionCode	R[h
//				pCompletionInfo		Cxg
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CSdkLayout::CallbackCompletionPrintDummyStatic(
	DWORD		dwCompletionCode,	// R[h
	PVOID		pCompletionInfo		// Cxg
	)
{
	//----------------------------------
	// O
	//----------------------------------
	NPSPRINTINFO Info;
	memcpy( &Info, pCompletionInfo, sizeof(NPSPRINTINFO) );

	//----------------------------------
	// SDK擾ibNj
	//----------------------------------
	BOOL bRet = FALSE;
	REALPRINT RealPrint;

	{
		NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

		if ( FALSE == g_pNpsControl->IsLibOpen() )
		{
			return;
		}

		CSdkLayout* pSdk	= (CSdkLayout*)g_pNpsControl->GetSdk( Info.hPrinter );

		if( pSdk )
		{
			bRet = pSdk->CompletionPrintProc( Info, &RealPrint );
		}
	}

	if( FALSE == bRet )
	{
		return;
	}

	//----------------------------------
	// KvR[obNĂяo
	//----------------------------------
	for( int idx = 0; idx < KOMADATA_NUM; idx++ )
	{
		if( RealPrint.KomaData[idx].DuplexKomaNo == 0 )
		{
			continue;
		}

		if( NULL != RealPrint.KomaData[idx].pEventProc )
		{
			Info.dwPrintId = RealPrint.KomaData[idx].PrintID;
			RealPrint.KomaData[idx].pEventProc( dwCompletionCode, &Info );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::CompletionPrintProc()
//	ABSTRACT : vgCxgʒmivgj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				NpsPrintInfo	R[obNvg vg
//				pRealPrint		wvgɑΉvgivg\́j
//	
//	RETURN   : 
//				TRUE	R[obNԂׂvgvo
//				FALSE	R[obNԂׂvgvo
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSdkLayout::CompletionPrintProc( NPSPRINTINFO NpsPrintInfo, REALPRINT* pRealPrint )
{
	BOOL bRet = FALSE;

	for( std::vector<REALPRINT>::iterator itRealPrint = m_vRequestedFrame.begin(); m_vRequestedFrame.end() != itRealPrint; itRealPrint++ )
	{
		if( (*itRealPrint).PrintID == NpsPrintInfo.dwPrintId )
		{
			(*itRealPrint).STATE					|= RPS_CALLBACK_RECV;
			(*itRealPrint).dwStatus				|= NpsPrintInfo.dwStatus;
			*pRealPrint								= (*itRealPrint);
			bRet									= TRUE;

			if( (0 == NpsPrintInfo.dwFinishNum) || (RESULT_OK == NpsPrintInfo.dwStatus) )
			{
				// t@C̍폜
				::DeleteFile( (*itRealPrint).FilePath );

				// ێf[^̍폜
				m_vRequestedFrame.erase( itRealPrint );
			}

			break;
		}
	}

	WriteStatusLog();
	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::CallbackCompletionDummyOrderStatic()
//	ABSTRACT : vgCxgʒmiI[_[jpR[obN֐ X^eBbN
//	FUNCTION : vgCxgʒmiI[_[jpR[obN֐ X^eBbNiNG̒ʒm̂݃tbNj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				dwCompletionCode	R[h
//				pCompletionInfo		Cxg
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CALLBACK CSdkLayout::CallbackCompletionOrderDummyStatic(
	DWORD		dwCompletionCode,	// R[h
	PVOID		pCompletionInfo		// Cxg
	)
{
	//----------------------------------
	// O
	//----------------------------------
	NPSORDERINFO Info;
	memcpy( &Info, pCompletionInfo, sizeof(NPSORDERINFO) );

	//----------------------------------
	// SDK擾ibNj
	//----------------------------------
	BOOL bRet = FALSE;
	std::vector<KOMADATA>	vKOMADATA;

	{
		NkcComApi::CCSScopeLock CSScopeLock( &g_csSdk );	// _04382Ή Y.Yoshinobu 2007.04.24

		if ( FALSE == g_pNpsControl->IsLibOpen() )
		{
			return;
		}

		CSdkLayout* pSdk	= (CSdkLayout*)g_pNpsControl->GetSdk( Info.hPrinter );

		if( pSdk )
		{
			bRet = pSdk->CompletionOrderProc( Info, &vKOMADATA );
		}
	}

	if( FALSE == bRet )
	{
		return;
	}

	//----------------------------------
	// KvR[obNĂяo
	//----------------------------------
	NPSPRINTINFO	wPrintInfo = {0};

	wPrintInfo.hPrinter			= Info.hPrinter;		// Cxg̔v^̃nh	wPrintInfo.hPrinter			= GetPrinterHandle();		// Cxg̔v^̃nh
	wPrintInfo.dwIPAddress		= Info.dwIPAddress;		// Cxg̔v^IPAhX
	wPrintInfo.sysTime			= Info.sysTime;			// Cxg
	wPrintInfo.dwStatus			= RESULT_TRANSFER;		// 
	wPrintInfo.dwFinishNum		= 0;					// I

	for( std::vector<KOMADATA>::iterator itKOMADATA = vKOMADATA.begin(); vKOMADATA.end() != itKOMADATA; itKOMADATA++ )
	{
		if( NULL != (*itKOMADATA).pEventProc )
		{
			wPrintInfo.dwPrintId	= (*itKOMADATA).PrintID;
			(*itKOMADATA).pEventProc( COMPLETION_PRINT, &wPrintInfo );
		}
	}
	
	vKOMADATA.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::CompletionOrderProc()
//	ABSTRACT : vgCxgʒmiI[_[j
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				NpsOrderInfo	R[obNI[_[
//				pvKOMADATA		R[obNԂׂR}ivgvj̃Xg
//	
//	RETURN   : 
//				TRUE	R[obNԂׂvgvo
//				FALSE	R[obNԂׂvgvo
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSdkLayout::CompletionOrderProc( NPSORDERINFO NpsOrderInfo, std::vector<KOMADATA>* pvKOMADATA )
{
	BOOL bRet = FALSE;

	//-----------------------------
	// v҂Xg`FbN
	//-----------------------------
	for( std::vector<KOMADATA>::iterator itLayoutGroups = m_vNotRequestFrame.begin(); m_vNotRequestFrame.end() != itLayoutGroups; )
	{
		if( (*itLayoutGroups).dwOrderId == NpsOrderInfo.dwOrderId )
		{
			// ǉ
			pvKOMADATA->push_back((*itLayoutGroups));
			
			// ێf[^̍폜
			itLayoutGroups = m_vNotRequestFrame.erase( itLayoutGroups );

			// 
			bRet = TRUE;
		}
		else
		{
			itLayoutGroups++;
		}
	}

	//-----------------------------
	// vς݁isj`FbN
	//-----------------------------
	for( std::vector<REALPRINT>::iterator itRealPrint = m_vRequestedFrame.begin(); m_vRequestedFrame.end() != itRealPrint; )
	{
		if(
			( (*itRealPrint).dwOrderId == NpsOrderInfo.dwOrderId ) &&
			( (*itRealPrint).STATE & RPS_PRINT_REQ_ERR )
			)
		{
			for( int komaidx = 0; komaidx < KOMADATA_NUM; komaidx++ )
			{
				if( (*itRealPrint).KomaData[komaidx].DuplexKomaNo > 0 )
				{
					// ǉ
					pvKOMADATA->push_back((*itRealPrint).KomaData[komaidx]);

					// 
					bRet = TRUE;
				}
			}

			// t@C̍폜
			::DeleteFile( (*itRealPrint).FilePath );

			// ێf[^̍폜
			itRealPrint = m_vRequestedFrame.erase( itRealPrint );
		}
		else
		{
			itRealPrint++;
		}
	}

	WriteStatusLog();
	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::CSdkLayout()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CSdkLayout::CSdkLayout()
{
	Initialize();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CSdkLayout::~CSdkLayout()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CSdkLayout::~CSdkLayout()
{
	Initialize();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevOpen ()
//	ABSTRACT : v^I[v
//	FUNCTION : v^𗘗p\ɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevOpen (
	DWORD			dwIPAddress,	// v^IPAhX
	HPRINTER*		phPrinter,		// 擾nh̊i[
	NPSEVENTPROC	pEventProc,		// Cxgʒm֐
	NPSUNITPROC		pUnitProc		// jbgԕύXʒm֐
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevOpen()" );

	long	lResult	= NPSERR_NORMAL;

	Initialize();	
	lResult	= CSdk::DevOpen( dwIPAddress, NPS_TCP_SERVER_PORT, NPS_TCP_SERVER_IMAGESEND_PORT, phPrinter, pEventProc, pUnitProc );
	m_PrintQue.m_pCallbackCompletionOrderNG	= CallbackCompletionOrderDummyStatic;

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevClose ()
//	ABSTRACT : v^N[Y
//	FUNCTION : v^𗘗p֎~ɂ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevClose (
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevClose()" );

	Initialize();

	return CSdk::DevClose();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevGetPrintNumInfo ()
//	ABSTRACT : vg擾
//	FUNCTION : vg̖擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_PRNERR		v^G[B
//				NPSERR_SYSERR		\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void MINUSANDPLUS( DWORD* pData, int nMinus, int nPlus )
{
	if( (int)*pData >= nMinus )
	{
		*pData -= nMinus;
		*pData += nPlus;
	}
}

long CSdkLayout::DevGetPrintNumInfo (
	PNPS_PrintNumInfo	pPrintNumInfo	// vg\̂ւ̃AhX
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevGetPrintNumInfo()" );

	//--------------------------------------
	// CSdk̏擾
	//--------------------------------------
	long	lResult	= NPSERR_NORMAL;
	lResult	= CSdk::DevGetPrintNumInfo( pPrintNumInfo );

	if( lResult != NPSERR_NORMAL )
	{
		return lResult;
	}

	// pPrintNumInfo->dwSdkReserver // Cuł̖vg
	// pPrintNumInfo->dwReserver // v^҂
	// pPrintNumInfo->dwPrtNumber // v^
	// pPrintNumInfo->dwProNumber // vZT[
	// pPrintNumInfo->dwTotalCount // CȗSĂ̑

	//--------------------------------------
	// vOXgmF
	//--------------------------------------
	for( std::vector<KOMADATA>::iterator itLayoutGroups = m_vNotRequestFrame.begin(); m_vNotRequestFrame.end() != itLayoutGroups; itLayoutGroups++ )
	{
		int	nPrintNum = 0;

		if( (*itLayoutGroups).bBlankPrint )
		{
			nPrintNum = (*itLayoutGroups).BlankPrintInfo.dwPrintNum;
		}
		else
		{
			nPrintNum = (*itLayoutGroups).PrintInfo.dwPrintNum;
		}

		pPrintNumInfo->dwSdkReserver	+= nPrintNum;
		pPrintNumInfo->dwTotalCount		+= nPrintNum;
	}

	//--------------------------------------
	// vXgmF
	//--------------------------------------
	for( std::vector<REALPRINT>::iterator itRealPrint = m_vRequestedFrame.begin(); m_vRequestedFrame.end() != itRealPrint; itRealPrint++ )
	{
		// ۂ̃R}Zo
		int nPrintNum1 = 0;
		int nPrintNum2 = 0;

		nPrintNum1 = (*itRealPrint).PrintInfo.dwPrintNum;

		for( int komaidx = 0; komaidx < KOMADATA_NUM; komaidx++ )
		{
			if( (*itRealPrint).KomaData[komaidx].DuplexKomaNo > 0 )
			{
				nPrintNum2	+= nPrintNum1;
			}
		}

		//--------------------------------------
		// R[obNMς
		//--------------------------------------
		if( (*itRealPrint).STATE & RPS_CALLBACK_RECV )
		{
			if( (*itRealPrint).dwStatus & RESULT_PRINT )
			{
				// vZT[
				MINUSANDPLUS( &(pPrintNumInfo->dwProNumber), nPrintNum1, nPrintNum2 );
			}
			else if( (*itRealPrint).dwStatus & RESULT_TRANSFER )
			{
				// v^҂
				MINUSANDPLUS( &(pPrintNumInfo->dwReserver), nPrintNum1, nPrintNum2 );
			}
			else
			{
				// 肦Ȃ
			}
		}
		//--------------------------------------
		// R[obNM
		//--------------------------------------
		else
		{
			// Cuł̖vg
			MINUSANDPLUS( &(pPrintNumInfo->dwSdkReserver), nPrintNum1, nPrintNum2 );

			// CȗSĂ̑
			MINUSANDPLUS( &(pPrintNumInfo->dwTotalCount), nPrintNum1, nPrintNum2 );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevStartOrder ()
//	ABSTRACT : I[_[Jn
//	FUNCTION : I[_[Jnw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_REJECT3		tłȂԁBI[_[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//	UPDATE   : Y.Yoshinobu	2008.11.12	OEM`FbN̕sC
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevStartOrder (
	DWORD*				pdwOrderId,	// 擾I[_[IDi[
	NPSCOMPLETIONPROC	pEventProc,	// ʒmpR[obN֐ւ̃AhX
	DWORD				dwPriority,	// Dxw
	DWORD				dwSorterNum,// vg̎d
	DWORD				dwSortFrame,// R}̃\[g@\
	DWORD				dwExOptions	// gIvV(Pvg) 2014.10.28 M.Yamamoto
									// EX_OPTIONS_NONE        : gIvVȂ
									// EX_OPTIONS_SINGLE_LINE : Pvg
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevStartOrder()" );

	return CSdk::DevStartOrder( pdwOrderId, pEventProc, dwPriority, dwSorterNum, dwSortFrame, dwExOptions );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevEndOrder ()
//	ABSTRACT : I[_[I
//	FUNCTION : I[_[Iw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂB
//				NPSERR_SYSERR		\[XsȂǂɂsłȂB
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevEndOrder (
	DWORD		dwOrderId	// II[_[IDw肷
)
{
	CString strLog;
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevEndOrder()" );

	ExecDuplexPrint();

	return CSdk::DevEndOrder( dwOrderId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevPrint ()
//	ABSTRACT : vgv
//	FUNCTION : vgv󂯕t
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : T.Isogai	2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : Y.Atoji	2014.02.24 6x6C`tHgubNΉ@QSS-GREEN-IIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevPrint (
	DWORD				dwOrderId,	// vgI[_[IDw肷
	LPDWORD				pPrintID,	// vgʎq
	NPSCOMPLETIONPROC	pEventProc,	// CxgʒmpR[obN֐ւ
									// AhX
	PNPS_PrintInfo		pPrintInfo,	// vgvp[^
	T_ICCSXML*			pIccsXml	// IccsXml
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevPrint()" );

	//------------------------------------
	// ʏ`FbN
	//------------------------------------
	BOOL bNormal = TRUE;

	if( IsD1005() || IsGreen2() )
	{
		if(
			( INFO_SHEET == pPrintInfo->dwFeed ) &&
			( 0 == strncmp( DUMMY_NAME_STRING, pPrintInfo->szPaperName, strlen( DUMMY_NAME_STRING ) ) )
			)
		{
			bNormal = FALSE;
		}
	}

	if( bNormal )
	{
		ExecDuplexPrint();
		return CSdk::DevPrint( dwOrderId, pPrintID, pEventProc, pPrintInfo, pIccsXml );
	}


	//-----------------------------
	// L`FbN
	//-----------------------------

	// rbg}bv
	if( IMGFMT_BMP != pPrintInfo->dwImageFormat )
	{
		NPS_LOGOUT_WARN( "--BADPARAM dwImageFormat is not IMGFMT_BMP" );
		return NPSERR_BADPARAM;
	}

	// ʈ[hɂȂĂ邩mF
	BOOL	bDuplexMode;

	if ( FALSE == m_PrintQue.IsDuplexMode( dwOrderId, &bDuplexMode, NULL, NULL ) )
	{
		CString strLog;
		strLog.Format( "--BADPARAM not exist dwOrderId ( %d )", dwOrderId );
		NPS_LOGOUT_WARN( strLog );
		return NPSERR_BADPARAM;
	}

	if ( FALSE == bDuplexMode )
	{
		NPS_LOGOUT_WARN( "--BADPARAM NOT DUPLEX MODE" );
		return NPSERR_BADPARAM;
	}

	//-----------------------------
	// y[p[`FbN
	//-----------------------------
	if ( 0 == m_DuplexKomaCount )
	{
		m_DuplexPaperInfo.dwPaperWidth		= pPrintInfo->dwPaperWidth;
		m_DuplexPaperInfo.dwSurface			= pPrintInfo->dwSurface;
		m_DuplexPaperInfo.dwPaperLength		= pPrintInfo->dwPaperLength;
		m_DuplexPaperInfo.dwFeed			= pPrintInfo->dwFeed;
		strncpy( m_DuplexPaperInfo.szPaperName, pPrintInfo->szPaperName, 32 );
		m_DuplexPaperInfo.dwPrintNum		= pPrintInfo->dwPrintNum;
		m_DuplexPaperInfo.dwResolution		= pPrintInfo->dwResolution;
		m_DuplexPaperInfo.dwPaperPresence	= pPrintInfo->dwPaperPresence;
		m_DuplexPaperInfo.wPrintQuality		= pPrintInfo->wPrintQuality;
	}
	else
	{
		if ( NPSERR_NORMAL != ParamChkOfDevPrintDuplex( pPrintInfo, &m_DuplexPaperInfo ) )
		{
			return NPSERR_BADPARAM;
		}
	}

	//-----------------------------
	// _~[ݒ
	//-----------------------------
	*pPrintID = m_PrintQue.GetLatestPrintIdInc();

	//-----------------------------
	// L[ɒǉ
	//-----------------------------
	KOMADATA KomaData;

	KomaData.DuplexKomaNo			= (++m_DuplexKomaCount);
	KomaData.bBlankPrint			= FALSE;
	KomaData.dwOrderId				= dwOrderId;
	KomaData.PrintID				= *pPrintID;
	KomaData.PrintInfo				= *pPrintInfo;
	strcpy( KomaData.FilePath, pPrintInfo->pName );
	KomaData.pEventProc				= pEventProc;
	KomaData.pIccsXml				= pIccsXml;

	m_vNotRequestFrame.push_back( KomaData );

	//-----------------------------
	// ʃvg
	//-----------------------------
	CheckForExecDuplexPrint();

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevSort ()
//	ABSTRACT : \[gv
//	FUNCTION : \[gw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevSort (
	DWORD		dwOrderId	// 擾I[_[IDw肷
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevSort()" );

	ExecDuplexPrint();

	return CSdk::DevSort( dwOrderId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevCancelPrintOrder ()
//	ABSTRACT : vgI[_[LZ
//	FUNCTION : 󂯕tĂvg1I[_[LZ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevCancelPrintOrder (
	DWORD		dwOrderId,	// LZI[_[IDw肷
	DWORD		dwPrintID	// vgʎq
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevCancelPrintOrder()" );

	//-----------------------------
	// ێf[^̍폜
	//-----------------------------
	for( std::vector<KOMADATA>::iterator itLayoutGroups = m_vNotRequestFrame.begin(); m_vNotRequestFrame.end() != itLayoutGroups; )
	{
		if( (*itLayoutGroups).dwOrderId == dwOrderId )
		{
			// LZiTRANSFERjʒm
			CallbackCancelTransfer( (*itLayoutGroups).pEventProc, (*itLayoutGroups).PrintID );

			// ێf[^̍폜
			itLayoutGroups = m_vNotRequestFrame.erase( itLayoutGroups );
		}
		else
		{
			itLayoutGroups++;
		}
	}

	return CSdk::DevCancelPrintOrder( dwOrderId, dwPrintID );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevGetPrintStatus ()
//	ABSTRACT : vgԎ擾
//	FUNCTION : vgԂ擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevGetPrintStatus (
	DWORD		dwPrintID,		// vgʎq
	LPDWORD		pPrintStatus	// vg
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevGetPrintStatus()" );

	//--------------------------------------
	// vOXgmF
	//--------------------------------------
	BOOL bFind = FALSE;
	
	for( std::vector<KOMADATA>::iterator itLayoutGroups = m_vNotRequestFrame.begin(); m_vNotRequestFrame.end() != itLayoutGroups; itLayoutGroups++ )
	{
		if( (*itLayoutGroups).PrintID == dwPrintID )
		{
			bFind = TRUE;
			break;
		}
	}

	if( bFind )
	{
		*pPrintStatus = REQSTS_WAIT;
		return NPSERR_NORMAL;
	}

	//--------------------------------------
	// vXgmF
	//--------------------------------------
	BOOL bBreak = FALSE;

	for( std::vector<REALPRINT>::iterator itRealPrint = m_vRequestedFrame.begin(); m_vRequestedFrame.end() != itRealPrint; itRealPrint++ )
	{
		for(int idxkoma = 0; idxkoma < KOMADATA_NUM; idxkoma++ )
		{
			if( (*itRealPrint).KomaData[idxkoma].PrintID == dwPrintID )
			{
				dwPrintID = (*itRealPrint).PrintID;
				bBreak = TRUE;
			}

			if( bBreak ) break;
		}

		if( bBreak ) break;
	}

	return CSdk::DevGetPrintStatus( dwPrintID, pPrintStatus );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevCloseCheck ()
//	ABSTRACT : v^N[Y`FbN
//	FUNCTION : v^̎gp֎~(npsDevClose)\ł邩`FbN
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[(/vg/e)
//				NPSERR_SYSERR		\[XsȂǂɂsłȂBSDKI[vĂȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevCloseCheck (
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevCloseCheck()" );

	if( m_vNotRequestFrame.size() > 0 )
	{
		return NPSERR_PRNERR;
	}

	return CSdk::DevCloseCheck();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevGetRegMagInfo ()
//	ABSTRACT : S}KW擾
//	FUNCTION : v^ɓo^ĂŎgpłSẴ}KW̏擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_PRNERR		v^G[
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : T.Isogai	2009.12.04
//	UPDATE   : Y.Atoji	2014.02.24 6x6C`tHgubNΉ@QSS-GREEN-IIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevGetAllMagInfo (
		PNPS_MagDetailInfo	pMagDetailInfo,	// }KWڍ׏󂯎obt@
		DWORD*				pdwSize			// obt@̃TCY
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevGetRegMagInfo()" );

	//------------------------------------
	// @`FbN
	//------------------------------------
	if( ( FALSE == IsD1005() ) && ( FALSE == IsGreen2() ) )
	{
		return CSdk::DevGetAllMagInfo( pMagDetailInfo, pdwSize );
	}

	//------------------------------------
	// `FbN
	//------------------------------------
	if( NULL == pdwSize )
	{
		return NPSERR_SYSERR;
	}

	//------------------------------------
	// 擾
	//------------------------------------
	// TCY擾
	DWORD dwSize;
	dwSize = 0;
	m_DataManager.GetAllMagInfo( NULL, &dwSize );

	// 擾
	int nMagDetailInfoCount = dwSize / sizeof(NPS_MagDetailInfo);
	NPS_MagDetailInfo* pMagDetailInfo2 = new NPS_MagDetailInfo[nMagDetailInfoCount];
	m_DataManager.GetAllMagInfo( pMagDetailInfo2, &dwSize );

	//------------------------------------
	// 6x6in.ǉȂ烊Xg쐬
	//------------------------------------
	CList<NPS_MagDetailInfo, NPS_MagDetailInfo> listNPS_MagDetailInfo;

	for( int idx = 0; idx < nMagDetailInfoCount; idx++ )
	{
		//------------------------------------
		// ǉ A
		//------------------------------------
		listNPS_MagDetailInfo.AddTail(pMagDetailInfo2[idx]);

		//------------------------------------
		// ǉ _~[
		//------------------------------------
		if(
			( INFO_SHEET == pMagDetailInfo2[idx].dwFeed ) &&
			( 0 == strncmp( REAL_NAME_STRING, pMagDetailInfo2[idx].szPaperName, strlen( REAL_NAME_STRING ) ) )
			)
		{
			NPS_MagDetailInfo MagDetailInfoDummy = pMagDetailInfo2[idx];

			// Width
			MagDetailInfoDummy.dwWidth = DUMMY_WIDTH;

			// LengthMinMax
			MagDetailInfoDummy.dwLengthMin = DUMMY_LENGTH;
			MagDetailInfoDummy.dwLengthMax = DUMMY_LENGTH;

			// PaperName
			ReplaceTopOfString( MagDetailInfoDummy.szPaperName,  REAL_NAME_STRING, DUMMY_NAME_STRING );

			// ǉ
			listNPS_MagDetailInfo.AddTail(MagDetailInfoDummy);
		}
	}

	delete [] pMagDetailInfo2;

	//------------------------------------
	// TCŶݕԂ
	//------------------------------------
	if( NULL == pMagDetailInfo )
	{	// TCŶݕԂ
		*pdwSize	= (DWORD)sizeof( NPS_MagDetailInfo ) * (DWORD)listNPS_MagDetailInfo.GetCount();
		return NPSERR_NORMAL;
	}

	//------------------------------------
	// TCY`FbN
	//------------------------------------
	if( *pdwSize < sizeof( NPS_MagDetailInfo ) * listNPS_MagDetailInfo.GetCount() )
	{	// obt@̃TCYȂ
		*pdwSize	= (DWORD)sizeof( NPS_MagDetailInfo ) * (DWORD)listNPS_MagDetailInfo.GetCount();
		return NPSERR_BADPARAM;
	}

	//------------------------------------
	// ݒ
	//------------------------------------
	POSITION pos = listNPS_MagDetailInfo.GetHeadPosition();
	int nCnt = 0;

	while(pos)
	{
		pMagDetailInfo[nCnt++] = listNPS_MagDetailInfo.GetNext(pos);
	}

	*pdwSize = (DWORD)sizeof( NPS_MagDetailInfo ) * (DWORD)listNPS_MagDetailInfo.GetCount();

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevGetProfile ()
//	ABSTRACT : v^vt@C擾
//	FUNCTION : y[p[Ƀvt@C擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2006.11.9
//	UPDATE   : Y.Atoji	2014.02.24 6x6C`tHgubNΉ@QSS-GREEN-IIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevGetProfile (
	LPCSTR			lpFileName,	// vt@Cf[^ot@Cw肷
	PNPS_PaperInfo	pPaperInfo	// vt@C擾y[p[̏w肷
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevGetProfile()" );

	NPS_PaperInfo PaperInfo = *pPaperInfo;

	//------------------------------------
	// `FbN
	//------------------------------------
	if( IsD1005() || IsGreen2() )
	{
		if(
			( INFO_SHEET == PaperInfo.dwFeed ) &&
			( 0 == strncmp( DUMMY_NAME_STRING, PaperInfo.szPaperName, strlen( DUMMY_NAME_STRING ) ) )
			)
		{
			PaperInfo.dwWidth	= REAL_WIDTH;
			ReplaceTopOfString( PaperInfo.szPaperName, DUMMY_NAME_STRING, REAL_NAME_STRING );
		}
	}

	return CSdk::DevGetProfile( lpFileName, &PaperInfo );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevStartDuplex ()
//	ABSTRACT : ʈJn
//	FUNCTION : ʈ̊Jnw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2008.5.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevStartDuplex(
	DWORD			dwOrderId	// 擾I[_[IDw肷
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevStartDuplex()" );

	m_DuplexKomaCount = 0;

	return CSdk::DevStartDuplex( dwOrderId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevEndDuplex ()
//	ABSTRACT : ʈI
//	FUNCTION : ʈ̏Iw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2008.5.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevEndDuplex(
	DWORD			dwOrderId	// 擾I[_[IDw肷
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevEndDuplex()" );

	ExecDuplexPrint();

	return CSdk::DevEndDuplex( dwOrderId );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::DevBlankPrint ()
//	ABSTRACT : 󔒃y[W̃vgv
//	FUNCTION : 󔒃y[W̃vgw
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				NPSERR_NORMAL		I
//				NPSERR_BADPARAM	wp[^ł͎słȂ
//				NPSERR_SYSERR		\[XsȂǂɂsłȂ
//	
//	CREATE	 : Y.Yoshinobu 2008.5.16
//	UPDATE   : T.Isogai	2008.06.06 npsDevPrintIccsXml APIǉ
//	UPDATE   : Y.Atoji	2014.02.24 6x6C`tHgubNΉ@QSS-GREEN-IIǉ
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CSdkLayout::DevBlankPrint(
	DWORD			dwOrderId,				// vgI[_[IDw肷
	LPDWORD			pPrintID,				// vgʎq
	NPSCOMPLETIONPROC pEventProc,			// CxgʒmpR[obN֐ւ̃AhX
	PNPS_BlankPrintInfo	pBlankPrintInfo		// 󔒃vgvp[^
)
{
	NPS_LOGOUT_DEBUG( "   CSdkLayout::DevBlankPrint()" );

	//------------------------------------
	// ʏ`FbN
	//------------------------------------
	BOOL bNormal = TRUE;

	if( IsD1005() || IsGreen2() )
	{
		if(
			( INFO_SHEET == pBlankPrintInfo->dwFeed ) &&
			( 0 == strncmp( DUMMY_NAME_STRING, pBlankPrintInfo->szPaperName, strlen( DUMMY_NAME_STRING ) ) )
			)
		{
			bNormal = false;
		}
	}

	if( bNormal )
	{
		return CSdk::DevBlankPrint( dwOrderId, pPrintID, pEventProc, pBlankPrintInfo );
	}

	//-----------------------------
	// y[p[`FbN
	//-----------------------------
	if ( 0 == m_DuplexKomaCount )
	{
		m_DuplexPaperInfo.dwPaperWidth		= pBlankPrintInfo->dwPaperWidth;
		m_DuplexPaperInfo.dwSurface			= pBlankPrintInfo->dwSurface;
		m_DuplexPaperInfo.dwPaperLength		= pBlankPrintInfo->dwPaperLength;
		m_DuplexPaperInfo.dwFeed			= pBlankPrintInfo->dwFeed;
		strncpy( m_DuplexPaperInfo.szPaperName, pBlankPrintInfo->szPaperName, 32 );
		m_DuplexPaperInfo.dwPrintNum		= pBlankPrintInfo->dwPrintNum;
		m_DuplexPaperInfo.dwResolution		= pBlankPrintInfo->dwResolution;
		m_DuplexPaperInfo.dwPaperPresence	= pBlankPrintInfo->dwPaperPresence;
		m_DuplexPaperInfo.wPrintQuality		= pBlankPrintInfo->wPrintQuality;
	}
	else
	{
		if ( NPSERR_NORMAL != ParamChkOfDevBlankPrintDuplex( pBlankPrintInfo, &m_DuplexPaperInfo ) )
		{
			return NPSERR_BADPARAM;
		}
	}

	//-----------------------------
	// _~[ݒ
	//-----------------------------
	*pPrintID = m_PrintQue.GetLatestPrintIdInc();

	//-----------------------------
	// L[ɒǉ
	//-----------------------------
	KOMADATA KomaData;

	KomaData.DuplexKomaNo = (++m_DuplexKomaCount);
	KomaData.bBlankPrint			= TRUE;
	KomaData.dwOrderId				= dwOrderId;
	KomaData.PrintID				= *pPrintID;
	KomaData.BlankPrintInfo			= *pBlankPrintInfo;
	KomaData.pEventProc				= pEventProc;

	m_vNotRequestFrame.push_back( KomaData );

	//-----------------------------
	// ʃvg
	//-----------------------------
	CheckForExecDuplexPrint();

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
// CAEgpi֐
//////////////////////////////////////////////////////////////////////////////

// 擪u
void CSdkLayout::ReplaceTopOfString( char* str, char* strA, char* strB )
{
	char strTmp[MAX_PATH];
	strcpy( strTmp, strB );
	strcat( strTmp, &(str[strlen( strA )]) );
	strcpy( str, strTmp );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::WriteStateLog ()
//	ABSTRACT : ԃOo
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::WriteStatusLog()
{
	//----------------------------------------
	// ԂƂ̃R}JEg
	//----------------------------------------
	// RESULT_OK				(0)			// Order was fulfilled successfully
	// RESULT_TRANSFER			(4)			// Transfer completed 
	// RESULT_PRINT				(11)		// Print completed 
	// RESULT_OK_REPEAT			(20)		// Order was fulfilled successfully (Repeat)
	// RESULT_PRINT_REPEAT		(21)		// Print completed (Repeat)

	int nDEVPRINT	= 0;
	int nTRANSFER	= 0;
	int nPRINT		= 0;

	for( std::vector<REALPRINT>::iterator itRealPrint = m_vRequestedFrame.begin(); m_vRequestedFrame.end() != itRealPrint; itRealPrint++ )
	{
		// ۂ̃R}Zo
		int KomaNum = 0;

		for( int komaidx = 0; komaidx < KOMADATA_NUM; komaidx++ )
		{
			if( (*itRealPrint).KomaData[komaidx].DuplexKomaNo > 0 )
			{
				KomaNum++;
			}
		}

		//--------------------------------------
		// R[obNMς
		//--------------------------------------
		if( (*itRealPrint).STATE & RPS_CALLBACK_RECV )
		{
			if( (*itRealPrint).dwStatus & RESULT_PRINT )
			{
				nPRINT		+= KomaNum;
			}
			else if( (*itRealPrint).dwStatus & RESULT_TRANSFER )
			{
				nTRANSFER	+= KomaNum;
			}
			else
			{
				// 肦Ȃ
			}
		}
		//--------------------------------------
		// R[obNM
		//--------------------------------------
		else
		{
			nDEVPRINT	+= KomaNum;
		}
	}

	//----------------------------------------
	// Oɏo
	//----------------------------------------
	CString strLog;
	strLog.Format( "---CSdkLayout STATUS--- m_vNotRequestFrame(%d) m_vRequestedFrame(%d) Koma[ 8WT(%d) / REQ(%d) / PRT(%d) / PRO(%d) ]",
					m_vNotRequestFrame.size(), m_vRequestedFrame.size(),
					m_vNotRequestFrame.size(), nDEVPRINT, nTRANSFER, nPRINT
					);
	NPS_LOGOUT( strLog );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::Initialize ()
//	ABSTRACT : CAEgo[ϐ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::Initialize()
{
	m_vNotRequestFrame.clear();	// LayoutvL[
	m_vRequestedFrame.clear();		// vgXg
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::IsD1005 ()
//	ABSTRACT : @햼"D1005"ǂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				TRUE	@햼"D1005"
//				FALSE	@햼"D1005"łȂ
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSdkLayout::IsD1005()
{
	BOOL bRet = FALSE;

	NPS_SetUpInfo SetUpInfo;
	m_DataManager.GetSetUpInfo( &SetUpInfo );

	if( 0 == strcmp( SetUpInfo.szMachineTypeName, MACHINE_TYPE_NAME_D1005 ) )
	{
		bRet = TRUE;
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::IsGreen2 ()
//	ABSTRACT : @햼"QSS-GREEN-II"ǂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				TRUE	@햼"QSS-GREEN-II"
//				FALSE	@햼"QSS-GREEN-II"łȂ
//	
//	CREATE	 : Y.Atoji	2014.02.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSdkLayout::IsGreen2()
{
	BOOL bRet = FALSE;

	NPS_SetUpInfo SetUpInfo;
	m_DataManager.GetSetUpInfo( &SetUpInfo );

	if( 0 == strcmp( SetUpInfo.szMachineTypeName, MACHINE_TYPE_NAME_GREEN2 ) )
	{
		bRet = TRUE;
	}

	return bRet;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : DMMP ()
//	ABSTRACT : 0.1mmPʂ̃TCYsNZPʂ̃TCYɕϊ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				i		0.1mmPʃTCY
//	
//	RETURN   : sNZPʂ̃TCYiZoʁj
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int DMMP(int i)
{
	return (int)((double)i * 360 / 254 + 0.5);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : LAYOUTIMG ()
//	ABSTRACT : 摜CAEgvZ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				No				ԍ
//				SIZE_W			o͉摜TCY 0.1mmP
//				SIZE_H			o͉摜TCY 0.1mmP
//				SIZE_IMGW		͉摜TCYi{ׂvZ̃TCYj 0.1mmP
//				SIZE_IMGH		͉摜TCYi{ׂvZ̃TCYj 0.1mmP
//				SIZE_CUTW		؂o 0.1mmP
//				SIZE_CUTH		؂o 0.1mmP
//				SIZE_INW		͉摜TCYiۂ͉̓摜̃TCYj 0.1mmP
//				SIZE_INH		͉摜TCYiۂ͉̓摜̃TCYj 0.1mmP
//				Trim1			vZ ؂oʒu sNZP
//				Trim2			vZ ؂oꂽ̂̔zuʒu sNZP
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void LAYOUTIMG(int No,							// ԍ
				int SIZE_W, int SIZE_H,			// o͉摜TCYA 0.1mmP
				int SIZE_IMGW, int SIZE_IMGH,	// ͉摜TCYAi{ׂvZ̃TCYj 0.1mmP
				int SIZE_CUTW, int SIZE_CUTH,	// ؂oA 0.1mmP
				int SIZE_INW, int SIZE_INH,		// ͉摜TCYAiۂ͉̓摜̃TCYj 0.1mmP
				RECT* Trim1, RECT* Trim2		// vZ ؂oʒuA؂oꂽ̂̔zuʒu sNZP
				)
{
	//-----------------------------------
	// SZo
	//-----------------------------------
	int SIZE_HALFW	= SIZE_W / 2;
	int SIZE_HALFH	= SIZE_H / 2;

	//-----------------------------------
	// 5`8ڂ̉̉摜0.5mړΉ 
	//-----------------------------------
	int SIZE_TUNE	= DMMP(5);

	//-----------------------------------
	// R}ʒuƂ̃TCYݒ
	//-----------------------------------
	int LayoutImg[KOMADATA_NUM][8] =
	{
		// 1
		{
			0, 0, SIZE_IMGW - SIZE_CUTW, SIZE_IMGH - SIZE_CUTH,
			0, 0, SIZE_IMGW - SIZE_CUTW, SIZE_IMGH - SIZE_CUTH
		},

		// 2
		{
			SIZE_CUTW, 0, SIZE_IMGW, SIZE_IMGH - SIZE_CUTH,
			SIZE_W - SIZE_IMGW + SIZE_CUTW, 0, SIZE_W, SIZE_IMGH - SIZE_CUTH
		},

		// 3
		{
			0, SIZE_CUTH + SIZE_TUNE, SIZE_IMGW - SIZE_CUTW, SIZE_IMGH,
			0, SIZE_H - SIZE_IMGH + SIZE_CUTH, SIZE_IMGW - SIZE_CUTW, SIZE_H - SIZE_TUNE
		},

		// 4
		{
			SIZE_CUTW, SIZE_CUTH + SIZE_TUNE, SIZE_IMGW, SIZE_IMGH,
			SIZE_W - SIZE_IMGW + SIZE_CUTW, SIZE_H - SIZE_IMGH + SIZE_CUTH, SIZE_W, SIZE_H - SIZE_TUNE
		},
	};

	//-----------------------------------
	// ؂oʒu
	//-----------------------------------
	Trim1->left		= LayoutImg[No][0];
	Trim1->top		= LayoutImg[No][1];
	Trim1->right	= LayoutImg[No][2];
	Trim1->bottom	= LayoutImg[No][3];

	//-----------------------------------
	// ؂ô̓\tʒu
	//-----------------------------------
	Trim2->left		= LayoutImg[No][4];
	Trim2->top		= LayoutImg[No][5];
	Trim2->right	= LayoutImg[No][6];
	Trim2->bottom	= LayoutImg[No][7];

	//----------------------------------
	// iZ^[Oj
	//----------------------------------
	int nDefW = (SIZE_INW - SIZE_IMGW) / 2;
	int nDefH = (SIZE_INH - SIZE_IMGH) / 2;

	Trim1->left += nDefW;
	Trim1->top += nDefH;

	if(Trim1->left < 0)
	{
		Trim2->left -= Trim1->left;
		Trim1->left = 0;
	}

	if(Trim1->top < 0)
	{
		Trim2->top -= Trim1->top;
		Trim1->top = 0;
	}

	//-----------------------------------
	// TCY̍Z
	//-----------------------------------

	// W
	if( (Trim1->left + Trim2->right - Trim2->left) >= SIZE_INW )
	{
		Trim2->right = SIZE_INW - Trim1->left + Trim2->left - 1;
	}

	// H
	if( (Trim1->top + Trim2->bottom - Trim2->top) >= SIZE_INH )
	{
		Trim2->bottom = SIZE_INH - Trim1->top + Trim2->top - 1;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::MakeImage ()
//	ABSTRACT : 摜
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				realprint		vg
//				ArrayKomaData	8R}zi\R}jĩR}̏\ɕ`悷邱Ƃ邽ߕKvj
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::MakeImage( REALPRINT* realprint, KOMADATA* ArrayKomaData )
{
	int idx;

	//------------------------------------------
	// 摜쐬
	//------------------------------------------
	COLORREF colorblack		= RGB(0, 0, 0);
	COLORREF colorred		= RGB(255, 0, 0);

	int SIZE_W = REAL_WIDTH_PIX;
	int SIZE_H = REAL_LENGTH_PIX;

	CMakeCompositeImage composite;
	composite.Initialize( SIZE_W, SIZE_H, realprint->FilePath );

	//------------------------------------------
	// `施
	//------------------------------------------
	int SIZE_HALFW	= SIZE_W / 2;
	int SIZE_HALFH	= SIZE_H / 2;
	int SIZE_DEF	= DMMP(15);		// ^񒆂̋
	int SIZE_IMG	= DMMP(1560);	// 摜iXsI[o[j

	//------------------------------------------
	// @͉摜
	//------------------------------------------
	for( idx = 0; idx < KOMADATA_NUM; idx++ )
	{
		if( (realprint->KomaData[idx].DuplexKomaNo == 0) || realprint->KomaData[idx].bBlankPrint )
		{
			continue;
		}

		int SIZE_CUTW	= 0;	// Jbg
		int SIZE_CUTH	= 0;	// cJbg

		if( realprint->bFront )
		{
			SIZE_CUTW	= DMMP(30);
			SIZE_CUTH	= DMMP(20);
		}
		else
		{
			SIZE_CUTW	= DMMP(30);
			SIZE_CUTH	= DMMP(15);
		}

		RECT Trim1, Trim2;

		LAYOUTIMG(idx,
					SIZE_W, SIZE_H,
					SIZE_IMG, SIZE_IMG,
					SIZE_CUTW, SIZE_CUTH,
					realprint->KomaData[idx].PrintInfo.dwImgWidth, realprint->KomaData[idx].PrintInfo.dwImgHeight,
					&Trim1, &Trim2);

		composite.DrawImage(Trim1, Trim2, realprint->KomaData[idx].FilePath);
	}

	//------------------------------------------
	// Aԍ
	//------------------------------------------

	// 1
	if(realprint->KomaData[0].DuplexKomaNo > 0)
	{
		composite.DrawNumber(SIZE_HALFW - SIZE_DEF, DMMP(320), realprint->KomaData[0].DuplexKomaNo / 2 + 1, colorblack, 0);	// XsI[o[2mmǉ
	}

	// 3
	if(realprint->KomaData[2].DuplexKomaNo > 0)
	{
		composite.DrawNumber(SIZE_HALFW - SIZE_DEF, SIZE_HALFH + DMMP(300), realprint->KomaData[2].DuplexKomaNo / 2 + 1, colorblack, 0);
	}

	if( realprint->bFront )
	{
		// 2
		if(ArrayKomaData[3-1].DuplexKomaNo > 0)
		{
			composite.DrawNumber(SIZE_HALFW + SIZE_DEF, DMMP(370), ArrayKomaData[3-1].DuplexKomaNo / 2 + 1, colorred, 180);	// XsI[o[2mmǉ
		}

		// 4
		if(ArrayKomaData[7-1].DuplexKomaNo > 0)
		{
			composite.DrawNumber(SIZE_HALFW + SIZE_DEF, SIZE_HALFH + DMMP(350), ArrayKomaData[7-1].DuplexKomaNo / 2 + 1, colorred, 180);
		}
	}

	//------------------------------------------
	// B}[N
	//------------------------------------------
	if( realprint->bFront )
	{
		// 1
		if(realprint->KomaData[0].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW - SIZE_DEF, DMMP(420), SIZE_HALFW, DMMP(470), colorblack );	// XsI[o[2mmǉ
		}

		// 3
		if(realprint->KomaData[2].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW - SIZE_DEF, SIZE_HALFH + DMMP(600), SIZE_HALFW, SIZE_HALFH + DMMP(650), colorblack );
		}

		// 2
		if(ArrayKomaData[3-1].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW, DMMP(520), SIZE_HALFW + SIZE_DEF, DMMP(570), colorred );	// XsI[o[2mmǉ
		}

		// 4
		if(ArrayKomaData[7-1].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW, SIZE_HALFH + DMMP(700), SIZE_HALFW + SIZE_DEF, SIZE_HALFH + DMMP(750), colorred );
		}
	}
	else
	{
		// 1
		if(realprint->KomaData[0].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW - SIZE_DEF, DMMP(520), SIZE_HALFW, DMMP(570), colorblack );	// XsI[o[2mmǉ
		}

		// 3
		if(realprint->KomaData[2].DuplexKomaNo > 0)
		{
			composite.DrawRect( SIZE_HALFW - SIZE_DEF, SIZE_HALFH + DMMP(700), SIZE_HALFW, SIZE_HALFH + DMMP(750), colorblack );
		}
	}

	//------------------------------------------
	// Cr
	//------------------------------------------
	if( realprint->bFront )
	{
		composite.DrawLine( SIZE_HALFW, 0, SIZE_HALFW, SIZE_H, RGB(0, 0, 0) );	// c
		composite.DrawLine( 0, SIZE_HALFH, SIZE_W, SIZE_HALFH, RGB(0, 0, 0) );	// 
	}

#if 0	// fobOp`施߃Oo
	NPS_LOGOUT( "DrawObj ------------------------------------------->" );
	for(std::vector<CDrawObj*>::iterator itpObj = composite.m_vDrawObj.begin(); composite.m_vDrawObj.end() != itpObj; itpObj++)
	{
		NPS_LOGOUT( (*itpObj)->GetInformation() );
	}
	NPS_LOGOUT( "DrawObj -------------------------------------------<" );
#endif

	//------------------------------------------
	// 摜쐬
	//------------------------------------------
	DWORD dwStartTime = GetTickCount();
	CMakeCompositeImage::ECODE ecode = composite.MakeCompositeImage();
	DWORD dwEndTime = GetTickCount();

	DWORD dwTransmitTime = ( dwStartTime <= dwEndTime ) ? ( dwEndTime - dwStartTime ): ( dwEndTime + (0xFFFFFFFF - dwStartTime) );
	{	// Oo
		CString	str;
		if( ecode == CMakeCompositeImage::SUCCESS )
		{
			str.Format( "---MakeCompositeImage TIME(%d [ms])", dwTransmitTime );
		}
		else
		{
			//------------------------------------------
			// wb_[݂̂̉摜t@C쐬
			//------------------------------------------
			composite.MakeDummyFileForError();

			str.Format( "---MakeCompositeImage Error(%d) : %s", ecode, composite.m_strLastError );
		}
		NPS_LOGOUT( str );
		TRACE("%s\n", str);
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::RequestFrame ()
//	ABSTRACT : vgv(CSdk::DevPrint())s
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				realprint		vg
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::RequestFrame( REALPRINT* realprint )
{
	//------------------------------------------
	// DevPrint
	//------------------------------------------
	realprint->STATE |= RPS_PRINT_REQ;

	long	lResult	= NPSERR_NORMAL;

	lResult = CSdk::DevPrint(
		realprint->dwOrderId,
		&(realprint->PrintID),
		CallbackCompletionPrintDummyStatic,
		&(realprint->PrintInfo),
		realprint->pIccsXml
		);

	if( NPSERR_NORMAL != lResult )
	{
		realprint->STATE |= RPS_PRINT_REQ_ERR;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::ExecDuplexPrint ()
//	ABSTRACT : \  siʂ̃vgv8R}Ƃɍsj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::ExecDuplexPrint()
{
	int idx;

	//------------------------------------------
	// 1Ȃ΂ȂɂȂ
	//------------------------------------------
	if( m_vNotRequestFrame.size() == 0 )
	{
		return;
	}

	//------------------------------------------
	// 8ɒBĂȂꍇ_~[Ŗ߂
	//------------------------------------------
	while( m_vNotRequestFrame.size() < 8 )
	{
		KOMADATA KomaData = {0};
		m_vNotRequestFrame.push_back( KomaData );
	}

	//------------------------------------------
	// zɐݒ
	//------------------------------------------
	KOMADATA ArrayKomaData[8];

	for( idx = 0; idx < 8; idx++ )
	{
		ArrayKomaData[idx] = m_vNotRequestFrame[idx];
	}

	//------------------------------------------
	// \ʁAʏ
	//------------------------------------------
	REALPRINT RealPrint;
	int iLayout;

	//------------------------------------------
	// ʐݒ
	//------------------------------------------

	// n߂Ɍvgvp[^gp
	KOMADATA SampleKomaData = {0};

	for( idx = 0; idx < 8; idx++ )
	{
		if( (ArrayKomaData[idx].DuplexKomaNo > 0) && (ArrayKomaData[idx].bBlankPrint == FALSE) )
		{
			SampleKomaData = ArrayKomaData[idx];
			break;
		}
	}

	RealPrint.dwOrderId					= SampleKomaData.dwOrderId;
	RealPrint.pIccsXml					= SampleKomaData.pIccsXml;
	RealPrint.PrintInfo					= SampleKomaData.PrintInfo;

	RealPrint.PrintInfo.dwPaperWidth	= REAL_WIDTH;
	RealPrint.PrintInfo.dwPaperLength	= REAL_LENGTH;

	strcpy( RealPrint.PrintInfo.szPaperName, REAL_NAME_STRING );
	strcat( RealPrint.PrintInfo.szPaperName, &(SampleKomaData.PrintInfo.szPaperName[strlen( DUMMY_NAME_STRING )]) );

	RealPrint.PrintInfo.dwDataLength	= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + NkcComApi::RowByte(REAL_WIDTH_PIX) * REAL_LENGTH_PIX;
	RealPrint.PrintInfo.dwImgWidth		= REAL_WIDTH_PIX;
	RealPrint.PrintInfo.dwImgHeight		= REAL_LENGTH_PIX;

	RealPrint.dwStatus					= 0;
	
	//------------------------------------------
	// t@C쐬
	//------------------------------------------
	char TmpFileName[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	::_splitpath( SampleKomaData.FilePath, drive, dir, fname, ext );
	sprintf(TmpFileName, "%s%s%s_%d_NPS_12x12", drive, dir, fname, SampleKomaData.PrintID);

	//------------------------------------------
	// \
	//------------------------------------------
	int LayoutFront[] = {1, 4, 5, 8};

	for( iLayout = 0; iLayout < 4; iLayout++ )
	{
		RealPrint.KomaData[iLayout]	= ArrayKomaData[LayoutFront[iLayout]-1];
	}

	RealPrint.STATE = RPS_INIT;
	RealPrint.bFront = TRUE;
	sprintf( RealPrint.FilePath, "%s_F.bmp", TmpFileName );
	RealPrint.PrintInfo.pName = RealPrint.FilePath;
	MakeImage( &RealPrint, ArrayKomaData );
	RequestFrame( &RealPrint );
	m_vRequestedFrame.push_back( RealPrint );

	//------------------------------------------
	// 
	//------------------------------------------
	int LayoutBack[] = {3, 2, 7, 6};

	for( iLayout = 0; iLayout < 4; iLayout++ )
	{
		RealPrint.KomaData[iLayout]	= ArrayKomaData[LayoutBack[iLayout]-1];
	}

	RealPrint.STATE = RPS_INIT;
	RealPrint.bFront = false;
	sprintf( RealPrint.FilePath, "%s_B.bmp", TmpFileName );
	RealPrint.PrintInfo.pName = RealPrint.FilePath;
	MakeImage( &RealPrint, ArrayKomaData );
	RequestFrame( &RealPrint );
	m_vRequestedFrame.push_back( RealPrint );

	//------------------------------------------
	// Еt
	//------------------------------------------
	m_vNotRequestFrame.clear();
	WriteStatusLog();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSdkLayout::CheckForExecDuplexPrint ()
//	ABSTRACT : CAEg`FbNi8R}jƎsi8R}sj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::CheckForExecDuplexPrint()
{
	//--------------------------------
	// `FbN
	//--------------------------------
	if( m_vNotRequestFrame.size() < 8 )
	{
		WriteStatusLog();
		return;
	}

	//--------------------------------
	// s
	//--------------------------------
	ExecDuplexPrint();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CallbackCancelTransfer()
//	ABSTRACT : R[obN TRANSFER LZo^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//
//	ARGUMENT :
//				pCompletionProc		R[obN֐|C^
//				dwPrintId			vgID
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2009.11.25
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSdkLayout::CallbackCancelTransfer( void* pCompletionProc, DWORD dwPrintId )
{
	// R[obN]
	SYSTEMTIME	localtime;
	GetLocalTime( &localtime );

	DWORD	dwCompletionCode	= COMPLETION_PRINT;

	NPSPRINTINFO	wPrintInfo;
	NPSORDERINFO	wOrderInfo;

	ZeroMemory( &wPrintInfo, sizeof( NPSPRINTINFO ) );
	ZeroMemory( &wOrderInfo, sizeof( NPSORDERINFO ) );

	wPrintInfo.hPrinter			= m_hPrinter;			// Cxg̔v^̃nh	wPrintInfo.hPrinter			= GetPrinterHandle();		// Cxg̔v^̃nh
	wPrintInfo.dwIPAddress		= m_dwIPAddress;		// Cxg̔v^IPAhX
	wPrintInfo.sysTime			= localtime;			// Cxg
	wPrintInfo.dwPrintId		= dwPrintId;			// vgʎq
	wPrintInfo.dwStatus			= RESULT_TRANSFER;		// 
	wPrintInfo.dwFinishNum		= 0;					// I

	if ( pCompletionProc )
	{
		if ( NULL != m_pCallbackCompletion )
		{
			m_pCallbackCompletion->AddNpsCALLBACKDATA( pCompletionProc, dwCompletionCode, wPrintInfo, wOrderInfo );
		}
	}
}
