// SendCmdBuffer.cpp: CSendCmdBuffer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SendCmdBuffer.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::CSendCmdBuffer()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CSendCmdBuffer::CSendCmdBuffer()
{
	m_nBufferLen = 0;
	m_nMaxBufferLen = 0;
	m_pBuffer = NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::~CSendCmdBuffer()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CSendCmdBuffer::~CSendCmdBuffer()
{
	Empty();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::Empty()
//	ABSTRACT : obt@쐬
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CSendCmdBuffer::Create( int nMaxBufferLen )
{
	Empty();

	BOOL bResult = TRUE;

	m_nMaxBufferLen = nMaxBufferLen;

	try
	{
		m_pBuffer = new BYTE[ m_nMaxBufferLen ];
	}
	catch( CMemoryException* e )
	{
		e->Delete();
		m_pBuffer = NULL;
		Empty();
		bResult = FALSE;
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::Empty()
//	ABSTRACT : obt@ɂ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CSendCmdBuffer::Empty()
{
	m_nBufferLen = 0;
	m_nMaxBufferLen = 0;
	if ( NULL != m_pBuffer )
	{
		delete [] m_pBuffer;
		m_pBuffer = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddHeader()
//	ABSTRACT : wb_[̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddHeader( WORD wInterfaceId, WORD wCommandId )
{
	USHORT nInterfaceId;
	USHORT nCommandId;

	nInterfaceId = NkcComApi::htons( wInterfaceId );
	nCommandId = NkcComApi::htons( wCommandId );

	memcpy( &m_pBuffer[m_nBufferLen], &nInterfaceId, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);
	memcpy( &m_pBuffer[m_nBufferLen], &nCommandId, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagChar()
//	ABSTRACT : CHAR^̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagChar( WORD wTag, char nValue )
{
	return AddTagChar( wTag, &nValue, 1 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagChar()
//	ABSTRACT : CHAR^̃^Oǉizj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagChar( WORD wTag, char* pValue, int nCount )
{
	USHORT nTag;
	USHORT nLength;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( (USHORT)sizeof(UCHAR) * nCount );

	// Tag
	memcpy( &m_pBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_pBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	memcpy( &m_pBuffer[m_nBufferLen], pValue, sizeof(UCHAR) * nCount );		m_nBufferLen += sizeof(UCHAR) * nCount;

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagShort()
//	ABSTRACT : SHORT^̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagShort( WORD wTag, short nValue )
{
	return AddTagShort( wTag, &nValue, 1 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagShort()
//	ABSTRACT : SHORT^̃^Oǉizj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagShort( WORD wTag, short* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	USHORT nValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( (USHORT)sizeof(USHORT) * nCount );

	// Tag
	memcpy( &m_pBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_pBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		nValue = NkcComApi::htons( *(pValue + nIdx) );
		memcpy( &m_pBuffer[m_nBufferLen], &nValue, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);
	}

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagLong()
//	ABSTRACT : LONG^̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagLong( WORD wTag, long nValue )
{
	return AddTagLong( wTag, &nValue, 1 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagLong()
//	ABSTRACT : LONG^̃^Oǉizj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagLong( WORD wTag, long* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	ULONG  nValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( (USHORT)sizeof(ULONG) * nCount );

	// Tag
	memcpy( &m_pBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_pBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		nValue = NkcComApi::htonl( *(pValue + nIdx) );
		memcpy( &m_pBuffer[m_nBufferLen], &nValue, sizeof(ULONG) );			m_nBufferLen += sizeof(ULONG);
	}

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagFloat()
//	ABSTRACT : FLOAT^̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagFloat( WORD wTag, float nValue )
{
	return AddTagFloat( wTag, &nValue, 1 );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagFloat()
//	ABSTRACT : FLOAT^̃^Oǉizj
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	CREATE	 : Y.Yoshinobu	2008.10.24	FLOAT^ϐɕύX
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagFloat( WORD wTag, float* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	FLOAT  fValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( (USHORT)sizeof(FLOAT) * nCount );

	// Tag
	memcpy( &m_pBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_pBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		fValue = (FLOAT)NkcComApi::htonf( *(pValue + nIdx) );
		memcpy( &m_pBuffer[m_nBufferLen], &fValue, sizeof(FLOAT) );			m_nBufferLen += sizeof(FLOAT);
	}

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::AddTagFooter()
//	ABSTRACT : tb^[̃^Oǉ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::AddTagFooter()
{
	USHORT nTag;
	USHORT nLength;

	nTag			= NkcComApi::htons( 0 );
	nLength			= NkcComApi::htons( 0 );

	// Tag
	memcpy( &m_pBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_pBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );	m_nBufferLen += sizeof(USHORT);

	return m_nBufferLen;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::GetBuffer()
//	ABSTRACT : obt@[̃̈̐擪擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
LPBYTE CSendCmdBuffer::GetBuffer()
{
	return m_pBuffer;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CSendCmdBuffer::GetBufferLen()
//	ABSTRACT : obt@[̃R}hf[^̃TCY擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.1.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int CSendCmdBuffer::GetBufferLen()
{
	return m_nBufferLen;
}
