// DevPrintExtendDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npsclient.h"
#include "DevPrintExtendDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDevPrintExtendDlg _CAO


CDevPrintExtendDlg::CDevPrintExtendDlg(CWnd* pParent /*=NULL*/)
	: CDevPrintDlg(CDevPrintExtendDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevPrintExtendDlg)
	m_strWithBorderColor = _T("");
	m_PaperName = _T("");
	m_WithBorderBottom = 0;
	m_WithBorderLeft = 0;
	m_WithBorderRight = 0;
	m_WithBorderTop = 0;
	m_PcFms = 0;
	//}}AFX_DATA_INIT
}


void CDevPrintExtendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevPrintExtendDlg)
	DDX_Control(pDX, IDC_COMBO_IMAGE_ENLARGE, m_ComboImageEnlarge);
	DDX_Control(pDX, IDC_COMBO_PRINT_QUALITY, m_ComboPrintQuality);
	DDX_Control(pDX, IDC_COMBO_COLOR_SPACE, m_ComboColorSpace);
	DDX_Control(pDX, IDC_COMBO_CVP_PRINT_SIZE, m_ComboCvpPrintSize);
	DDX_Control(pDX, IDC_COMBO_PAPER_FITTING, m_ComboPaperFitting);
	DDX_Control(pDX, IDC_COMBO_EDGE_ENHANCEMENT, m_ComboEdgeEnhancement);
	DDX_Control(pDX, IDC_COMBO_CMS, m_ComboCms);
	DDX_Control(pDX, IDC_COMBO_ANGLE, m_ComboAngle);
	DDX_Text(pDX, IDC_STATIC_COLOR, m_strWithBorderColor);
	DDV_MaxChars(pDX, m_strWithBorderColor, 100);
	DDX_Text(pDX, IDC_EDIT_PAPER_NAME, m_PaperName);
	DDX_Text(pDX, IDC_EDIT_WITH_BORDER_BOTTOM, m_WithBorderBottom);
	DDV_MinMaxUInt(pDX, m_WithBorderBottom, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_WITH_BORDER_LEFT, m_WithBorderLeft);
	DDV_MinMaxUInt(pDX, m_WithBorderLeft, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_WITH_BORDER_RIGHT, m_WithBorderRight);
	DDV_MinMaxUInt(pDX, m_WithBorderRight, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_WITH_BORDER_TOP, m_WithBorderTop);
	DDV_MinMaxUInt(pDX, m_WithBorderTop, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_PC_FMS, m_PcFms);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevPrintExtendDlg, CDialog)
	//{{AFX_MSG_MAP(CDevPrintExtendDlg)
	ON_BN_CLICKED(IDC_BUTTON_COLOR, OnButtonColor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevPrintExtendDlg bZ[W nh

void CDevPrintExtendDlg::OnButtonColor() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CColorDialog	wColorDlg;

	if( IDOK == wColorDlg.DoModal() )
	{
		COLORREF	color	= wColorDlg.GetColor();
		
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[0]	= GetRValue( color );
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[1]	= GetGValue( color );
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[2]	= GetBValue( color );

		SetWithBorderColor();
	}
}

BOOL CDevPrintExtendDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_ComboCvpPrintSize.SetCurSel( m_pNpsPrintInfo->PrintInfo.dwCvpPrintSize );
	m_ComboCms.SetCurSel( m_pNpsPrintInfo->PrintInfo.wCMS );
	m_ComboAngle.SetCurSel( m_pNpsPrintInfo->PrintInfo.wAngle );
	m_ComboPaperFitting.SetCurSel( m_pNpsPrintInfo->PrintInfo.wPaperFitting );
	m_ComboEdgeEnhancement.SetCurSel( m_pNpsPrintInfo->PrintInfo.wEdgeEnhancement );
	m_ComboColorSpace.SetCurSel( m_pNpsPrintInfo->PrintInfo.dwColorSpace );
	m_ComboPrintQuality.SetCurSel( m_pNpsPrintInfo->PrintInfo.wPrintQuality );
	m_ComboImageEnlarge.SetCurSel( m_pNpsPrintInfo->PrintInfo.byImageEnlargeType );

	SetWithBorderColor();

	m_WithBorderTop		= m_pNpsPrintInfo->PrintInfo.wWithBorderTop;
	m_WithBorderBottom	= m_pNpsPrintInfo->PrintInfo.wWithBorderBottom;
	m_WithBorderLeft	= m_pNpsPrintInfo->PrintInfo.wWithBorderLeft;
	m_WithBorderRight	= m_pNpsPrintInfo->PrintInfo.wWithBorderRight;
	m_PaperName			= m_pNpsPrintInfo->PrintInfo.szPaperName;
	m_PcFms				= m_pNpsPrintInfo->PrintInfo.nPcfms;

	UpdateData( FALSE );
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDevPrintExtendDlg::SetWithBorderColor()
{
	m_strWithBorderColor.Format( "R=%03d G=%03d B=%03d",
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[0],
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[1],
		m_pNpsPrintInfo->PrintInfo.byWithBorderColor[2]
		);

	UpdateData( FALSE );
}

void CDevPrintExtendDlg::UpdateMemberData()
{
	UpdateData();

	m_pNpsPrintInfo->PrintInfo.dwCvpPrintSize		= m_ComboCvpPrintSize.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.wCMS					= m_ComboCms.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.wAngle				= m_ComboAngle.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.wPaperFitting		= m_ComboPaperFitting.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.wEdgeEnhancement		= m_ComboEdgeEnhancement.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.dwColorSpace			= m_ComboColorSpace.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.wPrintQuality		= m_ComboPrintQuality.GetCurSel();
	m_pNpsPrintInfo->PrintInfo.byImageEnlargeType	= m_ComboImageEnlarge.GetCurSel();

	m_pNpsPrintInfo->PrintInfo.wWithBorderTop		= m_WithBorderTop;
	m_pNpsPrintInfo->PrintInfo.wWithBorderBottom	= m_WithBorderBottom;
	m_pNpsPrintInfo->PrintInfo.wWithBorderLeft		= m_WithBorderLeft;
	m_pNpsPrintInfo->PrintInfo.wWithBorderRight		= m_WithBorderRight;
	strcpy( m_pNpsPrintInfo->PrintInfo.szPaperName, m_PaperName );
	m_pNpsPrintInfo->PrintInfo.nPcfms				= m_PcFms;
}
