// LibOpenDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "npsclient.h"
#include "LibOpenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLibOpenDlg _CAO


CLibOpenDlg::CLibOpenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLibOpenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLibOpenDlg)
	m_nMaxLineEdit = 100;
	m_strLogger = _T("");
	//}}AFX_DATA_INIT
}


void CLibOpenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLibOpenDlg)
	DDX_Text(pDX, IDC_EDIT_MAX_LINE, m_nMaxLineEdit);
	DDV_MinMaxUInt(pDX, m_nMaxLineEdit, 100, 3000);
	DDX_Text(pDX, IDC_EDIT_LOGGER, m_strLogger);
	DDV_MaxChars(pDX, m_strLogger, 31);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLibOpenDlg, CDialog)
	//{{AFX_MSG_MAP(CLibOpenDlg)
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnButtonFind)
	ON_BN_CLICKED(IDC_CHECK_OUTPUT_LOG, OnCheckOutputLog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLibOpenDlg bZ[W nh

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CLibOpenDlg::OnInitDialog()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CLibOpenDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_bExistConfigFile = FALSE;

	((CButton*)GetDlgItem(IDC_CHECK_OUTPUT_LOG))->SetCheck( 1 );

	SetDlgItemText( IDC_EDIT_LOGGER, "NoritsuPrinter.dll" );
	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_MAX_LINE))->SetRange( 100, 3000 );
	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_MAX_LINE))->SetPos( 1000 );

	((CButton*)GetDlgItem(IDC_CHECK_FATAL))->SetCheck( 1 );
	((CButton*)GetDlgItem(IDC_CHECK_WARN))->SetCheck( 1 );
	((CButton*)GetDlgItem(IDC_CHECK_INFO))->SetCheck( 1 );
	((CButton*)GetDlgItem(IDC_CHECK_DEBUG))->SetCheck( 1 );

	// Ot@C
	char	drive[_MAX_DRIVE];
	char	dir[_MAX_DIR];
	char	fname[_MAX_FNAME];
	char	ext[_MAX_EXT];
	char	szLogFilePath[MAX_PATH];
	char	szConfigFilePath[MAX_PATH];

	// AvP[V̐΃pX擾i΃pXj
	::GetModuleFileName( NULL, szLogFilePath, MAX_PATH );
	::_splitpath( szLogFilePath, drive, dir, fname, ext );
	::_makepath( szLogFilePath, drive, dir, "NoritsuPrinter", "log" );
	SetDlgItemText( IDC_EDIT_FILE, szLogFilePath );

	::_makepath( szConfigFilePath, drive, dir, "NoritsuPrinter", "ini" );
	m_strConfigFile = szConfigFilePath;
	SetDlgItemText( IDC_STATIC_SETTING_FILE, szConfigFilePath );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CLibOpenDlg::OnButtonFind()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CLibOpenDlg::OnButtonFind() 
{
	CString strFile;

	GetDlgItemText( IDC_EDIT_FILE, strFile );

	CFileDialog fdlg(
		FALSE,								// t@C̓Ǐwi TRUE:Ǎ, FALSE: j
		NULL,								// gq̎w
		strFile,							// ftHg̃t@C
		OFN_LONGNAMES |	OFN_HIDEREADONLY,	// eݒtO
		"log file|*.log|all files|*.*||",	// tB^[̎w
		this
	);

	if( fdlg.DoModal()==IDOK )
	{
		SetDlgItemText( IDC_EDIT_FILE, fdlg.GetPathName() );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CLibOpenDlg::OnOK()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CLibOpenDlg::OnOK() 
{
	int nButtonStatus;

	nButtonStatus = ((CButton*)GetDlgItem(IDC_CHECK_OUTPUT_LOG))->GetCheck();

	if ( 0 != nButtonStatus )
	{
		CString str;

		// L
		m_bExistConfigFile = TRUE;

		// Oݒt@C쐬
		GetDlgItemText( IDC_EDIT_LOGGER, str );
		::WritePrivateProfileString( "log", "logger", str, m_strConfigFile );

		GetDlgItemText( IDC_EDIT_MAX_LINE, str );
		::WritePrivateProfileString( "log", "maxline", str, m_strConfigFile );

		GetDlgItemText( IDC_EDIT_FILE, str );
		::WritePrivateProfileString( "log", "filename", str, m_strConfigFile );

		str.Format( "%d", ( 0 == ((CButton*)GetDlgItem(IDC_CHECK_FATAL))->GetCheck() ) ? 1 : 0 );
		::WritePrivateProfileString( "log", "levelfatal", str, m_strConfigFile );

		str.Format( "%d", ( 0 == ((CButton*)GetDlgItem(IDC_CHECK_WARN))->GetCheck() ) ? 1 : 0 );
		::WritePrivateProfileString( "log", "levelwarn", str, m_strConfigFile );

		str.Format( "%d", ( 0 == ((CButton*)GetDlgItem(IDC_CHECK_INFO))->GetCheck() ) ? 1 : 0 );
		::WritePrivateProfileString( "log", "levelinfo", str, m_strConfigFile );

		str.Format( "%d", ( 0 == ((CButton*)GetDlgItem(IDC_CHECK_DEBUG))->GetCheck() ) ? 1 : 0 );
		::WritePrivateProfileString( "log", "leveldebug", str, m_strConfigFile );
	}

	CDialog::OnOK();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CLibOpenDlg::OnCheckOutputLog()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.11.11
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CLibOpenDlg::OnCheckOutputLog() 
{
	int nButtonStatus;
	int nCmdShow;
	nButtonStatus = ((CButton*)GetDlgItem(IDC_CHECK_OUTPUT_LOG))->GetCheck();

	if ( 0 == nButtonStatus )
	{
		// 
		nCmdShow = SW_HIDE;
	}
	else
	{
		// L
		nCmdShow = SW_SHOW;
	}

	GetDlgItem(IDC_STATIC_GROUP)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_STATIC_LOGGER)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_STATIC_MAXLINE)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_STATIC_FILENAME)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_EDIT_LOGGER)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_EDIT_MAX_LINE)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_SPIN_MAX_LINE)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_EDIT_FILE)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_BUTTON_FIND)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_CHECK_FATAL)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_CHECK_WARN)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_CHECK_INFO)->ShowWindow( nCmdShow );
	GetDlgItem(IDC_CHECK_DEBUG)->ShowWindow( nCmdShow );
}
