// OrderManager.cpp: OrderManager NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OrderManager.h"

namespace OrderManager
{
std::vector<COrder*>	Orders;

//////////////////////////////////////////////////////////////////////////////
//	R}NX
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CFrame::CFrame()
//	ABSTRACT : ftHgRXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame::CFrame(
	DWORD				dwOrderId,
	NPS_PrintInfo*		pPrintInfo,
	int					eType,
	short				nPriority,
	char*				pIccsCmdFilePath )
{
	m_dwOrderId		= dwOrderId;
	m_dwPrintId		= 0;
	m_tPrintInfo	= *pPrintInfo;
	if( pPrintInfo->pName )
	{
		::_snprintf( m_cNameBuffer, sizeof( m_cNameBuffer ), "%s", pPrintInfo->pName );
	}
	m_tPrintInfo.pName = m_cNameBuffer;
	m_eType			= eType;
	m_nPriority		= nPriority;
	memcpy( m_cIccsCmdFilePath, pIccsCmdFilePath, sizeof( m_cIccsCmdFilePath ) );
	m_bTransfered	= FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CFrame::CFrame()
//	ABSTRACT : Rs[RXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame::CFrame(
	CFrame*				pFrame )
{
	m_dwOrderId		= pFrame->m_dwOrderId;
	m_dwPrintId		= pFrame->m_dwPrintId;
	m_tPrintInfo	= pFrame->m_tPrintInfo;
	if( pFrame->m_tPrintInfo.pName )
	{
		::_snprintf( m_cNameBuffer, sizeof( m_cNameBuffer ), "%s", pFrame->m_tPrintInfo.pName );
	}
	m_tPrintInfo.pName = m_cNameBuffer;
	m_eType			= pFrame->m_eType;
	m_nPriority		= pFrame->m_nPriority;
	memcpy( m_cIccsCmdFilePath, pFrame->m_cIccsCmdFilePath, sizeof( m_cIccsCmdFilePath ) );
	m_bTransfered	= pFrame->m_bTransfered;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CFrame::~CFrame()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame::~CFrame()
{
}

//////////////////////////////////////////////////////////////////////////////
//	I[_[NX
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::COrder()
//	ABSTRACT : ftHgRXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder::COrder(
	DWORD				dwOrderId,
	DWORD				dwPriority,
	DWORD				dwSorterNum,
	DWORD				dwSortFrame,
	DWORD				dwExOptions)
{
	m_bInterrupted	= FALSE;						// f
	m_dwOrderId		= dwOrderId;					// I[_[ID
	m_dwPriority	= dwPriority;					// Dxw
	m_dwSorterNum	= dwSorterNum;					// vg̎d
	m_dwSortFrame	= dwSortFrame;					// R}̃\[g@\
	m_dwExOptinons	= dwExOptions;					// gIvV(Pvg)	2014.10.30 M.Yamamoto
	m_Frames.clear();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::COrder()
//	ABSTRACT : Rs[RXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder::COrder(
	COrder*				pOrder )
{
	m_bInterrupted	= pOrder->m_bInterrupted;		// f
	m_dwOrderId		= pOrder->m_dwOrderId;			// I[_[ID
	m_dwPriority	= pOrder->m_dwPriority;			// Dxw
	m_dwSorterNum	= pOrder->m_dwSorterNum;		// vg̎d
	m_dwSortFrame	= pOrder->m_dwSortFrame;		// R}̃\[g@\
	m_dwExOptinons	= pOrder->m_dwExOptinons;		// gIvV(Pvg)	2014.10.30 M.Yamamoto

	for( std::vector<CFrame*>::iterator it = pOrder->m_Frames.begin();
		 it != pOrder->m_Frames.end();
		 it++ )
	{
		m_Frames.push_back( new CFrame( ( *it ) ) );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::~COrder()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder::~COrder()
{
	std::vector<CFrame*>::iterator it = m_Frames.begin();
	while( it != m_Frames.end() )
	{
		delete ( *it );
		it = m_Frames.erase( it );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::AppendFrame()
//	ABSTRACT : R}̃CX^X𐶐ăL[ɒǉ
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame*	COrder::AppendFrame(
	CFrame*				pFrame )
{
	CFrame	*pTemp = new CFrame( pFrame );
	m_Frames.push_back( pTemp );
	return pTemp;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::RemoveFrame()
//	ABSTRACT : w̃R}L[폜ăCX^Xj
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	COrder::RemoveFrame(
	CFrame*&			pFrame )
{
	for( std::vector<CFrame*>::iterator it = m_Frames.begin();
		 it != m_Frames.end();
		 it++ )
	{
		if( ( *it ) == pFrame )
		{
			m_Frames.erase( it );
			delete pFrame;
			pFrame = NULL;
			break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::FindFrame()
//	ABSTRACT : w̃R}ID̃R}L[T
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame*	COrder::FindFrame(
	DWORD				dwPrintId )
{
	for( std::vector<CFrame*>::iterator it = m_Frames.begin();
		 it != m_Frames.end();
		 it++ )
	{
		if( ( *it )->m_dwPrintId == dwPrintId )
		{
			return ( *it );
		}
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::GetFrame()
//	ABSTRACT : wCfbNX̃R}L[擾
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CFrame*	COrder::GetFrame(
	int					nIndex )
{
	if( 0 <= nIndex && m_Frames.size() > nIndex )
	{
		return m_Frames[ nIndex ];
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : COrder::GetFrameSize()
//	ABSTRACT : L[ĂR}
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int		COrder::GetFrameSize()
{
	return m_Frames.size();
}

//////////////////////////////////////////////////////////////////////////////
//	I[_[Ǘ
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : Initialize()
//	ABSTRACT : I[_[L[
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	Initialize()
{
	for(	std::vector<COrder*>::iterator	it = Orders.begin();
			it != Orders.end();
			it = Orders.erase( it ) )
	{
		delete ( *it );
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : AppendOrder()
//	ABSTRACT : I[_[̃CX^X𐶐ăL[ɒǉ
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder*	AppendOrder(
	COrder*				pOrder )
{
	COrder*	pTemp = new COrder( pOrder );
	Orders.push_back( pTemp );
	return pTemp;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : RemoveOrder()
//	ABSTRACT : w̃I[_[L[폜ăCX^Xj
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	RemoveOrder(
	COrder*&			pOrder )
{
	for( std::vector<COrder*>::iterator it = Orders.begin();
		 it != Orders.end();
		 it++ )
	{
		if( ( *it ) == pOrder )
		{
			Orders.erase( it );
			delete pOrder;
			pOrder = NULL;
			break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FindOrder()
//	ABSTRACT : w̃I[_[ID̃I[_[L[T
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder*	FindOrder(
	DWORD				dwOrderId )
{
	for( std::vector<COrder*>::iterator it = Orders.begin();
		 it != Orders.end();
		 it++ )
	{
		if( ( *it )->m_dwOrderId == dwOrderId )
		{
			return ( *it );
		}
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetOrder()
//	ABSTRACT : wCfbNX̃I[_[L[擾
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
COrder*	GetOrder(
	int					nIndex )
{
	if( 0 <= nIndex && Orders.size() > nIndex )
	{
		return Orders[ nIndex ];
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetOrderSize()
//	ABSTRACT : L[ĂI[_[
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
int		GetOrderSize()
{
	return Orders.size();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : UpdateOrder()
//	ABSTRACT : ʒmMɃI[_[XV
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	UpdateOrder(
	PNPSORDERINFO		pInfo )
{
	// SẴvgro܂̓LZ܂ُ͈Iɂ
	// I[_[Iꍇ
	COrder*	pOrder = FindOrder( pInfo->dwOrderId );
	if( pOrder )
	{
		// fI[_[łȂꍇ̓I[_[폜
		if( !( pOrder->m_bInterrupted ) )
		{
			RemoveOrder( pOrder );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : UpdateFrame()
//	ABSTRACT : ʒmMɃR}XV
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	UpdateFrame(
	PNPSPRINTINFO		pInfo )
{
	for( std::vector<COrder*>::iterator it = Orders.begin();
		 it != Orders.end();
		 it++ )
	{
		CFrame*	pFrame = ( *it )->FindFrame( pInfo->dwPrintId );
		if( pFrame )
		{
			// đɕKvR}̃[fBOJnƃvgZ
			switch( pInfo->dwStatus )
			{
			case RESULT_TRANSFER:			// ]
				if( pFrame->m_tPrintInfo.dwPrintNum <= pInfo->dwFinishNum )
				{
					pFrame->m_bTransfered = TRUE;
				}
				break;
			case RESULT_OK:					// ro
				// fꂽꍇ͍đKv̂ŔroĂȂ
				break;
			case RESULT_PRINT:				// vg
//				pFrame->m_tPrintInfo.wPrintedCount = pInfo->dwFinishNum;
				break;
			case RESULT_LOADING:			// [fBOJn
				break;
			case RESULT_OK_RETRANSMISSION:	// đpro
				pFrame->m_tPrintInfo.wPrintedCount = pInfo->dwFinishNum;
				break;
			case RESULT_OK_REPEAT:			// rois[gPʁj
//				pFrame->m_tPrintInfo.wPrintedCount = pInfo->dwFinishNum;
				break;
			case RESULT_PRINT_REPEAT:		// vgis[gPʁj
				// roŃJEĝŉȂ
				break;
			case RESULT_LOADING_REPEAT:		// [fBOJnis[gPʁj
				pFrame->m_tPrintInfo.wLoadingCount = pInfo->dwFinishNum;
				break;
			default:
				break;
			}
			break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : UpdateFrame()
//	ABSTRACT : t[Cxg󋵒ʒmMɃR}XV
//	FUNCTION : 
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : H.Kamiya	2011.11.10
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void	UpdateFrame(
	PNPSEVENTINFOEX		pInfo )
{
	for( std::vector<COrder*>::iterator it = Orders.begin();
		 it != Orders.end();
		 it++ )
	{
		CFrame*	pFrame = ( *it )->FindFrame( pInfo->dwPrintId );
		if( pFrame )
		{
			// CxgʎqZbg
			pFrame->m_tPrintInfo.dwEventId = pInfo->dwEventId;
			// CxgR[hiԁjZbg
			pFrame->m_tPrintInfo.wEventCodeMain = pInfo->wEventCodeMain;
			break;
		}
	}
}
}
