// CmdBuffer.cpp: CCmdBuffer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "npsserver.h"
#include "CmdBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CCmdBuffer::CCmdBuffer()
{
	Empty();
}

CCmdBuffer::~CCmdBuffer()
{

}

void CCmdBuffer::Empty()
{
	m_nBufferLen = 0;
	::ZeroMemory( m_byBuffer, sizeof(m_byBuffer) );
}

int CCmdBuffer::AddHeader( WORD wInterfaceId, WORD wCommandId )
{
	{	// Oo
		switch ( MAKELONG( wCommandId, wInterfaceId ) )
		{
		case 0x6000F102:
		case 0x6000F202:
		case 0x6000F302:
			// Oo͂𑼂̏ꏊōsĂ邽߁Ał͏o͂Ȃ
			break;
		default:
			{
				CString str;
				str.Format( "SEND <---- [%04X] [%04X]", wInterfaceId, wCommandId );
				NPS_LOGOUT( str );
			}
			break;
		}
	}

	USHORT nInterfaceId;
	USHORT nCommandId;

	nInterfaceId = NkcComApi::htons( wInterfaceId );
	nCommandId = NkcComApi::htons( wCommandId );

	memcpy( &m_byBuffer[m_nBufferLen], &nInterfaceId, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);
	memcpy( &m_byBuffer[m_nBufferLen], &nCommandId, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);

	return m_nBufferLen;
}

int CCmdBuffer::AddTagChar( WORD wTag, char nValue )
{
	return AddTagChar( wTag, &nValue, 1 );
}

int CCmdBuffer::AddTagChar( WORD wTag, char* pValue, int nCount )
{
	USHORT nTag;
	USHORT nLength;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( sizeof(UCHAR) * nCount );

	// Tag
	memcpy( &m_byBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_byBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	memcpy( &m_byBuffer[m_nBufferLen], pValue, sizeof(UCHAR) * nCount );	m_nBufferLen += sizeof(UCHAR) * nCount;

	return m_nBufferLen;
}

int CCmdBuffer::AddTagShort( WORD wTag, short nValue )
{
	return AddTagShort( wTag, &nValue, 1 );
}

int CCmdBuffer::AddTagShort( WORD wTag, short* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	USHORT nValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( sizeof(USHORT) * nCount );

	// Tag
	memcpy( &m_byBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_byBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		nValue = NkcComApi::htons( *(pValue + nIdx) );
		memcpy( &m_byBuffer[m_nBufferLen], &nValue, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);
	}

	return m_nBufferLen;
}

int CCmdBuffer::AddTagLong( WORD wTag, long nValue )
{
	return AddTagLong( wTag, &nValue, 1 );
}

int CCmdBuffer::AddTagLong( WORD wTag, long* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	ULONG  nValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( sizeof(ULONG) * nCount );

	// Tag
	memcpy( &m_byBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_byBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		nValue = NkcComApi::htonl( *(pValue + nIdx) );
		memcpy( &m_byBuffer[m_nBufferLen], &nValue, sizeof(ULONG) );		m_nBufferLen += sizeof(ULONG);
	}

	return m_nBufferLen;
}

int CCmdBuffer::AddTagFloat( WORD wTag, FLOAT nValue )
{
	return AddTagFloat( wTag, &nValue, 1 );
}

//////////////////////////////////////////////////////////////////////
// AddTagFloat
// UPDATE: J.Fukumori(AVASYS) 2008.07.22 VS2005Ή
//////////////////////////////////////////////////////////////////////
int CCmdBuffer::AddTagFloat( WORD wTag, FLOAT* pValue, int nCount )
{
	int nIdx;
	USHORT nTag;
	USHORT nLength;
	FLOAT  nValue;

	nTag	= NkcComApi::htons( wTag );
	nLength	= NkcComApi::htons( sizeof(FLOAT) * nCount );

	// Tag
	memcpy( &m_byBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );				m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_byBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );			m_nBufferLen += sizeof(USHORT);

	// Value
	for ( nIdx=0 ; nCount > nIdx ; nIdx++ )
	{
		nValue = (FLOAT)NkcComApi::htonl( (unsigned long)*(pValue + nIdx) );
		memcpy( &m_byBuffer[m_nBufferLen], &nValue, sizeof(FLOAT) );		m_nBufferLen += sizeof(FLOAT);
	}

	return m_nBufferLen;
}

int CCmdBuffer::AddTagFooter()
{
	USHORT nTag;
	USHORT nLength;

	nTag			= NkcComApi::htons( 0 );
	nLength			= NkcComApi::htons( 0 );

	// Tag
	memcpy( &m_byBuffer[m_nBufferLen], &nTag, sizeof(USHORT) );		m_nBufferLen += sizeof(USHORT);

	// Length
	memcpy( &m_byBuffer[m_nBufferLen], &nLength, sizeof(USHORT) );	m_nBufferLen += sizeof(USHORT);

	return m_nBufferLen;
}

LPBYTE CCmdBuffer::GetBuffer()
{
	return m_byBuffer;
}

int CCmdBuffer::GetBufferLen()
{
	return m_nBufferLen;
}
