//////////////////////////////////////////////////////////////////////////////
//   File Name   : NkcComApi.cpp
//   Contents    : ʊ֐
//					
//   Author/Date : Y.Yoshinobu	2006.07.05
//	                                    (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "NkcComApi.h"
#include "Shlwapi.h"

#pragma comment( lib , "shlwapi.lib" )	// Shlwapi.h (shell Lightweight Utility APIs)

namespace NkcComApi {

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : GetHostName
//   ABSTRACT : hostent ^̃f[^AzXg̖O擾܂
//   FUNCTION : hostent ^̃f[^AzXg̖O擾܂
//////////////////////////////////////////////////////////////////////////////
CString GetHostName( hostent* p )
{
	USES_CONVERSION;
	return CString( A2T( p->h_name ) );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : GetHostAddr
//   ABSTRACT : hostent ^̃f[^AzXg̃AhX擾܂
//   FUNCTION : hostent ^̃f[^AzXg̃AhX擾܂
//////////////////////////////////////////////////////////////////////////////
CString GetHostAddr( hostent* p )
{
	USES_CONVERSION;
	return CString( A2T( inet_ntoa( *(LPIN_ADDR)( p->h_addr_list[0] ) ) ) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohs()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : short^
//////////////////////////////////////////////////////////////////////////////
unsigned short ntohs( unsigned short netshort )
{
	return ::ntohs( netshort );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohl()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : long^
//////////////////////////////////////////////////////////////////////////////
unsigned long ntohl( unsigned long netlong )
{
	return ::ntohl( netlong );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : int64^
//////////////////////////////////////////////////////////////////////////////
unsigned __int64 ntohi64( unsigned __int64 netint64 )
{
	union _NTOHI64_VAR {
		unsigned char		src_char[8];
		unsigned __int64	src_int64;
	};

	union _NTOHI64_VAR	var1;
	union _NTOHI64_VAR	var2;

	var1.src_int64 = netint64;

	var2.src_char[7] = var1.src_char[0];
	var2.src_char[6] = var1.src_char[1];
	var2.src_char[5] = var1.src_char[2];
	var2.src_char[4] = var1.src_char[3];
	var2.src_char[3] = var1.src_char[4];
	var2.src_char[2] = var1.src_char[5];
	var2.src_char[1] = var1.src_char[6];
	var2.src_char[0] = var1.src_char[7];

	return var2.src_int64;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : short^
//////////////////////////////////////////////////////////////////////////////
unsigned short htons( unsigned short hostshort )
{
	return ::htons( hostshort );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : htonl()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : long^
//////////////////////////////////////////////////////////////////////////////
unsigned long htonl( unsigned long hostlong )
{
	return ::htonl( hostlong );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : int64^
//////////////////////////////////////////////////////////////////////////////
unsigned __int64 htoni64( unsigned __int64 hostint64 )
{
	union _NTOHI64_VAR {
		unsigned char		src_char[8];
		unsigned __int64	src_int64;
	};

	union _NTOHI64_VAR	var1;
	union _NTOHI64_VAR	var2;

	var1.src_int64 = hostint64;

	var2.src_char[7] = var1.src_char[0];
	var2.src_char[6] = var1.src_char[1];
	var2.src_char[5] = var1.src_char[2];
	var2.src_char[4] = var1.src_char[3];
	var2.src_char[3] = var1.src_char[4];
	var2.src_char[2] = var1.src_char[5];
	var2.src_char[1] = var1.src_char[6];
	var2.src_char[0] = var1.src_char[7];

	return var2.src_int64;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WinSockCleanup()
//	ABSTRACT : WinSock 2.2 gpł悤ɂ܂
//	FUNCTION : WinSock 2.2 gpł悤ɂ܂
//////////////////////////////////////////////////////////////////////////////
BOOL WinSockStartup()
{
	int ret;
	unsigned short	wVersionRequired;
	WSADATA WSAData;

	// WinSock
	wVersionRequired = MAKEWORD(2,2);
	ret = WSAStartup( wVersionRequired, &WSAData );
	if ( 0 != ret ) {
		return FALSE;
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WinSockCleanup()
//	ABSTRACT : WinSock 2.2 ̎gpJ܂
//	FUNCTION : WinSock 2.2 ̎gpJ܂
//////////////////////////////////////////////////////////////////////////////
BOOL WinSockCleanup()
{
	int ret;

	// WinSock DLL ̎gpI
	ret = WSACleanup();
	if ( SOCKET_ERROR == ret ) {
		return FALSE;
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetFileSize()
//	ABSTRACT : t@C̃TCY擾܂
//	FUNCTION : t@C̃TCY擾܂
//////////////////////////////////////////////////////////////////////////////
unsigned long GetFileSize( LPCTSTR lpFilePath )
{
	BOOL	bRet;
	HANDLE	hFile;
	DWORD	dwSize;

	// 
	dwSize = 0;

	// t@C̃I[v
	hFile = ::CreateFile(
				lpFilePath,				// pointer to name of the file
				GENERIC_READ,			// access (read-write) mode
				FILE_SHARE_READ,		// share mode
				NULL,					// pointer to security attributes
				OPEN_EXISTING,			// how to create
				FILE_ATTRIBUTE_NORMAL,	// file attributes
				NULL
			);

	if ( hFile != INVALID_HANDLE_VALUE ) {

		// t@CTCY̊mF
		dwSize = ::GetFileSize( hFile, NULL );

		// t@C̃N[Y
		bRet = ::CloseHandle(hFile);
		if ( FALSE == bRet ) {
			return dwSize;
		}

	}

	return dwSize;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : MakeFullPath
//   ABSTRACT : wt@CsW[̃tpXɕϊ܂
//   FUNCTION : wt@CsW[̃tpXɕϊ܂
//////////////////////////////////////////////////////////////////////////////
CString MakeFullPath( CString szFileName )
{
	TCHAR		szModuleFileName[MAX_PATH];
	TCHAR		szDesFileName[MAX_PATH];

	// W[̃tpXt@C擾܂
	::GetModuleFileName( NULL , szModuleFileName , MAX_PATH );

	// t@C菜܂
	::PathRemoveFileSpec( szModuleFileName );

	// t@CĕԂ܂
	::PathCombine( szDesFileName , szModuleFileName , szFileName );

	// t@CԂ܂
	return CString( szDesFileName );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : MakeFullPath()
//	ABSTRACT : wt@CpXƃt@CtpXɕϊ܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
CString MakeFullPath( LPCTSTR lpFolderPath, LPCTSTR lpFileName )
{
	TCHAR	szFilePath[MAX_PATH];

	::PathCombine( szFilePath, lpFolderPath, lpFileName );

	return CString( szFilePath );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CreateFolder()
//	ABSTRACT : w肳ꂽtH_쐬
//	FUNCTION : ċA֐

//////////////////////////////////////////////////////////////////////////////
BOOL CreateFolder( LPCTSTR lpFolder )
{
	TCHAR	szFolder[MAX_PATH];
	TCHAR	szDrive[_MAX_DRIVE];
	TCHAR	szDir[_MAX_DIR];
	TCHAR	szFname[_MAX_FNAME];
	TCHAR	szExt[_MAX_EXT];

	// ΃pX͑ΏۊO
	if( TRUE == ::PathIsRelative( lpFolder ) ) {
		return FALSE;
	}

	// ݂t@CƈvĂꍇ͑ΏۊO
	if ( TRUE == ::PathFileExists( lpFolder ) ) {
		return FALSE;
	}

	// Root tH_mF
	if ( TRUE == ::PathIsRoot( lpFolder )) {
		return FALSE;
	}

	_tsplitpath( lpFolder, szDrive, szDir, szFname, szExt );
	_tmakepath( szFolder, szDrive, szDir, NULL, NULL );
	::PathRemoveBackslash( szFolder );

	if ( FALSE == ::PathFileExists( szFolder ) ) {
		if ( FALSE == CreateFolder( szFolder ) ) {
			return FALSE;
		}
	}

	// tH_̍쐬
	if ( FALSE == ::CreateDirectory( lpFolder, NULL ) ) {
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : DeleteFolder()
//	ABSTRACT : w肳ꂽtH_폜
//	FUNCTION : ċA֐
//////////////////////////////////////////////////////////////////////////////
BOOL DeleteFolder( LPCTSTR lpFolder )
{
	if ( !::PathFileExists( lpFolder ) ) {
		return FALSE;
	}

	TCHAR	szFilePath[MAX_PATH];
	TCHAR	szSearchPath[MAX_PATH];
	DWORD	dwFileAttributes;
	HANDLE	hFind;
	WIN32_FIND_DATA	FindFileData;

	::PathCombine( szSearchPath, lpFolder, "*.*" );

	hFind = ::FindFirstFile( szSearchPath, &FindFileData );
	if ( INVALID_HANDLE_VALUE != hFind ) {

		do
		{
			if ( FILE_ATTRIBUTE_OFFLINE & FindFileData.dwFileAttributes ) {
				// ItC̏ꍇɂ͑ΏۊO
				continue;
			}

			if (( 0 == ::lstrcmp( FindFileData.cFileName, "." )) ||
				( 0 == ::lstrcmp( FindFileData.cFileName, ".." ))) {
				// "." ܂ ".." ̏ꍇɂ͑ΏۊO
				continue;
			}

			// ΃pXɕϊ
			::PathCombine( szFilePath, lpFolder, FindFileData.cFileName );

			if ( FILE_ATTRIBUTE_READONLY & FindFileData.dwFileAttributes ) {
				// IɁAǂݎpO܂
				dwFileAttributes = ::GetFileAttributes( szFilePath );
				dwFileAttributes &= ~FILE_ATTRIBUTE_READONLY;
				::SetFileAttributes( szFilePath, dwFileAttributes );
			}

			if ( FILE_ATTRIBUTE_DIRECTORY & FindFileData.dwFileAttributes ) {
				// tH_̏ꍇ́AċAIɌĂяo
				DeleteFolder( szFilePath );
				continue;
			}

			::DeleteFile( szFilePath );
		}
		while ( TRUE == ::FindNextFile( hFind, &FindFileData) );

		::FindClose( hFind );
	}

	::RemoveDirectory( lpFolder );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ClearFolder()
//	ABSTRACT : w肳ꂽtH_̒g폜Ăꂢɂ
//	FUNCTION : w肳ꂽtH_͏Ȃ
//////////////////////////////////////////////////////////////////////////////
BOOL ClearFolder( LPCTSTR lpFolder )
{
	if ( !::PathFileExists( lpFolder ) ) {
		return FALSE;
	}

	TCHAR	szFilePath[MAX_PATH];
	TCHAR	szSearchPath[MAX_PATH];
	DWORD	dwFileAttributes;
	HANDLE	hFind;
	WIN32_FIND_DATA	FindFileData;

	::PathCombine( szSearchPath, lpFolder, "*.*" );

	hFind = ::FindFirstFile( szSearchPath, &FindFileData );
	if ( INVALID_HANDLE_VALUE != hFind ) {

		do
		{
			if ( FILE_ATTRIBUTE_OFFLINE & FindFileData.dwFileAttributes ) {
				// ItC̏ꍇɂ͑ΏۊO
				continue;
			}

			if (( 0 == ::lstrcmp( FindFileData.cFileName, "." )) ||
				( 0 == ::lstrcmp( FindFileData.cFileName, ".." ))) {
				// "." ܂ ".." ̏ꍇɂ͑ΏۊO
				continue;
			}

			// ΃pXɕϊ
			::PathCombine( szFilePath, lpFolder, FindFileData.cFileName );

			if ( FILE_ATTRIBUTE_READONLY & FindFileData.dwFileAttributes ) {
				// IɁAǂݎpO܂
				dwFileAttributes = ::GetFileAttributes( szFilePath );
				dwFileAttributes &= ~FILE_ATTRIBUTE_READONLY;
				::SetFileAttributes( szFilePath, dwFileAttributes );
			}

			if ( FILE_ATTRIBUTE_DIRECTORY & FindFileData.dwFileAttributes ) {
				// tH_̏ꍇ́AċAIɌĂяo
				DeleteFolder( szFilePath );
				continue;
			}

			::DeleteFile( szFilePath );
		}
		while ( TRUE == ::FindNextFile( hFind, &FindFileData) );

		::FindClose( hFind );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ReadMyVersion()
//	ABSTRACT : o[W擾
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL ReadMyVersion( DWORD* pdwFileVersionMS, DWORD* pdwFileVersionLS )
{
	HMODULE	hModule;
	HRSRC	hRsrc;
	HGLOBAL	hGlobal;
	struct VS_VERSIONINFO { 
		WORD  wLength;			// ̍\̂̃TCY(2oCg)
		WORD  wValueLength;		// ValuẽTCY(2oCg)
		WORD  wType;			// oCieLXg(2oCg)
		WCHAR szKey[16];		// "VS_VERSION_INFO\0"16(32oCg)
		WORD  Padding1[1];		// 2oCgčv40oCg
		VS_FIXEDFILEINFO Value;	// Ƀo[Wԍ
//		WORD  Padding2[];		// ϒ̂C̍\̂ł͕\s
//		WORD  Children[];		// ܂Ӗ̂Ȃf[^
	} *pData;

	*pdwFileVersionMS = 0;
	*pdwFileVersionLS = 0;

	// \[Xǂ
	hModule = GetModuleHandle(NULL);
	if ( NULL != (hRsrc=FindResource( hModule,(LPCTSTR)VS_VERSION_INFO,RT_VERSION)) )
	{
		if ( NULL != (hGlobal=LoadResource(hModule,hRsrc)) )
		{
			// \[XbNĂgp
			pData = (VS_VERSIONINFO*)LockResource(hGlobal);
			*pdwFileVersionMS = pData->Value.dwFileVersionMS;
			*pdwFileVersionLS = pData->Value.dwFileVersionLS;
			return TRUE;
		}
	}

	return FALSE;
}

}	// namespace NkcComApi

