#pragma once
//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : CRecvNpsData.h
//	ABSTRACT  : NPSf[^MNX
//	
//	CREATE    : Y.Yoshinobu   2008.12.1
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// #include
#include "vector"

#define	RECV_NPS_DATA_MAX_SIZE	(65535)

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CRecvNpsDataScopeLock
//	ABSTRACT : NeBJZNVANZXNX
//	
//	NOTE     : < RD-123 > 
//             < Note > XR[v͈͂̃NeBJZNṼbNs܂
//	
//	CREATE	 : Y.Yoshinobu	2008.12.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CRecvNpsDataScopeLock
{
private:
	CRITICAL_SECTION*	m_pCS;
public:
	CRecvNpsDataScopeLock( CRITICAL_SECTION* pCS ) {
		m_pCS = pCS;
		::EnterCriticalSection( m_pCS );
	}
	~CRecvNpsDataScopeLock()	{
		::LeaveCriticalSection( m_pCS );
	}
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CNpsTagData
//	ABSTRACT : NPS^Of[^NX
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CNpsTagData
{
public:
	CNpsTagData(void);
	~CNpsTagData(void);

	// ͌ʂ̏
	WORD	m_wTagNo;				// ^Oԍ
	WORD	m_wTagStartPos;			// ^Ol̊Jnʒu
	WORD	m_wTagLen;				// ^Ol̒
};

enum E_RECV_STATUS
{
	E_RECV_CMD_HEADER,	// R}hwb_[M
	E_RECV_TAG_HEADER,	// ^Owb_M
	E_RECV_TAG_VALUE,	// ^OlM
	E_RECV_END,			// ^OMI
};

//////////////////////////////////////////////////////////////////////////////
//	CLASS    : CRecvNpsData
//	ABSTRACT : NPSf[^MNX
//	
//	NOTE     : < RD-123 > 
//             < Note > 
//	
//	CREATE	 : Y.Yoshinobu	2008.12.1
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
class CRecvNpsData
{
public:
	CRecvNpsData(void);
	~CRecvNpsData(void);

	// M֌W
	WORD GetRemainLengthOfHeader();
	void AddRemainLengthOfHeader( WORD wRecvLen );

	WORD GetRemainLengthOfTagHeader();
	void AddRemainLengthOfTagHeader( WORD wRecvLen );

	WORD GetRemainLengthOfTagValue();
	void AddRemainLengthOfTagValue( WORD wRecvLen );

	E_RECV_STATUS GetRecvStatus();

	LPBYTE GetPointer();

	WORD GetLength();

	void Reset();

	// ^O͊֌W
	WORD GetInterfaceId();
	WORD GetCommandId();

	UINT32 GetLengthOfTagValue( const WORD wTagNo );
	UINT8  GetTagValueInt8( const WORD wTagNo, const INT32 nIdx = 0 );
	UINT16 GetTagValueInt16( const WORD wTagNo, const INT32 nIdx = 0 );
	UINT32 GetTagValueInt32( const WORD wTagNo, const INT32 nIdx = 0 );
	CString GetTagValueString( const WORD wTagNo );
	UINT32 GetTagValueChar( const WORD wTagNo, UINT32 nBufferSize, LPBYTE lpBuffer );

private:

	WORD	m_wRecvLength;			// M
	WORD	m_wHeaderRemain;		// wb_[̎cMTCY
									//   4Byte = C^[tFCXID[2Byte] + R}hID[2Byte]
	WORD	m_wTagHeaderRemain;		// ^Owb_[̎cMTCY
									//   4Byte = Tag[2Byte] + Length[2Byte]
	WORD	m_wTagValueRemain;		// ^Ol̎cMTCY
									//   ??? = ^Owb_[Length
	LPBYTE	m_lpRecvBuffer;			// NPSR}hM̈

	CRITICAL_SECTION	m_csPublicAccess;	// Public֐ւ̃ANZXr֐

	// ^O͊֌W
	void AddTagData( const WORD wTagNo, const WORD wTagStartPos, const WORD wTagLen );
	bool SelectTagData( const WORD wTagNo, LPWORD lpwTagStartPos, LPWORD lpwTagLen );
	void ClearTagData();

	std::vector<CNpsTagData*>	m_vNpsTagData;
};
