// ServerTcpCmd.cpp: CServerTcpCmd NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "ServerTcpCmd.h"
#include "CmdBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::CServerTcpCmd
//   ABSTRACT : RXgN^
//   FUNCTION : \PbgǗNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CServerTcpCmd::CServerTcpCmd()
{
	TRACE( "[%08X] CServerTcpCmd::CServerTcpCmd()\n", GetCurrentThreadId() );

	// ACprm
	InitializeCriticalSection( &m_apServSockLock );

	m_pServerSock=NULL;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::~CServerTcpCmd
//   ABSTRACT : fXgN^
//   FUNCTION : \PbgǗNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CServerTcpCmd::~CServerTcpCmd()
{
	TRACE( "[%08X] CServerTcpCmd::~CServerTcpCmd()\n", GetCurrentThreadId() );

	// T[o[\Pbg̊Jv
	ServerTcpCmdEnd();

	// ACprJ
	DeleteCriticalSection( &m_apServSockLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::AddServerSock
//   ABSTRACT : ǗT[o\Pbg̒ǉ
//   FUNCTION : ǗT[o\Pbg̒ǉ
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::AddServerSock( CWS2Tcp* pSock )
{
	static int iCount=0;
	TRACE( "[%08X] CServerTcpCmd::AddServerSock()\n", GetCurrentThreadId() );
   
	EnterCriticalSection( &m_apServSockLock );
	m_apServSocks.Add( pSock );
	LeaveCriticalSection( &m_apServSockLock );

}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::RemoveServerSock
//   ABSTRACT : ǗJ\PbgNX
//   FUNCTION : ǗJ\PbgNX
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::RemoveServerSock( CWS2Tcp* pSock )
{
	TRACE( "[%08X] CServerTcpCmd::RemoveServerSock()\n", GetCurrentThreadId() );

	EnterCriticalSection( &m_apServSockLock );
	for( int i = m_apServSocks.GetSize() - 1 ; i >= 0 ; i-- )
		if( m_apServSocks.GetAt( i ) == pSock ) {
			// L̃\Pbgؒf́ALs
			if ( ::GetVirtualPrinter()->GetPossessionSock() == pSock ) {
				::GetVirtualPrinter()->ResetPossession();
				::GetVirtualPrinter()->m_cPrintQue.DisableDuplex();
				::GetVirtualPrinter()->m_cPrintQue.ReciveCancelFrame();	// M̏폜
			}
			m_apServSocks.RemoveAt( i );
		}
	LeaveCriticalSection( &m_apServSockLock );
}

CWS2Tcp* WINAPI ServerCmdPortCreateFunc()
{
	TRACE( "ServerCmdPortCreateFunc()\n" );	
	CWS2TcpCmd* pSock;

	pSock = new CWS2TcpCmd();
	pSock->SetAutoDelete();
	return pSock;		
	
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::ServerTcpCmdStart
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::ServerTcpCmdStart()
{
	TRACE( "[%08X] CServerTcpCmd::ServerTcpCmdStart()\n", GetCurrentThreadId() );

	if (NULL != m_pServerSock)
	{
		TRACE( "T[o[\Pbg͊ɐς\n" );
		return;
	}

	m_pServerSock = new CWS2TcpListenCmd( ServerCmdPortCreateFunc );

	////////////////////////////////////////
	// T[o[IPAhX̎擾
	////////////////////////////////////////
	CString strIpAddress;
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("NpsServer.ini");
	GetPrivateProfileString("Common",
							"IPAddress",
							"",
							strIpAddress.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	strIpAddress.ReleaseBuffer();
	strIpAddress.FreeExtra();

	////////////////////////////////////////
	// \Pbg쐬
	////////////////////////////////////////
	BOOL bResult;
	if ( TRUE == strIpAddress.IsEmpty() )
	{
		bResult = m_pServerSock->Create( SERVER_CMD_PORT );
	}
	else
	{
		bResult = m_pServerSock->Create( SERVER_CMD_PORT, strIpAddress );
	}

	if ( FALSE == bResult )
	{
		CString str;
		str.Format( "Sockect creat failed. [ %s : %d ]", strIpAddress, SERVER_CMD_PORT );
		::AfxMessageBox( str );
	}
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::ServerTcpCmdEnd
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::ServerTcpCmdEnd()
{
	TRACE( "[%08X] CServerTcpCmd::ServerTcpCmdEnd()\n", GetCurrentThreadId() );

	if(NULL == m_pServerSock){
		TRACE( "T[o[\Pbg͐Ă܂\n" );
		return;
	}

	// T[o[\Pbg̃N[Y
	m_pServerSock->Close();
	delete m_pServerSock;
	m_pServerSock = NULL;

	// ڑ̑S\PbgN[Y
	int nCnt = m_apServSocks.GetSize();
	for( int i = 0 ; i < nCnt ; i++ ){
		CWS2Tcp* pSock = (CWS2Tcp*)(m_apServSocks.GetAt(0));
		m_apServSocks.RemoveAt(0);
		pSock->Close();
		delete pSock;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CServerTcpCmd::OnNotifyPrinterState()
//	ABSTRACT : v^ԕύXʒm
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::OnNotifyPrinterState( USHORT nTag, UCHAR nStatus )
{
	CCmdBuffer cBuffer;

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xF102 );

	// ԕωTag()̒ʒm
	cBuffer.AddTagChar( nTag, nStatus );

	// Tag I[
	cBuffer.AddTagFooter();

	{	// Oo
		CString str;
		str.Format( "SEND <---- [%04X] [%04X] Tag(%d)=0x%02X", 0x6000, 0xF102, nTag, nStatus );
		NPS_LOGOUT( str );
	}

	// M
	NotifyAll( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CServerTcpCmd::OnNotifyPrinterError()
//	ABSTRACT : v^Cxgʒm
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::OnNotifyPrinterError( ULONG nEventId, ULONG nEventCodeMain, LONG nParam1, LONG nParam2, LONG nParam3, LONG nParam4, UCHAR nOnOff)
{
	CCmdBuffer cBuffer;
	USHORT aDateTime[8];
	ULONG aParam[4];
	BOOL bSend=FALSE;

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xF202 );

	// Tag	1		CxgR[hiԁj
	cBuffer.AddTagLong( 1, nEventCodeMain );

	// Tag	2		Cxg̔E
	cBuffer.AddTagChar( 2, nOnOff );

	// Tag	3		
	SYSTEMTIME SysTime;
	GetLocalTime( &SysTime );
	aDateTime[0] = SysTime.wYear;			// N
	aDateTime[1] = SysTime.wMonth;			// 
	aDateTime[2] = SysTime.wDay;			// 
	aDateTime[3] = SysTime.wHour;			// 
	aDateTime[4] = SysTime.wMinute;			// 
	aDateTime[5] = SysTime.wSecond;			// b
	aDateTime[6] = SysTime.wMilliseconds;	// ~b
	aDateTime[7] = SysTime.wDayOfWeek;		// j
	cBuffer.AddTagShort( 3, (short*)aDateTime, COUNTOF(aDateTime) );

	// Tag	4		Cxg̃p[^ ilj
	aParam[0] = nParam1;
	aParam[1] = nParam2;
	aParam[2] = nParam3;
	aParam[3] = nParam4;
	cBuffer.AddTagLong( 4, (long*)aParam, COUNTOF(aParam) );

	// Tag	5		Cxgʎq
	cBuffer.AddTagLong( 5, nEventId );

	// Tag I[
	cBuffer.AddTagFooter();

	{	// Oo
		CString str;
		str.Format( "SEND <---- [%04X] [%04X] EventCodeMain=%d, nOnOff=%d, DateTime=%04d/%02d/%02d-%02d:%02d:%02d%03d(%d), Param=[%d][%d][%d][%d], EventId=%d",
						0x6000, 0xF202, nEventCodeMain, nOnOff,
						aDateTime[0], aDateTime[1], aDateTime[2], aDateTime[3], aDateTime[4], aDateTime[5], aDateTime[6], aDateTime[7],
						aParam[0], aParam[1], aParam[2], aParam[3], nEventId );
		NPS_LOGOUT( str );
	}

	// CxgǗNXɓo^
	if ( 0 == nOnOff ) {
		// 0FCxg
		::GetVirtualPrinter()->m_cErrorInfo.InsertErrorInfo( nEventId, nEventCodeMain, nParam1 );
		bSend = TRUE;
	} else {
		// 1FCxg
		if ( TRUE == ::GetVirtualPrinter()->m_cErrorInfo.DeleteErrorInfo( nEventCodeMain, nParam1 ) ) {
			bSend = TRUE;
			// 2006.10.06 T.Mizushima
			if(::GetVirtualPrinter()->ChkNotAcceptError() == FALSE)
			{
				::GetVirtualPrinter()->SetPrinterStateExt(STATE_PRN_ACCEPT, 2, FALSE);		// 󂯕t\
				::GetVirtualPrinter()->SetPrinterStateExt(STATE_PRN_ADVANCE, 2, TRUE);		// n[󂯕t\]
			}
		}
	}

	// M
	if ( TRUE == bSend ) {
		NotifyAll( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
	}
}

void CServerTcpCmd::OnNotifyPrinterError( CWS2Tcp* pSock, ULONG nEventId, ULONG nEventCodeMain, LONG nParam1, LONG nParam2, LONG nParam3, LONG nParam4, UCHAR nOnOff)
{
	CCmdBuffer cBuffer;
	USHORT aDateTime[8];
	ULONG aParam[4];

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xF202 );

	// Tag	1		CxgR[hiԁj
	cBuffer.AddTagLong( 1, nEventCodeMain );

	// Tag	2		Cxg̔E
	cBuffer.AddTagChar( 2, nOnOff );

	// Tag	3		
	SYSTEMTIME SysTime;
	GetLocalTime( &SysTime );
	aDateTime[0] = SysTime.wYear;			// N
	aDateTime[1] = SysTime.wMonth;			// 
	aDateTime[2] = SysTime.wDay;			// 
	aDateTime[3] = SysTime.wHour;			// 
	aDateTime[4] = SysTime.wMinute;			// 
	aDateTime[5] = SysTime.wSecond;			// b
	aDateTime[6] = SysTime.wMilliseconds;	// ~b
	aDateTime[7] = SysTime.wDayOfWeek;		// j
	cBuffer.AddTagShort( 3, (short*)aDateTime, COUNTOF(aDateTime) );

	// Tag	4		Cxg̃p[^ ilj
	aParam[0] = nParam1;
	aParam[1] = nParam2;
	aParam[2] = nParam3;
	aParam[3] = nParam4;
	cBuffer.AddTagLong( 4, (long*)aParam, COUNTOF(aParam) );

	// Tag	5		Cxgʎq
	cBuffer.AddTagLong( 5, nEventId );

	// Tag I[
	cBuffer.AddTagFooter();

	{	// Oo
		CString str;
		str.Format( "SEND <---- [%04X] [%04X] EventCodeMain=%d, nOnOff=%d, DateTime=%04d/%02d/%02d-%02d:%02d:%02d%03d(%d), Param=[%d][%d][%d][%d], EventId=%d",
						0x6000, 0xF202, nEventCodeMain, nOnOff,
						aDateTime[0], aDateTime[1], aDateTime[2], aDateTime[3], aDateTime[4], aDateTime[5], aDateTime[6], aDateTime[7],
						aParam[0], aParam[1], aParam[2], aParam[3], nEventId );
		NPS_LOGOUT( str );
	}

	// M
	NotifyOne( pSock, cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CServerTcpCmd::OnNotifyPrintState()
//	ABSTRACT : vg󋵒ʒm
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::OnNotifyPrintState( CWS2Tcp* pSock, ULONG nReceiptNumber, UCHAR nPrintStatus, USHORT nRepeatCount )
{
	CCmdBuffer cBuffer;

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xF302 );

	// Tag	1	tԍ
	cBuffer.AddTagLong( 1, nReceiptNumber);

	// Tag	2	vg
	cBuffer.AddTagChar( 2, nPrintStatus);

	// Tag	3	s[g
	cBuffer.AddTagShort( 3, nRepeatCount );

	// Tag I[
	cBuffer.AddTagFooter();

	{	// Oo
		CString str;
		CString strStatus;
		switch ( nPrintStatus )
		{
		case 1:	strStatus = _T( "[1]PRINT START     " );	break;	// 1:vgJn
		case 2:	strStatus = _T( "[2]PRINT END       " );	break;	// 2:vgiIj
		case 3:	strStatus = _T( "[3]PRINT OUT       " );	break;	// 3:vgro
		case 4:	strStatus = _T( "[4]PRINT ERROR     " );	break;	// 4:vgs
		case 5:	strStatus = _T( "[5]PRINT INTERRUPT1" );	break;	// 5:vg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[2FLiĊJ҂j]ŐLĊJ
		case 6:	strStatus = _T( "[6]PRINT INTERRUPT2" );	break;	// 6:vg荞ݒfiĊJ҂j => v^ԕύXʒḿuv^L̏ԁv[1FL]ŐLĊJ
		case 7:	strStatus = _T( "[7]PRINT CANCEL    " );	break;	// 7:vgLZ
		case 8:	strStatus = _T( "[8]PRINT RESTORE   " );	break;	// 8:vg
		}
		str.Format( "SEND <---- [%04X] [%04X] pSock=0x%08X, ReceiptNo=%d, Status=%s, Repeat=%d", 0x6000, 0xF302, pSock, nReceiptNumber, strStatus, nRepeatCount );
		NPS_LOGOUT( str );
	}

	// M
	NotifyOne( pSock, cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CServerTcpCmd::OnNotifyConnectCheck()
//	ABSTRACT : ڑmFʒm
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::OnNotifyConnectCheck()
{
	CCmdBuffer cBuffer;

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6000, 0xFF01 );

	// Tag I[
	cBuffer.AddTagFooter();

	// M
	NotifyAll( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CServerTcpCmd::OnNotifyEventStatus()
//	ABSTRACT : v^Cxggʒm
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::OnNotifyEventStatus( ULONG nReceiptNumber, ULONG nEventId, USHORT nEventCodeMain )
{
	CCmdBuffer cBuffer;

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x6001, 0xF102 );

	// Tag	1		tԍ
	cBuffer.AddTagLong( 1, nReceiptNumber );

	// Tag	2		Cxgʎq
	cBuffer.AddTagLong( 2, nEventId );

	// Tag	3		CxgR[hiԁj
	cBuffer.AddTagShort( 3, nEventCodeMain );

	// Tag I[
	cBuffer.AddTagFooter();

	{	// Oo
		CString str;
		str.Format( "SEND <---- [%04X] [%04X] ReceiptNumber=%d, EventId=%d, EventCodeMain=%d",
						0x6001, 0xF102, nReceiptNumber, nEventId, nEventCodeMain );
		NPS_LOGOUT( str );
	}

	// M
	NotifyAll( cBuffer.GetBuffer(), cBuffer.GetBufferLen() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::NotifyAll
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::NotifyAll( const void* lpBuf , int nBufLen )
{
	TRACE( "[%08X] CServerTcpCmd::NotifyAll()\n", GetCurrentThreadId() );

	int nCount;
	int nIndex;
	CWS2Tcp* pWS2Tcp;

	EnterCriticalSection( &m_apServSockLock );

	nCount = m_apServSocks.GetSize();

	for ( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		pWS2Tcp = m_apServSocks.GetAt( nIndex );

		pWS2Tcp->SendLock();
		pWS2Tcp->Send( lpBuf, nBufLen );
		pWS2Tcp->SendUnlock();
	}

	LeaveCriticalSection( &m_apServSockLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpCmd::NotifyOne
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpCmd::NotifyOne( CWS2Tcp* pSock, const void* lpBuf , int nBufLen )
{
	TRACE( "[%08X] CServerTcpCmd::NotifyOne()\n", GetCurrentThreadId() );

	int nCount;
	int nIndex;

	EnterCriticalSection( &m_apServSockLock );

	nCount = m_apServSocks.GetSize();

	for ( nIndex=0 ; nCount > nIndex ; nIndex++ )
	{
		if ( pSock == m_apServSocks.GetAt( nIndex ) ) {

			pSock->SendLock();
			pSock->Send( lpBuf, nBufLen );
			pSock->SendUnlock();

		}
	}

	LeaveCriticalSection( &m_apServSockLock );
}
