// ServerTcpImg.cpp: CServerTcpImg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "ServerTcpImg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::CServerTcpImg
//   ABSTRACT : RXgN^
//   FUNCTION : \PbgǗNX̐s܂
//////////////////////////////////////////////////////////////////////////////
CServerTcpImg::CServerTcpImg()
{
	TRACE( "[%08X] CServerTcpImg::CServerTcpImg()\n", GetCurrentThreadId() );

	// ACprm
	InitializeCriticalSection( &m_apServSockLock );

	m_pServerSock=NULL;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::~CServerTcpImg
//   ABSTRACT : fXgN^
//   FUNCTION : \PbgǗNX̊Js܂
//////////////////////////////////////////////////////////////////////////////
CServerTcpImg::~CServerTcpImg()
{
	TRACE( "[%08X] CServerTcpImg::~CServerTcpImg()\n", GetCurrentThreadId() );

	// T[o[\Pbg̊Jv
	EnterCriticalSection( &m_apServSockLock );
	while( m_apServSocks.GetSize() )
		delete m_apServSocks.GetAt( 0 );
	LeaveCriticalSection( &m_apServSockLock );


	// ACprJ
	DeleteCriticalSection( &m_apServSockLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::AddServerSock
//   ABSTRACT : ǗT[o\Pbg̒ǉ
//   FUNCTION : ǗT[o\Pbg̒ǉ
//////////////////////////////////////////////////////////////////////////////
void CServerTcpImg::AddServerSock( CWS2Tcp* pSock )
{
	TRACE( "[%08X] CServerTcpImg::AddServerSock()\n", GetCurrentThreadId() );

	EnterCriticalSection( &m_apServSockLock );
	m_apServSocks.Add( pSock );
	LeaveCriticalSection( &m_apServSockLock );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::RemoveServerSock
//   ABSTRACT : ǗJ\PbgNX
//   FUNCTION : ǗJ\PbgNX
//////////////////////////////////////////////////////////////////////////////
void CServerTcpImg::RemoveServerSock( CWS2Tcp* pSock )
{
	TRACE( "[%08X] CServerTcpImg::RemoveServerSock()\n", GetCurrentThreadId() );

	EnterCriticalSection( &m_apServSockLock );
	for( int i = m_apServSocks.GetSize() - 1 ; i >= 0 ; i-- )
		if( m_apServSocks.GetAt( i ) == pSock )
			m_apServSocks.RemoveAt( i );
	LeaveCriticalSection( &m_apServSockLock );
}

CWS2Tcp* WINAPI ServerImgPortCreateFunc()
{
	TRACE( "ServerImgPortCreateFunc()\n" );

	CWS2TcpImg* pSock = new CWS2TcpImg();
	pSock->SetAutoDelete();
	return pSock;
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::ServerTcpImgStart
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpImg::ServerTcpImgStart()
{
	TRACE( "[%08X] CServerTcpImg::ServerTcpImgStart()\n", GetCurrentThreadId() );

	// Xv[tH_̍쐬
	NkcComApi::CreateFolder( ::GetVirtualPrinter()->GetSpoolFolder() );

	if (NULL != m_pServerSock)
	{
		TRACE( "T[o[\Pbg͊ɐς\n" );
		return;
	}

	m_pServerSock = new CWS2TcpListenImg( ServerImgPortCreateFunc );

	////////////////////////////////////////
	// T[o[IPAhX̎擾
	////////////////////////////////////////
	CString strIpAddress;
	CString	strInfoFile;
	strInfoFile = NkcComApi::MakeFullPath("NpsServer.ini");
	GetPrivateProfileString("Common",
							"IPAddress",
							"",
							strIpAddress.GetBuffer(256),
							256,
							(LPCTSTR)strInfoFile
							);
	strIpAddress.ReleaseBuffer();
	strIpAddress.FreeExtra();

	////////////////////////////////////////
	// \Pbg쐬
	////////////////////////////////////////
	BOOL bResult;
	if ( TRUE == strIpAddress.IsEmpty() )
	{
		bResult = m_pServerSock->Create( SERVER_IMG_PORT );
	}
	else
	{
		bResult = m_pServerSock->Create( SERVER_IMG_PORT, strIpAddress );
	}

	if ( FALSE == bResult )
	{
		CString str;
		str.Format( "Sockect creat failed. [ %s : %d ]", strIpAddress, SERVER_IMG_PORT );
		::AfxMessageBox( str );
	}
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CServerTcpImg::ServerTcpImgEnd
//   ABSTRACT : 
//   FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void CServerTcpImg::ServerTcpImgEnd()
{
	TRACE( "[%08X] CServerTcpImg::ServerTcpImgEnd()\n", GetCurrentThreadId() );

	if(NULL == m_pServerSock){
		TRACE( "T[o[\Pbg͐Ă܂\n" );
		return;
	}

	// T[o[\Pbg̃N[Y
	m_pServerSock->Close();
	delete m_pServerSock;
	m_pServerSock = NULL;

	// ڑ̑S\PbgN[Y
	int nCnt = m_apServSocks.GetSize();
	for( int i = 0 ; i < nCnt ; i++ ){
		CWS2Tcp* pSock = (CWS2Tcp*)(m_apServSocks.GetAt(0));
		m_apServSocks.RemoveAt(0);
		pSock->Close();
		delete pSock;
	}

	// Xv[tH_̃t@CSč폜
	NkcComApi::ClearFolder( ::GetVirtualPrinter()->GetSpoolFolder() );
}
