// WS2UdpCmd.cpp: CWS2UdpCmd NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsServer.h"
#include "WS2UdpCmd.h"
#include "CmdBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CWS2UdpCmd::CWS2UdpCmd()
{
	TRACE( "[%08X] CWS2UdpCmd::CWS2UdpCmd()\n", GetCurrentThreadId() );

	{	// M̈̏
		::ZeroMemory( m_byBuffer, sizeof(m_byBuffer) );
		m_nBufferLen = 0;
	}
}

CWS2UdpCmd::~CWS2UdpCmd()
{
	TRACE( "[%08X] CWS2UdpCmd::~CWS2UdpCmd()\n", GetCurrentThreadId() );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : CWS2UdpCmd::OnReceive
//   ABSTRACT : I[o[Ch
//   FUNCTION : f[^M p
//////////////////////////////////////////////////////////////////////////////
void CWS2UdpCmd::OnReceive( int nErrorCode )
{
	CWS2Udp::OnReceive( nErrorCode );

	TRACE( "[%08X] CWS2UdpCmd::OnReceive()\n", GetCurrentThreadId() );

	TCHAR szHostAddress[64];
	UINT nHostPort;

	m_nBufferLen = ReceiveFrom( m_byBuffer, sizeof(m_byBuffer), szHostAddress, sizeof(szHostAddress), &nHostPort );

	if ( 0 < m_nBufferLen ) {
		CmdAnalyze( szHostAddress, (WORD)nHostPort, m_byBuffer );
	} else {
		TRACE( "ERR ReceiveFrom\n" );
	}

	{	// M̈̏
		::ZeroMemory( m_byBuffer, sizeof(m_byBuffer) );
		m_nBufferLen = 0;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2UdpCmd::CmdAnalyze()
//	ABSTRACT : NPSR}h̉͂sAύXB
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CWS2UdpCmd::CmdAnalyze( LPCTSTR lpszHostAddress, const WORD wPort, LPBYTE lpBuffer )
{
	WORD wInterfaceId;
	WORD wCommandId;

	if ( FALSE == ReadCmdHdr( lpBuffer, wInterfaceId, wCommandId ) ) {
		TRACE( "ERR ReadCmdHdr\n" );
		return;
	}

	TRACE( "Receive InterfaceId=%04XH wCommandId=%04XH\n", wInterfaceId, wCommandId );

	if ( FALSE == ReadCmdData( lpszHostAddress, wPort, lpBuffer + 4, wInterfaceId, wCommandId ) ) {
		TRACE( "ERR ReadCmdData\n" );
		return;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2UdpCmd::ReadCmdHdr()
//	ABSTRACT : NPSR}h̃wb_[擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2UdpCmd::ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId )
{
	WORD wId1;
	WORD wId2;

	::memcpy( &wId1, lpBuffer, sizeof(WORD) );
	::memcpy( &wId2, lpBuffer + sizeof(WORD), sizeof(WORD) );

	wInterfaceId = NkcComApi::ntohs( wId1 );
	wCommandId = NkcComApi::ntohs( wId2 );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2UdpCmd::ReadCmdData()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2UdpCmd::ReadCmdData( LPCTSTR lpszHostAddress, const WORD wPort, LPBYTE lpBuffer, WORD wInterfaceId, WORD wCommandId )
{
	BOOL bResult=FALSE;

	switch ( MAKELONG( wCommandId, wInterfaceId ) )
	{
	case 0x000F0100:	bResult = RCmd_000FH_0100H( lpszHostAddress, wPort, lpBuffer );	break;
	default:																			break;
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2UdpCmd::RCmd_000FH_0100H()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2UdpCmd::RCmd_000FH_0100H( LPCTSTR lpszHostAddress, const WORD wPort, LPBYTE lpBuffer )
{
	WORD wWord;
	WORD wTag;
	WORD wLength;
	LPBYTE pPoint = lpBuffer;

	while ( TRUE )
	{
		memcpy( &wWord, lpBuffer, sizeof(wTag) );	lpBuffer += sizeof(wWord);
		wTag = NkcComApi::ntohs( wWord );
		memcpy( &wWord, lpBuffer, sizeof(wTag) );	lpBuffer += sizeof(wWord);
		wLength = NkcComApi::ntohs( wWord );

		if (( 0 == wTag ) && ( 0 == wLength )) {
			// I[Ȃ̂ŏI
			break;
		}

		TRACE( "[Warning] Tag=%d, Length=%d\n", wTag, wLength );
		lpBuffer += wLength;
	}

	return WCmd_000FH_0101H( lpszHostAddress, wPort );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CWS2UdpCmd::WCmd_000FH_0101H()
//	ABSTRACT : 
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.27
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CWS2UdpCmd::WCmd_000FH_0101H( LPCTSTR lpszHostAddress, const WORD wPort )
{
	CCmdBuffer cBuffer;
	USHORT aResolutions[8];
	UCHAR aMacAddr[6];
	char szValue[20];

	cBuffer.Empty();

	// InterfaceId & CommandId
	cBuffer.AddHeader( 0x000F, 0x0101 );

	// Tag 1	@햼
	::GetVirtualPrinter()->m_cPrinterInfo.GetMachineTypeName( szValue, sizeof(szValue) );
	cBuffer.AddTagChar( 1, szValue, lstrlen( szValue ) + 1 );

	// Tag 2	VAԍ
	::GetVirtualPrinter()->m_cPrinterInfo.GetSerialNumber( szValue, sizeof(szValue) );
	cBuffer.AddTagChar( 2, szValue, lstrlen( szValue ) + 1 );

	// Tag 3	𑜓x iPʁF0.1 dpij
	::GetVirtualPrinter()->m_cPrinterInfo.GetSupportResolutions( aResolutions );
	cBuffer.AddTagShort( 3, (short*)aResolutions, COUNTOF(aResolutions) );

	// Tag 4	NPS I/F o[W
	cBuffer.AddTagShort( 4, ::GetVirtualPrinter()->m_cPrinterInfo.GetNpsVersion() );

	// Tag 5	MacAhX
	::GetVirtualPrinter()->m_cPrinterInfo.GetMacAddress( (unsigned char*)aMacAddr );
	cBuffer.AddTagChar( 5, (char*)aMacAddr, COUNTOF(aMacAddr) );

	// Tag 6	\tgEFA	2006.10.18 T.Mizushima
	::GetVirtualPrinter()->m_cPrinterInfo.GetSoftName( szValue, sizeof(szValue) );
	cBuffer.AddTagChar( 6, szValue, lstrlen( szValue ) + 1 );

	// Tag I[
	cBuffer.AddTagFooter();

	// ]
	SendTo( lpszHostAddress, wPort, cBuffer.GetBuffer(), cBuffer.GetBufferLen() );

	return TRUE;
}
