//////////////////////////////////////////////////////////////////////////////
//   File Name   : ComApi.cpp
//   Contents    : ʊ֐
//					
//   Author/Date : Y.Yoshinobu	2006.07.05
//	                                    (C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ComApi.h"

#include <Shlwapi.h>
#pragma comment( lib , "Shlwapi.lib" )

#if defined(NPS_CUSTOM_EDG)

#pragma pack(push, 2)
#include "NKC_Image_File_JPG_L6.h"
#include "NKC_Image_File_BMP_L2.h"
#include "NKC_Image_File_TIF_L1.h"
#pragma pack(pop)

//#define	RAW_READ_4BYTEBOUNDARY_JPEG
#define	RAW_READ_4BYTEBOUNDARY_BMP
#define	RAW_READ_4BYTEBOUNDARY_TIFF
#endif // defined(NPS_CUSTOM_EDG)

#define	MIN_USED_MEMORY		(1048576)		// 1MByte
#define	MAX_USED_MEMORY		(16777216)		// 16MByte

namespace COMAPI {

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : GetHostName
//   ABSTRACT : hostent ^̃f[^AzXg̖O擾܂
//   FUNCTION : hostent ^̃f[^AzXg̖O擾܂
//////////////////////////////////////////////////////////////////////////////
CString GetHostName( hostent* p )
{
	USES_CONVERSION;
	return CString( A2T( p->h_name ) );
}

//////////////////////////////////////////////////////////////////////////////
//   MODULE   : GetHostAddr
//   ABSTRACT : hostent ^̃f[^AzXg̃AhX擾܂
//   FUNCTION : hostent ^̃f[^AzXg̃AhX擾܂
//////////////////////////////////////////////////////////////////////////////
CString GetHostAddr( hostent* p )
{
	USES_CONVERSION;
	return CString( A2T( inet_ntoa( *(LPIN_ADDR)( p->h_addr_list[0] ) ) ) );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohs()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : short^
//////////////////////////////////////////////////////////////////////////////
unsigned short ntohs( unsigned short netshort )
{
	return ::ntohs( netshort );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohl()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : long^
//////////////////////////////////////////////////////////////////////////////
unsigned long ntohl( unsigned long netlong )
{
	return ::ntohl( netlong );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : int64^
//////////////////////////////////////////////////////////////////////////////
unsigned __int64 ntohi64( unsigned __int64 netint64 )
{
	union _NTOHI64_VAR {
		unsigned char		src_char[8];
		unsigned __int64	src_int64;
	};

	union _NTOHI64_VAR	var1;
	union _NTOHI64_VAR	var2;

	var1.src_int64 = netint64;

	var2.src_char[7] = var1.src_char[0];
	var2.src_char[6] = var1.src_char[1];
	var2.src_char[5] = var1.src_char[2];
	var2.src_char[4] = var1.src_char[3];
	var2.src_char[3] = var1.src_char[4];
	var2.src_char[2] = var1.src_char[5];
	var2.src_char[1] = var1.src_char[6];
	var2.src_char[0] = var1.src_char[7];

	return var2.src_int64;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohf()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[ɕϊ܂
//	FUNCTION : float^
//////////////////////////////////////////////////////////////////////////////
float ntohf( float netfloat )
{
	union _NTOHF_VAR {
		unsigned char		src_char[4];
		float				src_float;
	};

	union _NTOHF_VAR	var1;
	union _NTOHF_VAR	var2;

	var1.src_float = netfloat;

	var2.src_char[3] = var1.src_char[0];
	var2.src_char[2] = var1.src_char[1];
	var2.src_char[1] = var1.src_char[2];
	var2.src_char[0] = var1.src_char[3];

	return var2.src_float;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : short^
//////////////////////////////////////////////////////////////////////////////
unsigned short htons( unsigned short hostshort )
{
	return ::htons( hostshort );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : htonl()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : long^
//////////////////////////////////////////////////////////////////////////////
unsigned long htonl( unsigned long hostlong )
{
	return ::htonl( hostlong );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ntohi64()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : int64^
//////////////////////////////////////////////////////////////////////////////
unsigned __int64 htoni64( unsigned __int64 hostint64 )
{
	union _NTOHI64_VAR {
		unsigned char		src_char[8];
		unsigned __int64	src_int64;
	};

	union _NTOHI64_VAR	var1;
	union _NTOHI64_VAR	var2;

	var1.src_int64 = hostint64;

	var2.src_char[7] = var1.src_char[0];
	var2.src_char[6] = var1.src_char[1];
	var2.src_char[5] = var1.src_char[2];
	var2.src_char[4] = var1.src_char[3];
	var2.src_char[3] = var1.src_char[4];
	var2.src_char[2] = var1.src_char[5];
	var2.src_char[1] = var1.src_char[6];
	var2.src_char[0] = var1.src_char[7];

	return var2.src_int64;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : htonf()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[ɕϊ܂
//	FUNCTION : float^
//////////////////////////////////////////////////////////////////////////////
float htonf( float hostfloat )
{
	union _NTOHF_VAR {
		unsigned char		src_char[8];
		float				src_float;
	};

	union _NTOHF_VAR	var1;
	union _NTOHF_VAR	var2;

	var1.src_float = hostfloat;

	var2.src_char[3] = var1.src_char[0];
	var2.src_char[2] = var1.src_char[1];
	var2.src_char[1] = var1.src_char[2];
	var2.src_char[0] = var1.src_char[3];

	return var2.src_float;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WinSockCleanup()
//	ABSTRACT : WinSock 2.2 gpł悤ɂ܂
//	FUNCTION : WinSock 2.2 gpł悤ɂ܂
//////////////////////////////////////////////////////////////////////////////
BOOL WinSockStartup()
{
	int ret;
	unsigned short	wVersionRequired;
	WSADATA WSAData;

	// WinSock
	wVersionRequired = MAKEWORD(2,2);
	ret = WSAStartup( wVersionRequired, &WSAData );
	if ( 0 != ret ) {
		return FALSE;
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WinSockCleanup()
//	ABSTRACT : WinSock 2.2 ̎gpJ܂
//	FUNCTION : WinSock 2.2 ̎gpJ܂
//////////////////////////////////////////////////////////////////////////////
BOOL WinSockCleanup()
{
	int ret;

	// WinSock DLL ̎gpI
	ret = WSACleanup();
	if ( SOCKET_ERROR == ret ) {
		return FALSE;
	}
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : PingEx()
//	ABSTRACT : Pings܂
//	FUNCTION : 
//	RETURN   : TRUE:, FALSE:s
//////////////////////////////////////////////////////////////////////////////
enum{
	ICMP_ECHOREPLY		= 0,
	ICMP_ECHOREQ		= 8,
};
// IP Header -- RFC 791
typedef struct{
	u_char  VIHL;			// Version and IHL
	u_char	TOS;			// Type Of Service
	short	TotLen;			// Total Length
	short	ID;				// Identification
	short	FlagOff;		// Flags and Fragment Offset
	u_char	TTL;			// Time To Live
	u_char	Protocol;		// Protocol
	u_short	Checksum;		// Checksum
	struct	in_addr iaSrc;	// Internet Address - Source
	struct	in_addr iaDst;	// Internet Address - Destination
}IPHDR, *PIPHDR;
// ICMP Header - RFC 792
typedef struct tagICMPHDR
{
	u_char	Type;			// Type
	u_char	Code;			// Code
	u_short	Checksum;		// Checksum
	u_short	ID;				// Identification
	u_short	Seq;			// Sequence
	char	Data;			// Data
}ICMPHDR, *PICMPHDR;
enum{
	REQ_DATASIZE	= 32,		// Echo Request Data size
};
// ICMP Echo Request
typedef struct
{
	ICMPHDR icmpHdr;
	DWORD	dwTime;
	char	cData[REQ_DATASIZE];
}ECHOREQUEST, *PECHOREQUEST;
// ICMP Echo Reply
typedef struct
{
	IPHDR	ipHdr;
	ECHOREQUEST	echoRequest;
	char    cFiller[256];
}ECHOREPLY, *PECHOREPLY;

u_short in_cksum(u_short *addr, int len)
{
	register int nleft = len;
	register u_short *w = addr;
	register u_short answer;
	register int sum = 0;

	while( nleft > 1 )  {
		sum += *w++;
		nleft -= 2;
	}

	if( nleft == 1 ) {
		u_short	u = 0;

		*(u_char *)(&u) = *(u_char *)w ;
		sum += u;
	}

	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return (answer);
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : SendEchoRequest()
//  UPDATE	 : J.Fukumori(AVASYS) 2008.07.17 VS2005Ή
//////////////////////////////////////////////////////////////////////////////
int SendEchoRequest(SOCKET s,LPSOCKADDR_IN lpstToAddr) 
{
	static ECHOREQUEST echoReq;
	static unsigned short nId = 1;
	static unsigned short nSeq = 1;
	int nRet;

	// Fill in echo request
	echoReq.icmpHdr.Type		= ICMP_ECHOREQ;
	echoReq.icmpHdr.Code		= 0;
	echoReq.icmpHdr.Checksum	= 0;
	echoReq.icmpHdr.ID			= nId++;
	echoReq.icmpHdr.Seq			= nSeq++;

	// Fill in some data to send
	for (nRet = 0; nRet < REQ_DATASIZE; nRet++)
		echoReq.cData[nRet] = ' '+nRet;

	// Save tick count when sent
	echoReq.dwTime				= GetTickCount();

	// Put data in packet and compute checksum
	echoReq.icmpHdr.Checksum = in_cksum((u_short *)&echoReq, sizeof(ECHOREQUEST));

	// Send the echo request  								  
	nRet = sendto(s,						/* socket */
				 (LPSTR)&echoReq,			/* buffer */
				 sizeof(ECHOREQUEST),
				 0,							/* flags */
				 (LPSOCKADDR)lpstToAddr, /* destination */
				 sizeof(SOCKADDR_IN));   /* address length */

	if (nRet == SOCKET_ERROR) 
		return (nRet);

	return (nRet);
}

DWORD RecvEchoReply(SOCKET s, LPSOCKADDR_IN lpsaFrom, u_char *pTTL) 
{
	ECHOREPLY echoReply;
	int nRet;
	int nAddrLen = sizeof(struct sockaddr_in);

	// Receive the echo reply	
	nRet = recvfrom(s,					// socket
					(LPSTR)&echoReply,	// buffer
					sizeof(ECHOREPLY),	// size of buffer
					0,					// flags
					(LPSOCKADDR)lpsaFrom,	// From address
					&nAddrLen);			// pointer to address len

	// Check return value
	if (nRet == SOCKET_ERROR) 
		//ReportError("recvfrom()");
		return nRet;

	// return time sent and IP TTL
	*pTTL = echoReply.ipHdr.TTL;
	return(echoReply.echoRequest.dwTime);   		
}

int WaitForEchoReply(SOCKET s)
{
	struct timeval Timeout;
	fd_set readfds;

	readfds.fd_count = 1;
	readfds.fd_array[0] = s;
	Timeout.tv_sec = 1;
    Timeout.tv_usec = 0;

	return(select(1, &readfds, NULL, NULL, &Timeout));
}

BOOL PingEx(LPCSTR pstrHost)
{
	SOCKET	  rawSocket;
	LPHOSTENT lpHost;
	struct    sockaddr_in saDest;
	struct    sockaddr_in saSrc;
	u_char    cTTL;
	int       nRet;

	// Create a Raw socket
	rawSocket = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
	if (rawSocket == SOCKET_ERROR)
	{
		return FALSE;
	}

	// Lookup host
	lpHost = gethostbyname(pstrHost);
	if (lpHost == NULL)
	{
		return FALSE;
	}

	// Setup destination socket address
	saDest.sin_addr.s_addr = *((u_long FAR *) (lpHost->h_addr));
	saDest.sin_family = AF_INET;
	saDest.sin_port = 0;

	// Send ICMP echo request
	nRet = SendEchoRequest(rawSocket, &saDest);
	if(nRet == -1){
		// send
		nRet = closesocket(rawSocket);
		return FALSE;
	}

	// Use select() to wait for data to be received
	nRet = WaitForEchoReply(rawSocket);
	if (nRet == SOCKET_ERROR)
	{
		// select
		nRet = closesocket(rawSocket);
		return FALSE;
	}
	if (!nRet)
	{
		// TimeOut
		nRet = closesocket(rawSocket);
		return FALSE;
	}

	// Receive reply
	RecvEchoReply(rawSocket, &saSrc, &cTTL);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetFileSize()
//	ABSTRACT : t@C̃TCY擾܂
//	FUNCTION : t@C̃TCY擾܂
//////////////////////////////////////////////////////////////////////////////
unsigned long GetFileSize( LPCTSTR lpFilePath )
{
	BOOL	bRet;
	HANDLE	hFile;
	DWORD	dwSize;

	// 
	dwSize = 0;

	// t@C̃I[v
	hFile = ::CreateFile(
				lpFilePath,				// pointer to name of the file
				GENERIC_READ,			// access (read-write) mode
				FILE_SHARE_READ,		// share mode
				NULL,					// pointer to security attributes
				OPEN_EXISTING,			// how to create
				FILE_ATTRIBUTE_NORMAL,	// file attributes
				NULL
			);

	if ( hFile != INVALID_HANDLE_VALUE ) {

		// t@CTCY̊mF
		dwSize = ::GetFileSize( hFile, NULL );

		// t@C̃N[Y
		bRet = ::CloseHandle(hFile);
		if ( FALSE == bRet ) {
			return dwSize;
		}

	}

	return dwSize;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ReadFileToMemory()
//	ABSTRACT : t@C̃f[^ǂݍŃփRs[܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL ReadFileToMemory( LPCTSTR lpFilePath, unsigned long nOffset, unsigned long nReadSize, LPBYTE lpBuffer )
{
	BOOL bResult=FALSE;
	DWORD dwFileSize=0;
	DWORD dwBytesRead=0;
	HANDLE hFile=INVALID_HANDLE_VALUE;

	// t@C̃I[v
	hFile = ::CreateFile( lpFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

	if ( hFile != INVALID_HANDLE_VALUE )
	{

		// t@CTCY̊mF
		dwFileSize = ::GetFileSize( hFile, NULL );
		if ( dwFileSize >= ( nOffset + nReadSize ) )
		{
			// ItZbg̈ړ
			if ( INVALID_SET_FILE_POINTER != ::SetFilePointer( hFile, nOffset, NULL, FILE_BEGIN ) )
			{

				// t@Cǂݍ
				if ( TRUE == ReadFile( hFile, lpBuffer, nReadSize, &dwBytesRead, NULL ) )
				{
					// t@C烁ւ̓ǂݍ݂̂ŁA߂lTRUEZbg
					bResult = TRUE;
				}

			}
		}

		// t@C̃N[Y
		::CloseHandle( hFile );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WriteFileByMmf()
//	ABSTRACT : L̏t@Cɕۑ܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
#define NPS_DATAREADBYTE	( 1024 * 1024 * 2 )
BOOL WriteFileByMmf( LPCTSTR lpFilePath, LPCTSTR lpMmfName, unsigned long nOffset, unsigned long nDataSize )
{
	BOOL bResult = FALSE;
	HANDLE hMapFile;
	LPVOID lpMapView;
	DWORD dwCounter;
	DWORD dwOffset;
	DWORD dwBytes;
	DWORD dwTotalSize;
	DWORD dwAllocationGranularity;
	HANDLE hFile;
	long nDistanceLow;
	long nDistanceHigh;
	DWORD dwResult;
	DWORD dwWriteCount;
	SYSTEM_INFO info;

	// dwAllocationGranularity擾
	::GetSystemInfo( &info );
	dwAllocationGranularity = info.dwAllocationGranularity;

	// Lǂݍ݃[hŃI[v
	hMapFile = ::OpenFileMapping( FILE_MAP_READ, FALSE, lpMmfName );

	if ( NULL != hMapFile )
	{

		for ( dwBytes=0, dwCounter=0, dwTotalSize=0 ; nDataSize > dwTotalSize ; dwCounter++, dwTotalSize+=dwBytes )
		{
			dwOffset = ( ( dwTotalSize + nOffset ) / dwAllocationGranularity ) * dwAllocationGranularity;
			dwBytes = ( (NPS_DATAREADBYTE*(dwCounter+1)) > nDataSize ) ? nDataSize - (NPS_DATAREADBYTE*dwCounter) : NPS_DATAREADBYTE ;

			// L̃}bvɃI[v܂
			lpMapView = ::MapViewOfFile( hMapFile, FILE_MAP_READ, 0, dwOffset, dwBytes );

			// t@Cɏo܂
			hFile = ::CreateFile( lpFilePath, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
			if ( hFile != INVALID_HANDLE_VALUE )
			{

				// ItZbgI[Ɉړ
				nDistanceLow = 0;
				nDistanceHigh = 0;
				dwResult = ::SetFilePointer( hFile, nDistanceLow, &nDistanceHigh, FILE_END );
				if ( dwResult != 0xFFFFFFFF )
				{
					::WriteFile( hFile, lpMapView, dwBytes, &dwWriteCount, NULL );
				}

				// t@C̃N[Y
				::CloseHandle(hFile);

			}

			// L̃}bvN[Y܂
			if ( NULL != lpMapView )
			{
				::UnmapViewOfFile( lpMapView );
			}
		}

		CloseHandle( hMapFile );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CopyFileMid()
//	ABSTRACT : t@Cꕔ𔲂oāAʂ̃t@Cɕۑ܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL CopyFileMid( LPCTSTR lpInFileName, LPCTSTR lpOutFileName, unsigned long nOffset, unsigned long nDataSize )
{
	BOOL bResutl = FALSE;
	HANDLE hInFile;
	HANDLE hOutFile;
	DWORD dwInFileSize;

	BOOL bSuccess;
	DWORD dwBuffLen;
	LPBYTE lpBuff = NULL;

	DWORD dwRWCount;
	DWORD dwCopyBytes;
	DWORD dwRemainCopyBytes;

	if ( INVALID_HANDLE_VALUE != (hInFile=::CreateFile( lpInFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL )) )
	{
		// t@CTCY̊mF
		dwInFileSize = ::GetFileSize( hInFile, NULL );

		// ItZbg̈ړ
		if ( nOffset == ::SetFilePointer( hInFile, nOffset, NULL, FILE_BEGIN ) )
		{
			// ̊m
			bSuccess = TRUE;
			for ( dwBuffLen=MAX_USED_MEMORY ; MIN_USED_MEMORY <= dwBuffLen ; dwBuffLen /= 2 )
			{
				dwBuffLen = min( dwBuffLen, nDataSize );
				try
				{
					lpBuff = new BYTE [ dwBuffLen ];
				}
				catch( CMemoryException* e )
				{
					e->Delete();
					lpBuff = NULL;
					bSuccess = FALSE;
				}

				if ( TRUE == bSuccess )
				{
					break;
				}
			}

			if (( NULL != lpBuff ) &&
				( INVALID_HANDLE_VALUE != (hOutFile=::CreateFile( lpOutFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) ))
			{

				for ( dwRemainCopyBytes=nDataSize ; 0 != dwRemainCopyBytes ; dwRemainCopyBytes -= dwCopyBytes )
				{
					dwCopyBytes = min( dwBuffLen, dwRemainCopyBytes );
					if (( FALSE == ::ReadFile( hInFile, lpBuff, dwCopyBytes, &dwRWCount, NULL ) ) &&
						( dwCopyBytes == dwRWCount ))
					{
						break;
					}
					if (( FALSE == ::WriteFile( hOutFile, lpBuff, dwCopyBytes, &dwRWCount, NULL ) ) &&
						( dwCopyBytes == dwRWCount ))
					{
						break;
					}
				}

				if ( 0 == dwRemainCopyBytes )
				{
					bResutl = TRUE;
				}

				// t@C̃N[Y
				::CloseHandle(hOutFile);

				if ( FALSE == bResutl )
				{
					::DeleteFile( lpOutFileName );
				}
			}

			delete [] lpBuff;
		}

		// t@C̃N[Y
		::CloseHandle(hInFile);
	}

	return bResutl;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetTempFilePath()
//	ABSTRACT : e|tH_̎擾
//	FUNCTION : lpTempFolderPath Ŏw肵tH_̔zɃe|[t@C쐬܂
//           : lpTempFolderPath  NULL ̏ꍇ̓e|Ɏw肳ĂtH_ō쐬܂
//////////////////////////////////////////////////////////////////////////////
CString GetTempFolderPath( E_TempMode eMode )
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];
	TCHAR szTempFolder[MAX_PATH];
	CString	strFolderPath;

	// e|tH_̎擾
	switch ( eMode )
	{
	case TEMP_TEMP:
		::GetTempPath( MAX_PATH, szTempFolder );
		break;
	case TEMP_CURRENT:
		::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
#if _MSC_VER >= 1400
		::_splitpath_s( szModuleFilePath, drive, dir, fname, ext );
		::_makepath_s( szTempFolder, drive, dir, NULL, NULL );
#else
		::_splitpath( szModuleFilePath, drive, dir, fname, ext );
		::_makepath( szTempFolder, drive, dir, NULL, NULL );
#endif
		break;
	default:
		return strFolderPath;
		break;
	}

	strFolderPath = szTempFolder;

	return strFolderPath;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetTempFilePath()
//	ABSTRACT : e|t@C̎擾
//	FUNCTION : lpTempFolderPath Ŏw肵tH_̔zɃe|[t@C쐬܂
//           : lpTempFolderPath  NULL ̏ꍇ̓e|Ɏw肳ĂtH_ō쐬܂
//////////////////////////////////////////////////////////////////////////////
CString GetTempFilePath( E_TempMode eMode )
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];
	TCHAR szTempFolder[MAX_PATH];
	TCHAR szTempPath[MAX_PATH];
	CString	strFilePath;

	// e|tH_̎擾
	switch ( eMode )
	{
	case TEMP_TEMP:
		::GetTempPath( MAX_PATH, szTempFolder );
		break;
	case TEMP_CURRENT:
		::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
#if _MSC_VER >= 1400
		::_splitpath_s( szModuleFilePath, drive, dir, fname, ext );
		::_makepath_s( szTempFolder, drive, dir, NULL, NULL );
#else
		::_splitpath( szModuleFilePath, drive, dir, fname, ext );
		::_makepath( szTempFolder, drive, dir, NULL, NULL );
#endif
		break;
	default:
		return strFilePath;
		break;
	}

	// e|t@C̎擾
	::GetTempFileName( szTempFolder, "Nps", 0, szTempPath );

	strFilePath = szTempPath;

	return strFilePath;
}

BOOL GetTempFilePath( E_TempMode eMode, LPCTSTR lpExt, LPTSTR lpFilePath )
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];
	TCHAR szTempFolder[MAX_PATH];

	// e|tH_̎擾
	switch ( eMode )
	{
	case TEMP_TEMP:
		::GetTempPath( MAX_PATH, szTempFolder );
		break;
	case TEMP_CURRENT:
		::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
#if _MSC_VER >= 1400
		::_splitpath_s( szModuleFilePath, drive, dir, fname, ext );
		::_makepath_s( szTempFolder, drive, dir, NULL, NULL );
#else
		::_splitpath( szModuleFilePath, drive, dir, fname, ext );
		::_makepath( szTempFolder, drive, dir, NULL, NULL );
#endif
		break;
	default:
		return FALSE;
		break;
	}

	// e|t@C̍쐬
	::GetTempFileName( szTempFolder, "Nps", 0, lpFilePath );

	// gqt
	if ( NULL != lpExt )
	{
		::PathRemoveExtension( lpFilePath );	// gq "tmp" 폜Ăgqt܂
		::PathAddExtension( lpFilePath, lpExt );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : MakeFullPath()
//	ABSTRACT : tH_ƃt@CătpX쐬܂
//	FUNCTION : 
//	RETURN   : tpX
//////////////////////////////////////////////////////////////////////////////
CString MakeFullPath( LPCTSTR lpFolderPath, LPCTSTR lpFileName )
{
	TCHAR	szFilePath[MAX_PATH];

	::PathCombine( szFilePath, lpFolderPath, lpFileName );

	return CString( szFilePath );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CreateFolder()
//	ABSTRACT : w肳ꂽtH_쐬
//	FUNCTION : ċA֐
//	RETURN   : TRUE    
//             FALSE   s
//////////////////////////////////////////////////////////////////////////////
BOOL CreateFolder( LPCTSTR lpFolder )
{
	TCHAR	szFolder[MAX_PATH];
	TCHAR	szDrive[_MAX_DRIVE];
	TCHAR	szDir[_MAX_DIR];
	TCHAR	szFname[_MAX_FNAME];
	TCHAR	szExt[_MAX_EXT];

	// ΃pX͑ΏۊO
	if( TRUE == ::PathIsRelative( lpFolder ) ) {
		return FALSE;
	}

	// ݂t@CƈvĂꍇ͑ΏۊO
	if ( TRUE == ::PathFileExists( lpFolder ) ) {
		return FALSE;
	}

	// Root tH_mF
	if ( TRUE == ::PathIsRoot( lpFolder )) {
		return FALSE;
	}

#if _MSC_VER >= 1400
	_splitpath_s( lpFolder, szDrive, szDir, szFname, szExt );
	_makepath_s( szFolder, szDrive, szDir, NULL, NULL );
#else
	_tsplitpath( lpFolder, szDrive, szDir, szFname, szExt );
	_tmakepath( szFolder, szDrive, szDir, NULL, NULL );
#endif
	::PathRemoveBackslash( szFolder );

	if ( FALSE == ::PathFileExists( szFolder ) ) {
		if ( FALSE == CreateFolder( szFolder ) ) {
			return FALSE;
		}
	}

	// tH_̍쐬
	if ( FALSE == ::CreateDirectory( lpFolder, NULL ) ) {
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ClearFolder()
//	ABSTRACT : w肳ꂽtH_̒g폜Ăꂢɂ
//	FUNCTION : w肳ꂽtH_͏Ȃ
//	RETURN   : TRUE    
//             FALSE   s
//////////////////////////////////////////////////////////////////////////////
BOOL ClearFolder( LPCTSTR lpFolder )
{
	if ( !::PathFileExists( lpFolder ) ) {
		return FALSE;
	}

	TCHAR	szFilePath[MAX_PATH];
	TCHAR	szSearchPath[MAX_PATH];
	DWORD	dwFileAttributes;
	HANDLE	hFind;
	WIN32_FIND_DATA	FindFileData;

	::PathCombine( szSearchPath, lpFolder, "*.*" );

	hFind = ::FindFirstFile( szSearchPath, &FindFileData );
	if ( INVALID_HANDLE_VALUE != hFind ) {

		do
		{
			if ( FILE_ATTRIBUTE_OFFLINE & FindFileData.dwFileAttributes ) {
				// ItC̏ꍇɂ͑ΏۊO
				continue;
			}

			if (( 0 == ::lstrcmp( FindFileData.cFileName, "." )) ||
				( 0 == ::lstrcmp( FindFileData.cFileName, ".." ))) {
				// "." ܂ ".." ̏ꍇɂ͑ΏۊO
				continue;
			}

			// ΃pXɕϊ
			::PathCombine( szFilePath, lpFolder, FindFileData.cFileName );

			if ( FILE_ATTRIBUTE_READONLY & FindFileData.dwFileAttributes ) {
				// IɁAǂݎpO܂
				dwFileAttributes = ::GetFileAttributes( szFilePath );
				dwFileAttributes &= ~FILE_ATTRIBUTE_READONLY;
				::SetFileAttributes( szFilePath, dwFileAttributes );
			}

			if ( FILE_ATTRIBUTE_DIRECTORY & FindFileData.dwFileAttributes ) {
				// tH_̏ꍇ́AċAIɌĂяo
				//DeleteFolder( szFilePath );
				continue;
			}

			::DeleteFile( szFilePath );
		}
		while ( TRUE == ::FindNextFile( hFind, &FindFileData) );

		::FindClose( hFind );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : IsBmp24()
//	ABSTRACT : 24bit Windows BMP ǂ̊mF
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL IsBmp24( LPCTSTR lpFilePath )
{
	BOOL bResult = FALSE;
	DWORD dwSize;
	DWORD dwBytesRead;
	HANDLE hFile;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;

	// 
	bResult = FALSE;

	// t@C̃I[v
	hFile = ::CreateFile(
				lpFilePath,				// pointer to name of the file
				GENERIC_READ,			// access (read-write) mode
				FILE_SHARE_READ,		// share mode
				NULL,					// pointer to security attributes
				OPEN_EXISTING,			// how to create
				FILE_ATTRIBUTE_NORMAL,	// file attributes
				NULL
			);

	if ( hFile != INVALID_HANDLE_VALUE )
	{

		// t@CTCY̊mF
		dwSize = ::GetFileSize( hFile, NULL );

		if ( (sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) <= dwSize )
		{
			if ( TRUE == ReadFile( hFile, &bf, sizeof(BITMAPFILEHEADER), &dwBytesRead, NULL ) )
			{
				if ( sizeof(BITMAPFILEHEADER) == dwBytesRead )
				{
					if ( 0x4D42 == bf.bfType )
					{
						if ( TRUE == ReadFile( hFile, &bi, sizeof(BITMAPINFOHEADER), &dwBytesRead, NULL ) )
						{
							if ( sizeof(BITMAPINFOHEADER) == dwBytesRead )
							{
								if ( 24 == bi.biBitCount )
								{
									bResult = TRUE;
								}
							}
						}
					}
				}
			}
		}

		// t@C̃N[Y
		::CloseHandle(hFile);

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : DIBWidthBytes()
//	ABSTRACT : BITMAP̉摜f[^1C̃f[^ʂZo
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
DWORD DIBWidthBytes(DWORD dwWidth,int nBitCnt)
{
	DWORD	n = dwWidth * (nBitCnt / 8);
	return	n + ((4 - (n & 3)) & 3);
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetModuleFolder()
//	ABSTRACT : W[̂tH_pX擾
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
CString GetModuleFolder()
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char szModuleFilePath[MAX_PATH];
	char szModuleFolderPath[MAX_PATH];

	::GetModuleFileName( NULL, szModuleFilePath, MAX_PATH );
#if _MSC_VER >= 1400
	::_splitpath_s( szModuleFilePath, drive, dir, fname, ext );
	::_makepath_s( szModuleFolderPath, drive, dir, NULL, NULL );
#else
	::_splitpath( szModuleFilePath, drive, dir, fname, ext );
	::_makepath( szModuleFolderPath, drive, dir, NULL, NULL );
#endif

	return CString( szModuleFolderPath );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WritePrivateProfileString()
//	ABSTRACT : w肳ꂽ .ini t@ĆAw肳ꂽZNV
//             w肳ꂽL[ƂɊ֘Atꂽi[܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.3.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL WritePrivateProfileString( LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpString, LPCTSTR lpFileName )
{

	return ::WritePrivateProfileString( lpAppName, lpKeyName, lpString, lpFileName );

}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetPrivateProfileString()
//	ABSTRACT : w肳ꂽ .ini t@C̎w肳ꂽZNVɂ
//             w肳ꂽL[Ɋ֘AtĂ镶擾܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.3.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CString GetPrivateProfileString( LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefault, LPCTSTR lpFileName )
{
	CString	strReturnedString;

	if ( FALSE == ::PathFileExists( lpFileName ) ) {
		return lpDefault;
	}

	::GetPrivateProfileString( lpAppName, lpKeyName, lpDefault, strReturnedString.GetBuffer(1024), 1024, lpFileName );
	strReturnedString.ReleaseBuffer();

	return strReturnedString;
}

#if defined(NPS_CUSTOM_EDG)
//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ReverseLine()
//	ABSTRACT : 摜̏㉺t]܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
void ReverseLine( LPBYTE lpBuff, LPBYTE lpWork, DWORD dwLine, DWORD dwOneLineLen )
{
	DWORD dwIdx;
	DWORD dwCnt;

	if ( 1 < dwLine )
	{
		for ( dwCnt=dwLine/2, dwIdx=0 ; dwCnt > dwIdx ; dwIdx++ )
		{
			::MoveMemory( lpWork, lpBuff+(dwOneLineLen*dwIdx), dwOneLineLen );
			::MoveMemory( lpBuff+(dwOneLineLen*dwIdx), lpBuff+((dwLine-dwIdx-1)*dwOneLineLen), dwOneLineLen );
			::MoveMemory( lpBuff+((dwLine-dwIdx-1)*dwOneLineLen), lpWork, dwOneLineLen );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertJpgToBmp()
//	ABSTRACT : JPEG => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertJpgToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_JPG_L6* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if ( NULL != (hInst=::AfxLoadLibrary( "JPGconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_JPG_L6 *)Create( 6 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					//				OF̈̍ŏ́ABMP̃wb_傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );
						dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{
						// STEP-3	Bmp(24) t@C̃wb_[
						lpbf = (LPBITMAPFILEHEADER)lpBuff;
						lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

						// BITMAPINFOHEADER \̂̏
						::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
						lpbi->biSize = sizeof(BITMAPINFOHEADER);
						lpbi->biWidth = objSize.cx;
						lpbi->biHeight = objSize.cy;
						lpbi->biPlanes = 1;
						lpbi->biBitCount = 24;
						lpbi->biCompression = BI_RGB;
						lpbi->biSizeImage = dwImgLen;
						lpbi->biXPelsPerMeter = 0;
						lpbi->biYPelsPerMeter = 0;
						lpbi->biClrUsed = 0;
						lpbi->biClrImportant = 0;

						// BITMAPFILEHEADER \̂̏
						::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
						lpbf->bfType = 'MB';
						lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
						lpbf->bfReserved1 = 0;
						lpbf->bfReserved2 = 0;
						lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// wb_[̏
							dwBytesToWrite = lpbf->bfOffBits;
							if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
								( dwBytesToWrite == dwBytesWritten ))
							{
								// STEP-4	摜̃Rs[
								for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
								{
									// 1Ń֓ǂݍ߂svZ
									dwCopyLines = dwBuffLen / dwOneLineLen;

									if ( dwRemainLines < dwCopyLines )
									{
										dwCopyLines = dwRemainLines;
									}

									// gp郁eʂvZ
									dwCopyImgLen = dwCopyLines * dwOneLineLen;

									// t@C烁։摜ǂݍ
									if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
									{
										break;
									}

									// ݈ʒuړ
									dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
									if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
									{
										break;
									}

									// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
									dwBytesToWrite = dwOneLineLen;
									for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
									{
										if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
											( dwBytesToWrite != dwBytesWritten ))
										{
											break;
										}
									}
									if ( dwCopyLines != dwIdx )
									{
										break;
									}
								}

								if ( 0 == dwRemainLines )
								{
									bResult = TRUE;
								}
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
					
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertBmpToBmp()
//	ABSTRACT : BMP => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertBmpToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_BMP_L2* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if ( NULL != (hInst=::AfxLoadLibrary( "BMPconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					//				OF̈̍ŏ́ABMP̃wb_傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );
						dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{
						// STEP-3	Bmp(24) t@C̃wb_[
						lpbf = (LPBITMAPFILEHEADER)lpBuff;
						lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

						// BITMAPINFOHEADER \̂̏
						::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
						lpbi->biSize = sizeof(BITMAPINFOHEADER);
						lpbi->biWidth = objSize.cx;
						lpbi->biHeight = objSize.cy;
						lpbi->biPlanes = 1;
						lpbi->biBitCount = 24;
						lpbi->biCompression = BI_RGB;
						lpbi->biSizeImage = dwImgLen;
						lpbi->biXPelsPerMeter = 0;
						lpbi->biYPelsPerMeter = 0;
						lpbi->biClrUsed = 0;
						lpbi->biClrImportant = 0;

						// BITMAPFILEHEADER \̂̏
						::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
						lpbf->bfType = 'MB';
						lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
						lpbf->bfReserved1 = 0;
						lpbf->bfReserved2 = 0;
						lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// wb_[̏
							dwBytesToWrite = lpbf->bfOffBits;
							if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
								( dwBytesToWrite == dwBytesWritten ))
							{
								// STEP-4	摜̃Rs[
								for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
								{
									// 1Ń֓ǂݍ߂svZ
									dwCopyLines = dwBuffLen / dwOneLineLen;

									if ( dwRemainLines < dwCopyLines )
									{
										dwCopyLines = dwRemainLines;
									}

									// gp郁eʂvZ
									dwCopyImgLen = dwCopyLines * dwOneLineLen;

									// t@C烁։摜ǂݍ
									if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
									{
										break;
									}

									// ݈ʒuړ
									dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
									if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
									{
										break;
									}

									// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
									dwBytesToWrite = dwOneLineLen;
									for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
									{
										if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
											( dwBytesToWrite != dwBytesWritten ))
										{
											break;
										}
									}
									if ( dwCopyLines != dwIdx )
									{
										break;
									}
								}

								if ( 0 == dwRemainLines )
								{
									bResult = TRUE;
								}
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
					
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertTifToBmp()
//	ABSTRACT : TIFF => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertTifToBmp( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_TIF_L1* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if ( NULL != (hInst=::AfxLoadLibrary( "TIFconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_TIF_L1 *)Create( 1 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					//				OF̈̍ŏ́ABMP̃wb_傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );
						dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{
						// STEP-3	Bmp(24) t@C̃wb_[
						lpbf = (LPBITMAPFILEHEADER)lpBuff;
						lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

						// BITMAPINFOHEADER \̂̏
						::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
						lpbi->biSize = sizeof(BITMAPINFOHEADER);
						lpbi->biWidth = objSize.cx;
						lpbi->biHeight = objSize.cy;
						lpbi->biPlanes = 1;
						lpbi->biBitCount = 24;
						lpbi->biCompression = BI_RGB;
						lpbi->biSizeImage = dwImgLen;
						lpbi->biXPelsPerMeter = 0;
						lpbi->biYPelsPerMeter = 0;
						lpbi->biClrUsed = 0;
						lpbi->biClrImportant = 0;

						// BITMAPFILEHEADER \̂̏
						::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
						lpbf->bfType = 'MB';
						lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
						lpbf->bfReserved1 = 0;
						lpbf->bfReserved2 = 0;
						lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// wb_[̏
							dwBytesToWrite = lpbf->bfOffBits;
							if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
								( dwBytesToWrite == dwBytesWritten ))
							{
								// STEP-4	摜̃Rs[
								for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
								{
									// 1Ń֓ǂݍ߂svZ
									dwCopyLines = dwBuffLen / dwOneLineLen;

									if ( dwRemainLines < dwCopyLines )
									{
										dwCopyLines = dwRemainLines;
									}

									// gp郁eʂvZ
									dwCopyImgLen = dwCopyLines * dwOneLineLen;

									// t@C烁։摜ǂݍ
									if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
									{
										break;
									}

									// ݈ʒuړ
									dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
									if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
									{
										break;
									}

									// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
									dwBytesToWrite = dwOneLineLen;
									for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
									{
										if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
											( dwBytesToWrite != dwBytesWritten ))
										{
											break;
										}
									}
									if ( dwCopyLines != dwIdx )
									{
										break;
									}
								}

								if ( 0 == dwRemainLines )
								{
									bResult = TRUE;
								}
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
					
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}


//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertJpgToRaw()
//	ABSTRACT : JPEG => Raw(24) ϊi t@C ==> t@C j
//	FUNCTION : ʊ֐ŃvOCW[DLL[hς݂̏ꍇp ()
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertJpgToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_JPG_L6* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL == hInst )
	{
		return FALSE;
	}

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_JPG_L6 *)Create( 6 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_JPEG)
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
				dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// STEP-3	摜̃Rs[
						for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
						{
							// 1Ń֓ǂݍ߂svZ
							dwCopyLines = dwBuffLen / dwOneLineLen;

							if ( dwRemainLines < dwCopyLines )
							{
								dwCopyLines = dwRemainLines;
							}

							// gp郁eʂvZ
							dwCopyImgLen = dwCopyLines * dwOneLineLen;

							// t@C烁։摜ǂݍ
							if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
							{
								break;
							}
#if defined(RAW_READ_4BYTEBOUNDARY_JPEG)
							// t@C1sÂ摜 (4byteBoundary폜ď)
							dwBytesToWrite = objSize.cx * 3;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#else  // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
							// t@C1sÂ摜
							dwBytesToWrite = dwOneLineLen;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#endif // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
						}

						if ( 0 == dwRemainLines )
						{
							bResult = TRUE;
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertBmpToraw()
//	ABSTRACT : BMP => RAW(24) ϊi t@C ==> t@C j
//	FUNCTION : ʊ֐ŃvOCW[DLL[hς݂̏ꍇp ()
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertBmpToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_BMP_L2* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwDistanceToMove;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL == hInst )
	{
		return FALSE;
	}

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_BMP)
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_BMP)
				dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_BMP)
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// STEP-3	摜̃Rs[
						for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
						{
							// 1Ń֓ǂݍ߂svZ
							dwCopyLines = dwBuffLen / dwOneLineLen;

							if ( dwRemainLines < dwCopyLines )
							{
								dwCopyLines = dwRemainLines;
							}

							// gp郁eʂvZ
							dwCopyImgLen = dwCopyLines * dwOneLineLen;

							// t@C烁։摜ǂݍ
							if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
							{
								break;
							}

							// ݈ʒuړ
							dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen;
							if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
							{
								break;
							}

#if defined(RAW_READ_4BYTEBOUNDARY_BMP)
							// t@C1sÂ摜 (4byteBoundary폜ď)
							dwBytesToWrite = objSize.cx * 3;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#else  // defined(RAW_READ_4BYTEBOUNDARY_BMP)
							// t@C1sÂ摜
							dwBytesToWrite = dwOneLineLen;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#endif // defined(RAW_READ_4BYTEBOUNDARY_BMP)
						}

						if ( 0 == dwRemainLines )
						{
							bResult = TRUE;
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertTifToRaw()
//	ABSTRACT : TIFF => Raw(24) ϊi t@C ==> t@C j
//	FUNCTION : ʊ֐ŃvOCW[DLL[hς݂̏ꍇp ()
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertTifToRaw( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_TIF_L1* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL == hInst )
	{
		return FALSE;
	}

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_TIF_L1 *)Create( 1 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_TIFF)
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
				dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// STEP-3	摜̃Rs[
						for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
						{
							// 1Ń֓ǂݍ߂svZ
							dwCopyLines = dwBuffLen / dwOneLineLen;

							if ( dwRemainLines < dwCopyLines )
							{
								dwCopyLines = dwRemainLines;
							}

							// gp郁eʂvZ
							dwCopyImgLen = dwCopyLines * dwOneLineLen;

							// t@C烁։摜ǂݍ
							if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
							{
								break;
							}
#if defined(RAW_READ_4BYTEBOUNDARY_TIFF)
							// t@C1sÂ摜 (4byteBoundary폜ď)
							dwBytesToWrite = objSize.cx * 3;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#else  // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
							// t@C1sÂ摜
							dwBytesToWrite = dwOneLineLen;
							for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
							{
								if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
									( dwBytesToWrite != dwBytesWritten ))
								{
									break;
								}
							}
							if ( dwCopyLines != dwIdx )
							{
								break;
							}
#endif // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
						}

						if ( 0 == dwRemainLines )
						{
							bResult = TRUE;
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertJpgToBmp()
//	ABSTRACT : JPEG => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : ϊɎsꍇ́AlpOutFilePath̃t@C͍폜܂B
//	RETURN   : TRUE:, FALSE:s
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertJpgToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_JPG_L6* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_JPG_L6 *)Create( 6 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				//				OF̈̍ŏ́ABMP̃wb_傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );
					dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{
					// STEP-3	Bmp(24) t@C̃wb_[
					lpbf = (LPBITMAPFILEHEADER)lpBuff;
					lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

					// BITMAPINFOHEADER \̂̏
					::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
					lpbi->biSize = sizeof(BITMAPINFOHEADER);
					lpbi->biWidth = objSize.cx;
					lpbi->biHeight = objSize.cy;
					lpbi->biPlanes = 1;
					lpbi->biBitCount = 24;
					lpbi->biCompression = BI_RGB;
					lpbi->biSizeImage = dwImgLen;
					lpbi->biXPelsPerMeter = 0;
					lpbi->biYPelsPerMeter = 0;
					lpbi->biClrUsed = 0;
					lpbi->biClrImportant = 0;

					// BITMAPFILEHEADER \̂̏
					::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
					lpbf->bfType = 'MB';
					lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
					lpbf->bfReserved1 = 0;
					lpbf->bfReserved2 = 0;
					lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// wb_[̏
						dwBytesToWrite = lpbf->bfOffBits;
						if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
							( dwBytesToWrite == dwBytesWritten ))
						{
							// STEP-4	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}

								// ݈ʒuړ
								dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
								if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
								{
									break;
								}

								// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
								dwBytesToWrite = dwOneLineLen;
								for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
				
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertBmpToBmp()
//	ABSTRACT : BMP => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : ϊɎsꍇ́AlpOutFilePath̃t@C͍폜܂B
//	RETURN   : TRUE:, FALSE:s
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertBmpToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_BMP_L2* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				//				OF̈̍ŏ́ABMP̃wb_傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );
					dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{
					// STEP-3	Bmp(24) t@C̃wb_[
					lpbf = (LPBITMAPFILEHEADER)lpBuff;
					lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

					// BITMAPINFOHEADER \̂̏
					::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
					lpbi->biSize = sizeof(BITMAPINFOHEADER);
					lpbi->biWidth = objSize.cx;
					lpbi->biHeight = objSize.cy;
					lpbi->biPlanes = 1;
					lpbi->biBitCount = 24;
					lpbi->biCompression = BI_RGB;
					lpbi->biSizeImage = dwImgLen;
					lpbi->biXPelsPerMeter = 0;
					lpbi->biYPelsPerMeter = 0;
					lpbi->biClrUsed = 0;
					lpbi->biClrImportant = 0;

					// BITMAPFILEHEADER \̂̏
					::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
					lpbf->bfType = 'MB';
					lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
					lpbf->bfReserved1 = 0;
					lpbf->bfReserved2 = 0;
					lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// wb_[̏
						dwBytesToWrite = lpbf->bfOffBits;
						if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
							( dwBytesToWrite == dwBytesWritten ))
						{
							// STEP-4	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}

								// ݈ʒuړ
								dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
								if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
								{
									break;
								}

								// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
								dwBytesToWrite = dwOneLineLen;
								for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
				
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertTifToBmp()
//	ABSTRACT : TIFF => BMP(24) ϊi t@C ==> t@C j
//	FUNCTION : ϊɎsꍇ́AlpOutFilePath̃t@C͍폜܂B
//	RETURN   : TRUE:, FALSE:s
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertTifToBmp( HMODULE hInst, LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	NKC_Image_File_TIF_L1* pInFile;

	HANDLE hFile;
	DWORD dwDistanceToMove;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwIdx;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	LPBITMAPFILEHEADER	lpbf;
	LPBITMAPINFOHEADER	lpbi;

	if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
		( NULL != (pInFile=(NKC_Image_File_TIF_L1 *)Create( 1 )) ))
	{

		if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
		{

			// STEP-1	摜̃TCY擾܂
			objSize = pInFile->GetImageSize();

			if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
			{
				if ( NULL != pImgSize )
				{
					pImgSize->cx = objSize.cx;
					pImgSize->cy = objSize.cy;
				}

				// 1Cǂݍނ̂ɕKvȃTCY̌vZ
				dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
				dwImgLen = dwOneLineLen * objSize.cy;

				// STEP-2	Ɨp̃̈mۂ
				//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
				//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
				//				OF̈̍ŏ́A摜1s̃TCY傫
				//				OF̈̍ŏ́ABMP̃wb_傫
				for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
				{
					// 摜Ƃ́A摜TCYmۂ
					dwBuffLen = min( dwBuffLen, dwImgLen );
					dwBuffLen = max( dwBuffLen,  (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)) );	// ŒKvȗe

					try
					{
						lpBuff = new BYTE [ dwBuffLen ];
					}
					catch( CMemoryException* e )
					{
						e->Delete();
						lpBuff = NULL;
					}

					if ( NULL != lpBuff )
					{
						break;
					}
				}

				if ( NULL != lpBuff )
				{
					// STEP-3	Bmp(24) t@C̃wb_[
					lpbf = (LPBITMAPFILEHEADER)lpBuff;
					lpbi = (LPBITMAPINFOHEADER)(lpBuff + sizeof(BITMAPFILEHEADER));

					// BITMAPINFOHEADER \̂̏
					::ZeroMemory( lpbi, sizeof(BITMAPINFOHEADER) );
					lpbi->biSize = sizeof(BITMAPINFOHEADER);
					lpbi->biWidth = objSize.cx;
					lpbi->biHeight = objSize.cy;
					lpbi->biPlanes = 1;
					lpbi->biBitCount = 24;
					lpbi->biCompression = BI_RGB;
					lpbi->biSizeImage = dwImgLen;
					lpbi->biXPelsPerMeter = 0;
					lpbi->biYPelsPerMeter = 0;
					lpbi->biClrUsed = 0;
					lpbi->biClrImportant = 0;

					// BITMAPFILEHEADER \̂̏
					::ZeroMemory( lpbf, sizeof(BITMAPFILEHEADER) );
					lpbf->bfType = 'MB';
					lpbf->bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + lpbi->biSizeImage;
					lpbf->bfReserved1 = 0;
					lpbf->bfReserved2 = 0;
					lpbf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

					if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
					{
						// wb_[̏
						dwBytesToWrite = lpbf->bfOffBits;
						if (( TRUE==::WriteFile( hFile, lpBuff, dwBytesToWrite, &dwBytesWritten, NULL ) ) &&
							( dwBytesToWrite == dwBytesWritten ))
						{
							// STEP-4	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}

								// ݈ʒuړ
								dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
								if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
								{
									break;
								}

								// t@C1sÂ摜 (ꊇŏ݂s1sÂ݂sx)
								dwBytesToWrite = dwOneLineLen;
								for ( dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}
						}

						::CloseHandle( hFile );

						// Rs[ŝŃt@C폜
						if ( FALSE == bResult )
						{
							::DeleteFile( lpOutFilePath );
						}
					}

				}

				// ̊J
				if ( NULL != lpBuff )
				{
					delete [] lpBuff;
				}
				
			}

			// Close()
			pInFile->Close();

		}

		delete pInFile;

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertJpgToRaw()
//	ABSTRACT : JPEG => Raw(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertJpgToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_JPG_L6* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL != (hInst=::AfxLoadLibrary( "JPGconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_JPG_L6 *)Create( 6 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_JPEG)
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
					dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// STEP-3	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}
#if defined(RAW_READ_4BYTEBOUNDARY_JPEG)
								// t@C1sÂ摜 (4byteBoundary폜ď)
								dwBytesToWrite = objSize.cx * 3;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#else  // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
								// t@C1sÂ摜
								dwBytesToWrite = dwOneLineLen;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#endif // defined(RAW_READ_4BYTEBOUNDARY_JPEG)
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertBmpToraw()
//	ABSTRACT : BMP => RAW(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertBmpToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_BMP_L2* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwDistanceToMove;
	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL != (hInst=::AfxLoadLibrary( "BMPconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_BMP)
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_BMP)
					dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_BMP)
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// STEP-3	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}

								// ݈ʒuړ
								dwDistanceToMove = ( dwRemainLines - dwCopyLines ) * dwOneLineLen;
								if ( dwDistanceToMove != ::SetFilePointer( hFile, dwDistanceToMove, NULL, FILE_BEGIN ) )
								{
									break;
								}

#if defined(RAW_READ_4BYTEBOUNDARY_BMP)
								// t@C1sÂ摜 (4byteBoundary폜ď)
								dwBytesToWrite = objSize.cx * 3;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#else  // defined(RAW_READ_4BYTEBOUNDARY_BMP)
								// t@C1sÂ摜
								dwBytesToWrite = dwOneLineLen;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#endif // defined(RAW_READ_4BYTEBOUNDARY_BMP)
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertTifToRaw()
//	ABSTRACT : TIFF => Raw(24) ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertTifToRaw( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	BOOL bResult = FALSE;
	CSize objSize;
	CREATE Create;
	HMODULE hInst;
	NKC_Image_File_TIF_L1* pInFile;

	HANDLE hFile;
	DWORD dwBytesToWrite;
	DWORD dwBytesWritten;

	DWORD dwBuffLen;
	DWORD dwOneLineLen;
	LPBYTE lpBuff = NULL;

	DWORD dwCopyLines;
	DWORD dwRemainLines;
	DWORD dwCopyImgLen;
	DWORD dwImgLen;

	if ( NULL != (hInst=::AfxLoadLibrary( "TIFconv.dll" )) )
	{

		if (( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) ) &&
			( NULL != (pInFile=(NKC_Image_File_TIF_L1 *)Create( 1 )) ))
		{

			if ( TRUE == pInFile->Open( lpInFilePath, NKC_Image_File::modeRead | NKC_Image_File::RGB24 ) )
			{

				// STEP-1	摜̃TCY擾܂
				objSize = pInFile->GetImageSize();

				if (( objSize.cx != 0 ) && ( objSize.cy != 0 ))
				{
					if ( NULL != pImgSize )
					{
						pImgSize->cx = objSize.cx;
						pImgSize->cy = objSize.cy;
					}

					// 1Cǂݍނ̂ɕKvȃTCY̌vZ
#if defined(RAW_READ_4BYTEBOUNDARY_TIFF)
					dwOneLineLen = DIBWidthBytes( objSize.cx, 24 );
#else  // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
					dwOneLineLen = objSize.cx * 3;
#endif // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
					dwImgLen = dwOneLineLen * objSize.cy;

					// STEP-2	Ɨp̃̈mۂ
					//			MAX_USED_MEMORY  MIN_USED_MEMORY ܂Ŋmۂł܂ŏɎ݂
					//				OF摜TCY MAX_USED_MEMORY ȉ̏ꍇ͉摜TCY擾
					//				OF̈̍ŏ́A摜1s̃TCY傫
					for ( dwBuffLen=MAX_USED_MEMORY ; max( MIN_USED_MEMORY, dwOneLineLen ) <= dwBuffLen ; dwBuffLen /= 2 )
					{
						// 摜Ƃ́A摜TCYmۂ
						dwBuffLen = min( dwBuffLen, dwImgLen );

						try
						{
							lpBuff = new BYTE [ dwBuffLen ];
						}
						catch( CMemoryException* e )
						{
							e->Delete();
							lpBuff = NULL;
						}

						if ( NULL != lpBuff )
						{
							break;
						}
					}

					if ( NULL != lpBuff )
					{

						if ( INVALID_HANDLE_VALUE != (hFile=::CreateFile( lpOutFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL )) )
						{
							// STEP-3	摜̃Rs[
							for ( dwRemainLines=objSize.cy ; 0 != dwRemainLines ; dwRemainLines -= dwCopyLines )
							{
								// 1Ń֓ǂݍ߂svZ
								dwCopyLines = dwBuffLen / dwOneLineLen;

								if ( dwRemainLines < dwCopyLines )
								{
									dwCopyLines = dwRemainLines;
								}

								// gp郁eʂvZ
								dwCopyImgLen = dwCopyLines * dwOneLineLen;

								// t@C烁։摜ǂݍ
								if ( dwCopyLines != (DWORD)pInFile->Read( lpBuff, dwCopyLines ) )
								{
									break;
								}
#if defined(RAW_READ_4BYTEBOUNDARY_TIFF)
								// t@C1sÂ摜 (4byteBoundary폜ď)
								dwBytesToWrite = objSize.cx * 3;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#else  // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
								// t@C1sÂ摜
								dwBytesToWrite = dwOneLineLen;
								for ( DWORD dwIdx=0 ; dwCopyLines > dwIdx ; dwIdx++ )
								{
									if (( FALSE==::WriteFile( hFile, lpBuff + (dwOneLineLen*(dwCopyLines-dwIdx-1)), dwBytesToWrite, &dwBytesWritten, NULL ) ) ||
										( dwBytesToWrite != dwBytesWritten ))
									{
										break;
									}
								}
								if ( dwCopyLines != dwIdx )
								{
									break;
								}
#endif // defined(RAW_READ_4BYTEBOUNDARY_TIFF)
							}

							if ( 0 == dwRemainLines )
							{
								bResult = TRUE;
							}

							::CloseHandle( hFile );

							// Rs[ŝŃt@C폜
							if ( FALSE == bResult )
							{
								::DeleteFile( lpOutFilePath );
							}
						}

					}

					// ̊J
					if ( NULL != lpBuff )
					{
						delete [] lpBuff;
					}
				}

				// Close()
				pInFile->Close();

			}

			delete pInFile;

		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : FileConvertBmpToJpg()
//	ABSTRACT : BMP => JPEG ϊi t@C ==> t@C j
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL FileConvertBmpToJpg( LPCTSTR lpInFilePath, LPCTSTR lpOutFilePath, SIZE* pImgSize )
{
	SIZE ImgSize;
	LPBYTE lpBuff = NULL;

	// BMP t@C̏擾
	if ( FALSE == GetBmpInfo( lpInFilePath, &ImgSize ) )
	{
		return FALSE;
	}

	// 摜ǂݍݗ̈mۂ
	try
	{
		lpBuff = new BYTE [ WIDTHBYTES(24 * ImgSize.cx) * ImgSize.cy ];
	}
	catch( CMemoryException* e )
	{
		e->Delete();
		return FALSE;
	}

	// BMP t@C̓ǂݍ
	if ( FALSE == ReadProcBmp( lpInFilePath, &ImgSize, lpBuff ) )
	{
		delete [] lpBuff;
		return FALSE;
	}

	// JPEG t@C̏
	if ( FALSE == WriteProcJpg( lpOutFilePath, &ImgSize, 100, lpBuff ) )
	{
		delete [] lpBuff;
		return FALSE;
	}

	// 摜ǂݍݗ̈̊J
	delete [] lpBuff;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetBmpInfo()
//	ABSTRACT : BMP t@C̏擾܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL GetBmpInfo( LPCTSTR lpFilePath, SIZE* pSize )
{
	BOOL bResult = FALSE;
	CREATE Create;
	HMODULE	hInst;
	NKC_Image_File_BMP_L2* pFile;


	if ( NULL != (hInst=::AfxLoadLibrary( "BMPconv.dll" )) )
	{

		if ( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) )
		{

			if ( NULL != (pFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) )
			{

				if ( TRUE == pFile->Open( lpFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
				{

					// GetImageSize()
					*pSize = pFile->GetImageSize();

					if (( pSize->cx != 0 ) && ( pSize->cy != 0 ))
					{
						bResult = TRUE;
					}

					// Close()
					pFile->Close();

				}

				delete pFile;

			}
		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : ReadProcBmp()
//	ABSTRACT : BMP t@C̉摜ǂݍ݂܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL ReadProcBmp( LPCTSTR lpFilePath, SIZE* pSize, LPVOID pImg )
{
	BOOL bResult = FALSE;
	CSize cSize;
	CREATE Create;
	HMODULE	hInst;
	NKC_Image_File_BMP_L2* pFile;

	if (( 0 == pSize->cx ) || ( 0 == pSize->cy ))
	{
		return FALSE;
	}

	if ( NULL == pImg )
	{
		return FALSE;
	}

	if ( NULL != (hInst=::AfxLoadLibrary( "BMPconv.dll" )) )
	{

		if ( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) )
		{

			if ( NULL != (pFile=(NKC_Image_File_BMP_L2 *)Create( 2 )) )
			{

				if ( TRUE == pFile->Open( lpFilePath, NKC_Image_File::modeRead | NKC_Image_File::BGR24 ) )
				{

					// GetImageSize()
					cSize = pFile->GetImageSize();
					if (( cSize.cx == pSize->cx ) && ( cSize.cy == pSize->cy ))
					{

						// Read() Ssꊇœǂݍ
						if ( pSize->cy == pFile->Read( pImg, pSize->cy ) )
						{
							bResult = TRUE;
						}

					}

					// Close()
					pFile->Close();

				}

				delete pFile;

			}
		}

		::AfxFreeLibrary( hInst );

	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : WriteProcJpg()
//	ABSTRACT : JPEG t@C̉摜݂܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL WriteProcJpg( LPCTSTR lpFilePath, SIZE* pSize, int nQuality, LPVOID pImg )
{
	BOOL bResult = FALSE;
	CSize cSize( *pSize );
	CREATE Create;
	HMODULE	hInst;
	NKC_Image_File_JPG_L6* pFile;

	if (( 0 == pSize->cx ) || ( 0 == pSize->cy ))
	{
		return FALSE;
	}

	if ( NULL == pImg )
	{
		return FALSE;
	}

	if ( NULL != (hInst=::AfxLoadLibrary( "JPGconv.dll" )) )
	{

		if ( NULL != (Create=(CREATE)::GetProcAddress( hInst, "Create" )) )
		{

			if ( NULL != (pFile=(NKC_Image_File_JPG_L6 *)Create( 6 )) )
			{

				if ( TRUE == pFile->Open( lpFilePath, NKC_Image_File_JPG_L6::modeWrite | NKC_Image_File_JPG_L6::BGR24 ) )
				{

					// SetQuality()
					pFile->SetQuality( nQuality );

					// SetWriteMode()
					pFile->SetWriteMode( NKC_Image_File_JPG_L6::Normal );

					// SetImageSize()
					if ( TRUE == pFile->SetImageSize( cSize ) )
					{

						// Write() Ssꊇŏ
						if ( cSize.cy == pFile->Write( pImg, cSize.cy ) )
						{
							bResult = TRUE;
						}

					}

					// Close()
					pFile->Close();

				}

				delete pFile;

			}
		}

		::AfxFreeLibrary( hInst );						// DLL UnLoad

	}

	return bResult;
}
#endif // defined(NPS_CUSTOM_EDG)

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetDayofweek()
//	ABSTRACT : j	0ijj-6iyjj擾܂
//	FUNCTION : j	0ijj-6iyjj擾܂
//////////////////////////////////////////////////////////////////////////////
DWORD GetDayofweek(
						DWORD	dwYear,			// N	1980-2079
						DWORD	dwMonth,		// 	1-12
						DWORD	dwDay			// 	1-31
						)
{
	if(
		( 0 == dwYear )		||
		( 0 == dwMonth )	|| ( 12 < dwMonth ) ||
		( 0 == dwDay )		|| ( 31 < dwDay )
		)
	{
		return 0;
	}

	COleDateTime	wTime( dwYear, dwMonth, dwDay, 12, 0, 0 );

	return wTime.GetDayOfWeek() - 1;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : MyUTCToLocalTime()
//	ABSTRACT : UTCLocalTimeɕϊ܂
//	FUNCTION : UTCLocalTimeɕϊ܂
//////////////////////////////////////////////////////////////////////////////
SYSTEMTIME MyUTCToLocalTime( SYSTEMTIME utc )
{
	SYSTEMTIME	localtime;

	SystemTimeToTzSpecificLocalTime( NULL,&utc,&localtime );

	return localtime;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CommaFieldSeparate()
//	ABSTRACT : ","J}ŋ؂ꂽ擾܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL CommaFieldSeparate( int nPos, LPSTR lpSrc, LPSTR lpDest )
{
	int nIdx;
	int nLen;
	LPSTR lpStart;
	LPSTR lpEnd;

	lpStart = lpEnd = lpSrc;
	for ( nIdx=1 ; ; nIdx++ )
	{
		lpEnd = _tcschr( lpStart, ',' );

		if ( NULL == lpEnd )
		{
			nLen = (int)_tcslen( lpStart );

			if ( 0 < nLen )
			{
				lpEnd = lpStart + nLen;

				// Op󔒂̍폜
				while ( ' ' == *lpStart )
				{
					lpStart++;
				}
				nLen = int( lpEnd - lpStart );
				::MoveMemory( lpDest, lpStart, nLen );
				// p󔒂̍폜
				for ( nLen--, lpEnd = lpDest + nLen ; 0 < nLen ; nLen-- )
				{
					if ( ' ' == *lpEnd )
					{
						*lpEnd = '\0';
						lpEnd--;
						continue;
					}
					break;
				}
				return TRUE;
			}
		}

		if ( nPos == nIdx )
		{
			// Op󔒂̍폜
			while ( ' ' == *lpStart )
			{
				lpStart++;
			}
			nLen = int( lpEnd - lpStart );
			::MoveMemory( lpDest, lpStart, nLen );
			// p󔒂̍폜
			for ( nLen--, lpEnd = lpDest + nLen ; 0 < nLen ; nLen-- )
			{
				if ( ' ' == *lpEnd )
				{
					*lpEnd = '\0';
					lpEnd--;
					continue;
				}
				break;
			}
			return TRUE;
		}

		lpStart = lpEnd + 1;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : GetRegString()
//	ABSTRACT : WXg當擾܂
//	FUNCTION : 
//	UPDATE   : Y.Yoshinobu	2010.08.04	64bitőΉ
//////////////////////////////////////////////////////////////////////////////
BOOL GetRegString( HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpValueName, CString& string, CString* pstrErrMsg )
{
	LONG nResult;
	BOOL bResult=FALSE;
	HKEY hkResult;
	DWORD dwType;
	DWORD dwByte;
	CString strSubKey = lpSubKey;

#if defined( _WIN64 )
	// 64bitł"HKEY_LOCAL_MACHINE\SOFTWARE"QƂƂ͋I
	// "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432node"QƂ悤ɕύX
	CString strSoftware32 = "SOFTWARE\\";
	CString strSoftware64 = "SOFTWARE\\Wow6432node\\";
	if ( HKEY_LOCAL_MACHINE == hKey )
	{
		if ( 0 == strSubKey.FindOneOf(strSoftware32) )
		{
			// 擪"SOFTWARE\\"Ŏn܂ĂƂ
			// "SOFTWARE\\Wow6432node"ɒu
			strSubKey.Delete( 0, strSoftware32.GetLength() );
			strSubKey.Insert( 0, strSoftware64 );
		}
	}
#endif

	if ( NULL != pstrErrMsg )
	{
		pstrErrMsg->Empty();
	}

	nResult = ::RegOpenKeyEx( hKey, strSubKey, 0, KEY_READ, &hkResult );
	if ( ERROR_SUCCESS == nResult )
	{
		dwByte = MAX_PATH;
		nResult = ::RegQueryValueEx( hkResult, lpValueName, NULL, &dwType, (LPBYTE)string.GetBuffer( dwByte ), &dwByte );
		if ( ERROR_SUCCESS == nResult )
		{
			string.ReleaseBuffer();
			bResult = TRUE;
		}
		else
		{
			if ( NULL != pstrErrMsg )
			{
				pstrErrMsg->Format( "   RegQueryValueEx( %s ) FAIL( %d )", lpValueName, nResult );
			}
		}
		::RegCloseKey( hkResult );
	}
	else
	{
		if ( NULL != pstrErrMsg )
		{
			pstrErrMsg->Format( "   RegOpenKeyEx( %s ) FAIL( %d )", strSubKey, nResult );
		}
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : StartProcess()
//	ABSTRACT : vZXN܂
//	FUNCTION : 
//////////////////////////////////////////////////////////////////////////////
BOOL StartProcess( LPCTSTR lpCommandLine, BOOL bInitWait )
{
	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInfo;

	// ϐ̏
	::ZeroMemory( &StartupInfo, sizeof(StartupInfo) );
	StartupInfo.cb		= sizeof(STARTUPINFO);
	StartupInfo.dwFlags	= STARTF_FORCEONFEEDBACK;
	::ZeroMemory( &ProcessInfo, sizeof(ProcessInfo) );

	// vZXN
	if( FALSE == ::CreateProcess(
					NULL,					// s\W[̖O(2Ԗڂ̈őp)
					(char*)lpCommandLine,	// R}hC̕
					NULL,					// ZLeBLqq
					NULL,					// ZLeBLqq
					FALSE,					// nȟpIvV
					NORMAL_PRIORITY_CLASS,	// 쐬̃tO
					NULL,					// VubN
					NULL,					// JgfBNg̖O
					&StartupInfo,			// X^[gAbv
					&ProcessInfo))			// vZX
	{
		int nErr = GetLastError();
		return FALSE;
	}

	if ( TRUE == bInitWait )
	{
		// vZX̏([U[̓͂҂ĂԂɂȂ܂)܂őҋ@
		::WaitForInputIdle( ProcessInfo.hProcess, INFINITE );
	}

	return TRUE;
}

}	// namespace COMAPI
