//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : Dib24.cpp
//	ABSTRACT  : DIB ̃x[Xi24BitjNX
//	
//	CREATE    : Y.Yoshinobu	2004.1.5
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

// Dib24.cpp: CDib24 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ComApi.h"
#include "Dib24.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::CDib24()
//	ABSTRACT : RXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDib24::CDib24()
{
	m_dwWidth = 0;
	m_dwHeight = 0;
	m_dwResolution = 0;
	m_hMemoryDC = NULL;
	m_hBitmap = NULL;
	m_hBitmapOrg = NULL;
	m_lpBits = NULL;

	Initialize();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::~CDib24()
//	ABSTRACT : fXgN^
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CDib24::~CDib24()
{
	Initialize();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::Initialize()
//	ABSTRACT : NX̏s
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CDib24::Initialize()
{
	m_dwWidth = 0;
	m_dwHeight = 0;
	m_dwResolution = 0;

	if ( NULL != m_hMemoryDC )
	{
		if ( NULL != m_hBitmapOrg )
		{
			::SelectObject( m_hMemoryDC, m_hBitmapOrg );
			m_hBitmapOrg = NULL;
		}
		::DeleteDC( m_hMemoryDC );
		m_hMemoryDC = NULL;
	}

	if ( NULL != m_hBitmap )
	{
		::DeleteObject( m_hBitmap );
		ZeroMemory( &m_tBmpInfo, sizeof(m_tBmpInfo) );
		m_hBitmap = NULL;
		m_lpBits = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::Create()
//	ABSTRACT : rbg}bv̍쐬i24Bitj
//	FUNCTION : 
//	ARGUMENT : dwWidth       X̃sNZ
//	           dwHeight      ỸsNZ
//	           dwResolution  摜𑜓x(0.1dpi)
//	
//	NOTE     : 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::Create( const DWORD dwWidth, const DWORD dwHeight, const DWORD dwResolution )
{
	Initialize();

	BOOL bResult = FALSE;
	m_dwWidth = dwWidth;
	m_dwHeight = dwHeight;
	m_dwResolution = dwResolution;

	HWND hDesktop;
	HDC hDesktopDC;

	hDesktop = ::GetDesktopWindow();
	hDesktopDC = GetDC( hDesktop );

	if ( NULL != hDesktopDC )
	{
		// fBXNgbvƌ݊̂郁foCXReLXg쐬܂
		m_hMemoryDC = ::CreateCompatibleDC( hDesktopDC );
		if ( NULL != m_hMemoryDC )
		{
			// CBitmap::CreateCompatibleBitmapł͑傫BMP͍쐬łȂ̂CreateDIBSectionō쐬
			ZeroMemory( &m_tBmpInfo, sizeof(m_tBmpInfo) );
			m_tBmpInfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
			m_tBmpInfo.bmiHeader.biBitCount	= 32;
			m_tBmpInfo.bmiHeader.biPlanes	= 1;
			m_tBmpInfo.bmiHeader.biWidth	= dwWidth;
			m_tBmpInfo.bmiHeader.biHeight	= dwHeight;
			m_hBitmap = ::CreateDIBSection( m_hMemoryDC, &m_tBmpInfo, DIB_RGB_COLORS, (void **)(&m_lpBits), NULL, 0 );
			if ( NULL != m_hBitmap )
			{
				m_hBitmapOrg = (HBITMAP)::SelectObject( m_hMemoryDC, m_hBitmap );
				if ( NULL != m_hBitmapOrg )
				{
					// _Pʂ 1 foCX sNZɃ}bv܂
					::SetMapMode( m_hMemoryDC, MM_TEXT );

					// wi𔒂œhԂ
					::PatBlt( m_hMemoryDC, 0, 0, m_dwWidth, m_dwHeight, WHITENESS );

					bResult = TRUE;
				}
				else
				{
					AfxMessageBox( _T("CDib24::Create() : SelectObject() ֐Ăяos") );
				}
			}
			else
			{
				int nErr = GetLastError();
				AfxMessageBox( _T("CDib24::Create() : CBitmap::CreateCompatibleBitmap() ֐Ăяos") );
			}
		}
		else
		{
			AfxMessageBox( _T("CDib24::Create() : CreateCompatibleDC() ֐Ăяos") );
		}

		if ( 0 == ::ReleaseDC( hDesktop, hDesktopDC ) )
		{
			AfxMessageBox( _T("CDib24::Create() : ReleaseDC() ֐Ăяos") );
		}
	}
	else
	{
		AfxMessageBox( _T("CDib24::Create() : GetDC() ֐Ăяos") );
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::GetHeight()
//	ABSTRACT : rbg}bv̍擾܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CDib24::GetHeight()
{
	return m_dwHeight;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::GetWidth()
//	ABSTRACT : rbg}bv̕擾܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
DWORD CDib24::GetWidth()
{
	return m_dwWidth;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::WriteBMP()
//	ABSTRACT : rbg}bvt@Cɏo܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.1.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::WriteBMP( LPCTSTR lpFileName )
{
	if (( NULL == lpFileName ) || ( '\0' == *lpFileName ) ||
		( m_hMemoryDC == NULL )) {
		return FALSE;
	}

	LPBYTE pImgData = NULL;
	DWORD dwSizeImage = 0;
	DWORD dwLines = 0;
	HANDLE hFile = NULL;
	DWORD nByteWrite = 0;
	BITMAP tBmp = { 0 };
	BITMAPFILEHEADER	tBmpFileHdr = { 0 };			// rbg}bvt@C̃wb_[
	BITMAPINFO		    tBmpInfo = { 0 };				// rbg}bṽwb_[

	if ( sizeof(BITMAP) == ::GetObject( m_hBitmap, sizeof(BITMAP), &tBmp ) )
	{
		dwSizeImage = WIDTHBYTES(24 * tBmp.bmWidth) * tBmp.bmHeight;
		// BITMAPFILEHEADER \̂̏
		tBmpFileHdr.bfType = BFT_BITMAP;
		tBmpFileHdr.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwSizeImage;
		tBmpFileHdr.bfReserved1 = 0;
		tBmpFileHdr.bfReserved2 = 0;
		tBmpFileHdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
		// BITMAPINFOHEADER \̂̏
		tBmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		tBmpInfo.bmiHeader.biWidth = m_dwWidth;
		tBmpInfo.bmiHeader.biHeight = m_dwHeight;
		tBmpInfo.bmiHeader.biPlanes = 1;
		tBmpInfo.bmiHeader.biBitCount = 24;
		tBmpInfo.bmiHeader.biCompression = BI_RGB;
		tBmpInfo.bmiHeader.biSizeImage = dwSizeImage;
		tBmpInfo.bmiHeader.biXPelsPerMeter = 0;
		tBmpInfo.bmiHeader.biYPelsPerMeter = 0;
		tBmpInfo.bmiHeader.biClrUsed = 0;
		tBmpInfo.bmiHeader.biClrImportant = 0;

		// C[Wf[^̎擾
		pImgData = new BYTE[dwSizeImage];
		::ZeroMemory( pImgData, dwSizeImage );
		dwLines = ::GetDIBits( m_hMemoryDC, m_hBitmap, 0, tBmp.bmHeight, pImgData, &tBmpInfo, DIB_RGB_COLORS );
		if ( tBmp.bmHeight != dwLines )
		{
			AfxMessageBox( _T("CDib24::WriteBMP() : GetDIBits() ֐Ăяos") );
		}
	}

	hFile = CreateFile( lpFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( INVALID_HANDLE_VALUE != hFile )
	{
		WriteFile( hFile, (LPSTR)&tBmpFileHdr, sizeof(BITMAPFILEHEADER), &nByteWrite, NULL );
		WriteFile( hFile, (LPSTR)&tBmpInfo.bmiHeader, sizeof(BITMAPINFOHEADER), &nByteWrite, NULL );
		WriteFile( hFile, (LPSTR)pImgData, dwSizeImage, &nByteWrite, NULL );
		CloseHandle( hFile );
	}

	if ( NULL != pImgData )
	{
		delete [] pImgData;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::FrameArea()
//	ABSTRACT : DIB ̈ɁAlp`̋E`悵܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2009.9.9
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::FrameArea( const LPRECT lpRect, const COLORREF tColor, const int nWidth )
{
	if ( NULL == m_hMemoryDC )
	{
		return FALSE;
	}

	HPEN hPen;
	HPEN hPenOrg;

	hPen = ::CreatePen( PS_SOLID, nWidth, tColor );
	if ( NULL != hPen )
	{
		hPenOrg = (HPEN)::SelectObject( m_hMemoryDC, hPen );

		// 1mmPʂ̃XP[`悵܂
		::MoveToEx( m_hMemoryDC, lpRect->left,	lpRect->top,	NULL );	::LineTo( m_hMemoryDC,	lpRect->right,	lpRect->top );
		::MoveToEx( m_hMemoryDC, lpRect->right,	lpRect->top,	NULL );	::LineTo( m_hMemoryDC,	lpRect->right,	lpRect->bottom );
		::MoveToEx( m_hMemoryDC, lpRect->right,	lpRect->bottom,	NULL );	::LineTo( m_hMemoryDC,	lpRect->left,	lpRect->bottom );
		::MoveToEx( m_hMemoryDC, lpRect->left,	lpRect->bottom,	NULL );	::LineTo( m_hMemoryDC,	lpRect->left,	lpRect->top );

		::SelectObject( m_hMemoryDC, hPenOrg );
		::DeleteObject( hPen );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::FillRect()
//	ABSTRACT : DIB ̈ɁAlp`̈œhׂ܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2009.11.26
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::FillRect( const LPRECT lpRect, const COLORREF tColor )
{
	if ( NULL == m_hMemoryDC )
	{
		return FALSE;
	}

	HBRUSH hBruah;
	HBRUSH hBruahOrg;

	hBruah = ::CreateSolidBrush( tColor );
	if ( NULL != hBruah )
	{
		hBruahOrg = (HBRUSH)::SelectObject( m_hMemoryDC, hBruah );

		// lp`̗̈hׂ
		::FillRect( m_hMemoryDC, lpRect, hBruah );

		::SelectObject( m_hMemoryDC, hBruahOrg );
		::DeleteObject( hBruah );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::TextArea()
//	ABSTRACT : DIB ̈ɁA`悵܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.2.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::TextArea( const LPRECT lpRect, LPCTSTR lpString, const int nFontHeight, const int nFontWeight, const BOOL bFontItalic, LPCTSTR lpFacename, const COLORREF tColor, const UINT nFormat )
{
	if ( NULL == m_hMemoryDC )
	{
		return FALSE;
	}

	HFONT hFont;
	HFONT hFontOrg;

	// tHg̍쐬
	hFont = ::CreateFont(
		nFontHeight * -1,			// tHg
		0,							// 
		0,							// eLXg̊px
		0,							// x[XCƂƂ̊px
		nFontWeight,				// tHg̏dij
		bFontItalic,				// C^bN
		FALSE,						// A_[C
		FALSE,						// ł
		1,							// Zbg
		OUT_DEFAULT_PRECIS,			// o͐x
		CLIP_DEFAULT_PRECIS,		// NbsOx
		DEFAULT_QUALITY,			// o͕i
		DEFAULT_PITCH|FF_DONTCARE,	// sb`ƃt@~[
		lpFacename					// ̖
	);

	// tHg̐ݒ
	hFontOrg = (HFONT)::SelectObject( m_hMemoryDC, hFont );

	// F̐ݒ
	::SetTextColor( m_hMemoryDC, tColor );

	// ̕`
	::DrawText( m_hMemoryDC, lpString, -1, lpRect, nFormat );

	// tHgɖ߂
	::SelectObject( m_hMemoryDC, hFontOrg );
	::DeleteObject( hFont );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::ScaleHorizontalArea()
//	ABSTRACT : DIB ̈ɁÃXP[(1mmP)`悵܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.2.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::ScaleHorizontalArea( const LPRECT lpRect, const DWORD dwResolution, const COLORREF tColor )
{
	if ( NULL == m_hMemoryDC )
	{
		return FALSE;
	}

	HPEN hPen;
	HPEN hPenOrg;

	hPen = CreatePen( PS_SOLID, 1, tColor );
	if ( NULL != hPen )
	{
		hPenOrg = (HPEN)::SelectObject( m_hMemoryDC, hPen );

		// 1mmPʂ̃XP[`悵܂
		ULONG x = 0;
		ULONG x_max = 0;
		ULONG Height = 0;
		CRect objRect( lpRect );

		x_max = ((objRect.Width() * 254 * 10 / dwResolution + 5 ) / 10 );
		for ( x=0 ; x_max >= x ; x++ )
		{
			if ( 0 == ( x % 10 ) )
			{
				// 1cmԊu̐̍
				Height = objRect.Height();
			}
			else
			{
				if ( 0 == ( x % 5 ) )
				{
					// 5mmԊu̐̍
					Height = objRect.Height() / 4 * 3;
				}
				else
				{
					// 1mmԊu̐̍
					Height = objRect.Height() / 4 * 2;
				}
			}
			::MoveToEx( m_hMemoryDC, objRect.left + (( x * 10 * dwResolution / 254 + 5 ) / 10 ), objRect.bottom, NULL );
			::LineTo( m_hMemoryDC, objRect.left + (( x * 10 * dwResolution / 254 + 5 ) / 10 ), objRect.bottom - Height );
		}

		// ̕`
		::MoveToEx( m_hMemoryDC, objRect.left, objRect.bottom, NULL );
		::LineTo( m_hMemoryDC, objRect.right, objRect.bottom );

		::SelectObject( m_hMemoryDC, hPenOrg );
		::DeleteObject( hPen );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CDib24::ScaleVerticalArea()
//	ABSTRACT : DIB ̈ɁAc̃XP[(1mmP)`悵܂
//	FUNCTION : 
//	
//	NOTE     : < RD-26 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2004.2.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CDib24::ScaleVerticalArea( const LPRECT lpRect, const DWORD dwResolution, const COLORREF tColor )
{
	if ( NULL == m_hMemoryDC )
	{
		return FALSE;
	}

	HPEN hPen;
	HPEN hPenOrg;

	hPen = CreatePen( PS_SOLID, 1, tColor );
	if ( NULL != hPen )
	{
		hPenOrg = (HPEN)::SelectObject( m_hMemoryDC, hPen );

		// 1mmPʂ̃XP[`悵܂
		ULONG y = 0;
		ULONG y_max = 0;
		ULONG Width = 0;
		CRect objRect( lpRect );

		y_max = ((objRect.Height() * 254 * 10 / dwResolution + 5 ) / 10 );
		for ( y=0 ; y_max >= y ; y++ )
		{
			if ( 0 == ( y % 10 ) )
			{
				// 1cmԊu̐̍
				Width = objRect.Width();
			}
			else
			{
				if ( 0 == ( y % 5 ) )
				{
					// 5mmԊu̐̍
					Width = objRect.Width() / 4 * 3;
				}
				else
				{
					// 1mmԊu̐̍
					Width = objRect.Width() / 4 * 2;
				}
			}
			::MoveToEx( m_hMemoryDC, objRect.right, objRect.top + (( y * 10 * dwResolution / 254 + 5 ) / 10 ), NULL );
			::LineTo( m_hMemoryDC, objRect.right - Width, objRect.top + (( y * 10 * dwResolution / 254 + 5 ) / 10 ) );
		}

		// ̕`
		::MoveToEx( m_hMemoryDC, objRect.right, objRect.top, NULL );
		::LineTo( m_hMemoryDC, objRect.right, objRect.bottom );

		::SelectObject( m_hMemoryDC, hPenOrg );
		::DeleteObject( hPen );
	}

	return TRUE;
}
