// NpsLib.cpp: CNpsLib NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsTester.h"
#include "NpsLib.h"

#if _MSC_VER >= 1400
	#if !defined( _WIN64 )
		#pragma comment( lib , "NoritsuPrinter80.lib" )
	#else
		#pragma comment( lib , "NoritsuPrinter80_64.lib" )
	#endif
#else
	#pragma comment( lib , "NoritsuPrinter.lib" )
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CNpsLib* g_objNpsLib = NULL;

void CreateNpsLib( DWORD dwMode )	{ g_objNpsLib = new CNpsLib( dwMode ); };
void DropNpsLib()					{ delete g_objNpsLib; };
CNpsLib* GetNpsLib()				{ return g_objNpsLib; };

// R[obN֐
// --------------------------------------------------
VOID __stdcall CallBack_npsEventProc( PNPSEVENTINFO pEventInfo )
{
	switch ( pEventInfo->dwOnOff )
	{
	case EVENT_ON:	GetNpsLib()->AddEventInfo( pEventInfo );	break;
	case EVENT_OFF:	GetNpsLib()->DelEventInfo( pEventInfo );	break;
	}

	::PostMessage( g_hWndNpsTesterDlg, UM_UPDATE_EVENT_VIEW, NULL, NULL );
}

// --------------------------------------------------
VOID __stdcall CallBack_npsUnitProc( PNPSUNITNOTIFYINFO pUnitInfo )
{
	NPS_UnitInfoEx stUnitInfoEx = { 0 };

	if ( TRUE == GetNpsLib()->GetMemberDataOfUnitInfo( &stUnitInfoEx ) )
	{
		switch ( pUnitInfo->lUnitId )
		{
		case INFO_PRINTER:			stUnitInfoEx.stUnitInfo.dwPrinterStatus = pUnitInfo->iNewStatus;						// v^S
			if ( NULL != g_hWndNpsTesterDlg )
			{
				// IC
				if ( INFO_SALLOFFLN == pUnitInfo->iOldStatus && INFO_SALLOFFLN != pUnitInfo->iNewStatus )
				{
					::PostMessage( g_hWndNpsTesterDlg, UM_PROC_ONLINE, NULL, NULL );
				}
				// ItC
				if ( INFO_SALLOFFLN != pUnitInfo->iOldStatus && INFO_SALLOFFLN == pUnitInfo->iNewStatus )
				{
					::PostMessage( g_hWndNpsTesterDlg, UM_PROC_OFFLINE, NULL, NULL );
				}
			}
			break;
		case INFO_ADVANCE:			stUnitInfoEx.stUnitInfo.dwAdvanceStatus = pUnitInfo->iNewStatus;				break;	// nS
		case INFO_LASER:			stUnitInfoEx.stUnitInfo.dwLaserStatus = pUnitInfo->iNewStatus;					break;	// w[U[
		case INFO_DEVELOPMENT:		stUnitInfoEx.stUnitInfo.dwDevelopmentStatus = pUnitInfo->iNewStatus;			break;	// nS
		case INFO_PROCESSOR:		stUnitInfoEx.stUnitInfo.dwProcessorStatus = pUnitInfo->iNewStatus;				break;	// 
		case INFO_REPLENISHER:		stUnitInfoEx.stUnitInfo.dwReplenisherStatus = pUnitInfo->iNewStatus;			break;	// [
		case INFO_REPLACECARTRIDGE:	stUnitInfoEx.stUnitInfo.dwReplaceCartridgeStatus = pUnitInfo->iNewStatus;		break;	// [J[gbW
		case INFO_ACCEPT:			stUnitInfoEx.stUnitInfo.dwAcceptStatus = pUnitInfo->iNewStatus;					break;	// t
		case INFO_POSSESSION:		stUnitInfoEx.stUnitInfo.dwPrinterPossession = pUnitInfo->iNewStatus;			break;	// v^L
		case INFO_STARTCHECK:		stUnitInfoEx.stUnitInfo.dwStartUpChecksStatus = pUnitInfo->iNewStatus;			break;	// I[gZbgAbvł̎nƓ_
		case INFO_REFILLWATER:		stUnitInfoEx.stUnitInfo.dwRefillWaterStatus = pUnitInfo->iNewStatus;			break;	// I[gZbgAbvł̕␅
		case INFO_DAILYSETUP:		stUnitInfoEx.stUnitInfo.dwDailySetupStatus = pUnitInfo->iNewStatus;				break;	// I[gZbgAbvł̃fC[ZbgAbv
		case INFO_CNTRSTRP:			stUnitInfoEx.stUnitInfo.dwControlStripStatus = pUnitInfo->iNewStatus;			break;	// I[gZbgAbvł̃Rg[Xgbv
		case INFO_MNTNNC:			stUnitInfoEx.stUnitInfo.dwMaintenanceStatus = pUnitInfo->iNewStatus;			break;	// eiX\tg̐L
		case INFO_FAD:				stUnitInfoEx.stUnitInfo.dwFadStatus = pUnitInfo->iNewStatus;					break;	// FAD̏
		case INFO_INSTMAG:																									// }KW
			if ( NULL != g_hWndNpsTesterDlg )
			{
				::PostMessage( g_hWndNpsTesterDlg, UM_INFO_INSTMAG, NULL, NULL );
			}
			break;
		case INFO_INFOMAG:																									// }KW
			if ( NULL != g_hWndNpsTesterDlg )
			{
				::PostMessage( g_hWndNpsTesterDlg, UM_INFO_INFOMAG, NULL, NULL );
			}
			break;
		}

		GetNpsLib()->SetMemberDataOfUnitInfo( &stUnitInfoEx );
	}
}

// --------------------------------------------------
VOID __stdcall CallBack_npsCompletionProc( DWORD dwCompletionCode, PVOID pCompletionInfo )
{
	switch ( dwCompletionCode )
	{
	case COMPLETION_ORDER:	GetPrintQue()->UpdateOrderStatus( (NPSORDERINFO*)pCompletionInfo );	break;
	case COMPLETION_PRINT:	GetPrintQue()->UpdateFrameStatus( (NPSPRINTINFO*)pCompletionInfo );	break;
	}
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// --------------------------------------------------
CNpsLib::CNpsLib( DWORD dwMode )
{
	::InitializeCriticalSection( &m_csMemberData );

	// f[^̏
	ClearMemberDataOfLibOpen();

	// Oo͐ݒt@C̍쐬
	CString strLogIniFile = COMAPI::GetModuleFolder() + _T("NpsTester_Nps.ini");
	CString strLogFile = COMAPI::GetModuleFolder() + _T("NpsTester_Nps.log");
	::WritePrivateProfileString( "log", "logger", "NoritsuPrinter.dll", strLogIniFile );
	::WritePrivateProfileString( "log", "memorysize", "1", strLogIniFile );
	::WritePrivateProfileString( "log", "filename", strLogFile, strLogIniFile );
	::WritePrivateProfileString( "log", "levelfatal", "0", strLogIniFile );
	::WritePrivateProfileString( "log", "levelwarn", "0", strLogIniFile );
	::WritePrivateProfileString( "log", "levelinfo", "0", strLogIniFile );
	::WritePrivateProfileString( "log", "leveldebug", "0", strLogIniFile );

	if ( NPSERR_NORMAL == npsLibOpen( strLogIniFile ) )
	{
		m_bLibOpen = TRUE;

		// NPSJX^[hύX
		npsSetCustomMode( NPSCTM_CMSTBLMAKE_ON );

		npsSetConnectMode( dwMode );

		// ʒm̓샂[hs[gPʒʒmɕύX
		npsSetCompletionProcMode( NPS_PRINT_DETAIL_NOTIFY_ENABLE | NPS_OUTPUT_DETAIL_NOTIFY_ENABLE );
	}
}

// --------------------------------------------------
CNpsLib::~CNpsLib()
{
	if ( TRUE == m_bLibOpen )
	{
		npsLibClose();
	}

	::DeleteCriticalSection( &m_csMemberData );
}

// --------------------------------------------------
void CNpsLib::ClearMemberDataOfLibOpen()
{
	ClearMemberDataOfDevOpen();

	m_bLibOpen = FALSE;
}

// --------------------------------------------------
void CNpsLib::ClearMemberDataOfDevOpen()
{
	ClearMemberDataOfOnLine();

	m_hPrinter = NULL;
	m_bDevOpen = FALSE;
}

// --------------------------------------------------
void CNpsLib::ClearMemberDataOfOnLine()
{
	ZeroMemory( &m_tUnitInfoEx, sizeof(NPS_UnitInfoEx) );
	m_tUnitInfoEx.stUnitInfo.dwPrinterStatus			= INFO_SALLOFFLN;
	m_tUnitInfoEx.stUnitInfo.dwAcceptStatus				= INFO_SACDISABLE;
	m_tUnitInfoEx.stUnitInfo.dwPrinterPossession		= INFO_SPPNOUSE;
	m_tUnitInfoEx.stUnitInfo.dwAdvanceStatus			= INFO_SMCALLMOTNONE;
	m_tUnitInfoEx.stUnitInfo.dwLaserStatus				= INFO_SLDLZNONE;
	m_tUnitInfoEx.stUnitInfo.dwDevelopmentStatus		= INFO_SPRALLMTNONE;
	m_tUnitInfoEx.stUnitInfo.dwProcessorStatus			= INFO_SPRBTHNONE;
	m_tUnitInfoEx.stUnitInfo.dwReplenisherStatus		= INFO_SPRSPNONE;
	m_tUnitInfoEx.stUnitInfo.dwReplaceCartridgeStatus	= INFO_SPRKITNONE;
	m_tUnitInfoEx.stUnitInfo.dwStartUpChecksStatus		= INFO_SUCSNONE;
	m_tUnitInfoEx.stUnitInfo.dwRefillWaterStatus		= INFO_RWSNONE;
	m_tUnitInfoEx.stUnitInfo.dwDailySetupStatus			= INFO_DSSNONE;
	m_tUnitInfoEx.stUnitInfo.dwControlStripStatus		= INFO_CSSNONE;
	m_tUnitInfoEx.stUnitInfo.dwMaintenanceStatus		= INFO_MNTNONE;
	m_tUnitInfoEx.stUnitInfo.dwFadStatus				= INFO_FADNONE;
	ZeroMemory( &m_tSetUpInfo, sizeof(NPS_SetUpInfo) );
	ZeroMemory( &m_tPrintNumInfo, sizeof(NPS_PrintNumInfo) );
	ZeroMemory( &m_tDateTime, sizeof(NPS_DateTime) );

	m_vMagInfo.clear();
	m_vMagDetailInfo.clear();

	m_bOnLine = FALSE;
}

// --------------------------------------------------
BOOL CNpsLib::npsSearchPrinter2( LPWORD pPrinterNum, DWORD dwWaitTime )
{
	BOOL bResult = FALSE;

	if ( FALSE == m_bDevOpen )
	{
		if ( NPSERR_NORMAL == ::npsSearchPrinter2( pPrinterNum, dwWaitTime ) )
		{
			bResult = TRUE;
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsGetPrinter( WORD wBufferNum, PNPS_PRINTER_ENUM pPrinterInfo )
{
	BOOL bResult = FALSE;

	if ( FALSE == m_bDevOpen )
	{
		if ( NPSERR_NORMAL == ::npsGetPrinter( wBufferNum, pPrinterInfo ) )
		{
			bResult = TRUE;
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevOpen( DWORD dwIPAddress )
{
	BOOL bResult = FALSE;

	if ( FALSE == m_bDevOpen )
	{
		if ( NULL == m_hPrinter )
		{
			// f[^̏
			ClearMemberDataOfDevOpen();

			m_bDevOpen = TRUE;
			if ( NPSERR_NORMAL == ::npsDevOpen( dwIPAddress, &m_hPrinter, CallBack_npsEventProc, CallBack_npsUnitProc ) )
			{
				bResult = TRUE;
			}
			else
			{
				m_hPrinter = NULL;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevClose()
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevClose( m_hPrinter ) )
			{
				bResult = TRUE;
				m_bDevOpen = FALSE;
				m_hPrinter = NULL;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetUnitInfo()
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			NPS_UnitInfoEx stUnitInfoEx = { 0 };
			if ( TRUE == GetMemberDataOfUnitInfo( &stUnitInfoEx ) )
			{
				if ( NPSERR_NORMAL == ::npsDevGetUnitInfo( m_hPrinter, &stUnitInfoEx.stUnitInfo ) )
				{
					bResult = TRUE;
					SetMemberDataOfUnitInfo( &stUnitInfoEx );
				}
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetMagInfo()
{
	BOOL bResult = FALSE;
	DWORD dwSize = 0;
	NPS_MagInfo stMagInfo = { 0 };
	BYTE* pstMagInfo = NULL;

	m_vMagInfo.clear();

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			// }KW擾
			if ( NPSERR_BADPARAM == ::npsDevGetMagInfo( m_hPrinter, &stMagInfo, &dwSize ) )
			{
				// S}KW擾
				pstMagInfo = new BYTE[ dwSize ];
				if ( NPSERR_NORMAL == ::npsDevGetMagInfo( m_hPrinter, (NPS_MagInfo*)pstMagInfo, &dwSize ) )
				{
					int nIdx = 0;
					int nCnt = dwSize / sizeof(NPS_MagInfo);
					for ( nIdx=0 ; nCnt > nIdx ; nIdx++ )
					{
						m_vMagInfo.push_back( *(((NPS_MagInfo*)pstMagInfo) + nIdx) );
					}

					// }KW擾Ԃ̍XV
					NPS_UnitInfoEx stUnitInfoEx = { 0 };

					if ( TRUE == GetNpsLib()->GetMemberDataOfUnitInfo( &stUnitInfoEx ) )
					{
						::GetLocalTime( &stUnitInfoEx.stInstMag );
						GetNpsLib()->SetMemberDataOfUnitInfo( &stUnitInfoEx );
					}
					bResult = TRUE;
				}
				else
				{
				}
				delete [] pstMagInfo;
			}
			else
			{
				m_vMagInfo.clear();
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetAllMagInfo()
{
	BOOL bResult = FALSE;
	DWORD dwSize = 0;
	NPS_MagDetailInfo stMagDetailInfo = { 0 };
	BYTE* pstMagDetailInfo = NULL;

	m_vMagDetailInfo.clear();

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			// }KW擾
			if ( NPSERR_BADPARAM == ::npsDevGetAllMagInfo( m_hPrinter, &stMagDetailInfo, &dwSize ) )
			{
				// S}KW擾
				pstMagDetailInfo = new BYTE[ dwSize ];
				if ( NPSERR_NORMAL == ::npsDevGetAllMagInfo( m_hPrinter, (NPS_MagDetailInfo*)pstMagDetailInfo, &dwSize ) )
				{
					int nIdx = 0;
					int nCnt = dwSize / sizeof(NPS_MagDetailInfo);
					for ( nIdx=0 ; nCnt > nIdx ; nIdx++ )
					{
						m_vMagDetailInfo.push_back( *(((NPS_MagDetailInfo*)pstMagDetailInfo) + nIdx) );
					}

					// }KW擾Ԃ̍XV
					NPS_UnitInfoEx stUnitInfoEx = { 0 };

					if ( TRUE == GetNpsLib()->GetMemberDataOfUnitInfo( &stUnitInfoEx ) )
					{
						::GetLocalTime( &stUnitInfoEx.stInfoMag );
						GetNpsLib()->SetMemberDataOfUnitInfo( &stUnitInfoEx );
					}
					bResult = TRUE;
				}
				else
				{
					m_vMagDetailInfo.clear();
				}
				delete [] pstMagDetailInfo;
			}
			else
			{
				m_vMagDetailInfo.clear();
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetSetUpInfo()
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			NPS_SetUpInfo stSetUpInfo = { 0 };
			if ( NPSERR_NORMAL == ::npsDevGetSetUpInfo( m_hPrinter, &stSetUpInfo ) )
			{
				bResult = TRUE;
			}
			SetMemberDataOfSetUpInfo( &stSetUpInfo );
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetPrintNumInfo()
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			NPS_PrintNumInfo stPrintNumInfo = { 0 };
			if ( NPSERR_NORMAL == ::npsDevGetPrintNumInfo( m_hPrinter, &stPrintNumInfo ) )
			{
				bResult = TRUE;
			}
			SetMemberDataOfPrintNumInfo( &stPrintNumInfo );
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevGetTime()
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			NPS_DateTime stDateTime = { 0 };
			if ( NPSERR_NORMAL == ::npsDevGetTime( m_hPrinter, &stDateTime ) )
			{
				bResult = TRUE;
			}
			SetMemberDataOfDateTime( &stDateTime );
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevStartOrderEx( DWORD* pdwOrderId, DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame, DWORD dwExOptions )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevStartOrderEx( m_hPrinter, pdwOrderId, CallBack_npsCompletionProc, dwPriority, dwSorterNum, dwSortFrame, dwExOptions ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevEndOrder( DWORD dwOrderId )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevEndOrder( m_hPrinter, dwOrderId ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevPrint( DWORD dwOrderId, LPDWORD pPrintID, PNPS_PrintInfo pPrintInfo )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevPrint( m_hPrinter, dwOrderId, pPrintID, CallBack_npsCompletionProc, pPrintInfo ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevSort( DWORD dwOrderId )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevSort( m_hPrinter, dwOrderId ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevCancelPrintOrder( DWORD dwOrderId, DWORD dwPrintID )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevCancelPrintOrder( m_hPrinter, dwOrderId, dwPrintID ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevStartDuplex( DWORD dwOrderId )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevStartDuplex( m_hPrinter, dwOrderId ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevEndDuplex( DWORD dwOrderId )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevEndDuplex( m_hPrinter, dwOrderId ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevBlankPrint( DWORD dwOrderId, LPDWORD pPrintID, PNPS_BlankPrintInfo pBlankPrintInfo )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevBlankPrint( m_hPrinter, dwOrderId, pPrintID, CallBack_npsCompletionProc, pBlankPrintInfo ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevResetEvent( DWORD dwErrHandle, DWORD dwActionId )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevResetEvent( m_hPrinter, dwErrHandle, dwActionId ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
BOOL CNpsLib::npsDevCtrlPrint( DWORD dwCtrl )
{
	BOOL bResult = FALSE;

	if ( TRUE == m_bDevOpen )
	{
		if ( NULL != m_hPrinter )
		{
			if ( NPSERR_NORMAL == ::npsDevCtrlPrint( m_hPrinter, dwCtrl ) )
			{
				bResult = TRUE;
			}
		}
	}

	return bResult;
}

// --------------------------------------------------
void CNpsLib::SetMemberDataOfUnitInfo( NPS_UnitInfoEx* ptUnitInfoEx )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	::CopyMemory( &m_tUnitInfoEx, ptUnitInfoEx, sizeof(NPS_UnitInfoEx) );

	if ( INFO_SALLOFFLN == ptUnitInfoEx->stUnitInfo.dwPrinterStatus )
	{
		// f[^̏
		ClearMemberDataOfOnLine();
	}
	else
	{
		m_bOnLine = TRUE;
	}
}

// --------------------------------------------------
void CNpsLib::SetMemberDataOfSetUpInfo( NPS_SetUpInfo* ptSetUpInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	::CopyMemory( &m_tSetUpInfo, ptSetUpInfo, sizeof(NPS_SetUpInfo) );
}

void CNpsLib::SetMemberDataOfPrintNumInfo( NPS_PrintNumInfo* ptPrintNumInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	::CopyMemory( &m_tPrintNumInfo, ptPrintNumInfo, sizeof(NPS_PrintNumInfo) );
}

void CNpsLib::SetMemberDataOfDateTime( NPS_DateTime* ptDateTime )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	::CopyMemory( &m_tDateTime, ptDateTime, sizeof(NPS_DateTime) );
}

// --------------------------------------------------
BOOL CNpsLib::GetMemberDataOfUnitInfo( NPS_UnitInfoEx* ptUnitInfoEx )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == m_bDevOpen )	return FALSE;

	::CopyMemory( ptUnitInfoEx, &m_tUnitInfoEx, sizeof(NPS_UnitInfoEx) );

	return TRUE;
}

// --------------------------------------------------
BOOL CNpsLib::GetMemberDataOfSetUpInfo( NPS_SetUpInfo* ptSetUpInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if ( FALSE == m_bOnLine )	return FALSE;

	::CopyMemory( ptSetUpInfo, &m_tSetUpInfo, sizeof(NPS_SetUpInfo) );

	return TRUE;
}

// --------------------------------------------------
BOOL CNpsLib::GetMemberDataOfMagInfo( int nIdx, NPS_MagInfo* ptMagInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if (( 0 <= nIdx ) && ( (UINT)nIdx < m_vMagInfo.size() ))
	{
		CopyMemory( ptMagInfo, &m_vMagInfo.at( nIdx ), sizeof(NPS_MagInfo) );
		return TRUE;
	}

	return FALSE;
}

// --------------------------------------------------
BOOL CNpsLib::GetMemberDataOfMagDetailInfo( int nIdx, NPS_MagDetailInfo* ptMagDetailInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if (( 0 <= nIdx ) && ( (UINT)nIdx < m_vMagDetailInfo.size() ))
	{
		CopyMemory( ptMagDetailInfo, &m_vMagDetailInfo.at( nIdx ), sizeof(NPS_MagDetailInfo) );
		return TRUE;
	}

	return FALSE;
}

// --------------------------------------------------
BOOL CNpsLib::GetMemberDataOfEventInfo( int nIdx, NPSEVENTINFO* ptEventInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	if (( 0 <= nIdx ) && ( (UINT)nIdx < m_vEventInfo.size() ))
	{
		CopyMemory( ptEventInfo, &m_vEventInfo.at( nIdx ), sizeof(NPSEVENTINFO) );
		return TRUE;
	}

	return FALSE;
}

// --------------------------------------------------
void CNpsLib::AddEventInfo( NPSEVENTINFO* ptEventInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<NPSEVENTINFO>::iterator	itEventInfo;

	// d`FbN
	for ( itEventInfo=m_vEventInfo.begin() ; m_vEventInfo.end() != itEventInfo ; itEventInfo++ )
	{
		if (( ptEventInfo->hPrinter == itEventInfo->hPrinter ) &&
			( ptEventInfo->dwErrCode == itEventInfo->dwErrCode ))
		{
			break;
		}
	}
	if ( m_vEventInfo.end() != itEventInfo )
	{
		// d
		CString strMsg;
		strMsg.Format( "CNpsLib::AddEventInfo() : G[e[u̐`FbNŖ肪܂B<dG[> %u", ptEventInfo->dwErrCode );
		AfxMessageBox( strMsg );
	}
	else
	{
		// dȂ
		m_vEventInfo.push_back( *ptEventInfo );
	}
}

// --------------------------------------------------
void CNpsLib::DelEventInfo( NPSEVENTINFO* ptEventInfo )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	std::vector<NPSEVENTINFO>::iterator	itEventInfo;

	// ݃`FbN
	for ( itEventInfo=m_vEventInfo.begin() ; m_vEventInfo.end() != itEventInfo ; itEventInfo++ )
	{
		if (( ptEventInfo->hPrinter == itEventInfo->hPrinter ) &&
			( ptEventInfo->dwErrCode == itEventInfo->dwErrCode ))
		{
			break;
		}
	}
	if ( m_vEventInfo.end() != itEventInfo )
	{
		// o^ς
		m_vEventInfo.erase( itEventInfo );
	}
	else
	{
		// o^
		CString strMsg;
		strMsg.Format( "CNpsLib::DelEventInfo() : G[e[u̐`FbNŖ肪܂B<o^G[> %u", ptEventInfo->dwErrCode );
		AfxMessageBox( strMsg );
	}
}

// --------------------------------------------------
CString CNpsLib::GetStringData( ENUM_VARIABLE_TYPE eType )
{
	COMAPI::CCSScopeLock CSScopeLock( &m_csMemberData );

	CString str;
	CString strValue;

	switch ( eType )
	{
	case NPS_UnitInfo_dwPrinterStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwPrinterStatus )
		{
		case INFO_SALLBOOT:		str = _T("v^");			break;
		case INFO_SALLOFFLN:	str = _T("ItC");				break;
		case INFO_SALLEND:		str = _T("I");					break;
		case INFO_SALLSELFINST:	str = _T("INFO_SALLSELFINST");		break;
		case INFO_SALLIDLE:		str = _T("ACh");				break;
		case INFO_SALLPRINT:	str = _T("vg");				break;
		case INFO_SALLPRGTM:	str = _T("vO^C}[");	break;
		case INFO_SALLINST:		str = _T("CXg[");			break;
		}
		strValue.Format( "%s <v^S̏>", str );
		break;
	case NPS_UnitInfo_dwAcceptStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwAcceptStatus )
		{
		case INFO_SACDISABLE:	str = _T("ts\");	break;
		case INFO_SACENABLE:	str = _T("t\");	break;
		}
		strValue.Format( "%s <t>", str );
		break;
	case NPS_UnitInfo_dwPrinterPossession:
		switch ( m_tUnitInfoEx.stUnitInfo.dwPrinterPossession )
		{
		case INFO_SPPNOUSE:		str = _T("L");				break;
		case INFO_SPPRESTART:	str = _T("L (ĊJ҂)");	break;
		case INFO_SPPUSENORMAL:	str = _T("ʏL");			break;
		case INFO_SPPUSEEXPRESS:str = _T("}L");			break;
		}
		strValue.Format( "%s <v^L>", str );
		break;
	case NPS_UnitInfo_dwAdvanceStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwAdvanceStatus )
		{
		case INFO_SMCALLMOTNG:	str = _T("̗vts");	break;
		case INFO_SMCALLMOTOK:	str = _T("̗vt\");	break;
		case INFO_SMCALLMOTACT:	str = _T("쒆");				break;
		case INFO_SMCALLMOTNONE:str = _T("---");						break;
		}
		strValue.Format( "%s <nS>", str );
		break;
	case NPS_UnitInfo_dwLaserStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwLaserStatus )
		{
		case INFO_SLDLZSTOP:	str = _T("");			break;
		case INFO_SLDLZSTART:	str = _T("Jn ()");	break;
		case INFO_SLDLZEND:		str = _T("");			break;
		case INFO_SLDLZNONE:	str = _T("---");				break;
		}
		strValue.Format( "%s <w[U[>", str );
		break;
	case NPS_UnitInfo_dwDevelopmentStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwDevelopmentStatus )
		{
		case INFO_SPRALLMTNG:	str = _T("̗vts\");	break;
		case INFO_SPRALLMTOK:	str = _T("̗vt\");	break;
		case INFO_SPRALLMTDO:	str = _T("쒆");				break;
		case INFO_SPRALLMTNONE:	str = _T("---");						break;
		}
		strValue.Format( "%s <S>", str );
		break;
	case NPS_UnitInfo_dwProcessorStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwProcessorStatus )
		{
		case INFO_SPRBTHTPNO:	str = _T("");			break;
		case INFO_SPRBTHHTUP:	str = _T("q[gAbv");	break;
		case INFO_SPRBTHPRTP:	str = _T("");		break;
		case INFO_SPRBTHTPNG:	str = _T("s");		break;
		case INFO_SPRBTHNONE:	str = _T("---");			break;
		}
		strValue.Format( "%s <>", str );
		break;
	case NPS_UnitInfo_dwReplenisherStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwReplenisherStatus )
		{
		case INFO_SPRSPAAL:		str = _T("ʏ^]");		break;
		case INFO_SPRSPASA:		str = _T("[");	break;
		case INFO_SPRSPADO:		str = _T("ՎU");		break;
		case INFO_SPRSPAKT:		str = _T("Lbg[");	break;
		case INFO_SPRSPNONE:	str = _T("---");			break;
		}
		strValue.Format( "%s <[>", str );
		break;
	case NPS_UnitInfo_dwReplaceCartridgeStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwReplaceCartridgeStatus )
		{
		case INFO_SPRKITCG:		str = _T("\");	break;
		case INFO_SPRKITLY:		str = _T("[ҋ@");	break;
		case INFO_SPRKITOP:		str = _T("J");		break;
		case INFO_SPRKITNONE:	str = _T("---");		break;
		}
		strValue.Format( "%s <[J[gbWύX>", str );
		break;
	case NPS_UnitInfo_dwStartUpChecksStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwStartUpChecksStatus )
		{
		case INFO_SUCSNO:		str = _T("{");		break;
		case INFO_SUCSOK:		str = _T("{ς");	break;
		case INFO_SUCSNONE:		str = _T("---");		break;
		}
		strValue.Format( "%s <nƓ_̎{>", str );
		break;
	case NPS_UnitInfo_dwRefillWaterStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwRefillWaterStatus )
		{
		case INFO_RWSNO:		str = _T("{");		break;
		case INFO_RWSOK:		str = _T("{ς");	break;
		case INFO_RWSNONE:		str = _T("---");		break;
		}
		strValue.Format( "%s <␅̎{>", str );
		break;
	case NPS_UnitInfo_dwDailySetupStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwDailySetupStatus )
		{
		case INFO_DSSNO:		str = _T("{");		break;
		case INFO_DSSOK:		str = _T("{ς");	break;
		case INFO_DSSNONE:		str = _T("---");		break;
		}
		strValue.Format( "%s <fC[ZbgAbv̎{>", str );
		break;
	case NPS_UnitInfo_dwControlStripStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwControlStripStatus )
		{
		case INFO_CSSNO:		str = _T("{");		break;
		case INFO_CSSOK:		str = _T("{ς");	break;
		case INFO_CSSNONE:		str = _T("---");		break;
		}
		strValue.Format( "%s <Rg[Xgbv̎{>", str );
		break;
	case NPS_UnitInfo_dwMaintenanceStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwMaintenanceStatus )
		{
		case INFO_MNTNOTUSE:	str = _T("L");	break;
		case INFO_MNTUSE:		str = _T("L");	break;
		case INFO_MNTNONE:		str = _T("---");	break;
		}
		strValue.Format( "%s <eiX\tg̐L>", str );
		break;
	case NPS_UnitInfo_dwFadStatus:
		switch ( m_tUnitInfoEx.stUnitInfo.dwFadStatus )
		{
		case INFO_FADOFFLN:		str = _T("ItC");		break;
		case INFO_FADUNWK:		str = _T("ғ");		break;
		case INFO_FADWRRNG:		str = _T("x");		break;
		case INFO_FADMNT:		str = _T("eiX");	break;
		case INFO_FADIDLE:		str = _T("ACh");		break;
		default:
		case INFO_FADNONE:		str = _T("---");			break;
		}
		strValue.Format( "%s <FAD̏>", str );
		break;
	case NPS_UnitInfo_stInstMag:
		strValue.Format( "%02d:%02d'%02d <}KW>",
							m_tUnitInfoEx.stInstMag.wHour,
							m_tUnitInfoEx.stInstMag.wMinute,
							m_tUnitInfoEx.stInstMag.wSecond );
		break;
	case NPS_UnitInfo_stInfoMag:
		strValue.Format( "%02d:%02d'%02d <}KW>",
							m_tUnitInfoEx.stInfoMag.wHour,
							m_tUnitInfoEx.stInfoMag.wMinute,
							m_tUnitInfoEx.stInfoMag.wSecond );
		break;
	case NPS_SetUpInfo_szMachineTypeName:
		strValue.Format( "\"%s\" <@햼>", m_tSetUpInfo.szMachineTypeName );
		break;
	case NPS_SetUpInfo_szSoftName:
		strValue.Format( "\"%s\" <\tgEFA>", m_tSetUpInfo.szSoftName );
		break;
	case NPS_SetUpInfo_szSerialNumber:
		strValue.Format( "\"%s\" <VAԍ>", m_tSetUpInfo.szSerialNumber );
		break;
	case NPS_SetUpInfo_wSupportResolutions:
		strValue.Format( "%u, %u, %u, %u, %u, %u, %u, %u <𑜓x>",
							m_tSetUpInfo.wSupportResolutions[0],
							m_tSetUpInfo.wSupportResolutions[1],
							m_tSetUpInfo.wSupportResolutions[2],
							m_tSetUpInfo.wSupportResolutions[3],
							m_tSetUpInfo.wSupportResolutions[4],
							m_tSetUpInfo.wSupportResolutions[5],
							m_tSetUpInfo.wSupportResolutions[6],
							m_tSetUpInfo.wSupportResolutions[7] );
		break;
	case NPS_SetUpInfo_wNpsVersion:
		strValue.Format( "0x%04X <NPS I/F ̃o[W>", m_tSetUpInfo.wNpsVersion );
		break;
	case NPS_SetUpInfo_wMachineTypeID:
		switch ( m_tSetUpInfo.wMachineTypeID )
		{
		case INFO_TYPEEXP:		str = _T("≖I^CviLaserj");	break;
		case INFO_TYPEIJ:		str = _T("CNWFbg^Cv");		break;
		case INFO_TYPEIBEAM:	str = _T("≖I^CviiBeamj");	break;
		}
		strValue.Format( "%s <@敪>", str );
		break;
	case NPS_SetUpInfo_dwTotalMemory:
		strValue.Format( "%u Byte <v^̃e>", m_tSetUpInfo.dwTotalMemory );
		break;
	case NPS_SetUpInfo_dwImageSizeMinWidth:
		strValue.Format( "%u pixel <t摜̍̕ŏTCY>", m_tSetUpInfo.dwImageSizeMinWidth );
		break;
	case NPS_SetUpInfo_dwImageSizeMinHeight:
		strValue.Format( "%u pixel <t摜̍̍ŏTCY>", m_tSetUpInfo.dwImageSizeMinHeight  );
		break;
	case NPS_SetUpInfo_dwImageSizeMaxWidth:
		strValue.Format( "%u pixel <t摜̍̕őTCY>", m_tSetUpInfo.dwImageSizeMaxWidth  );
		break;
	case NPS_SetUpInfo_dwImageSizeMaxHeight:
		strValue.Format( "%u pixel <t摜̍̍őTCY>", m_tSetUpInfo.dwImageSizeMaxHeight  );
		break;
	case NPS_SetUpInfo_dwNumberOfMagazine:
		strValue.Format( "%u <U\ȃ}KW>", m_tSetUpInfo.dwNumberOfMagazine );
		break;
	case NPS_SetUpInfo_PrinterTime:
		strValue.Format( "%04u/%02u/%02u %02u:%02u'%02u <v^̓>",
							m_tSetUpInfo.PrinterTime.tDate.dwYear,
							m_tSetUpInfo.PrinterTime.tDate.dwMonth,
							m_tSetUpInfo.PrinterTime.tDate.dwDay,
							m_tSetUpInfo.PrinterTime.tTime.dwHour,
							m_tSetUpInfo.PrinterTime.tTime.dwMinute,
							m_tSetUpInfo.PrinterTime.tTime.dwSecond );
		break;
	case NPS_SetUpInfo_dwRepeatCountMax:
		strValue.Format( "%u  <ő僊s[g>", m_tSetUpInfo.dwRepeatCountMax );
		break;
	case NPS_SetUpInfo_SupportImageFormat:
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 0] )	str += "JPEG(TYPE1), ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 1] )	str += "Bitmap(TYPE1), ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 2] )	str += "RGB24, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 3] )	str += "RGB48LSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 4] )	str += "RGB48LSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 5] )	str += "BGR48LSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 6] )	str += "BGR48LSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 7] )	str += "RGB48MSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 8] )	str += "RGB48MSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[ 9] )	str += "BGR48MSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[10] )	str += "BGR48MSB, ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[11] )	str += "JPEG(TYPE2), ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[12] )	str += "Bitmap(TYPE2), ";
		if ( INFO_IMGOK == m_tSetUpInfo.SupportImageFormat[13] )	str += "TIFF(TYPE1), ";
		strValue.Format( "%s <T|[g摜>", str );
		break;
	case NPS_SetUpInfo_wLaminatorUnitAttach:
		switch ( m_tSetUpInfo.wLaminatorUnitAttach )
		{
		case INFO_LAMIDISABLE:	str = _T("");	break;
		case INFO_LAMIENABLE:	str = _T("");	break;
		}
		strValue.Format( "%s <~l[^[jbg̑>", str );
		break;
	case NPS_SetUpInfo_InstallationDate:
		strValue.Format( "%04u/%02u/%02u <ݒu>",
							m_tSetUpInfo.InstallationDate.dwYear,
							m_tSetUpInfo.InstallationDate.dwMonth,
							m_tSetUpInfo.InstallationDate.dwDay );
		break;
	case NPS_SetUpInfo_OperationStartDate:
		strValue.Format( "%04u/%02u/%02u <ғJn>",
							m_tSetUpInfo.OperationStartDate.dwYear,
							m_tSetUpInfo.OperationStartDate.dwMonth,
							m_tSetUpInfo.OperationStartDate.dwDay );
		break;
	case NPS_SetUpInfo_wProcessorType:
		switch ( m_tSetUpInfo.wProcessorType )
		{
		case INFO_PRIDNONE:		str = _T("l");				break;
		case INFO_PRIDGPRO1:	str = _T("LPP600(iBEAM600)");	break;
		case INFO_PRIDGPRO2:	str = _T("LPP600(Laser600)");	break;
		case INFO_PRIDGPRO3:	str = _T("LPP1000(Laser1000)");	break;
		case INFO_PRIDGPRO4:	str = _T("LP1700(900)");		break;
		case INFO_PRIDGPRO5:	str = _T("LP1700(1300)");		break;
		case INFO_PRIDGPRO6:	str = _T("LP1700(1700)");		break;
		case INFO_PRIDGPRO7:	str = _T("LP2500(2300)");		break;
		case INFO_PRIDGPRO8:	str = _T("LP2500(2500)");		break;
		}
		strValue.Format( "%s <vZT[>", str );
		break;
	case NPS_SetUpInfo_wEmulsionNumber:
		strValue.Format( "%u <>", m_tSetUpInfo.wEmulsionNumber );
		break;
	case NPS_SetUpInfo_szPrinterNickname:
		strValue.Format( "\"%s\" <[U[`̃v^>", m_tSetUpInfo.szPrinterNickname );
		break;
	case NPS_SetUpInfo_wSupportAngle:
		switch ( m_tSetUpInfo.wSupportAngle )
		{
		case INFO_ROTATIONNO:	str = _T("90x]Ή");		break;
		case INFO_ROTATIONOK:	str = _T("90x]Ή");		break;
		}
		strValue.Format( "%s <T|[g90x]>", str );
		break;
	case NPS_SetUpInfo_wSupportIntoPrinter:
		switch ( m_tSetUpInfo.wSupportIntoPrinter )
		{
		case INFO_EXPRESSNO:	str = _T("}ݖT|[g");	break;
		case INFO_EXPRESSOK:	str = _T("}ݑΉ");			break;
		}
		strValue.Format( "%s <L>", str );
		break;
	case NPS_SetUpInfo_wSorterStatus:
		strValue.Format( "%u <\[^[̃gC̐>", m_tSetUpInfo.wSorterStatus );
		break;
	case NPS_SetUpInfo_wCvpStatus:
		switch ( m_tSetUpInfo.wCvpStatus )
		{
		case INFO_SMCMT1BPUNSET:	str = _T("AZbg");		break;
		case INFO_SMCMT1BPSET:		str = _T("1sw\");	break;
		case INFO_SMCMT2BPSET:		str = _T("2sw\");	break;
		}
		strValue.Format( "%s <CVP󎚍s>", str );
		break;
	case NPS_SetUpInfo_wSupportPaperFitting:
		switch ( m_tSetUpInfo.wSupportPaperFitting )
		{
		case INFO_PFNO:	str = _T("tBbeBOΉ");	break;
		case INFO_PFOK:	str = _T("tBbeBOΉ");		break;
		}
		strValue.Format( "%s <T|[gy[p[tBbeBO>", str );
		break;
	case NPS_SetUpInfo_wSupportEdgeEnhancement:
		switch ( m_tSetUpInfo.wSupportEdgeEnhancement )
		{
		case INFO_EENO:	str = _T("GbWΉ");	break;
		case INFO_EEOK:	str = _T("GbWΉ");		break;
		}
		strValue.Format( "%s <T|[gGbW>", str );
		break;
	case NPS_SetUpInfo_wSupportWithBorder:
		switch ( m_tSetUpInfo.wSupportWithBorder )
		{
		case INFO_WBNO:	str = _T("쐬Ή");	break;
		case INFO_WBOK:	str = _T("쐬Ή");		break;
		}
		strValue.Format( "%s <T|[g쐬>", str );
		break;
	case NPS_SetUpInfo_wMachinTypeForProfile:
		strValue.Format( "%u <vt@Cp@R[h>", m_tSetUpInfo.wMachinTypeForProfile );
		break;
	case NPS_SetUpInfo_wPaperTypeCode:
		strValue.Format( "%u <y[p[^CvR[h>", m_tSetUpInfo.wPaperTypeCode );
		break;
	case NPS_SetUpInfo_wSupportCMS:
		switch ( m_tSetUpInfo.wSupportCMS )
		{
		case INFO_CMSNO:	str = _T("CMSΉ");	break;
		case INFO_CMSOK:	str = _T("CMSΉ");	break;
		}
		strValue.Format( "%s <T|[gCMS>", str );
		break;
	case NPS_SetUpInfo_wSetupAlgorithm:
		strValue.Format( "%u <ZbgAbvASY>", m_tSetUpInfo.wSetupAlgorithm );
		break;
	case NPS_SetUpInfo_wSupportDuplex:
		switch ( m_tSetUpInfo.wSupportDuplex )
		{
		case INFO_DUPLEXNO:	str = _T("ʈΉ");	break;
		case INFO_DUPLEXOK:	str = _T("ʈΉ");	break;
		}
		strValue.Format( "%s <T|[gʈ>", str );
		break;
	case NPS_SetUpInfo_dwFadAttachNo:
		strValue.Format( "%u <FADڑԍ>", m_tSetUpInfo.dwFadAttachNo );
		break;
	case NPS_SetUpInfo_wSupportInterrupt:	// @@@RD-151Ή	2012.02.20	T.Mizushima
		switch ( m_tSetUpInfo.wSupportInterrupt )
		{
		case INFO_SUPPORTINTNO:		str = _T( "Ή" );					break;
		case INFO_SUPPORTINTOK:		str = _T( "Ή" );						break;
		case INFO_SUPPORTINTNEW:	str = _T( "V^(RD-151^Cv)Ή" );	break;
		}
		strValue.Format( "%s <f>", str );
		break;
	case NPS_DateTime_tDate:
		strValue.Format( "%04u/%02u/%02u <t>",
							m_tDateTime.tDate.dwYear,
							m_tDateTime.tDate.dwMonth,
							m_tDateTime.tDate.dwDay );
		break;
	case NPS_DateTime_tTime:
		strValue.Format( "%02u:%02u'%02u <>",
							m_tDateTime.tTime.dwHour,
							m_tDateTime.tTime.dwMinute,
							m_tDateTime.tTime.dwSecond );
		break;
	case NPS_PrintNumInfo_dwSdkReserver:
		strValue.Format( "%u  <Cuł̖vg>", m_tPrintNumInfo.dwSdkReserver );
		break;
	case NPS_PrintNumInfo_dwFrmRatio:
		strValue.Format( "%u  <t[gp>", m_tPrintNumInfo.dwFrmRatio );
		break;
	case NPS_PrintNumInfo_dwReserver:
		strValue.Format( "%u  <v^҂>", m_tPrintNumInfo.dwReserver );
		break;
	case NPS_PrintNumInfo_dwPrtNumber:
		strValue.Format( "%u  <v^>", m_tPrintNumInfo.dwPrtNumber );
		break;
	case NPS_PrintNumInfo_dwProNumber:
		strValue.Format( "%u  <vZT[>", m_tPrintNumInfo.dwProNumber );
		break;
	case NPS_PrintNumInfo_dwTotalCount:
		strValue.Format( "%u  <CȗSĂ̑>", m_tPrintNumInfo.dwTotalCount );
		break;
	case NPS_MagInfo_Element1:
	case NPS_MagInfo_Element2:
	case NPS_MagInfo_Element3:
	case NPS_MagInfo_Element4:
	case NPS_MagInfo_Element5:
		std::vector<NPS_MagInfo>::iterator itMagInfo=m_vMagInfo.end();
		if ( NPS_MagInfo_Element1 == eType )	if ( 0 < m_vMagInfo.size() )	itMagInfo = m_vMagInfo.begin() + 0;
		if ( NPS_MagInfo_Element2 == eType )	if ( 1 < m_vMagInfo.size() )	itMagInfo = m_vMagInfo.begin() + 1;
		if ( NPS_MagInfo_Element3 == eType )	if ( 2 < m_vMagInfo.size() )	itMagInfo = m_vMagInfo.begin() + 2;
		if ( NPS_MagInfo_Element4 == eType )	if ( 3 < m_vMagInfo.size() )	itMagInfo = m_vMagInfo.begin() + 3;
		if ( NPS_MagInfo_Element5 == eType )	if ( 4 < m_vMagInfo.size() )	itMagInfo = m_vMagInfo.begin() + 4;
		if ( m_vMagInfo.end() != itMagInfo )
		{
			if ( 0 == (*itMagInfo).dwFeed )
			{
				// [
				strValue.Format( "[%u] ROLL  %.1f(%u) c:%.4fm",
							(*itMagInfo).dwPresence,
							(double)(*itMagInfo).dwWidth / 10.,
							(*itMagInfo).dwSurface,
							(double)(*itMagInfo).dwRemain / 10000. );
			}
			else
			{
				// V[g
				strValue.Format( "[%u] SHEET %s c:%.4fm ʎ:%u",
							(*itMagInfo).dwPresence,
							(*itMagInfo).szName,
							(double)(*itMagInfo).dwRemain / 10000.,
							(*itMagInfo).dwSurface );
			}
		}
		break;
	}

	return strValue;
}
