// NpsLib.h: CNpsLib NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NPSLIB_H__DC7A8406_418D_4342_A60B_C6E5810EFCC4__INCLUDED_)
#define AFX_NPSLIB_H__DC7A8406_418D_4342_A60B_C6E5810EFCC4__INCLUDED_

#include "Nps.h"
#include <vector>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum ENUM_VARIABLE_TYPE {
	NPS_UnitInfo_dwPrinterStatus,
	NPS_UnitInfo_dwAcceptStatus,
	NPS_UnitInfo_dwPrinterPossession,
	NPS_UnitInfo_dwAdvanceStatus,
	NPS_UnitInfo_dwLaserStatus,
	NPS_UnitInfo_dwDevelopmentStatus,
	NPS_UnitInfo_dwProcessorStatus,
	NPS_UnitInfo_dwReplenisherStatus,
	NPS_UnitInfo_dwReplaceCartridgeStatus,
	NPS_UnitInfo_dwStartUpChecksStatus,
	NPS_UnitInfo_dwRefillWaterStatus,
	NPS_UnitInfo_dwDailySetupStatus,
	NPS_UnitInfo_dwControlStripStatus,
	NPS_UnitInfo_dwMaintenanceStatus,
	NPS_UnitInfo_dwFadStatus,
	NPS_UnitInfo_stInstMag,
	NPS_UnitInfo_stInfoMag,
	NPS_SetUpInfo_szMachineTypeName,
	NPS_SetUpInfo_szSoftName,
	NPS_SetUpInfo_szSerialNumber,
	NPS_SetUpInfo_wSupportResolutions,
	NPS_SetUpInfo_wNpsVersion,
	NPS_SetUpInfo_wMachineTypeID,
	NPS_SetUpInfo_dwTotalMemory,
	NPS_SetUpInfo_dwImageSizeMinWidth,
	NPS_SetUpInfo_dwImageSizeMinHeight,
	NPS_SetUpInfo_dwImageSizeMaxWidth,
	NPS_SetUpInfo_dwImageSizeMaxHeight,
	NPS_SetUpInfo_dwNumberOfMagazine,
	NPS_SetUpInfo_PrinterTime,
	NPS_SetUpInfo_dwRepeatCountMax,
	NPS_SetUpInfo_SupportImageFormat,
	NPS_SetUpInfo_wLaminatorUnitAttach,
	NPS_SetUpInfo_InstallationDate,
	NPS_SetUpInfo_OperationStartDate,
	NPS_SetUpInfo_wProcessorType,
	NPS_SetUpInfo_wEmulsionNumber,
	NPS_SetUpInfo_szPrinterNickname,
	NPS_SetUpInfo_wSupportAngle,
	NPS_SetUpInfo_wSupportIntoPrinter,
	NPS_SetUpInfo_wSorterStatus,
	NPS_SetUpInfo_wCvpStatus,
	NPS_SetUpInfo_wSupportPaperFitting,
	NPS_SetUpInfo_wSupportEdgeEnhancement,
	NPS_SetUpInfo_wSupportWithBorder,
	NPS_SetUpInfo_wMachinTypeForProfile,
	NPS_SetUpInfo_wPaperTypeCode,
	NPS_SetUpInfo_wSupportCMS,
	NPS_SetUpInfo_wSetupAlgorithm,
	NPS_SetUpInfo_wSupportDuplex,
	NPS_SetUpInfo_dwFadAttachNo,
	NPS_SetUpInfo_wSupportInterrupt,	// @@@RD-151Ή	2012.02.20	T.Mizushima
	NPS_DateTime_tDate,
	NPS_DateTime_tTime,
	NPS_PrintNumInfo_dwSdkReserver,
	NPS_PrintNumInfo_dwFrmRatio,
	NPS_PrintNumInfo_dwReserver,
	NPS_PrintNumInfo_dwPrtNumber,
	NPS_PrintNumInfo_dwProNumber,
	NPS_PrintNumInfo_dwTotalCount,
	NPS_MagInfo_Element1,
	NPS_MagInfo_Element2,
	NPS_MagInfo_Element3,
	NPS_MagInfo_Element4,
	NPS_MagInfo_Element5,
};

typedef struct {
	NPS_UnitInfo	stUnitInfo;
	SYSTEMTIME		stInstMag;
	SYSTEMTIME		stInfoMag;
} NPS_UnitInfoEx, *PNPS_UnitInfoEx;

class CNpsLib  
{
public:
	CNpsLib( DWORD dwMode );
	virtual ~CNpsLib();

	BOOL npsSearchPrinter2( LPWORD pPrinterNum, DWORD dwWaitTime );
	BOOL npsGetPrinter( WORD wBufferNum, PNPS_PRINTER_ENUM pPrinterInfo );
	BOOL npsDevOpen( DWORD dwIPAddress );
	BOOL npsDevClose();
	BOOL npsDevGetUnitInfo();
	BOOL npsDevGetMagInfo();
	BOOL npsDevGetAllMagInfo();
	BOOL npsDevGetSetUpInfo();
	BOOL npsDevGetPrintNumInfo();
	BOOL npsDevGetTime();
	BOOL npsDevStartOrderEx( DWORD* pdwOrderId, DWORD dwPriority, DWORD dwSorterNum, DWORD dwSortFrame, DWORD dwExOptions );
	BOOL npsDevEndOrder( DWORD dwOrderId );
	BOOL npsDevPrint( DWORD dwOrderId, LPDWORD pPrintID, PNPS_PrintInfo pPrintInfo );
	BOOL npsDevSort( DWORD dwOrderId );
	BOOL npsDevCancelPrintOrder( DWORD dwOrderId, DWORD dwPrintID );
	BOOL npsDevStartDuplex( DWORD dwOrderId );
	BOOL npsDevEndDuplex( DWORD dwOrderId );
	BOOL npsDevBlankPrint( DWORD dwOrderId, LPDWORD pPrintID, PNPS_BlankPrintInfo pBlankPrintInfo );
	BOOL npsDevResetEvent( DWORD dwErrHandle, DWORD dwActionId );
	BOOL npsDevCtrlPrint( DWORD dwCtrl );

	void SetMemberDataOfUnitInfo( NPS_UnitInfoEx* ptUnitInfoEx );

	BOOL GetMemberDataOfUnitInfo( NPS_UnitInfoEx* ptUnitInfoEx );
	BOOL GetMemberDataOfSetUpInfo( NPS_SetUpInfo* ptSetUpInfo );
	BOOL GetMemberDataOfMagInfo( int nIdx, NPS_MagInfo* ptMagInfo );
	BOOL GetMemberDataOfMagDetailInfo( int nIdx, NPS_MagDetailInfo* ptMagDetailInfo );
	BOOL GetMemberDataOfEventInfo( int nIdx, NPSEVENTINFO* ptEventInfo );

	CString GetStringData( ENUM_VARIABLE_TYPE eType );

	void AddEventInfo( NPSEVENTINFO* ptEventInfo );
	void DelEventInfo( NPSEVENTINFO* ptEventInfo );

private:

	void ClearMemberDataOfLibOpen();
	void ClearMemberDataOfDevOpen();
	void ClearMemberDataOfOnLine();

private:

	CRITICAL_SECTION				m_csMemberData;

	HPRINTER						m_hPrinter;
	BOOL							m_bLibOpen;
	BOOL							m_bDevOpen;
	BOOL							m_bOnLine;

	NPS_UnitInfoEx					m_tUnitInfoEx;
	NPS_SetUpInfo					m_tSetUpInfo;
	NPS_PrintNumInfo				m_tPrintNumInfo;
	NPS_DateTime					m_tDateTime;
	std::vector<NPSEVENTINFO>		m_vEventInfo;
	std::vector<NPS_MagInfo>		m_vMagInfo;
	std::vector<NPS_MagDetailInfo>	m_vMagDetailInfo;

	void SetMemberDataOfSetUpInfo( NPS_SetUpInfo* ptSetUpInfo );
	void SetMemberDataOfPrintNumInfo( NPS_PrintNumInfo* ptPrintNumInfo );
	void SetMemberDataOfDateTime( NPS_DateTime* ptDateTime );
};

void CreateNpsLib( DWORD dwMode );
void DropNpsLib();
CNpsLib* GetNpsLib();

#endif // !defined(AFX_NPSLIB_H__DC7A8406_418D_4342_A60B_C6E5810EFCC4__INCLUDED_)
