//////////////////////////////////////////////////////////////////////////////
//	FILE NAME : CNpsCmd.cpp
//	ABSTRACT  : CNpsCmd NX̃Cve[V
//	
//	CREATE    : T.Isogai	2006.7.6
//	UPDATE    : 
//	
//										(C)Copyright : Noritsu Koki CO.,LTD.
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NpsCmd.h"
#include "SendCmdBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCmd::CNpsCmd()
//	ABSTRACT : RXgN^
//	FUNCTION : RXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCmd::CNpsCmd()
{
	InitializeCriticalSection( &m_csSend );
	InitializeCriticalSection( &m_CS );

	m_pDataManager	= NULL;

	//m_TimeOut	= INFINITE;
	m_TimeOut	= NPS_DEFAULT_TIMEOUT;

	{	// ꊇM
		::ZeroMemory( m_bySendBuffer, sizeof(m_bySendBuffer) );
		m_wSendSize = 0;
	}

	{	// M
		::ZeroMemory( m_byBuffer, sizeof(m_byBuffer) );
		m_wWritePoint = 0;
		m_wHeaderRemain = 4;
		m_wTagRemain = 4;
		m_wTagValue = 0;
	}

	m_pCallbackFuncEventEx = NULL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCmd::~CNpsCmd()
//	ABSTRACT : fXgN^
//	FUNCTION : fXgN^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
CNpsCmd::~CNpsCmd()
{
	Close();

	// CxgIɃZbgďI
	m_RecvRequestControl.EventAllSetOffline();

	DeleteCriticalSection( &m_CS );
	DeleteCriticalSection( &m_csSend );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetDataManager()
//	ABSTRACT : v^Ǘ̓o^
//	FUNCTION : v^Ǘo^
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.10.13
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCmd::SetDataManager( CDataManager * pDataManager )
{
	m_pDataManager	= pDataManager;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CallCallbackFuncUnit()
//	ABSTRACT : v^ԕύXʒmM
//	FUNCTION : v^ԕύXʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS6000H_F102H_PROC)(
		T_Nps6000H_F102H *	pInfo,
		LPVOID				pParam
);

void CNpsCmd::CallCallbackFuncUnit( BYTE * lpBuff, unsigned long AttSize )
{
	T_Nps6000H_F102H	wNps6000H_F102H;

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( &wNps6000H_F102H, sizeof(T_Nps6000H_F102H) );

	ULONG	RecvBufLen			= AttSize;

	int		Type	= NPS_DATATYPE_TAG_NO;
	ULONG	Counter	= 0;
	USHORT	TagNo;
	USHORT	Length;
	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	BYTE*	pRecvBuf	= lpBuff;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.PrinterStatus),			NPS_UCHAR ); } break;	// v^Ŝ̏ iv^S̏ԁj
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.AcceptStatus),				NPS_UCHAR ); } break;	// t
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.PrinterPossession),		NPS_UCHAR ); } break;	// v^L̏
			case 4:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.MagagineChange),			NPS_UCHAR ); } break;	// }KW̑^
			case 5:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.AdvanceStatus),			NPS_UCHAR ); } break;	// v^Ŝ̏ inŚj
			case 6:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.LaserStatus),				NPS_UCHAR ); } break;	// w[U[̏ iw[U[j
			case 7:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.DevelopmentStatus),		NPS_UCHAR ); } break;	// vZT[Ŝ̏ inŚj
			case 8:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.ProcessorStatus),			NPS_UCHAR ); } break;	// ̏ ij
			case 9:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.ReplenisherStatus),		NPS_UCHAR ); } break;	// [Ŝ̏ i[j
			case 10:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.ReplaceCartridgeStatus),	NPS_UCHAR ); } break;	// [J[gbW̌̉ i[J[gbWj
			case 11:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.PaperInfoChange),			NPS_UCHAR ); } break;	// Sy[p[̏
			case 12:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.StartUpChecksStatus),		NPS_UCHAR ); } break;	// nƓ_̎{
			case 13:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.RefillWaterStatus),		NPS_UCHAR ); } break;	// I[gZbgAbvł̕␅̎{
			case 14:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.DailySetupStatus),			NPS_UCHAR ); } break;	// I[gZbgAbvł̃fC[ZbgAbv̎{
			case 15:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.ControlStripStatus),		NPS_UCHAR ); } break;	// I[gZbgAbvł̃Rg[Xgbv̎{
			case 16:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.InMaintenance),			NPS_UCHAR ); } break;	// eiX
			case 17:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F102H.FadStatus),				NPS_UCHAR ); } break;	// FAD̏
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	{	// Oo
		CString str;
		str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0xF102H ) [01]=0x%02X, [02]=0x%02X, [03]=0x%02X, [04]=0x%02X, [05]=0x%02X, [06]=0x%02X, [07]=0x%02X, [08]=0x%02X, [09]=0x%02X, [10]=0x%02X, [11]=0x%02X, [12]=0x%02X, [13]=0x%02X, [14]=0x%02X, [15]=0x%02X, [16]=0x%02X, [17]=0x%02X",
						wNps6000H_F102H.PrinterStatus,
						wNps6000H_F102H.AcceptStatus,
						wNps6000H_F102H.PrinterPossession,
						wNps6000H_F102H.MagagineChange,
						wNps6000H_F102H.AdvanceStatus,
						wNps6000H_F102H.LaserStatus,
						wNps6000H_F102H.DevelopmentStatus,
						wNps6000H_F102H.ProcessorStatus,
						wNps6000H_F102H.ReplenisherStatus,
						wNps6000H_F102H.ReplaceCartridgeStatus,
						wNps6000H_F102H.PaperInfoChange,
						wNps6000H_F102H.StartUpChecksStatus,
						wNps6000H_F102H.RefillWaterStatus,
						wNps6000H_F102H.DailySetupStatus,
						wNps6000H_F102H.ControlStripStatus,
						wNps6000H_F102H.InMaintenance,
						wNps6000H_F102H.FadStatus );
		NPS_LOGOUT( str );
	}

	( ( NPS6000H_F102H_PROC )( m_pCallbackFuncUnit ) )( &wNps6000H_F102H, m_pCallbackFuncUnitParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CallCallbackFuncEvent()
//	ABSTRACT : v^CxgʒmM
//	FUNCTION : v^CxgʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS6000H_F202H_PROC)(
		T_Nps6000H_F202H *	pInfo,
		LPVOID				pParam
);

void CNpsCmd::CallCallbackFuncEvent( BYTE * lpBuff, unsigned long AttSize )
{
	T_Nps6000H_F202H	wNps6000H_F202H;

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( &wNps6000H_F202H, sizeof(T_Nps6000H_F202H) );

	// o̓f[^̍쐬
	USHORT	wIfId				= 0x6000;
	USHORT	wRecvCmdId			= 0xF202;
	ULONG	RecvBufLen			= AttSize;

	int		Type	= NPS_DATATYPE_TAG_NO;
	ULONG	Counter	= 0;
	USHORT	TagNo;
	USHORT	Length;
	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	BYTE*	pRecvBuf	= lpBuff;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F202H.EventCode),			NPS_ULONG ); } break;	// CxgR[h iԁj
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F202H.EventStatus),			NPS_UCHAR ); } break;	// Cxg̔E
			case 3:{ for( int Array = 0; Array < 8; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(wNps6000H_F202H.OccurredTime[Array]),	NPS_USHORT ); } break;	// 
			case 4:{ for( int Array = 0; Array < 4; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( LONG ) * Array ),		(BYTE*)&(wNps6000H_F202H.EventParam[Array]),	NPS_LONG ); } break;	// Cxg̃p[^ ilj
			case 5:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F202H.EventId),				NPS_ULONG ); } break;	// Cxgʎq
			case 6:
				{	// ͂ߍݕ
					int nIdx;
					int nArrayPos	= 0;
					int nStrPos		= 0;

					BYTE* pSrc = (BYTE*)pRecvBuf + Counter;

					for( nIdx = 0; nIdx < Length; nIdx++ )
					{
						wNps6000H_F202H.EventString[nArrayPos][nStrPos] = pSrc[nIdx];

						if( 0 == pSrc[nIdx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				}
				break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	{	// Oo
		CString str;
		str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0xF202H ) %05d, %05d, 0x%02X, %04d%02d%02d %02d%02d%02d%03d(%d), [0x%08X][0x%08X][0x%08X], [%s][%s][%s][%s], 0x%08X",
						wNps6000H_F202H.EventCode,
						wNps6000H_F202H.EventParam[0],
						wNps6000H_F202H.EventStatus,
						wNps6000H_F202H.OccurredTime[0],
						wNps6000H_F202H.OccurredTime[1],
						wNps6000H_F202H.OccurredTime[2],
						wNps6000H_F202H.OccurredTime[3],
						wNps6000H_F202H.OccurredTime[4],
						wNps6000H_F202H.OccurredTime[5],
						wNps6000H_F202H.OccurredTime[6],
						wNps6000H_F202H.OccurredTime[7],
						wNps6000H_F202H.EventParam[1],
						wNps6000H_F202H.EventParam[2],
						wNps6000H_F202H.EventParam[3],
						wNps6000H_F202H.EventString[0],
						wNps6000H_F202H.EventString[1],
						wNps6000H_F202H.EventString[2],
						wNps6000H_F202H.EventString[3],
						wNps6000H_F202H.EventId );
		NPS_LOGOUT( str );
	}

	( ( NPS6000H_F202H_PROC )( m_pCallbackFuncEvent ) )( &wNps6000H_F202H, m_pCallbackFuncEventParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CallCallbackFuncCompletion()
//	ABSTRACT : vg󋵒ʒmM
//	FUNCTION : vg󋵒ʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS6000H_F302H_PROC)(
		T_Nps6000H_F302H *	pInfo,
		LPVOID				pParam
);

void CNpsCmd::CallCallbackFuncCompletion( BYTE * lpBuff, unsigned long AttSize )
{
	T_Nps6000H_F302H	wNps6000H_F302H;

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( &wNps6000H_F302H, sizeof(T_Nps6000H_F302H) );

	// o̓f[^̍쐬
	USHORT	wIfId				= 0x6000;
	USHORT	wRecvCmdId			= 0xF302;
	ULONG	RecvBufLen			= AttSize;

	int		Type	= NPS_DATATYPE_TAG_NO;
	ULONG	Counter	= 0;
	USHORT	TagNo;
	USHORT	Length;
	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	BYTE*	pRecvBuf	= lpBuff;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F302H.ReceiptNumber),		NPS_ULONG ); } break;	// tԍ
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F302H.PrintStatus),			NPS_UCHAR ); } break;	// vg
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F302H.RepeatCount),			NPS_USHORT ); } break;	// s[g
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	{	// Oo
		CString str;
		str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0xF302H ) ReceiptNo=%d, Status=0x%02X, Repeat=%d",
			wNps6000H_F302H.ReceiptNumber,
			wNps6000H_F302H.PrintStatus,
			wNps6000H_F302H.RepeatCount);
		NPS_LOGOUT( str );
	}

	( ( NPS6000H_F302H_PROC )( m_pCallbackFuncCompletion ) )( &wNps6000H_F302H, m_pCallbackFuncCompletionParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CallCallbackFuncFunction()
//	ABSTRACT : ㏈sʒmM
//	FUNCTION : ㏈sʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS6000H_F502H_PROC)(
		T_Nps6000H_F502H *	pInfo,
		LPVOID				pParam
);

void CNpsCmd::CallCallbackFuncFunction( BYTE * lpBuff, unsigned long AttSize )
{
	T_Nps6000H_F502H	wNps6000H_F502H;

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( &wNps6000H_F502H, sizeof(T_Nps6000H_F502H) );

	// o̓f[^̍쐬
	USHORT	wIfId				= 0x6000;
	USHORT	wRecvCmdId			= 0xF502;
	ULONG	RecvBufLen			= AttSize;

	int		Type	= NPS_DATATYPE_TAG_NO;
	ULONG	Counter	= 0;
	USHORT	TagNo;
	USHORT	Length;
	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	BYTE*	pRecvBuf	= lpBuff;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F502H.FunctionCode),		NPS_USHORT ); } break;	// @\ʃR[h
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6000H_F502H.Parameter1),		NPS_LONG   ); } break;	// ėpp[^1
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	{	// Oo
		CString str;
		str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0xF502H ) FunctionCode=%d, Parameter1=%d",
			wNps6000H_F502H.FunctionCode, wNps6000H_F502H.Parameter1 );
		NPS_LOGOUT( str );
	}

	( ( NPS6000H_F502H_PROC )( m_pCallbackFuncFunction ) )( &wNps6000H_F502H, m_pCallbackFuncFunctionParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CallCallbackFuncEventEx()
//	ABSTRACT : v^CxggʒmM
//	FUNCTION : v^CxggʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu		2011.11.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS6001H_F102H_PROC)(
		T_Nps6001H_F102H *	pInfo,
		LPVOID				pParam
);

void CNpsCmd::CallCallbackFuncEventEx( BYTE * lpBuff, unsigned long AttSize )
{
	T_Nps6001H_F102H	wNps6001H_F102H;

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( &wNps6001H_F102H, sizeof(T_Nps6001H_F102H) );

	// o̓f[^̍쐬
	ULONG	RecvBufLen	= AttSize;

	int		Type	= NPS_DATATYPE_TAG_NO;
	ULONG	Counter	= 0;
	USHORT	TagNo;
	USHORT	Length;
	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	BYTE*	pRecvBuf	= lpBuff;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6001H_F102H.ReceiptNumber),	NPS_ULONG ); } break;	// tԍ
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6001H_F102H.EventId),			NPS_ULONG ); } break;	// Cxgʎq
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(wNps6001H_F102H.EventCodeMain),	NPS_USHORT ); } break;	// CxgR[h iԁj
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	{	// Oo
		CString str;
		str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0xF102H ) ReceiptNumber=%d, EventId=%d, EventCodeMain=%d",
						wNps6001H_F102H.ReceiptNumber,
						wNps6001H_F102H.EventId,
						wNps6001H_F102H.EventCodeMain );
		NPS_LOGOUT( str );
	}
	
	if( NULL == m_pCallbackFuncEventEx )
	{
		NPS_LOGOUT( "m_pCallbackFuncEventEx() : NPSERR_BADPARAM" );
		return;
	}

	( ( NPS6001H_F102H_PROC )( m_pCallbackFuncEventEx ) )( &wNps6001H_F102H, m_pCallbackFuncEventExParam );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::ReadCmdHdr()
//	ABSTRACT : NPSR}h̃wb_[擾
//	FUNCTION : NPSR}h̃wb_[擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2006.7.19
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::ReadCmdHdr( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId )
{
	WORD wId1;
	WORD wId2;

	::memcpy( &wId1, lpBuffer, sizeof(WORD) );
	::memcpy( &wId2, lpBuffer + sizeof(WORD), sizeof(WORD) );

	wInterfaceId = NkcComApi::ntohs( wId1 );
	wCommandId = NkcComApi::ntohs( wId2 );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::Read6000H_FFFFH()
//	ABSTRACT : R}hT|[gʒmM
//	FUNCTION : R}hT|[gʒmM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::Read6000H_FFFFH( LPBYTE lpBuffer, WORD &wInterfaceId, WORD &wCommandId )
{
	int		Type		= NPS_DATATYPE_TAG_NO;
	USHORT	TagNo;
	USHORT	Length;
	BYTE*	pBufAtt;
	ULONG	Counter	= 0;

	pBufAtt	= lpBuffer;

	// Mf[^ǂݎ
	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			TagNo	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			TagNo	= ntohs( TagNo );

			if( 0 == TagNo )
			{
				break;
			}

			Type	= NPS_DATATYPE_TAG_LENGTH;
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			Length	= *( (USHORT*)&pBufAtt[ Counter ] );
			Counter += sizeof( USHORT );
			Length	= ntohs( Length );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:
				{
					USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ Counter ];
					wInterfaceId	= ntohs( *pusTmp );
				}
				break;
			case 2:
				{
					USHORT* pusTmp	= ( USHORT* ) &pBufAtt[ Counter ];
					wCommandId	= ntohs( *pusTmp );
				}
				break;
			default:break;
			}

			Counter += Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::RecvEndFunc()
//	ABSTRACT : R}hI[M
//	FUNCTION : R}hI[M
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::RecvEndFunc( LPBYTE lpBuffer, unsigned long AttSize )
{
	WORD				wIfId;			// C^[tFCXID
	WORD				wCmdId;			// R}hID
	BOOL				bResult;

	ReadCmdHdr( lpBuffer, wIfId, wCmdId );

	{	// Oo
		CString	str;
		switch ( MAKELONG( wCmdId, wIfId ) )
		{
			case 0x60000101:	// v^{̎擾
			case 0x60000201:	// v^ݒ̎擾
			case 0x60000301:	// v^Ԃ̎擾
			case 0x60000401:	// y[p[̎擾
			case 0x60000501:	// v^LJn
			case 0x60000601:	// v^LI
			case 0x60000701:	// tJn
			case 0x60000801:	// 摜MmF
			case 0x60000901:	// vg
			case 0x60000A01:	// v^Cxg
			case 0x60000B01:	// gCύX
			case 0x60000C01:	// vg擾
			case 0x60000D01:	// vg~ ivg̒~ƒ~j
			case 0x60000E01:	// ڑJn
			case 0x60001201:	// vgIvVݒ
			case 0x60001301:	// Sy[p[̎擾
			case 0x60001601:	// ʈJn
			case 0x60001701:	// ʈI
			case 0x60001801:	// 󔒃vg
			case 0x60001901:	// I[_[		@@@RD-151Ή	2012.04.12	T.Mizushima
			case 0x6000F102:	// v^ԕύXʒm
			case 0x6000F202:	// v^Cxgʒm
			case 0x6000F302:	// vg󋵒ʒm
			case 0x6000F502:	// ㏈sʒm
			case 0x6000FFFF:	// R}hT|[gʒm
			case 0x6000FF01:	// ʐMȂ̂ŃOɂ͏o͂Ȃ
			case 0x60010701:	// ^[Qbg擾
			case 0x60010801:	// ^[Qbgf[^XVv
			case 0x60010901:	// vt@Co[WXVv
			case 0x60010A01:	// FADgpJnv
				// e͕ŃOo͂̂ŁAł̓Oo͂Ȃ
				break;
			default:
				str.Format( " --COMMAND RECV( IfId=0x%04XH, CmdId=0x%04XH, AttSize=%d )", wIfId, wCmdId, AttSize );
				NPS_LOGOUT( str );
				break;
		}
	}

	// BNpsNotice`FbN
	m_NoticeRequestControl.SetBuf( wIfId, wCmdId, lpBuffer + sizeof( DWORD ), AttSize );

	// @MvXg`FbN
	bResult	= m_RecvRequestControl.SetBuf( wIfId, wCmdId, lpBuffer + sizeof( DWORD ), AttSize );

	if( bResult )
	{
		return TRUE;
	}

	// A񓯊o^Xg`FbN
	if( ( 0x6000 == wIfId ) && ( 0xF102 == wCmdId ) )
	{
		CallCallbackFuncUnit( lpBuffer + sizeof( DWORD ), AttSize );
		return TRUE;
	}
	else if( ( 0x6000 == wIfId ) && ( 0xF202 == wCmdId ) )
	{
		CallCallbackFuncEvent( lpBuffer + sizeof( DWORD ), AttSize );
		return TRUE;
	}
	else if( ( 0x6000 == wIfId ) && ( 0xF302 == wCmdId ) )
	{
		CallCallbackFuncCompletion( lpBuffer + sizeof( DWORD ), AttSize );
		return TRUE;
	}
	else if( ( 0x6000 == wIfId ) && ( 0xF502 == wCmdId ) )
	{
		CallCallbackFuncFunction( lpBuffer + sizeof( DWORD ), AttSize );
		return TRUE;
	}
	else if( ( 0x6001 == wIfId ) && ( 0xF102 == wCmdId ) )
	{
		CallCallbackFuncEventEx( lpBuffer + sizeof( DWORD ), AttSize );
		return TRUE;
	}

	// BR}hT|[gʒmłꍇ
	if( ( 0x6000 == wIfId ) && ( 0xFFFF == wCmdId ) )
	{
		WORD	wNotSupportIfId		= 0;
		WORD	wNotSupportCmdId	= 0;
		Read6000H_FFFFH( lpBuffer + sizeof( DWORD ), wNotSupportIfId, wNotSupportCmdId );
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0xFFFFH, IfId=0x%04XH, CmdId=0x%04XH )", wNotSupportIfId, wNotSupportCmdId );
			NPS_LOGOUT( str );
		}
		m_RecvRequestControl.NoticeNotSupport( wNotSupportIfId, wNotSupportCmdId );
		return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OnClose()
//	ABSTRACT : I[o[Ch
//	FUNCTION : Close p
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
typedef VOID  (CALLBACK*  NPS_SOCKETCLOSE_PROC)(
		LPVOID				pParam
);

void CNpsCmd::OnClose( int nErrorCode )
{
	( ( NPS_SOCKETCLOSE_PROC )( m_pCallbackFuncSocketClose ) )( m_pCallbackFuncSocketCloseParam );

	CWS2Tcp::OnClose( nErrorCode );
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::Send()
//	ABSTRACT : f[^̑Ms܂
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::Send( const void* lpBuf, int nBufLen, DWORD dwFlags )
{
	BOOL bResult;

	bResult = CWS2Tcp::Send( lpBuf, nBufLen, dwFlags );

	if ( TRUE == bResult )
	{
		// ŏIMԂL^
		m_pDataManager->UpdateSendLastTime();
	}

	return bResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OnReceive()
//	ABSTRACT : I[o[Ch
//	FUNCTION : f[^M p
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCmd::OnReceive( int nErrorCode )
{
	{	// M
		int nRecv;
		DWORD dwTagHeader=0;

		// R}hwb_̓ǂݍ
		while ( TRUE )
		{
			if ( 0 < m_wHeaderRemain ) {
				nRecv = Receive( &m_byBuffer[m_wWritePoint], m_wHeaderRemain );
				if ( 0 < nRecv ) {
					m_wWritePoint += nRecv;
					m_wHeaderRemain -= nRecv;
				} else {
					{	// Oo
						NPS_LOGOUT_DEBUG( "===NPSCMD RECEIVE SIZE 0 BYTE" );
					}
					return;
				}
			} else {
				break;
			}
		}

		while ( TRUE )
		{
			// Tagwb_ǂݍ
			if ( 0 < m_wTagRemain ) {
				nRecv = Receive( &m_byBuffer[m_wWritePoint], m_wTagRemain );
				if ( 0 < nRecv ) {
					m_wWritePoint += nRecv;
					m_wTagRemain -= nRecv;

					if ( 0 == m_wTagRemain ) {
						::memcpy( &dwTagHeader, &m_byBuffer[m_wWritePoint-sizeof(dwTagHeader)], sizeof(dwTagHeader) );
						if ( 0 != dwTagHeader ) {
							m_wTagValue = NkcComApi::ntohs( HIWORD(dwTagHeader) );

							#if 0 // ÔŃRg Y.Yoshinobu 2006.11.27
							#ifdef _DEBUG
							{
								WORD wTagNo = NkcComApi::ntohs( LOWORD(dwTagHeader) );
								CString	str;
								str.Format( "RCV Tag[%02d] Length[%03d]", wTagNo, m_wTagValue );
								NPS_LOGOUT_DEBUG( str );
							}
							#endif
							#endif // #if 0

							if ( 0 == m_wTagValue ) {
								// ^O̒0̏ꍇ́ATag̓ǂݍ݂Ɉړ
								m_wTagRemain = 4;
							}
						} else {
							// I[Tagǂݍ񂾂̂œǂݍݏI

							// I[ 
							RecvEndFunc( m_byBuffer, m_wWritePoint - sizeof( dwTagHeader ) );
							// I[ 

							// 
							::ZeroMemory( m_byBuffer, sizeof(m_byBuffer) );
							m_wWritePoint = 0;
							m_wHeaderRemain = 4;
							m_wTagRemain = 4;
							m_wTagValue = 0;

							return;
						}
					}
				} else {
					{	// Oo
						NPS_LOGOUT_DEBUG( "===NPSCMD RECEIVE SIZE 0 BYTE" );
					}
					return;
				}
			}

			// Tag̒lǂݍ
			if ( 0 < m_wTagValue ) {
				nRecv = Receive( &m_byBuffer[m_wWritePoint], m_wTagValue );
				if ( 0 < nRecv ) {

					#if 0
					#ifdef _DEBUG
					{
						CString	str1;
						CString	str2;

						for( int i = 0; i < nRecv; i++ )
						{
							str2.Format( " %02X", m_byBuffer[m_wWritePoint +i] );
							str1 += str2;

							if( ( ( i + 1 ) == nRecv ) || ( ( ( i + 1 ) % 16 ) == 0 ) )
							{
								NPS_LOGOUT_DEBUG( str1 );
								str1 = "";
							}
						}
					}
					#endif
					#endif

					m_wWritePoint += nRecv;
					m_wTagValue -= nRecv;

					if ( 0 == m_wTagValue ) {
						m_wTagRemain = 4;
					}
				} else {
					{	// Oo
						NPS_LOGOUT_DEBUG( "===NPSCMD RECEIVE SIZE 0 BYTE" );
					}
					return;
				}
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackSocketClose()
//	ABSTRACT : lbg[NؒfʒmR[obNݒ
//	FUNCTION : lbg[NؒfʒmR[obNݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.22
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncSocketClose( void * pFunc, LPVOID pParam )
{
	// lbg[NؒfʒmR[obNݒ
	m_pCallbackFuncSocketClose		= pFunc;
	m_pCallbackFuncSocketCloseParam	= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackFuncUnit()
//	ABSTRACT : 񓯊ʐMMɌĂяoR[obN֐Zbg
//	FUNCTION : 񓯊ʐMMɌĂяoR[obN֐Zbg
//				iv^ԕύXʒmj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncUnit( void * pFunc, LPVOID pParam )
{
	// v^ԕύXʒmR[obNݒ
	m_pCallbackFuncUnit			= pFunc;
	m_pCallbackFuncUnitParam	= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackFuncEvent()
//	ABSTRACT : 񓯊ʐMMɌĂяoR[obN֐Zbg
//	FUNCTION : 񓯊ʐMMɌĂяoR[obN֐Zbg
//				iv^Cxgʒmj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncEvent( void * pFunc, LPVOID pParam )
{
	// v^CxgʒmR[obNݒ
	m_pCallbackFuncEvent		= pFunc;
	m_pCallbackFuncEventParam	= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackFuncCompletion()
//	ABSTRACT : 񓯊ʐMMɌĂяoR[obN֐Zbg
//	FUNCTION : 񓯊ʐMMɌĂяoR[obN֐Zbg
//				ivg󋵒ʒmj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.31
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncCompletion( void * pFunc, LPVOID pParam )
{
	// vg󋵒ʒmR[obNݒ
	m_pCallbackFuncCompletion		= pFunc;
	m_pCallbackFuncCompletionParam	= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackFuncFunction()
//	ABSTRACT : 񓯊ʐMMɌĂяoR[obN֐Zbg
//	FUNCTION : i㏈sʒmj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.11.28
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncFunction( void * pFunc, LPVOID pParam )
{
	// ㏈sʒmR[obNݒ
	m_pCallbackFuncFunction		= pFunc;
	m_pCallbackFuncFunctionParam= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetCallbackFuncEventEx()
//	ABSTRACT : 񓯊ʐMMɌĂяoR[obN֐Zbg
//	FUNCTION : 񓯊ʐMMɌĂяoR[obN֐Zbg
//				iv^Cxggʒmj
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu	2011.11.15
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetCallbackFuncEventEx( void * pFunc, LPVOID pParam )
{
	// v^CxgʒmR[obNݒ
	m_pCallbackFuncEventEx		= pFunc;
	m_pCallbackFuncEventExParam	= pParam;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetTimeout()
//	ABSTRACT : ʐM̃^CAEglZbg
//	FUNCTION : ʐM̃^CAEglZbg
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetTimeout( ULONG TimeOut )
{
	m_TimeOut	= TimeOut;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::Open()
//	ABSTRACT : v^I[v
//	FUNCTION : v^I[v
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//				1:
//				2:ɃI[vĂ
//				3:CreateɎs
//				4:ConnectɎs
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::Open( LPCTSTR lpszHostAddress, USHORT wNpsPortNo )
{
	if( TRUE == IsOpenSocket() )
	{	
		// OpenĂ
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSCMD SOCKET ALREADY OPEN" );
		}
		return 2;
	}

	if( FALSE == Create() )
	{
		{	// Oo
			NPS_LOGOUT_FATAL( "===NPSCMD CREATE SOCKET FAIL" );
		}
		return 3;
	}

	if( FALSE == Connect( lpszHostAddress, wNpsPortNo ) )
	{
		Close();
		{	// Oo
			CString str;
			str.Format( "===NPSCMD CONNECT FAIL ( %s, %d )", lpszHostAddress, wNpsPortNo );
			NPS_LOGOUT_FATAL( str );
		}
		return 4;
	}

	// >>> _7462Ή 2008.01.19 Yoshinobu
	// WinSockł̓ɂʐM̖Ή邽߂
	// \PbgIvVύX

	// NagleASY𖳌ɂ܂
	if ( TRUE == SetNoDelay( TRUE ) )
	{
		NPS_LOGOUT( "---SetNoDelay( TRUE ) SUCCESS" );
	}
	else
	{
		NPS_LOGOUT( "---SetNoDelay( TRUE ) FAIL" );
	}

	// Mobt@TCY0ɂ܂
	if ( TRUE == SetSendBufSize( 0 ) )
	{
		NPS_LOGOUT( "---SetSendBufSize( 0 ) SUCCESS" );
	}
	else
	{
		NPS_LOGOUT( "---SetSendBufSize( 0 ) FAIL" );
	}

	// <<< _7462Ή 2008.01.19 Yoshinobu

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::Close()
//	ABSTRACT : v^N[Y
//	FUNCTION : v^N[Y
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::Close()
{

	CWS2Tcp::Close();

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OfflineProc()
//	ABSTRACT : ItC̏
//	FUNCTION : ItCɂȂƂɒʐM̃^CAEgIɃZbg
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2007.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCmd::OfflineProc()
{
	// CxgIɃZbgďI
	m_RecvRequestControl.EventAllSetOffline();
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCommand()
//	ABSTRACT : NPSʐM
//	FUNCTION : NPSʐM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCommand(
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					LPVOID	lpRecvBuf,		// p̃R}h̃obt@
					DWORD	dwTimeOut,		// ^CAEg(~b)
					BOOL	bSendHeader		// vMŃwb_[ݒ肷邩Ȃ
					)
{
	switch ( MAKELONG( wSendCmdId, wIfId ) )
	{
	case 0x60000300:	// v^Ԃ̎擾
	case 0x60000400:	// y[p[̎擾
		break;
	default:
	{
		CString	str;

		str.Format( " --COMMAND SEND( IfId=0x%04XH, CmdId=0x%04XH, RecvCmdId=0x%04XH ) PORT=%u",
			wIfId, wSendCmdId, wRecvCmdId, GetSocketPortNo() );

		NPS_LOGOUT( str );
	}
		break;
	}

	DWORD dwCommand;
	HANDLE hEvent;
	CNpsRecvRequest1* pNpsRecvRequest;

	// f[^Mv̐ݒ
	hEvent = CreateEvent( 0, FALSE, FALSE, 0 );
	try
	{
		pNpsRecvRequest	= new CNpsRecvRequest1( wIfId, wRecvCmdId, pwRecvBufLen, lpRecvBuf, wSendCmdId, hEvent );
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CNpsRecvRequest1]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return NPSERR_SYSERR;
	}
	m_RecvRequestControl.AddRequest( pNpsRecvRequest );

	{	// send ̔r

		NkcComApi::CCSScopeLock CSScopeLock( &m_csSend );

		if ( TRUE == bSendHeader )
		{
			// Y.Yoshinobu	2011.01.20
			// R}h𕪊đMWindows̃T[o[łACK̉0.2b̒x̂
			// R}hĈꊇőM悤ɕύX܂B
			// MSDNZp	http://support.microsoft.com/kb/214397/ja

			// C^[tFCXID & vp̃R}hID
			dwCommand = MAKELONG( htons( wIfId ), htons( wSendCmdId ) );
			::CopyMemory( &m_bySendBuffer[0], &dwCommand, sizeof(DWORD) );			m_wSendSize = sizeof(DWORD);
			// vp̃R}h̃obt@
			::CopyMemory( &m_bySendBuffer[m_wSendSize], lpSendBuf, wSendBufLen );	m_wSendSize += wSendBufLen;
			// f[^[M
			if( !Send( (void *) &m_bySendBuffer[0], m_wSendSize ) )
			{
				NPS_LOGOUT_FATAL( "NpsCommand: Send Error ( IfId and CmdId and Buffer )" );
				m_RecvRequestControl.DeleteRequest( hEvent );
				CloseHandle( hEvent );
				return NPSERR_SYSERR;
			}
		}
		else
		{
			// f[^[M
			if( wSendBufLen > 0 )
			{
				if( !Send( (void *) lpSendBuf, wSendBufLen ) )
				{
					NPS_LOGOUT_FATAL( "NpsCommand: Send Error ( Buffer )" );
					m_RecvRequestControl.DeleteRequest( hEvent );
					CloseHandle( hEvent );
					return NPSERR_SYSERR;
				}
			}
		}

	}

	// f[^M҂
	DWORD dwResult	= ::WaitForSingleObject( hEvent, dwTimeOut );
	BOOL bOffline		= pNpsRecvRequest->IsOffline();
	BOOL bNotSupport	= pNpsRecvRequest->IsNotSupport();
	BOOL bShortage		= pNpsRecvRequest->IsShortage();
	m_RecvRequestControl.DeleteRequest( hEvent );
	CloseHandle( hEvent );

	if( WAIT_OBJECT_0 != dwResult )
	{
		return NPSERR_TIMEOUT;
	}
	else if ( TRUE == bOffline )
	{
		NPS_LOGOUT_DEBUG( "NpsCommand: bOffline is TRUE" );
		return NPSERR_TIMEOUT;
	}
	else if( bNotSupport )
	{
		NPS_LOGOUT_DEBUG( "NpsCommand: bNotSupport is TRUE" );
		return NPSERR_BADPARAM;
	}
	else if( bShortage )
	{
		return NPSERR_REMAINING_DATA;
	}

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCommand1()
//	ABSTRACT : NPSʐMi^Cv1j
//	FUNCTION : NPSʐMi^Cv1j
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCommand1(
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					LPVOID	lpRecvBuf,		// p̃R}h̃obt@
					DWORD	dwTimeOut		// ^CAEg(~b)
					)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	long	lResult;

	lResult	= NpsCommand(
							wIfId,			// C^[tFCXID
							wSendCmdId,		// vp̃R}hID
							wSendBufLen,	// vp̃R}h̃obt@TCY
							lpSendBuf,		// vp̃R}h̃obt@
							wRecvCmdId,		// p̃R}hID
							pwRecvBufLen,	// p̃R}h̃obt@TCY
							lpRecvBuf,		// p̃R}h̃obt@
							dwTimeOut,		// ^CAEg(~b)
							TRUE			// vMŃwb_[ݒ肷邩Ȃ
							);

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCommand2()
//	ABSTRACT : NPSʐMi^Cv2j
//	FUNCTION : NPSʐMi^Cv2j
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.18
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCommand2(
					WORD	wIfId,			// C^[tFCXID
					WORD	wSendCmdId,		// vp̃R}hID
					WORD	wSendBufLen,	// vp̃R}h̃obt@TCY
					LPVOID	lpSendBuf,		// vp̃R}h̃obt@
					WORD	wRecvCmdId,		// p̃R}hID
					LPWORD	pwRecvBufLen,	// p̃R}h̃obt@TCY
					void *	pFunc,			// ɌĂяo֐
					DWORD	dwTimeOut		// ^CAEg(~b)
					)
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	DWORD dwCommand;
	CNpsRecvRequest2* pNpsRecvRequest;

	// f[^Mv̐ݒ
	try
	{
		pNpsRecvRequest	= new CNpsRecvRequest2( wIfId, wRecvCmdId, *pwRecvBufLen, wSendCmdId, pFunc, dwTimeOut );
	}
	catch (CMemoryException* e)
	{
		{
			CString str;
			str.Format( "===Memory allocation error [CNpsRecvRequest2]" );
			NPS_LOGOUT_FATAL( str );
		}
		e->Delete();
		return NPSERR_SYSERR;
	}
	m_RecvRequestControl.AddRequest( pNpsRecvRequest );

	{	// send ̔r

		NkcComApi::CCSScopeLock CSScopeLock( &m_csSend );

		// f[^[M C^[tFCXID & vp̃R}hID
		dwCommand = MAKELONG( htons( wIfId ), htons( wSendCmdId ) );
		if( !Send( (void *) &dwCommand, sizeof( DWORD ) ) )
		{
			m_RecvRequestControl.DeleteRequest( pNpsRecvRequest );
			return NPSERR_PRNERR;
		}

		// f[^[M vp̃R}h̃obt@
		if( wSendBufLen > 0 )
		{
			if( !Send( (void *) lpSendBuf, wSendBufLen ) )
			{
				m_RecvRequestControl.DeleteRequest( pNpsRecvRequest );
				return NPSERR_PRNERR;
			}
		}

	}

	return NPSERR_NORMAL;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsNotice()
//	ABSTRACT : NPS񓯊ʐM
//	FUNCTION : NPS񓯊ʐM
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.9.6
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsNotice(
						HPRINTER	hPrinter,		// v^̃nh
						DWORD		dwIPAddress,	// v^IPAhX
						WORD		wIfId,			// C^[tFCXID
						WORD		wCmdId,			// R}hID
						NOTICEPROC	pNoticeProc		// ɌĂяo֐
						)
{
	long	lResult	= 0;
	BOOL	bResult;

	if( NULL != pNoticeProc )
	{
		CNpsNoticeRequest* pRequest;
		try
		{
			pRequest = new CNpsNoticeRequest( hPrinter, dwIPAddress, wIfId, wCmdId, pNoticeProc );
		}
		catch (CMemoryException* e)
		{
			{
				CString str;
				str.Format( "===Memory allocation error [CNpsNoticeRequest]" );
				NPS_LOGOUT_FATAL( str );
			}
			e->Delete();
			return NPSERR_SYSERR;
		}

		bResult	= m_NoticeRequestControl.AddRequest( pRequest );

		if( FALSE == bResult )
		{
			delete pRequest;
		}
	}
	else
	{
		bResult	= m_NoticeRequestControl.DeleteRequest( wIfId, wCmdId );
	}

	if( bResult )
	{
		lResult	= NPSERR_NORMAL;
	}
	else
	{
		lResult	= NPSERR_BADPARAM;
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   :CNpsCmd::SetSndBuf()
//	ABSTRACT : ^ɂ鑗Mf[^̐ݒ
//	FUNCTION : ^ɂ鑗Mf[^̐ݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.7
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
void CNpsCmd::SetSndBuf( BYTE* pSendBuf, USHORT TagNo, BYTE* pData, enum NpsType Type ,ULONG* pCounter )
{
	// TagNo
	*( USHORT* ) ( pSendBuf + *pCounter )	= NkcComApi::htons( TagNo );
	*pCounter	+= sizeof( USHORT );

	// Length
	*( USHORT* ) ( pSendBuf + *pCounter )	= NkcComApi::htons( GetTypeSize( Type ) );
	*pCounter	+= sizeof( USHORT );

	// Value
	SetDataHtoN( pData, ( pSendBuf + *pCounter ), Type );
	*pCounter	+= GetTypeSize( Type );

	#if 0
	#ifdef _DEBUG
	{
		CString	str;
		str.Format( "SND Tag[%02d] Length[%03d]", TagNo, GetTypeSize( Type ) );
		NPS_LOGOUT_DEBUG( str );
	}
	#endif

	#ifdef _DEBUG
	{
		CString	str1;
		CString	str2;

		DWORD	Length	= GetTypeSize( Type );

		for( int i = 0; i < Length; i++ )
		{
			str2.Format( " %02X", *(pSendBuf + *pCounter - Length + i) );
			str1 += str2;

			if( ( ( i + 1 ) == Length ) || ( ( ( i + 1 ) % 16 ) == 0 ) )
			{
				NPS_LOGOUT_DEBUG( str1 );
				str1 = "";
			}
		}
	}
	#endif
	#endif
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetTypeSize()
//	ABSTRACT : ^ɂ鑗Mf[^TCY̎擾
//	FUNCTION : ^ɂ鑗Mf[^TCY̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
USHORT CNpsCmd::GetTypeSize( enum NpsType Type )
{
	USHORT	Size	= 0;

	switch( Type )
	{
	case NPS_CHAR:		Size = sizeof( CHAR );		break;	// CHAR^
	case NPS_UCHAR:		Size = sizeof( UCHAR );		break;	// UCHAR^
	case NPS_SHORT:		Size = sizeof( SHORT );		break;	// SHORT^
	case NPS_USHORT:	Size = sizeof( USHORT );	break;	// USHORT^
	case NPS_LONG:		Size = sizeof( LONG );		break;	// LONG^
	case NPS_ULONG:		Size = sizeof( ULONG );		break;	// ULONG^
	case NPS_INT64:		Size = 64;					break;	// int64^
	case NPS_FLOAT:		Size = sizeof( FLOAT );		break;	// float^
	};

	return Size;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetDataNtoH()
//	ABSTRACT : lbg[NoCgI[_[zXgoCgI[_[
//	FUNCTION : lbg[NoCgI[_[zXgoCgI[_[
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetDataNtoH( void * pIn, void * pOut, enum NpsType Type, int Array )
{
	BYTE* pIn2	= ( BYTE* ) pIn + Array * GetTypeSize( Type );

	switch( Type )
	{
	case NPS_CHAR:
	case NPS_UCHAR:
		{
			*( char * ) pOut 				= *( char * ) pIn2;
		} break;

	case NPS_SHORT:
	case NPS_USHORT:
		{
			*( unsigned short * ) pOut		= NkcComApi::ntohs( *( unsigned short * ) pIn2 );
		} break;

	case NPS_LONG:
	case NPS_ULONG:
		{
			*( unsigned long * ) pOut		= NkcComApi::ntohl( *( unsigned long * ) pIn2 );
		} break;

	case NPS_INT64:
		{
			*( unsigned __int64 * ) pOut	= NkcComApi::ntohi64( *( unsigned __int64 * ) pIn2 );
		} break;

	case NPS_FLOAT:
		{
			*( float * ) pOut				= NkcComApi::ntohf( *( float * ) pIn2 );
		} break;

	default:
		return FALSE;
	};

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetDataHtoN()
//	ABSTRACT : zXgoCgI[_[lbg[NoCgI[_[
//	FUNCTION : zXgoCgI[_[lbg[NoCgI[_[
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
BOOL CNpsCmd::SetDataHtoN( void * pIn, void * pOut, enum NpsType Type )
{
	switch( Type )
	{
	case NPS_CHAR:
	case NPS_UCHAR:
		{
			*( char * ) pOut	= *( char * ) pIn;
		} break;

	case NPS_SHORT:
	case NPS_USHORT:
		{
			*( unsigned short * ) pOut		= NkcComApi::htons( *( unsigned short * ) pIn );
		} break;

	case NPS_LONG:
	case NPS_ULONG:
		{
			*( unsigned long * ) pOut		= NkcComApi::htonl( *( unsigned long * ) pIn );
		} break;

	case NPS_INT64:
		{
			*( unsigned __int64 * ) pOut	= NkcComApi::htoni64( *( unsigned __int64 * ) pIn );
		} break;

	case NPS_FLOAT:
		{
			*( float * ) pOut				= NkcComApi::htonf( *( float * ) pIn );
		} break;

	default:
		return FALSE;
	};

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetPrinterBasic()
//	ABSTRACT : v^{̎擾
//	FUNCTION : v^{̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetPrinterBasic( T_Nps6000H_0100H * pInBuf, T_Nps6000H_0101H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0101H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0100 );
	SendCmdBuf.AddTagFooter();


	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0100,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0101,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;

			case 2:
				{
					memcpy( (BYTE*)&(pOutBuf->MachineTypeName), (BYTE*)pRecvBuf + Counter, Length );
				}
				break;

			case 3:
				{
					memcpy( (BYTE*)&(pOutBuf->SerialNumber), (BYTE*)pRecvBuf + Counter, Length );
				}
				break;

			case 4:
				{
					for( int Array = 0; Array < 8; Array++ )
					{
						 SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(pOutBuf->SupportResolutions[Array]),	NPS_USHORT );
					}
				}
				break;

			case 5:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->MachineTypeID),	NPS_USHORT ); } break;

			case 6:
				{
					memcpy( (BYTE*)&(pOutBuf->SoftName), (BYTE*)pRecvBuf + Counter, Length );
				}
				break;

			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0101H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	//----------------------------------------
	// CDataManageȑXV
	//----------------------------------------
	if (( NPSERR_NORMAL == lResult ) && ( NULL != m_pDataManager ))
	{
		m_pDataManager->SetPrinterBasic( pOutBuf );
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetPrinterSetup()
//	ABSTRACT : v^ݒ̎擾
//	FUNCTION : v^ݒ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetPrinterSetup( T_Nps6000H_0200H * pInBuf, T_Nps6000H_0201H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0201H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0200 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0200,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0201,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->TotalMemory),			NPS_ULONG ); } break;
			case 3:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ImageSizeMinWidth),	NPS_ULONG ); } break;
			case 4:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ImageSizeMinHeight),	NPS_ULONG ); } break;
			case 5:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ImageSizeMaxWidth),	NPS_ULONG ); } break;
			case 6:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ImageSizeMaxHeight),	NPS_ULONG ); } break;
			case 7:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->NumberOfMagazine),	NPS_USHORT ); } break;
			case 8:		{ for( int Array = 0; Array < 8; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(pOutBuf->PrinterTime[Array]),			NPS_USHORT ); } break;
			case 9:		{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->RepeatCountMax),		NPS_ULONG ); } break;
			case 10:	{ for( int Array = 0; Array < 32; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( UCHAR ) * Array ),	(BYTE*)&(pOutBuf->SupportImageFormat[Array]),	NPS_UCHAR ); } break;
			case 11:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->LaminatorUnitAttach),	NPS_UCHAR ); } break;
			case 13:	{ for( int Array = 0; Array < 3; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(pOutBuf->InstallationDate[Array]),	NPS_USHORT ); } break;
			case 14:	{ for( int Array = 0; Array < 3; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(pOutBuf->OperationStartDate[Array]),	NPS_USHORT ); } break;
			case 15:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ProcessorType),		NPS_USHORT ); } break;
			case 16:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->EmulsionNumber),		NPS_USHORT ); } break;
			case 17:	{ memcpy( (BYTE*)&(pOutBuf->PrinterNickname),(BYTE*)pRecvBuf + Counter,	Length ); } break;
			case 18:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportAngle),		NPS_USHORT ); } break;
			case 19:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportIntoPrinter),	NPS_USHORT ); } break;
			case 20:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportLongPaper),	NPS_USHORT ); } break;
			case 21:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SorterStatus),		NPS_UCHAR ); } break;
			case 23:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->CvpStatus),			NPS_UCHAR ); } break;
			case 24:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportPaperFitting),		NPS_USHORT ); } break;	// T|[gy[p[tBbeBO
			case 25:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportEdgeEnhancement),	NPS_USHORT ); } break;	// T|[gGbW
			case 26:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportCMS),				NPS_USHORT ); } break;	// T|[gCMS
			case 27:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportWithBorder),		NPS_USHORT ); } break;	// T|[g
			case 28:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->MachinTypeForProfile),	NPS_USHORT ); } break;	// vt@Cp̋@R[h
			case 29:	{ memcpy( (BYTE*)&(pOutBuf->MachinProfileVersion),(BYTE*)pRecvBuf + Counter,	Length ); } break;
			case 30:	{ for( int Array = 0; Array < 6; Array++ ) SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * Array ),	(BYTE*)&(pOutBuf->PaperTypeCode[Array]),	NPS_USHORT ); } break;
			case 31:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->OemCode),				NPS_UCHAR ); } break;		// OEMR[h
			case 32:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SetupAlgorithm),		NPS_USHORT ); } break;	// ZbgAbvASY
			case 33:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportDoubleSided),	NPS_USHORT ); } break;	// T|[gʈ
			case 34:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->FadAttachNo),			NPS_ULONG ); } break;	// FADڑԍ
			case 35:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SupportInterrupt),	NPS_USHORT ); } break;	// f	2011.11.08 A.Nagamatsu (D703/WG)
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}


	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0201H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	//----------------------------------------
	// CDataManageȑXV
	//----------------------------------------
	if (( NPSERR_NORMAL == lResult ) && ( NULL != m_pDataManager ))
	{
		m_pDataManager->SetPrinterSetup( pOutBuf );
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetPrinterState()
//	ABSTRACT : v^Ԃ̎擾
//	FUNCTION : v^Ԃ̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetPrinterState( T_Nps6000H_0300H * pInBuf, T_Nps6000H_0301H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0301H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0300 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0300,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0301,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PrinterStatus),	NPS_UCHAR ); } break;
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->AcceptStatus),	NPS_UCHAR ); } break;
			case 4:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PrinterPossession),	NPS_UCHAR ); } break;
			case 5:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->AdvanceStatus),	NPS_UCHAR ); } break;
			case 6:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->LaserStatus),	NPS_UCHAR ); } break;
			case 7:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->DevelopmentStatus),	NPS_UCHAR ); } break;
			case 8:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ProcessorStatus),	NPS_UCHAR ); } break;
			case 9:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReplenisherStatus),	NPS_UCHAR ); } break;
			case 10:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReplaceCartridgeStatus),	NPS_UCHAR ); } break;
			case 11:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->StartUpChecksStatus),	NPS_UCHAR ); } break;
			case 12:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->RefillWaterStatus),	NPS_UCHAR ); } break;
			case 13:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->DailySetupStatus),	NPS_UCHAR ); } break;
			case 14:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ControlStripStatus),	NPS_UCHAR ); } break;
			case 15:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->InMaintenance),		NPS_UCHAR ); } break;	// eiX
			case 16:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->FadStatus),			NPS_UCHAR ); } break;	// FAD̏
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
	}

	//----------------------------------------
	// CDataManageȑXV
	//----------------------------------------
	if (( NPSERR_NORMAL == lResult ) && ( NULL != m_pDataManager ))
	{
		m_pDataManager->SetPrinterState( pOutBuf );
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetPaper()
//	ABSTRACT : y[p[̎擾
//	FUNCTION : y[p[̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetPaper( T_Nps6000H_0400H * pInBuf, T_Nps6000H_0401H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0401H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0400 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0400,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0401,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;
	USHORT	NOP;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->NumberOfPaper),	NPS_USHORT ); NOP = pOutBuf->NumberOfPaper; } break;	// 擾y[p[̐
			case 3:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperWidth[Array]),			NPS_USHORT, Array ); } break;	// y[p[̕ iPʁF0.1mmj
			case 6:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperId[Array]),				NPS_USHORT, Array ); } break;	// y[p[ID iʎj
			case 12:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperRemaind[Array]),			NPS_ULONG, Array ); } break;	// y[p[c iPʁF0.1mmj
			case 13:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperFeed[Array]),			NPS_UCHAR, Array ); } break;	// @
			case 14:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperPresence[Array]),		NPS_UCHAR, Array ); } break;	// U
			case 20:
				{	// y[p[
					int nArrayPos	= 0;
					int nStrPos		= 0;
					
					BYTE*	pSrc	= (BYTE*)pRecvBuf + Counter;

					for( int idx = 0; idx < Length; idx++ )
					{
						pOutBuf->PaperName[nArrayPos][nStrPos]	= pSrc[idx];

						if( 0 == pSrc[idx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				} break;

			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
	}

	//----------------------------------------
	// CDataManageȑXV
	//----------------------------------------
	if (( NPSERR_NORMAL == lResult ) && ( NULL != m_pDataManager ))
	{
		m_pDataManager->SetMagInfo( pOutBuf );
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OccupyStart()
//	ABSTRACT : v^LJn
//	FUNCTION : v^LJn
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : M.Yamamoto	2014.10.28	݃vg̏ԒZk@\ǉ(Pvg)
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::OccupyStart( T_Nps6000H_0500H * pInBuf, T_Nps6000H_0501H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0501H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0500 );
	SendCmdBuf.AddTagShort( 1, pInBuf->Port );				// 摜Mp̃|[gԍ
	SendCmdBuf.AddTagShort( 2, pInBuf->PossessionMode );	// L[h
	SendCmdBuf.AddTagShort( 3, pInBuf->InterruptMode );		// 荞݃[h
	SendCmdBuf.AddTagChar ( 4, pInBuf->InMaintenance );		// eiX
	SendCmdBuf.AddTagShort( 5, pInBuf->PossessionNo );		// Lԍ		@@@RD-151Ή	2012.02.09	T.Mizushima
	SendCmdBuf.AddTagLong ( 6, pInBuf->ExOptions );			// gIvV(Pvg)	2014.10.28	M.Yamamoto
	SendCmdBuf.AddTagFooter();


	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x0500,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0501,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	{	// Oo
		CString str;
		// LԍOo͒ǉ	@@@RD-151Ή	2012.02.17	T.Mizushima
		str.Format( " --SEND PARAM( 6000H-0500H, PossessionMode=%d, InterruptMode=%d, PossessionNo=%d )", pInBuf->PossessionMode, pInBuf->InterruptMode, pInBuf->PossessionNo );
		NPS_LOGOUT( str );
	}

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if( lResult == NPSERR_NORMAL )
	{
		if( 0 == pOutBuf->Result )
		{
			// LԂ̈ʒuŃZbĝ́A[0500H]`[0501H]̊Ԃ[F102H]̒ʒm̂
			// [F102H]ŐL荞݂𔻒fɐLԂXVKv邽 2007.03.09 Y.Yoshinobu
			switch ( pInBuf->PossessionMode )
			{
			case 0:	// 0Fʏ
			case 1:	// 1Fʏi荞ݍĊJj

				m_pDataManager->SetOccupyState( CDataManager::OCCUPY_STATE_NORMAL );
				break;

			case 2:	// 2F}[x1]
			case 3:	// 3F}[x1]i荞ݍĊJj

				m_pDataManager->SetOccupyState( CDataManager::OCCUPY_STATE_EXPRESS1 );
				break;

			case 4:	// 4F}[x2]
			case 5:	// 5F}[x2]i荞ݍĊJj

				m_pDataManager->SetOccupyState( CDataManager::OCCUPY_STATE_EXPRESS2 );
				break;

			}
		}
	}


	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0501H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );

			str.Format( " --RECV PARAM( 6000H-0501H, PossessionNo=%d )", pOutBuf->PossessionNo );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OccupyEnd()
//	ABSTRACT : v^LI
//	FUNCTION : v^LI
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::OccupyEnd( T_Nps6000H_0600H * pInBuf, T_Nps6000H_0601H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0601H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0600 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );
	SendCmdBuf.AddTagFooter();


	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0600,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0601,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	{	// Oo
		CString str;
		str.Format( " --SEND PARAM( 6000H-0600H, PossessionNo=%d )", pInBuf->PossessionNo );
		NPS_LOGOUT( str );
	}

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if( lResult == NPSERR_NORMAL )
	{
		if( pOutBuf->Result == 0 )
		{	// L
			m_pDataManager->SetOccupyState( CDataManager::OCCUPY_STATE_NONE );
		}
	}

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0601H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::PrintRequest()
//	ABSTRACT : tJn
//	FUNCTION : tJn
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : A.Nagamatsu 2011.11.1	D703/WG: ʊ荞ݑΉ
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::PrintRequest( T_Nps6000H_0700H * pInBuf, T_Nps6000H_0701H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0701H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0700 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );
	SendCmdBuf.AddTagLong ( 2, pInBuf->ImageCapacity );
	SendCmdBuf.AddTagChar ( 3, pInBuf->ImageFormat );
	SendCmdBuf.AddTagShort( 4, pInBuf->ImageWidth );
	SendCmdBuf.AddTagShort( 5, pInBuf->ImageHeight );
	SendCmdBuf.AddTagShort( 6, pInBuf->PaperResolution );
	SendCmdBuf.AddTagShort( 7, pInBuf->PaperWidth );
	SendCmdBuf.AddTagShort( 8, pInBuf->PaperLength );
	SendCmdBuf.AddTagShort( 9, pInBuf->PaperID );
	SendCmdBuf.AddTagShort( 10, pInBuf->Repeat );
	SendCmdBuf.AddTagShort( 11, pInBuf->PaperFeed );
	SendCmdBuf.AddTagShort( 12, pInBuf->Laminator );
	SendCmdBuf.AddTagShort( 13, pInBuf->CvpInitialValue1 );
	SendCmdBuf.AddTagShort( 14, pInBuf->CvpPoint1 );
	SendCmdBuf.AddTagShort( 15, pInBuf->CvpInitialWidth1 );
	SendCmdBuf.AddTagShort( 16, pInBuf->CvpInitialValue2 );
	SendCmdBuf.AddTagShort( 17, pInBuf->CvpPoint2 );
	SendCmdBuf.AddTagShort( 18, pInBuf->CvpInitialWidth2 );
	SendCmdBuf.AddTagChar ( 19, (char*)pInBuf->CvpLine1, 256 );
	SendCmdBuf.AddTagChar ( 20, (char*)pInBuf->CvpLine2, 256 );
	SendCmdBuf.AddTagShort( 21, pInBuf->Angle );
	SendCmdBuf.AddTagChar ( 22, pInBuf->PaperPresence );
	SendCmdBuf.AddTagShort( 23, pInBuf->Espc );
	SendCmdBuf.AddTagShort( 24, pInBuf->Retry );
	SendCmdBuf.AddTagLong ( 25, pInBuf->OrderId );
	SendCmdBuf.AddTagShort( 26, pInBuf->PaperFitting );
	SendCmdBuf.AddTagShort( 27, pInBuf->EdgeEnhancement );
	SendCmdBuf.AddTagShort( 28, pInBuf->CMS );
	SendCmdBuf.AddTagShort( 29, pInBuf->WithBorderTop );
	SendCmdBuf.AddTagShort( 30, pInBuf->WithBorderBottom );
	SendCmdBuf.AddTagShort( 31, pInBuf->WithBorderLeft );
	SendCmdBuf.AddTagShort( 32, pInBuf->WithBorderRight );
	SendCmdBuf.AddTagChar ( 33, (char*)pInBuf->WithBorderColor, 3 );
	SendCmdBuf.AddTagChar ( 34, pInBuf->PaperName, 32 );
	SendCmdBuf.AddTagShort( 35, pInBuf->PrintCenterOffset );
	SendCmdBuf.AddTagShort( 36, pInBuf->CvpPrintSize );
	SendCmdBuf.AddTagShort( 37, pInBuf->PrintQuality );
	SendCmdBuf.AddTagChar ( 38, pInBuf->ImageEnLargeType );
	SendCmdBuf.AddTagShort( 39, pInBuf->LoadingCount );					// 2011.11.1 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagShort( 40, pInBuf->PrintedCount );					// 2011.11.1 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagLong ( 41, pInBuf->EventId );						// 2011.11.1 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagShort( 42, pInBuf->EventCodeMain );				// 2011.11.1 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagFooter();

	{	// Oo
		CString str;
		str.Format( "   PossessionNo=%d, ImageCapacity=%ld, ImageFormat=%d, ImageWidth=%d, ImageHeight=%d", pInBuf->PossessionNo, pInBuf->ImageCapacity, pInBuf->ImageFormat, pInBuf->ImageWidth, pInBuf->ImageHeight);
		NPS_LOGOUT_DEBUG( str );
		str.Format( "   PaperResolution=%d, PaperWidth=%ld, PaperLength=%d, PaperID=%d, Repeat=%d", pInBuf->PaperResolution, pInBuf->PaperWidth, pInBuf->PaperLength, pInBuf->PaperID, pInBuf->Repeat);
		NPS_LOGOUT_DEBUG( str );
		str.Format( "   Angle=%d, PaperPresence=%ld, Espc=%d, Retry=%d, OrderId=%d", pInBuf->Angle, pInBuf->PaperPresence, pInBuf->Espc, pInBuf->Retry, pInBuf->OrderId);
		NPS_LOGOUT_DEBUG( str );
		str.Format( "   LoadingCount=%d, PrintedCount=%ld, EventId=%d, EventCodeMain=%d", pInBuf->LoadingCount, pInBuf->PrintedCount, pInBuf->EventId, pInBuf->EventCodeMain);
		NPS_LOGOUT_DEBUG( str );
	}

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0700,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0701,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReceiptNumber),	NPS_LONG ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0701H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::CheckSendImage()
//	ABSTRACT : 摜MmF
//	FUNCTION : 摜MmF
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::CheckSendImage( T_Nps6000H_0800H * pInBuf, T_Nps6000H_0801H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0801H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0800 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );		// Lԍ
	SendCmdBuf.AddTagLong ( 2, pInBuf->ReceiptNumber );		// tԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0800,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0801,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReceiptNumber),	NPS_ULONG ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0801H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::PrintCancel()
//	ABSTRACT : vg
//	FUNCTION : vg
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::PrintCancel( T_Nps6000H_0900H * pInBuf, T_Nps6000H_0901H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0901H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0900 );
	SendCmdBuf.AddTagLong( 1, pInBuf->ReceiptNumber );				// tԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0900,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0901,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	{	// Oo
		CString str;
		str.Format( " --SEND PARAM( 6000H-0900H, ReceiptNo=%ld )", pInBuf->ReceiptNumber );
		NPS_LOGOUT( str );
	}

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReceiptNumber),	NPS_ULONG ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0901H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::OrderCancel()
//	ABSTRACT : I[_[
//	FUNCTION : I[_[
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2012.04.12		@@@RD-151Ή
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::OrderCancel( T_Nps6000H_1900H * pInBuf, T_Nps6000H_1901H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1901H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1900 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );				// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x1900,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),		// vp̃R}h̃obt@
					0x1901,						// p̃R}hID
					&RecvBufLen,				// p̃R}h̃obt@TCY
					pRecvBuf,					// p̃R}h̃obt@
					420000						// ^CAEg(~b)
					);

	{	// Oo
		CString str;
		str.Format( " --SEND PARAM( 6000H-1900H, PossessionNo=%ld )", pInBuf->PossessionNo );
		NPS_LOGOUT( str );
	}

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1901H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::EventCancel()
//	ABSTRACT : v^Cxg
//	FUNCTION : v^Cxg
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::EventCancel( T_Nps6000H_0A00H * pInBuf, T_Nps6000H_0A01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0A01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0A00 );
	SendCmdBuf.AddTagLong( 1, pInBuf->EventId );			// Cxgʎq
	SendCmdBuf.AddTagChar( 2, pInBuf->ActionId );			// Cxg̃ANV
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0A00,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0A01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0A01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::ChangeTray()
//	ABSTRACT : gCύX
//	FUNCTION : gCύX
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::ChangeTray( T_Nps6000H_0B00H * pInBuf, T_Nps6000H_0B01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0B01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0B00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );				// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0B00,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0B01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0B01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetPrintCount()
//	ABSTRACT : vg擾
//	FUNCTION : vg擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetPrintCount( T_Nps6000H_0C00H * pInBuf, T_Nps6000H_0C01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0C01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0C00 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0C00,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0C01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReserverCount),	NPS_USHORT ); } break;	// v^҂
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PrinterCount),	NPS_USHORT ); } break;	// v^
			case 4:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ProcessorCount),	NPS_USHORT ); } break;	// vZT[
			case 5:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->UsedMemory),	NPS_ULONG ); } break;		// gpʁ@(PʁFByte)
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0C01H, Result=%d ) ReserverCount=%d, PrinterCount=%d, ProcessorCount=%d", pOutBuf->Result, pOutBuf->ReserverCount, pOutBuf->PrinterCount, pOutBuf->ProcessorCount );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::PrintCtrl()
//	ABSTRACT : vg~
//	FUNCTION : vg~
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::PrintCtrl( T_Nps6000H_0D00H * pInBuf, T_Nps6000H_0D01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0D01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0D00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PrintStopStart );		// vg~ƒ~
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0D00,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0D01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0D01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::Login()
//	ABSTRACT : ڑJn
//	FUNCTION : ڑJn
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::Login( T_Nps6000H_0E00H * pInBuf, T_Nps6000H_0E01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0E01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0E00 );
	SendCmdBuf.AddTagLong ( 1, pInBuf->OemCode );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x0E00,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0E01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->NpsVersion),	NPS_USHORT ); } break;	// NPS I/F ̃o[W
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0E01H, Result=%d [%d] )", pOutBuf->Result, pInBuf->OemCode );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SetPrintOption()
//	ABSTRACT : vgIvVݒ
//	FUNCTION : vgIvVݒ
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.8
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::SetPrintOption( T_Nps6000H_1200H * pInBuf, T_Nps6000H_1201H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1201H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1200 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );			// Lԍ
	SendCmdBuf.AddTagShort( 2, pInBuf->SorterNum );				// vg̎d
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x1200,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1201,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),		NPS_USHORT ); } break;	// 
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1201H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetAllPaper()
//	ABSTRACT : Sy[p[̎擾
//	FUNCTION : Sy[p[̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.8.8
//	UPDATE   : Y.Yoshinobu 2006.12.06	v^[瑗Ăf[^ꂽꍇ̃oJ悯̏ǉ
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetAllPaper( T_Nps6000H_1300H * pInBuf, T_Nps6000H_1301H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
		
	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1301H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1300 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,						// C^[tFCXID
					0x1300,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1301,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;
	USHORT	NOP;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{																										// 擾y[p[̐
						SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->NumberOfPaper),	NPS_USHORT );
						if ( COUNTOF(pOutBuf->PaperWidth) < pOutBuf->NumberOfPaper )
						{
							{	// Oo
								CString str;
								str.Format( "---RANGE ERROR( IfId=0x6000H, CmdId=0x1201H, Tag=2, Value=%d [MAX 1024] )", pOutBuf->NumberOfPaper );
								NPS_LOGOUT_FATAL( str );
							}
							pOutBuf->NumberOfPaper = COUNTOF(pOutBuf->PaperWidth);
						}
						NOP = pOutBuf->NumberOfPaper;
					}
					break;

			case 3:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperWidth[Array]),			NPS_USHORT, Array ); } break;	// y[p[̕ iPʁF0.1mmj
			case 4:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperLengthMin[Array]),		NPS_USHORT, Array ); } break;	// y[p[̑蒷̍ŏl iPʁF0.1mmj
			case 5:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperLengthMax[Array]),		NPS_USHORT, Array ); } break;	// y[p[̑蒷̍ől iPʁF0.1mmj
			case 6:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperId[Array]),				NPS_USHORT, Array ); } break;	// y[p[ID iʎj
			case 7:	{ for( int Array = 0; Array < NOP; Array++ ) for( int Array2 = 0; Array2 < 8; Array2++ )SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( USHORT ) * 8 * Array ),	(BYTE*)&(pOutBuf->PaperResolution[Array][Array2]),	NPS_USHORT, Array2 ); } break;	// ͉𑜓x iPʁF0.1dpij
			case 8:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperAllocationTop[Array]),	NPS_SHORT, Array ); } break;	// t㕔 iPʁF0.1mmj
			case 9:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperAllocationBottom[Array]),NPS_SHORT, Array ); } break;	// t iPʁF0.1mmj
			case 10:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperAllocationLeft[Array]),	NPS_SHORT, Array ); } break;	// t iPʁF0.1mmj
			case 11:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperAllocationRight[Array]),	NPS_SHORT, Array ); } break;	// tE iPʁF0.1mmj
			case 12:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->SetupStatus[Array]),			NPS_USHORT, Array ); } break;	// ZbgAbv iPʁF0.1mmj
			case 13:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperFeed[Array]),			NPS_UCHAR, Array ); } break;	// @
			case 14:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperTypeCode[Array]),		NPS_USHORT, Array ); } break;	// y[p[^CvR[h
			case 15:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperKind[Array]),			NPS_UCHAR, Array ); } break;	// y[p[ʎ
			case 16:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->MagazineID[Array]),			NPS_UCHAR, Array ); } break;	// }KWID
			case 17:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->WBAdjustLeft[Array]),			NPS_USHORT, Array ); } break;	// WB␳l
			case 18:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->WBAdjustRight[Array]),		NPS_USHORT, Array ); } break;	// WB␳lE
			case 19:
				{	// y[p[
					int nArrayPos	= 0;
					int nStrPos		= 0;
					
					BYTE*	pSrc	= (BYTE*)pRecvBuf + Counter;

					for( int idx = 0; idx < Length; idx++ )
					{
						pOutBuf->PaperName[nArrayPos][nStrPos]	= pSrc[idx];

						if( 0 == pSrc[idx] )
						{
							nArrayPos++;
							nStrPos	= 0;
						}
						else
						{
							nStrPos++;
						}
					}
				} break;
			case 20:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperType[Array]),		NPS_UCHAR, Array ); } break;	// y[p[^Cvi܎j
			case 21:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Direction[Array]),		NPS_UCHAR, Array ); } break;	// fBNV
			case 22:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PrintQuality[Array]),		NPS_UCHAR, Array ); } break;	// i
			case 23:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->DoubleSidedPaper[Array]),	NPS_USHORT, Array ); } break;	// ʃy[p[
			case 24:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperInfo[Array]),		NPS_USHORT, Array ); } break;	// y[p[
			case 25:{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperTypeValid[Array]),	NPS_UCHAR, Array ); } break;	// y[p[^CvuL/v	(2011.8.4 A.Nagamatsu)
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1301H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	//----------------------------------------
	// CDataManageȑXV
	//----------------------------------------
	if (( NPSERR_NORMAL == lResult ) && ( NULL != m_pDataManager ))
	{
		m_pDataManager->SetRegMagInfo( pOutBuf );
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::UpdateDateTime()
//	ABSTRACT : XV
//	FUNCTION : XV
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Isogai	2006.7.5
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::UpdateDateTime( T_Nps6001H_0100H * pInBuf, T_Nps6001H_0101H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );
		
	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0101H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0100 );
	SendCmdBuf.AddTagShort( 1, (short*)pInBuf->PrinterTime, 8 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,						// C^[tFCXID
					0x0100,						// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0101,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::BuzzerControl()
//	ABSTRACT : uU[
//	FUNCTION : uU[
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::BuzzerControl( T_Nps6000H_0F00H * pInBuf, T_Nps6000H_0F01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_0F01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x0F00 );
	SendCmdBuf.AddTagLong( 1, pInBuf->WorkingNumber );		// wߔԍ
	SendCmdBuf.AddTagLong( 2, pInBuf->OnTime );				// ON
	SendCmdBuf.AddTagLong( 3, pInBuf->OffTime );			// OFF
	SendCmdBuf.AddTagLong( 4, pInBuf->Volume );				// 
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x0F00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0F01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x0F01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::SignalLampControl()
//	ABSTRACT : \
//	FUNCTION : \
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.17
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::SignalLampControl( T_Nps6000H_1000H * pInBuf, T_Nps6000H_1001H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1001H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1000 );
	SendCmdBuf.AddTagLong( 1, pInBuf->WorkingNumber );			// wߔԍ
	SendCmdBuf.AddTagLong( 2, pInBuf->OnTime );					// ON
	SendCmdBuf.AddTagLong( 3, pInBuf->OffTime );				// OFF
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x1000,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1001,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1001H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetVersion()
//	ABSTRACT : o[W̎擾
//	FUNCTION : o[W̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : T.Mizushima	2006.11.29
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetVersion( T_Nps6002H_7304H * pInBuf, T_Nps6002H_7305H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6002H_7305H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6002, 0x7304 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6002,					// C^[tFCXID
					0x7304,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x7305,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 5:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 581:
				{	// v^I/F
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->ptMainIF) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->ptMainIF);
					}
					memcpy( (void*)pOutBuf->ptMainIF, (void*)(pRecvBuf + Counter), size );
				} break;
			case 582:
				{	// v^Rg[ ()
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->printerCtrl1) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->printerCtrl1);
					}
					memcpy( (void*)pOutBuf->printerCtrl1, (void*)(pRecvBuf + Counter), size );
				} break;
			case 583:
				{	// [U[Rg[
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->laserCtrl) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->laserCtrl);
					}
					memcpy( (void*)pOutBuf->laserCtrl, (void*)(pRecvBuf + Counter), size );
				} break;
			case 584:
				{	// vZTRg[
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->procCtrl) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->procCtrl);
					}
					memcpy( (void*)pOutBuf->procCtrl, (void*)(pRecvBuf + Counter), size );
				} break;
			case 585:
				{	// v^Rg[ ()
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->printerCtrl2) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->printerCtrl2);
					}
					memcpy( (void*)pOutBuf->printerCtrl2, (void*)(pRecvBuf + Counter), size );
				} break;
			case 586:
				{	// v^I/F (640dpiΉ@p)
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->ptMainIF640) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->ptMainIF640);
					}
					memcpy( (void*)pOutBuf->ptMainIF640, (void*)(pRecvBuf + Counter), size );
				} break;
			case 587:
				{	// [U[Rg[ (640dpiΉ@p)
					size_t	size;
					if( (USHORT)sizeof(pOutBuf->laserCtrl640) > Length)
					{
						size = (size_t)Length;
					}
					else
					{
						size = sizeof(pOutBuf->laserCtrl640);
					}
					memcpy( (void*)pOutBuf->laserCtrl640, (void*)(pRecvBuf + Counter), size );
				} break;

			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	// 擾f[^̐ݒ
	m_pDataManager->SetVersionInfo( pOutBuf );

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6002H, CmdId=0x7305H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );

			char	vstr[256];
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->ptMainIF[0], sizeof(pOutBuf->ptMainIF[0]) );
			str.Format( "***PrinterI/F[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->ptMainIF[1], sizeof(pOutBuf->ptMainIF[1]) );
			str.Format( "***PrinterI/F[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->printerCtrl1[0], sizeof(pOutBuf->printerCtrl1[0]) );
			str.Format( "***Printer1[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->printerCtrl1[1], sizeof(pOutBuf->printerCtrl1[1]) );
			str.Format( "***Printer1[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->printerCtrl2[0], sizeof(pOutBuf->printerCtrl2[0]) );
			str.Format( "***Printer2[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->printerCtrl2[1], sizeof(pOutBuf->printerCtrl2[1]) );
			str.Format( "***Printer2[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->laserCtrl[0], sizeof(pOutBuf->laserCtrl[0]) );
			str.Format( "***Laser[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->laserCtrl[1], sizeof(pOutBuf->laserCtrl[1]) );
			str.Format( "***Laser[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->procCtrl[0], sizeof(pOutBuf->procCtrl[0]) );
			str.Format( "***Processer[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->procCtrl[1], sizeof(pOutBuf->procCtrl[1]) );
			str.Format( "***Processer[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->ptMainIF640[0], sizeof(pOutBuf->ptMainIF640[0]) );
			str.Format( "***PrinterI/F 640dpi[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->ptMainIF640[1], sizeof(pOutBuf->ptMainIF640[1]) );
			str.Format( "***PrinterI/F 640dpi[1] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->laserCtrl640[0], sizeof(pOutBuf->laserCtrl640[0]) );
			str.Format( "***Laser 640dpi[0] = %s", vstr );
			NPS_LOGOUT( str );
			::ZeroMemory( vstr, 256 );
			strncpy( vstr, (char*)pOutBuf->laserCtrl640[1], sizeof(pOutBuf->laserCtrl640[1]) );
			str.Format( "***Laser 640dpi[1] = %s", vstr );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::GetMachineSpec()
//	ABSTRACT : @Bdl̎擾
//	FUNCTION : @Bdl̎擾
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.01.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::GetMachineSpec( T_Nps6002H_732AH * pInBuf, T_Nps6002H_732BH * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6002H_732BH) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6002, 0x732A );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6002,					// C^[tFCXID
					0x732A,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x732B,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 5:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 546:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->MachineSubInfo),	NPS_USHORT ); } break;	// Tu@B
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	// 擾f[^̐ݒ
	m_pDataManager->SetMachineSpecInfo( pOutBuf );

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6002H, CmdId=0x732BH, Result=%d, MachineSubInfo=%d )", pOutBuf->Result, pOutBuf->MachineSubInfo );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::DuplexStart()
//	ABSTRACT : ʈJn
//	FUNCTION : ʈJn
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.05.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::DuplexStart( T_Nps6000H_1600H * pInBuf, T_Nps6000H_1601H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1601H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1600 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );				// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x1600,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1601,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1601H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::DuplexEnd()
//	ABSTRACT : ʈI
//	FUNCTION : ʈI
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.05.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::DuplexEnd( T_Nps6000H_1700H * pInBuf, T_Nps6000H_1701H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1701H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1700 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );				// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x1700,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1701,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1701H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::BlankPrintRequest()
//	ABSTRACT : 󔒈tJn
//	FUNCTION : 󔒈tJn
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu	2008.05.16
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::BlankPrintRequest( T_Nps6000H_1800H * pInBuf, T_Nps6000H_1801H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1801H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1800 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );
	SendCmdBuf.AddTagShort( 6, pInBuf->PaperResolution );
	SendCmdBuf.AddTagShort( 7, pInBuf->PaperWidth );
	SendCmdBuf.AddTagShort( 8, pInBuf->PaperLength );
	SendCmdBuf.AddTagShort( 9, pInBuf->PaperID );
	SendCmdBuf.AddTagShort( 10, pInBuf->Repeat );
	SendCmdBuf.AddTagShort( 11, pInBuf->PaperFeed );
	SendCmdBuf.AddTagShort( 12, pInBuf->Laminator );
	SendCmdBuf.AddTagChar ( 22, pInBuf->PaperPresence );
	SendCmdBuf.AddTagLong ( 25, pInBuf->OrderId );
	SendCmdBuf.AddTagChar ( 34, pInBuf->PaperName, 32 );
	SendCmdBuf.AddTagShort( 37, pInBuf->PrintQuality );
	SendCmdBuf.AddTagShort( 50, pInBuf->ClearInk );
	SendCmdBuf.AddTagShort( 39, pInBuf->LoadingCount );					// 2011.11.18 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagShort( 40, pInBuf->PrintedCount );					// 2011.11.18 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagLong ( 41, pInBuf->EventId );						// 2011.11.18 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagShort( 42, pInBuf->EventCodeMain );				// 2011.11.18 A.Nagamatsu (D703/WG)
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x1800,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1801,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					420000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;
			case 2:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;
			case 3:{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->ReceiptNumber),	NPS_ULONG ); } break;
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6000H, CmdId=0x1801H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6000_1500_1501()
//	ABSTRACT : ڑmF
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.21
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6000_1500_1501( T_Nps6000H_1500H * pInBuf, T_Nps6000H_1501H * pOutBuf )
{
	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6000H_1501H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6000, 0x1500 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6000,					// C^[tFCXID
					0x1500,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x1501,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0700_0701()
//	ABSTRACT : ^[Qbg擾
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0700_0701( T_Nps6001H_0700H * pInBuf, T_Nps6001H_0701H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0701H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [32]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0700 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0700,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0701,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	NOP;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->RegionCode),		NPS_UCHAR ); } break;	// nR[h
			case 3:	{																										// 擾^[Qbg̐
						SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->NumberOfTarget),	NPS_USHORT );
						if ( COUNTOF(pOutBuf->PaperType) < pOutBuf->NumberOfTarget )
						{
							{	// Oo
								CString str;
								str.Format( "---RANGE ERROR( IfId=0x6001H, CmdId=0x0701H, Tag=3, Value=%d [MAX 10] )", pOutBuf->NumberOfTarget );
								NPS_LOGOUT_FATAL( str );
							}
							pOutBuf->NumberOfTarget = COUNTOF(pOutBuf->PaperType);
						}
						NOP = pOutBuf->NumberOfTarget;
					}
					break;
			case 4:	{ for( int Array = 0; Array < NOP; Array++ ) for( int Array2 = 0; Array2 < 192; Array2++ )SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( FLOAT ) * 8 * Array ),	(BYTE*)&(pOutBuf->MeasureColor[Array][Array2]),	NPS_USHORT, Array2 ); } break;	// v^[vt@CZiFlj
			case 5:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperType[Array]),			NPS_UCHAR, Array ); } break;	// y[p[^Cv i܎j
			case 6:	{ for( int Array = 0; Array < NOP; Array++ ) SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PaperTypeCode[Array]),			NPS_USHORT, Array ); } break;	// ^[Qbgf[^iy[p[^CvR[hj
			case 7:	{ for( int Array = 0; Array < NOP; Array++ ) for( int Array2 = 0; Array2 < 60; Array2++ )SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( FLOAT ) * 60 * Array ),	(BYTE*)&(pOutBuf->TargetValue[Array][Array2]),	NPS_FLOAT, Array2 ); } break;	// ^[Qbgf[^iڕWlj
			case 8:	{ for( int Array = 0; Array < NOP; Array++ ) for( int Array2 = 0; Array2 < 3; Array2++ )SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( FLOAT ) * 3 * Array ),	(BYTE*)&(pOutBuf->DMaxControl[Array][Array2]),	NPS_FLOAT, Array2 ); } break;	// ^[Qbgf[^iRg[lj
			case 9:	{ for( int Array = 0; Array < NOP; Array++ ) for( int Array2 = 0; Array2 < 21; Array2++ )SetDataNtoH( (BYTE*)( pRecvBuf + Counter + sizeof( CHAR ) * 21 * Array ),	(BYTE*)&(pOutBuf->TypeName[Array][Array2]),	NPS_CHAR, Array2 ); } break;	// ޖ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0701H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0800_0801()
//	ABSTRACT : ^[Qbgf[^XVv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0800_0801( T_Nps6001H_0800H * pInBuf, T_Nps6001H_0801H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0801H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0800 );
	SendCmdBuf.AddTagChar ( 1, pInBuf->PaperType );			// y[p[^Cv i܎j
	SendCmdBuf.AddTagShort( 2, pInBuf->PaperTypeCode );		// y[p[^CvR[h
	SendCmdBuf.AddTagFloat( 3, pInBuf->TargetValue, 60 );	// ^[Qbgf[^iڕWlj
	SendCmdBuf.AddTagFloat( 4, pInBuf->DMaxControl, 3 );	// ^[Qbgf[^iRg[lj
	SendCmdBuf.AddTagChar ( 5, pInBuf->TypeName, 25 );		// ޖ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0800,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0801,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0801H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0900_0901()
//	ABSTRACT : vt@Co[WXVv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0900_0901( T_Nps6001H_0900H * pInBuf, T_Nps6001H_0901H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0901H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0900 );
	SendCmdBuf.AddTagChar( 1, (char*)pInBuf->MachinProfileVersion, 7 );	// vt@Co[W
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0900,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0901,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0901H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0A00_0A01()
//	ABSTRACT : FADgpJnv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2008.12.24
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0A00_0A01( T_Nps6001H_0A00H * pInBuf, T_Nps6001H_0A01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0A01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 65535 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [65535]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0A00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );								// Lԍ
	SendCmdBuf.AddTagChar ( 2, pInBuf->OrderKey, (int)strlen(pInBuf->OrderKey) + 1 );	// I[_[ʎq
	SendCmdBuf.AddTagShort( 3, pInBuf->PrintOut );									// vgro
	if ( 0 < pInBuf->TotalDataSize )
	{
		SendCmdBuf.AddTagLong ( 4, pInBuf->TotalDataSize );								// Sf[^TCY iPʁFBytej
		SendCmdBuf.AddTagLong ( 5, pInBuf->DataGetPoint );								// f[^MJnʒu iPʁFBytej
		SendCmdBuf.AddTagShort( 6, pInBuf->DataSize );									// f[^MTCY iPʁFBytej
		SendCmdBuf.AddTagChar ( 7, (char*)pInBuf->FadData, pInBuf->DataSize );			// FADf[^
	}
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0A00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0A01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					180000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->FadResult),		NPS_ULONG  ); } break;	// FAD
			case 3:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			case 4:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->DataGetPoint),	NPS_ULONG  ); } break;	// f[^MJnʒu iPʁFBytej
			case 5:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->DataSize),		NPS_USHORT ); } break;	// f[^MTCY iPʁFBytej
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0A01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0B00_0B01()
//	ABSTRACT : vgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2009.03.23
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0B00_0B01( T_Nps6001H_0B00H * pInBuf, T_Nps6001H_0B01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0B01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 32 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [64]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0B00 );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0B00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0B01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					60000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0B01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0C00_0C01()
//	ABSTRACT : đJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0C00_0C01( T_Nps6001H_0C00H * pInBuf, T_Nps6001H_0C01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0C01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0C00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );			// Lԍ
	SendCmdBuf.AddTagShort( 2, pInBuf->OrderState );			// f̃I[_[
	SendCmdBuf.AddTagShort( 3, pInBuf->MainSideState );			// ʃvg̕\ʊJnm点
	SendCmdBuf.AddTagShort( 4, pInBuf->BackSideState );			// ʃvg̗ʊJnm点
	SendCmdBuf.AddTagShort( 5, pInBuf->PrintSide );				// ʃvg̃vg
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0C00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0C01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					60000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0C01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0D00_0D01()
//	ABSTRACT : đI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0D00_0D01( T_Nps6001H_0D00H * pInBuf, T_Nps6001H_0D01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0D01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0D00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );			// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0D00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0D01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					60000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0D01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_0E00_0E01()
//	ABSTRACT : fLZ
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : A.Nagamatsu 2011.11.02
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_0E00_0E01( T_Nps6001H_0E00H * pInBuf, T_Nps6001H_0E01H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_0E01H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0x0E00 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );			// Lԍ
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0x0E00,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x0E01,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					60000					// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->OrderState),		NPS_USHORT ); } break;	// f̃I[_[
			case 3:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->MainSideState),	NPS_USHORT ); } break;	// ʃvg̕\ʊJnm点
			case 4:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->BackSideState),	NPS_USHORT ); } break;	// ʃvg̗ʊJnm点
			case 5:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PrintSide),		NPS_USHORT ); } break;	// ʃvg̃vg
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0x0E01H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_B006_B007()
//	ABSTRACT : NWbgJn
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.02.20
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_B006_B007( T_Nps6001H_B006H * pInBuf, T_Nps6001H_B007H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_B007H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0xB006 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0xB006,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0xB007,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2: { SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0xB007H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6001_B008_B009()
//	ABSTRACT : NWbgI
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2006.12.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6001_B008_B009( T_Nps6001H_B008H * pInBuf, T_Nps6001H_B009H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6001H_B009H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6001, 0xB008 );
	SendCmdBuf.AddTagShort( 1, pInBuf->PossessionNo );
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6001,					// C^[tFCXID
					0xB008,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0xB009,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 1:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			case 2: { SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->PossessionNo),	NPS_USHORT ); } break;	// Lԍ
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6001H, CmdId=0xB009H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}

//////////////////////////////////////////////////////////////////////////////
//	MODULE   : CNpsCmd::NpsCmd_6002_7300_7301()
//	ABSTRACT : [hύXv
//	FUNCTION : 
//	
//	NOTE     : < RD-111 > 
//             < Note > 
//	
//	RETURN   : 
//	
//	CREATE	 : Y.Yoshinobu 2007.03.07
//	UPDATE   : 
//////////////////////////////////////////////////////////////////////////////
long CNpsCmd::NpsCmd_6002_7300_7301( T_Nps6002H_7300H * pInBuf, T_Nps6002H_7301H * pOutBuf )
{
	NkcComApi::CCSScopeLock CSScopeLock( &m_CS );

	//----------------------------------------------------------------------------
	// \̂̏
	//----------------------------------------------------------------------------
	::ZeroMemory( pOutBuf, sizeof(T_Nps6002H_7301H) );

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@쐬
	CSendCmdBuffer SendCmdBuf;

	if ( FALSE == SendCmdBuf.Create( 1024 ) )
	{
		NPS_LOGOUT_FATAL( "===Memory Allocation error [1024]" );
		return NPSERR_SYSERR;
	}

	SendCmdBuf.AddHeader( 0x6002, 0x7300 );
	SendCmdBuf.AddTagShort( 2, pInBuf->TargetCpu );	// ΏCPU
	SendCmdBuf.AddTagShort( 3, pInBuf->Mode );		// [h
	SendCmdBuf.AddTagFooter();

	//////////////////////////////////////////////////////////////////////////////
	// p̃R}h̃obt@쐬
	char *	pRecvBuf	= NULL;
	WORD	RecvBufLen	= 65535;
	pRecvBuf	= new char[ RecvBufLen ];
	ZeroMemory( pRecvBuf, RecvBufLen );

	long	lResult;

	//////////////////////////////////////////////////////////////////////////////
	// NPSʐM
	lResult	= NpsCommand(
					0x6002,					// C^[tFCXID
					0x7300,					// vp̃R}hID
					SendCmdBuf.GetBufferLen(),	// vp̃R}h̃obt@TCY
					SendCmdBuf.GetBuffer(),	// vp̃R}h̃obt@
					0x7301,					// p̃R}hID
					&RecvBufLen,			// p̃R}h̃obt@TCY
					pRecvBuf,				// p̃R}h̃obt@
					m_TimeOut				// ^CAEg(~b)
					);

	//////////////////////////////////////////////////////////////////////////////
	// vp̃R}h̃obt@폜
	SendCmdBuf.Empty();

	//////////////////////////////////////////////////////////////////////////////
	// o̓f[^̍쐬
	USHORT	TagNo;
	USHORT	Length;
	USHORT	Type	= NPS_DATATYPE_TAG_NO;

	USHORT	TmpTagNo	= 0;
	USHORT	RepeatNo	= 0;

	ULONG	Counter		= 0;

	while( 1 )
	{
		// Tag̔ԍ
		if( Type == NPS_DATATYPE_TAG_NO )
		{
			memcpy( &TagNo, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			TagNo	= ntohs( TagNo );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_LENGTH;

			if( 0 == TagNo )
			{
				break;
			}

			// REPEAT
			if( TagNo != TmpTagNo )
			{
				RepeatNo	= 0;
				TmpTagNo	= TagNo;
			}
			else
			{
				RepeatNo++;
			}
		}
		// Valuẽf[^
		else if( Type == NPS_DATATYPE_TAG_LENGTH )
		{
			memcpy( &Length, (char*) pRecvBuf + Counter, sizeof( USHORT ) );
			Length	= ntohs( Length );
			Counter	+= sizeof( USHORT );
			Type	= NPS_DATATYPE_TAG_VALUE;
		}
		// Tagɑ΂lf[^
		else if( Type == NPS_DATATYPE_TAG_VALUE )
		{
			switch( TagNo )
			{
			case 5:	{ SetDataNtoH( (BYTE*)pRecvBuf + Counter,	(BYTE*)&(pOutBuf->Result),			NPS_USHORT ); } break;	// 
			default:break;
			}

			Counter	+= Length;
			Type	= NPS_DATATYPE_TAG_NO;
		}

		// I`FbN
		if( Counter >= RecvBufLen )
		{
			break;
		}
	}

	// p̃R}h̃obt@폜
	delete [] pRecvBuf;

	if ( NPSERR_NORMAL == lResult )
	{
		{	// Oo
			CString str;
			str.Format( " --COMMAND RECV( IfId=0x6002H, CmdId=0x7301H, Result=%d )", pOutBuf->Result );
			NPS_LOGOUT( str );
		}
	}

	return lResult;
}
